Package: karyoploteR
Type: Package
Title: Plot customizable linear genomes displaying arbitrary data
Version: 1.37.0
Date: 2025-06-20
Authors@R: 
  c(person(given = "Bernat",
           family = "Gel",
           role = c("aut", "cre"),
           email = "bgel@igtp.cat",
           comment = c(ORCID = "0000-0001-8878-349X")))
Description: karyoploteR creates karyotype plots of arbitrary genomes and offers
    a complete set of functions to plot arbitrary data on them. It mimicks many
    R base graphics functions coupling them with a coordinate change function 
    automatically mapping the chromosome and data coordinates into the plot 
    coordinates. In addition to the provided data plotting functions, it is 
    easy to add new ones.
License: Artistic-2.0
Depends: R (>= 3.4), regioneR, GenomicRanges, methods
Imports: regioneR, GenomicRanges, IRanges, Rsamtools, stats, graphics,
        memoise, rtracklayer, Seqinfo, GenomeInfoDb, S4Vectors,
        biovizBase, digest, bezier, GenomicFeatures, bamsignals,
        AnnotationDbi, grDevices, VariantAnnotation
Suggests: BiocStyle, knitr, rmarkdown, markdown, testthat, magrittr,
        BSgenome.Hsapiens.UCSC.hg19,
        BSgenome.Hsapiens.UCSC.hg19.masked,
        TxDb.Hsapiens.UCSC.hg19.knownGene,
        TxDb.Mmusculus.UCSC.mm10.knownGene, org.Hs.eg.db, org.Mm.eg.db,
        pasillaBamSubset
URL: https://github.com/bernatgel/karyoploteR
BugReports: https://github.com/bernatgel/karyoploteR/issues
VignetteBuilder: knitr
biocViews: Visualization, CopyNumberVariation, Sequencing, Coverage,
        DNASeq, ChIPSeq, MethylSeq, DataImport, OneChannel
NeedsCompilation: no
Encoding: UTF-8
RoxygenNote: 7.3.2
git_url: https://git.bioconductor.org/packages/karyoploteR
git_branch: devel
git_last_commit: fd32b1e
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-04
Packaged: 2025-11-04 23:14:26 UTC; biocbuild
Author: Bernat Gel [aut, cre] (ORCID: <https://orcid.org/0000-0001-8878-349X>)
Maintainer: Bernat Gel <bgel@igtp.cat>

[![Build Status](https://travis-ci.org/bernatgel/karyoploteR.svg?branch=master)](https://travis-ci.org/bernatgel/karyoploteR)
[![Project Status: Active – The project has reached a stable, usable state and is being actively developed.](http://www.repostatus.org/badges/latest/active.svg)](http://www.repostatus.org/#active)

# karyoploteR - An R/Biocondutor package to plot arbitrary data along the genome


![karyoploteR Example](https://raw.githubusercontent.com/bernatgel/karyoploter_tutorial/master/docs/Examples/MultipleDataTypes/images/Figure-1.png
 "Example of plot created with karyoploteR")

## Description

[karyoploteR](http://bioconductor.org/packages/karyoploteR) is an R package to 
plot data along the genome using a karyotype style plot.

It is entirely based on R base graphics and inspired by the R base graphics API. 
It includes functions to plot primitive graphic elements such as points, lines,
rectangles, text, etc mapped into the genome plot coordinates and higher 
level functions to plot a heatmap, the regions in a GenomicRanges object
or the cumulative coverage of such regions.

Data positioning and track configuration has been inspired by Circos and does
not explicitly understands the concept of track. Thus, it is possible to freely specify 
where to plot the data and to create plots with multiple independent tracks or
overlapping representations.

It is highly configurable and in addition to the parametrization of the 
different data plotting functions, it is possible to specify custom functions 
for every plotting action from the basic chromosome bands to the chromosome labels
or base numbers as well as creating completely new plotting functions.

## How to use it

Documentation ([vignette](http://bioconductor.org/packages/devel/bioc/vignettes/karyoploteR/inst/doc/karyoploteR.pdf) and [user manual](http://bioconductor.org/packages/devel/bioc/manuals/karyoploteR/man/karyoploteR.pdf)) is available at the karyoploteR's 
Bioconductor landing page at [http://bioconductor.org/packages/karyoploteR](http://bioconductor.org/packages/karyoploteR)

## Tutorial and Examples

In addition to the documentation above, a short tutorial and some examples can be found at [https://bernatgel.github.io/karyoploter_tutorial/](https://bernatgel.github.io/karyoploter_tutorial/)

## <a name="Citing"></a>Citing karyoploteR

karyoploteR has been developed by [Bernat Gel](https://twitter.com/bernatgel) and [Eduard Serra](mailto:eserra@igtp.cat) at [IGTP](http://www.germanstrias.org/)
Hereditary Cancer Group.

If you use karyoploteR in your research, please cite the [Bioinformatics paper](https://academic.oup.com/bioinformatics/article/3857734/karyoploteR-an-R-Bioconductor-package-to-plot) describing it:

Bernat Gel & Eduard Serra. (2017). *karyoploteR: an R/Bioconductor package to plot customizable genomes displaying arbitrary data*. Bioinformatics, 31–33. [doi:10.1093/bioinformatics/btx346](https://doi.org/10.1093/bioinformatics/btx346)

## A few example plots created with karyoploteR

These images are all created with karyoploteR and are part of the documented 
examples in the [karyoploteR's tutorial and examples page](https://bernatgel.github.io/karyoploter_tutorial/).
Click on them to see how the code needed to create them.


<p align="center">
  <a href="https://bernatgel.github.io/karyoploter_tutorial/Examples/GeneExpression/GeneExpression.html" target="_blank">
    <img src="https://bernatgel.github.io/karyoploter_tutorial/Examples/GeneExpression/images/Figure13-1.png" width="40%"  alt="A karyoploteR example plotting differential expression results computed with RNA-seq data from Drosophila Melanogaster" title="Differential expression results computed with RNA-seq data from Drosophila Melanogaster" style="max-width:100%;margin-right:5%;" ></img>
  </a>
  <a href="https://bernatgel.github.io/karyoploter_tutorial//Examples/GeneDensityIdeograms/GeneDensityIdeograms.html" target="_blank">
    <img src="https://bernatgel.github.io/karyoploter_tutorial//Examples/GeneDensityIdeograms/images/Figure9-1.png" width="40%"  alt="A karyoploteR example plotting the density of genes instead of the ideograms" title="Usiong the density of genes instead of ideograms"></img> 
  </a>
  <br>
  <br>
  <a href="https://bernatgel.github.io/karyoploter_tutorial//Examples/NucleotideFrequency/NucleotideFrequency.html" target="_blank">
    <img src="https://bernatgel.github.io/karyoploter_tutorial//Examples/NucleotideFrequency/images/Figure11-1.png" width="40%"  alt="A karyoploteR example plotting the nucleotide frequency, genes and CpG-islands on a small genomic region" title="The nucleotide frequency, genes and CpG-islands on a small genomic region"></img>
  </a>
  <a href="https://bernatgel.github.io/karyoploter_tutorial//Examples/SNPArray/SNPArray.html" target="_blank">
    <img src="https://bernatgel.github.io/karyoploter_tutorial//Examples/SNPArray/images/Figure4-1.png" width="40%"  alt="A karyoploteR example plotting raw SNP-array data" title="Raw SNP-array data"></img>
  </a>
  <br>
  <br>
  <a href="https://bernatgel.github.io/karyoploter_tutorial//Examples/PVivaxGenes/PVivaxGenes.html" target="_blank">
    <img src="https://bernatgel.github.io/karyoploter_tutorial//Examples/PVivaxGenes/images/Figure6-1.png" width="40%"  alt="A karyoploteR example plotting the genes from Plasmodium Vivax PvP01 genome version" title="The genes from Plasmodium Vivax PvP01 genome version"></img>
  </a>
  <a href="https://bernatgel.github.io/karyoploter_tutorial//Examples/PlotGenes/PlotGenes.html" target="_blank">
    <img src="https://bernatgel.github.io/karyoploter_tutorial//Examples/PlotGenes/images/Figure2-1.png" width="40%"  alt="A karyoploteR example plotting genes positioned on the genome" title="Genes positioned on the genome"></img>
  </a>
  <br>
  <br>
  <a href="https://bernatgel.github.io/karyoploter_tutorial//Examples/Rainfall/Rainfall.html" target="_blank">
    <img src="https://bernatgel.github.io/karyoploter_tutorial//Examples/Rainfall/images/Figure3-1.png" width="40%"  alt="A karyoploteR example plotting a rainfall plot showing the distances between consecutive somatic variants" title="A rainfall plot showing the distances between consecutive somatic variants"></img>
  </a>  
  <a href="https://bernatgel.github.io/karyoploter_tutorial//Examples/CpGIslands/CpGIslands.html" target="_blank">
    <img src="https://bernatgel.github.io/karyoploter_tutorial//Examples/CpGIslands/images/Figure5-1.png" width="40%"  alt="A karyoploteR example plotting the density and positions of CpG islands along the genome" title="The density and positions of CpG islands along the genome"></img>
  </a>
</p>

#' kpAddColorRect
#' 
#' @description 
#' 
#' Add color rectangles next to the data panels. Ideal to identify the data in the plot
#' 
#' @details 
#' 
#' Given a KaryoPlot object, plot colored rectangles on the side of the data panels to help identify the different samples or types of data plotted
#' 
#' @usage kpAddColorRect(karyoplot, col="gray", rect.width=0.02, rect.margin=0.01,  side="left", y0=0, y1=1, r0=NULL, r1=NULL, data.panel=1, border=NA, ...)
#' 
#' @param karyoplot    a \code{karyoplot} object returned by a call to \code{plotKaryotype}
#' @param col   (color) the color of the rectangle
#' @param rect.width    (numeric) the width of the rectangle in plot coordinates (the whole plot has a width of 1). Usual value might be 0.05. Can be negative. (defaults to 0.02)
#' @param rect.margin    (numeric) the additional the margin between the rectangle and the chromosome. In plot coordinates (the whole plot has a width of 1). Usual value might be 0.05. Can be negative. (defaults to 0.01)
#' @param side ("left" or "right") The side of the plot where to plot the labels. (defaults to "left") 
#' @param y0 (numeric) If the vertical space defined by r0 and r1 goes from 0 to 1, the value at which the bottom of the rectangle starts. Ex: y0=0.5, y1=1 will create a rectangle occupying the top half of the total allocated vertical space. (defaults to 0)
#' @param y1 (numeric) If the vertical space defined by r0 and r1 goes from 0 to 1, the value at which the top of the rectangle ends. Ex: y0=0, y1=0.5 will create a rectangle occupying the bottom half of the total allocated vertical space. (defaults to 1)
#' @param r0    (numeric) r0 and r1 define the vertical range of the data panel to be used to position the rectangle. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param r1    (numeric) r0 and r1 define the vertical range of the data panel to be used to position the rectangle. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param data.panel    (numeric) The identifier of the data panel where the labels are to be added. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param border (color) The color of the rectangle border. If NA, no border will be plotted. (defaults to NA)
#' @param ...  any additional parameter to be passed to the text plotting. All R base graphics params are passed along.
#' 
#' @return
#' invisibly returns the given karyoplot object
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{autotrack}}
#' 
#' @examples
#'
#'  num.samples <- 10
#' samples.metadata <- data.frame(stage=c("I", "I", "I", "III", "IV", "III", "II", "IV", "IV", "IV"),
#'                                 metastasis=c(0,0,0,0,1,0,0,0,1,0),
#'                                 subtype=c("A", "A", "B", "B", "A", "B", "B", "B", "A", "B"))
#' 
#' kp <- plotKaryotype(plot.type=4)
#' for(i in 1:num.samples) {
#'   #metastasis
#'   kpAddColorRect(kp, col = colByCategory(samples.metadata$metastasis, color=c("white", "black"))[i],
#'                  rect.margin = 0.01, rect.width = 0.01, r0=autotrack(i, num.samples))
#'   #stage
#'   kpAddColorRect(kp, 
#'     col = colByCategory(samples.metadata$stage, colors=c("I"="plum1", "II"="hotpink", "III"="orange", "IV"="red2"))[i],
#'     rect.margin = 0.021, rect.width = 0.01, r0=autotrack(i, num.samples))
#'   #subtype
#'   kpAddColorRect(kp, 
#'                  col = colByCategory(samples.metadata$subtype, colors=c("dodgerblue", "gold"))[i],
#'                  rect.margin = 0.032, rect.width = 0.01, r0=autotrack(i, num.samples))
#' }
#' 
#' @export kpAddColorRect
#' 

kpAddColorRect <- function(karyoplot, col="gray", rect.width=0.02, rect.margin=0.01,  side="left", y0=0, y1=1, r0=NULL, r1=NULL, data.panel=1, border=NA, ...) {
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  #Depending on the plot type, rectangles will be added to every chromosome or just to the first/last chromosome
  if(karyoplot$plot.type %in% c(1,2,6)) {
    chrs <- karyoplot$chromosomes
  } 
  if(karyoplot$plot.type %in% c(3,4,5,7)) {
    if(side=="left") {
      chrs <- karyoplot$chromosomes[1]
    } else {
      chrs <- karyoplot$chromosomes[length(karyoplot$chromosomes)]
    }
  }
  
  #Compute the vertical positioning
    # 1 - adjust the y in chromosomal coordinates to take r's, y values, etc into account
      adj.y <- prepareParameters2("kpAddColorRect", karyoplot, data=NULL, chr=chrs, 
                    x=0, y=c(y0,y1), ymax=1, ymin=0, r0=r0, r1=r1, data.panel=data.panel)$y
    # 2 - Transform the y values into plot coordinates
      y0.plot <- karyoplot$coord.change.function(chr = chrs, x = 0, y=rep(adj.y[1], length(chrs)), data.panel = data.panel)$y
      y1.plot <- karyoplot$coord.change.function(chr = chrs, x = 0, y=rep(adj.y[2], length(chrs)), data.panel = data.panel)$y
  
  #Now compute the horizontal positioning
    if(side == "left") { #if side="left", plot them on the left
      #The right end of the left-side margin minus the rect.margin
      x1.plot <- rep(karyoplot$plot.params$leftmargin, length(chrs)) - rect.margin
      x0.plot <- x1.plot - rect.width
    } else {  #if side="right", plot them on the right
      #The last position of each chrs plus the label.margin
      x0.plot <- karyoplot$coord.change.function(chr = chrs, 
                                           x = end(karyoplot$genome[chrs]),
                                           y=rep(adj.y[1], length(chrs)), 
                                           data.panel = data.panel)$x + rect.margin
      x1.plot <- x0.plot + rect.width
    }

  graphics::rect(xleft = x0.plot, xright = x1.plot, ybottom = y0.plot, ytop = y1.plot, col = col, border=border, ...)

  invisible(karyoplot)
}

#' kpArea
#' 
#' @description 
#' 
#' Plots a line joining the data points along the genome and fills the area below the line.
#' 
#' @details 
#'  
#' This is a karyoploteR low-level plotting functions. Given a set of positions 
#' on the genome (chromosome and base) and a value (y) for each of them, it 
#' plots a line joining them and shades the area below them. Data can be 
#' provided via a \code{GRanges} object (\code{data}), independent parameters 
#' for chr, x and y or a combination of both. A number of parameters can be used
#' to define exactly where and how the line and area are drawn. In addition, 
#' via the ellipsis operator (\code{...}), \code{kpArea} accepts any parameter 
#' valid for \code{\link[graphics]{lines}} and \code{\link[graphics]{polygon}}
#' (e.g. \code{lwd}, \code{lty}, \code{col}, \code{density}...) The lines are drawn in a per 
#' chromosome basis, so it is not possible to draw lines encompassing more than 
#' one chromosome.
#'
#' @usage kpArea(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, base.y=0, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, col=NULL, border=NULL, clipping=TRUE, ...)
#' 
#' @inheritParams kpPoints 
#' @param base.y  (numeric) The y value at which the polygon will be closed. (defaults to 0)
#' @param col  (color) The fill color of the area. A single color. If NULL the color will be assigned automatically, either a lighter version of the color used for the outer line or gray if the line color is not defined. If NA no area will be drawn. (defaults to NULL)
#' @param border  (color) The color of the line enclosing the area. A single color. If NULL the color will be assigned automatically, either a darker version of the color used for the area or black if col=NA. If NA no border will be drawn. (Defaults to NULL)
#' 
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpLines}}, \code{\link{kpText}}, \code{\link{kpPlotRibbon}}
#' 
#' @examples
#'  
#' set.seed(1000)
#' data.points <- sort(createRandomRegions(nregions=500, mask=NA))
#' mcols(data.points) <- data.frame(y=runif(500, min=0, max=1))
#' 
#' kp <- plotKaryotype("hg19", plot.type=2, chromosomes=c("chr1", "chr2"))
#'   kpDataBackground(kp, data.panel=1)
#'   kpDataBackground(kp, data.panel=2)
#' 
#'   kpArea(kp, data=data.points)
#'   kpArea(kp, data=data.points, col="lightgray", border="red", lty=2, r0=0, r1=0.5)
#'   kpArea(kp, data=data.points, border="red", data.panel=2, r0=0, r1=0.5)
#'   kpArea(kp, data=data.points, border="blue", data.panel=2, r0=0, r1=0.5, base.y=1)
#'
#'   kpArea(kp, data=data.points, border="gold", data.panel=2, r0=0.5, r1=1, base.y=0.5)
#' 
#' 
#'  
#' @export kpArea
#' 


kpArea <- function(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, base.y=0, ymin=NULL, ymax=NULL,
                    data.panel=1, r0=NULL, r1=NULL, col=NULL, border=NULL, clipping=TRUE, ...) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
 
  #COLORS
    #Check the length of the color parameters. it does not make sense to specify more than one in this function
    if(length(col)>1) {
      col <- col[1]
      warning("kpArea: more than one color provided in 'col'. Using only the first element ('", col, "') and ignoring the rest") 
    }
    if(length(border)>1) {
      border <- border[1]
      warning("kpArea: more than one color provided in 'border'. Using only the first element ('", border, "') and ignoring the rest") 
    }
  
    #Specify the missing colors with defaults if needed
    if(is.null(col) && (is.null(border) || is.na(border))) {
      col <- "gray70"
    }
    if(is.na(col) && is.null(border)) {
      border <- "black"
    }
    
    #And derive the missing from the other ones, if needed
    if(is.null(border) && !is.null(col) && !is.na(col)) {
      border=darker(col, amount = 100)
    }
    if(is.null(col) && !is.null(border) && !is.na(border)) {
      col=lighter(border)
    }
    
  
  #Prepare the rest of the parameters
  pp <- prepareParameters2("kpArea", karyoplot=karyoplot, data=data, chr=chr, x=x, y=y, 
                           ymin=0, ymax=1, r0=0, r1=1, data.panel=data.panel, ...)
  
  for(current.chr in karyoplot$chromosomes) {
    in.chr <- which(pp$chr==current.chr)
    
    if(!is.na(col)) { #Plot the polygon only if we have a color for it
      #prepare data for the polygon (basically add on initial and one final point at the base level)
      pol.chr <- c(current.chr, pp$chr[in.chr], current.chr)
      pol.x <- c(pp$x[in.chr][1], pp$x[in.chr], pp$x[in.chr][length(pp$x[in.chr])])
      pol.y <- c(base.y, pp$y[in.chr], base.y)
      
      kpPolygon(karyoplot, chr=pol.chr, x=pol.x, y=pol.y, col=col, border=NA, ymin=ymin, ymax=ymax,
                data.panel=data.panel, r0=r0, r1=r1, clipping=clipping, ...)
    }
    
    if(!is.na(border)) { #Plot the line only if we have a color for it
      kpLines(karyoplot, chr=pp$chr[in.chr], x= pp$x[in.chr], y=pp$y[in.chr], col=border,
              ymin=ymin, ymax=ymax, data.panel=data.panel, r0=r0, r1=r1, clipping=clipping, ...)
    }
    
  }
  
 
  invisible(karyoplot)
}

#' kpPlotBigWig
#' 
#' @description 
#' 
#' Plots the wiggle values in a BigWig file. This function does not work on windows.
#' 
#' @details 
#'  
#' \code{kpPlotBigWig} plots the data contained in a binary file format called 
#' BigWig. BigWig are used to efficiently store numeric values computed for 
#' windows covering the whole genome, ususally the coverage from an NGS 
#' experiment such as ChIP-seq. Only data required for the plotted region
#' is loaded, and when more than one chromosome is visible, it will load the
#' data for one crhomosome at a time.
#' The function accepts either a \code{\link{BigWigFile}} oject or a 
#' \code{character} with the path to a valid big wig file. The character can 
#' also be a URL to a remote server. In this case data will be loaded 
#' transparently using the \code{import} function from 
#' \code{rtracklayer}.  
#' The data is plotted using \code{\link{kpArea}} and therefore it is possible
#' to plot as a single line, a line with shaded area below or as a shaded area 
#' only adjusting the \code{col} and \code{border} parameters. 
#' 
#' 
#' @usage kpPlotBigWig(karyoplot, data, ymin=NULL, ymax="global", data.panel=1, r0=NULL, r1=NULL, col=NULL, border=NULL, clipping=TRUE, ...) 
#' 
#' @param karyoplot    (a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.
#' @param data    (a \code{BigWigFile} or character) The path to a bigwig file (either local or a URL to a remote file) or a \code{BigWigFile} object.
#' @param data.panel    (numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param r0    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param r1    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param ymin    (numeric) The minimum value to be plotted on the data panel. If NULL, the minimum between 0 and the minimum value in the WHOLE GENOME will be used. (deafults to NULL)
#' @param ymax    (numeric or c("global", "per.chr", "visible.region")) The maximum value to be plotted on the data.panel. It can be either a numeric value or one of c("global", "per.chr", "per.region"). "Global" will set ymax to the maximum value in the whole data file. "per.chr" will set ymax to the maximum value in each chromosome. "visible.region" will set ymax to the maximum value in the visible region. (defaults to "global")
#' @param col  (color) The fill color of the area. A single color. If NULL the color will be assigned automatically, either a lighter version of the color used for the outer line or gray if the line color is not defined. If NA no area will be drawn. (defaults to NULL)
#' @param border  (color) The color of the line enclosing the area. A single color. If NULL the color will be assigned automatically, either a darker version of the color used for the area or black if col=NA. If NA no border will be drawn. (Defaults to NULL)
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param ...    The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.
#'   
#' @return
#' 
#' Returns the original karyoplot object with the data computed (ymax and ymin values used) stored at \code{karyoplot$latest.plot}
#' 
#' @note Since this functions uses \code{rtracklayer} BigWig infrastructure and it does not work on windows, this function won't work on windows either.
#' 
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpArea}}, \code{\link{kpPlotBAMDensity}}
#' 
#' @examples
#' 
#' if (.Platform$OS.type != "windows") {
#'   bigwig.file <- system.file("extdata", "BRCA.genes.hg19.bw", package = "karyoploteR")
#'   brca.genes.file <- system.file("extdata", "BRCA.genes.hg19.txt", package = "karyoploteR")
#'   brca.genes <- toGRanges(brca.genes.file)
#'   library(GenomeInfoDb)  # for seqlevelsStyle()
#'   seqlevelsStyle(brca.genes) <- "UCSC"
#' 
#'   kp <- plotKaryotype(zoom = brca.genes[1])
#'   kp <- kpPlotBigWig(kp, data=bigwig.file, r0=0, r1=0.2)
#'   kp <- kpPlotBigWig(kp, data=bigwig.file, r0=0.25, r1=0.45, border="red", lwd=2)
#'   kp <- kpPlotBigWig(kp, data=bigwig.file, r0=0.5, r1=0.7, ymin=0, ymax=1000, border="gold", col=NA)
#'   kpAxis(kp, r0=0.5, r1=0.7, ymin=0, ymax=1000)
#'   kp <- kpPlotBigWig(kp, data=bigwig.file, r0=0.75, r1=0.95, ymin=0, ymax="visible.region", border="orchid", col=NA)
#'   kpAxis(kp, r0=0.75, r1=0.95, ymin=0, ymax=kp$latest.plot$computed.values$ymax)
#' }
#' 
#' 
#' @export kpPlotBigWig
#' @importFrom rtracklayer BigWigFile seqinfo summary
#' @importFrom S4Vectors intersect
#' 


kpPlotBigWig <- function(karyoplot, data, ymin=NULL, ymax="global", data.panel=1, 
                         r0=NULL, r1=NULL, 
                         col=NULL, border=NULL, clipping=TRUE, ...) {
  
  #karyoplot
  if(missing(karyoplot)) stop("The parameter 'karyoplot' is required")
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  
  #data
  if(missing(data)) stop("The parameter 'data' is required")
  if(!methods::is(data, "BigWigFile") & !methods::is(data, "character")) stop("'data' must be a character or a BigWigFile object")
  
  #Prepare the access to the data
  if(methods::is(data, "character")) {
    data <- rtracklayer::BigWigFile(data)
  }
  
  #Check ymax
  if(is.null(ymax)) ymax <- "global"
  if(!all(is.numeric(ymax))) {
    ymax <- match.arg(ymax, choices = c("global", "per.chr", "visible.region"))
  }
  
  
  #Check seqinfo(data) to validate at least some intersection between the genome
  #and data chromosome names
  data.chrs <- seqnames(seqinfo(data))
  if(!any(data.chrs %in% karyoplot$chromosomes)) {
    #NOTE: We can deactivate this warning and make it fail silently. Not sure 
    #      what the best option is yet
    warning("None of the chromosome names in the data file (", 
            paste0(data.chrs, collapse = ","), 
            ") matches a chromosome name in the plotted genome (", 
            paste0(karyoplot$chromosomes, collapse=","), "). Nothing will be plotted")
  }
  
  #if ymax is NULL, set it to the maximum of the file on the whole genome using
  # the summary info from BigWigFile or 0 if all values are negative
  if(all(is.numeric(ymax))) {
    ymax <- setNames(rep(ymax, length.out=length(karyoplot$plot.region)),
                     as.character(seqnames(karyoplot$plot.region)))
  } else {
    if(length(ymax)==1 && ymax=="global") {
      max.vals <- unlist(summary(data, type="max"))
      ymax <- setNames(rep(max(0, max(mcols(max.vals)[,1])), length(max.vals)), as.character(seqnames(max.vals)))
    }
    if(length(ymax)==1 && ymax=="per.chr") {
      max.vals <- unlist(summary(data, type="max"))
      ymax <- setNames(mcols(max.vals)[,1], as.character(seqnames(max.vals)))
    }
  }    

  #if ymin is NULL, set it to the minimum of the file on the whole genome or 0 
  #if all values are above 0
  if(is.null(ymin)) {
    ymin <- min(0, min(mcols(unlist(summary(data, type="min")))[,1]))
  }
  
  
  #Load and plot the data serially for each chromosome. This will reduce the 
  # memory load when plotting on the whole genome
  
  #Filter out the plot regions (i.e. chromosomes) not known to data. This reduces work and avoids warnings about unknown seqlevels
  plot.region <- GenomeInfoDb::keepSeqlevels(karyoplot$plot.region, value = S4Vectors::intersect(seqlevels(data), seqlevels(karyoplot$plot.region)), pruning.mode = "coarse")
  
  for(i in seq_along(plot.region)) {
    #Note: remove unneeded seqlevels when calling import to avoid a warning about unknown seqlevels
    wig.data <- rtracklayer::import(data, format = "bigWig", selection=plot.region[i])
    if(all(is.numeric(ymax))) {
      region.ymax <- ymax[as.character(seqnames(plot.region[i]))]
    } else {
      if(length(ymax)==1 && ymax == "visible.region") {
        region.ymax <- max(0, max(mcols(wig.data)[,1]))
      } else {
        stop("Unexpected ymax value")
      }
    }
    kpArea(karyoplot, data = wig.data, y=wig.data$score, 
           ymin=ymin, ymax=region.ymax,
           data.panel=data.panel, r0=r0, r1=r1,
           col=col, border=border, clipping=TRUE, ...)
  }
  
  #TODO: Should return all ymax values instead of using only the last one
  karyoplot$latest.plot <- list(funct="kpPlotBigWig", computed.values=list(ymax=region.ymax, ymin=ymin))
  
  
  invisible(karyoplot)
}

#' kpAddBaseNumbers
#' 
#' @description 
#' 
#' Plots the base numbers along the chromosome ideograms
#' 
#' @details 
#'  
#' This function can be used to add the base numbers scale to the chromosome ideograms.
#' The base numbers and ticks will be drawn next to the ideograms and not on a separate
#' independent x axis. It is possible to control the number and position of the tick
#' marks and labels
#' 
#' @usage kpAddBaseNumbers(karyoplot, tick.dist=20000000, tick.len=5, units="auto", add.units=FALSE, digits=2, minor.ticks=TRUE, minor.tick.dist=5000000, minor.tick.len=2,  cex=0.5, tick.col=NULL, minor.tick.col=NULL, clipping=TRUE, ...)
#' 
#' @param karyoplot  (karyoplot object) A valid karyoplot object created by a call to \code{\link{plotKaryotype}}
#' @param tick.dist  (numeric) The distance between the major numbered tick marks in bases (defaults to 20 milions, one major tick every 20Mb)
#' @param tick.len  (numeric) The length of the major tick marks in plot coordinates (defaults to 5)
#' @param units (character) the units for the numbers to be represented. Must be one of "auto", "b", "kb" or "Mb". If auto, it will utomatically choose the most suitable unit. (Defaults to "auto")
#' @param add.units (boolean) Add the units (Mb, Kb...) to the tick labels. (Defaults to FALSE)
#' @param digits   (integer) The maximum number of digits after the decimal point in labels. (defaults to 2)
#' @param minor.ticks (boolean) Whether to add unlabeled minor ticks between the major ticks (defaults to TRUE)
#' @param minor.tick.dist   (numeric) The distance between the minor ticks in bases (defaults to 5 milions, a minor tick mark every 5Mb)
#' @param minor.tick.len   (numeric) The length of the minor tick marks in plot coordinates (defaults to 2)
#' @param cex  (numeric) The cex parameter for the major ticks label (defaults to 0.5)
#' @param tick.col   (color) If specified, the color to plot the major ticks. Otherwise the default color or, if given, the col parameter will be used. (Defaults to NULL)
#' @param minor.tick.col  (color) If specified, the color to plot the minor ticks. Otherwise the default color or, if given, the col parameter will be used. (Defaults to NULL)
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param ...  Any other parameter to be passed to internal function calls. Specially useful for graphic parameters.
#' 
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#'  
#' @seealso \code{\link{plotKaryotype}}
#' 
#' @examples
#'  
#' 
#' kp <- plotKaryotype()
#' kpAddBaseNumbers(kp)
#' 
#' kp <- plotKaryotype(chromosomes="chr17")
#' kpAddBaseNumbers(kp, tick.dist=10000000, minor.tick.dist=1000000)
#' 
#' 
#'  
#' @export kpAddBaseNumbers
#' 


kpAddBaseNumbers <- function(karyoplot, tick.dist=20000000, tick.len=5, 
                             units="auto", add.units=FALSE,
                             digits=2, minor.ticks=TRUE, 
                            minor.tick.dist=5000000, minor.tick.len=2,  cex=0.5, 
                            tick.col=NULL, minor.tick.col=NULL, clipping=TRUE,  ...) {
  
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  if(!(units %in% c("auto", "b", "kb", "Kb", "mb", "Mb"))) stop("invalid units. Must be one of: 'auto', 'b', 'Kb' or 'Mb'")
  
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  ccf <- karyoplot$coord.change.function
  pp <- karyoplot$plot.params
  mids <- karyoplot$ideogram.mid
  
  
  toLabel <- function(n, units, add.units, digits) {
    if(add.units==TRUE) {
      unit.labels <- c("b", "Kb", "Mb")
    } else {
      unit.labels <- c("", "", "")
    }
    if(units == "auto") {
      if(abs(n)<1000) { units <- "b"}
      else if(abs(n)<1000000) {units <- "Kb"}
      else {units <- "Mb"}
    }
    if(tolower(units) == "b") return(paste0(as.character(n), unit.labels[1])) #b
    if(tolower(units) == "kb") return(paste0(as.character(round(n/1000, digits=digits)), unit.labels[2])) #Kb
    return(paste0(as.character(round(n/1000000, digits=digits)), unit.labels[3])) #Mb
  }
  
  old.scipen <- options("scipen")$scipen
  options(scipen=999)
  on.exit(options(scipen=old.scipen), add=TRUE)

 
  #For every chromsome
  for(chr.name in karyoplot$chromosomes) {

    chr <- karyoplot$genome[chr.name]
    #Major ticks
    num.ticks <- width(chr)/tick.dist + 1
  
    tick.pos <- start(chr) + (tick.dist*(0:(num.ticks-1))) - 1 
    tick.pos[1] <- start(chr)
    
    #if zoomed in, keep only the ticks in the plot region
    if(karyoplot$zoom==TRUE) {
      if(clipping==TRUE) {
        tick.pos <- tick.pos[tick.pos >= start(karyoplot$plot.region) & tick.pos<= end(karyoplot$plot.region)]
      }
    }
    
    if(length(tick.pos)>0) {#We have to test here and cannot test on num.ticks to take the zooming into account
      tick.labels <- sapply(tick.pos, toLabel, units=units, add.units=add.units, digits=digits)
        #
      #function(x){return(toLabel(x, units=units, add.units=add.units, digits=digits))}
      
      
      xplot <- ccf(chr=rep(chr.name, length(tick.pos)), x=tick.pos, data.panel="ideogram")$x
      y0plot <- mids(chr.name)-karyoplot$plot.params$ideogramheight/2
      if(is.null(tick.col)) {
        graphics::segments(x0=xplot, x1=xplot, y0=y0plot, y1=y0plot-tick.len, ...)
      } else {
        graphics::segments(x0=xplot, x1=xplot, y0=y0plot, y1=y0plot-tick.len, col=tick.col, ...)
      }
      graphics::text(x=xplot, y=y0plot-tick.len, labels=tick.labels, pos=1, cex=cex, offset=0.1, ...)
    }
    #Minor ticks
    if(minor.ticks) {
      if(width(chr)>minor.tick.dist) {
        minor.num.ticks <- floor(width(chr)/minor.tick.dist)
        minor.tick.pos <- start(chr) + (minor.tick.dist*(seq_len(minor.num.ticks))) - 1
  
        #if zoomed in, keep only the ticks in the plot region
        if(karyoplot$zoom==TRUE) {
          if(clipping==TRUE) {
          minor.tick.pos <- minor.tick.pos[minor.tick.pos >= start(karyoplot$plot.region) & minor.tick.pos<= end(karyoplot$plot.region)]
          }
        }
        if(length(minor.tick.pos)>0) { 
          xplot <- ccf(chr=rep(chr.name, length(minor.tick.pos)), x=minor.tick.pos , data.panel="ideogram")$x
          y0plot <- mids(chr.name) - karyoplot$plot.params$ideogramheight/2
          if(is.null(minor.tick.col)) {
            graphics::segments(x0=xplot, x1=xplot, y0=y0plot, y1=y0plot-minor.tick.len, ...)       
          } else {
            graphics::segments(x0=xplot, x1=xplot, y0=y0plot, y1=y0plot-minor.tick.len, col=minor.tick.col, ...)       
          }
        }
      }
    }
  }
  
  invisible(karyoplot)
}

library(karyoploteR)
context("Main plotKaryotype function")

#Test plotKaryotype
test_that("plotKaryotype works with different genome definitions", {
  
  valid.genome <- toGRanges(data.frame(chr=c("1"), start=c(1), end=1000))
  invalid.genome <- toGRanges(data.frame(chr=c("1"), start=c(1,1), end=1000)) #repeted chr names
  
  require(BSgenome.Hsapiens.UCSC.hg19)
  
  expect_silent(plotKaryotype())
  expect_silent(plotKaryotype(genome="hg19"))
  expect_silent(plotKaryotype(genome="mm10"))
  expect_silent(plotKaryotype(genome=BSgenome.Hsapiens.UCSC.hg19))
  expect_silent(plotKaryotype(genome=seqinfo(BSgenome.Hsapiens.UCSC.hg19)))
  #expect_silent(plotKaryotype(genome=valid.genome))
  #expect_silent(plotKaryotype(genome=valid.genome, cex=2))
  expect_silent(plotKaryotype(genome=valid.genome, zoom=toGRanges(data.frame("1", 5, 20))))
  #expect_silent(plotKaryotype(genome=valid.genome, ideogram.plotter = NULL))
  #expect_silent(plotKaryotype(genome=valid.genome, labels.plotter = NULL))
  expect_error(plotKaryotype(genome=invalid.genome))
  
})

#kpAddCytobands
test_that("the returned karyoplot object is complete and correct", {
  #TODO!
  
})


#kpAddBaseNumbers
test_that("kpAddBaseNumbers works", {
  #github issue 26
  kp <- plotKaryotype(genome="hg19",plot.type=2)
  kpAddBaseNumbers(kp)
  #TODO: Extend testing
  
})


#kpAddCytobandLabels
test_that("kpAddCytobandLabels works", {
  #identified when fixing github issue 26
  kp <- plotKaryotype(genome="hg19", plot.type=2)
  kpAddCytobandLabels(kp)
  
  #TODO: Extend testing
  
})

#' kpPlotHorizon
#' 
#' @description 
#' 
#' Plot a horizon plot, an area-like plot where different value levels are
#' plotted in different colors.
#' 
#' @details 
#'  
#' kpPlotHorizon will create a horizon plot, a plot usually used in time series,
#' that will represent a wiggle value (coverage, methylation, expression...) 
#' that we'd usually plot with a line or area in a fraction of the vertical
#' space used by these function (usually in 1/6, but that's configurable).
#' To do that, it will cut the \code{y} space into N parts and assign a 
#' different color to each one, flip the negative values into the positive space
#' (with negative value colors) and plot all parts in the same vertical space.
#' 
#' A more detailed explanation of horizon plots can be found at  
#' https://flowingdata.com/2015/07/02/changing-price-of-food-items-and-horizon-graphs/ 
#' and a more detailed explanation of the horizon plots implemented in 
#' karyoploteR together with an explicative animation can be found at
#' https://bernatgel.github.io/karyoploter_tutorial/ 
#' 
#' 
#' @usage kpPlotHorizon(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, 
#'                      num.parts=3, breaks=NULL, ymin=NULL, ymax=NULL,
#'                      data.panel=1, r0=0, r1=1, col="redblue6", 
#'                      border=NA, clipping=TRUE, ...)
#' 
#' @inheritParams kpPoints 
#' @param num.parts (numeric) The number of parts into which the positive and the negative y spaces will be cut. Only used if \code{breaks} is NULL. (defaults to 3)
#' @param breaks (numeric vector or list) A numeric vector of a list with two numeric vectors named "pos" and "neg". The exact break points where the y space will be cut. If NULL, the breaks will be automatically computed using num.parts. (defaults to NULL)
#' @param col  (character, color vector or list) The palette name to be used, a color vector with the color to be used to define the color gradients or a list with two color vectors named "pos" and "neg". Available palettes are: redblue6, bluepurple10 and bluegold3 (defaults to "redblue6")
#' @param border  (color) The color of the line delimiting the filled areas. If NULL the color will be assigned automatically to a darker version of the color used for the area. If NA no border will be drawn. (Defaults to NA)
#' 
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpLines}}, \code{\link{kpText}}, \code{\link{kpPlotRibbon}}
#' 
#' @examples
#'
#'
#' data.points <- toGRanges(data.frame(chr=c("chr1", "chr1"), start=c(1, 100), end=c(1, 100), y=c(-2, 2)))
#' kp <- plotKaryotype(zoom=toGRanges("chr1:1-100"))
#' kpLines(kp, data.points, r0=0, r1=0.5, ymin=-2, ymax=2)
#' kpAbline(kp, h=c(-2,-1,0,1,2), col="#AAAAAA", r0=0, r1=0.5, ymin=-2, ymax=2)
#' kpAxis(kp, r0=0, r1=0.5, ymin=-2, ymax=2)
#' kpPlotHorizon(kp, data.points, r0=0.55, r1=1)
#'
#'
#' data.points <- toGRanges(data.frame(chr="chr1", start=1:100, end=1:100))
#' data.points$y <- sin(start(data.points)/2)
#' kp <- plotKaryotype(zoom=toGRanges("chr1:1-100"))
#' kpLines(kp, data.points, r0=0, r1=0.5, ymin=-1, ymax=1)
#' kpAbline(kp, h=c(-1,0,1), col="#AAAAAA", r0=0, r1=0.5, ymin=-1, ymax=1)
#' kpAxis(kp, r0=0, r1=0.5, ymin=-1, ymax=1)
#' kpPlotHorizon(kp, data.points, r0=0.55, r1=1)
#'
#'
#' set.seed(1000)
#' data.points <- sort(createRandomRegions(nregions=500, mask=NA))
#' mcols(data.points) <- data.frame(y=runif(500, min=-3, max=3))
#' 
#' kp <- plotKaryotype(chromosomes=c("chr1", "chr2"))
#' kpPlotHorizon(kp, data=data.points)
#'
#' kp <- plotKaryotype(chromosomes=c("chr1", "chr2"))
#' kpPlotHorizon(kp, data=data.points, num.parts=1, r0=autotrack(1, 6)$r0, r1=autotrack(1, 6)$r1)
#' kpPlotHorizon(kp, data=data.points, num.parts=2, r0=autotrack(2, 6)$r0, r1=autotrack(2, 6)$r1)
#' kpPlotHorizon(kp, data=data.points, num.parts=3, r0=autotrack(3, 6)$r0, r1=autotrack(3, 6)$r1)
#' kpPlotHorizon(kp, data=data.points, num.parts=5, r0=autotrack(4, 6)$r0, r1=autotrack(4, 6)$r1)
#' kpPlotHorizon(kp, data=data.points, num.parts=9, r0=autotrack(5, 6)$r0, r1=autotrack(5, 6)$r1)
#' kpPlotHorizon(kp, data=data.points, num.parts=15, r0=autotrack(6, 6)$r0, r1=autotrack(6, 6)$r1)
#' kpLines(kp, data=data.points, ymin=-3, ymax=3)
#' kpAbline(kp, h=0, ymin=-3, ymax=3)
#'  
#' kp <- plotKaryotype(chromosomes=c("chr1", "chr2"))
#' kpPlotHorizon(kp, data=data.points, num.parts=4, r0=autotrack(1, 6)$r0, r1=autotrack(1, 6)$r1)
#' kpPlotHorizon(kp, data=data.points, col="redblue6", num.parts=4, r0=autotrack(2, 6)$r0, r1=autotrack(2, 6)$r1)
#' kpPlotHorizon(kp, data=data.points, col="bluepurple10", num.parts=4, r0=autotrack(3, 6)$r0, r1=autotrack(3, 6)$r1)
#' kpPlotHorizon(kp, data=data.points, col="bluegold3", num.parts=4, r0=autotrack(4, 6)$r0, r1=autotrack(4, 6)$r1)
#' kpPlotHorizon(kp, data=data.points, col=c("red", "black", "green"), num.parts=4, r0=autotrack(5, 6)$r0, r1=autotrack(5, 6)$r1)
#' kpPlotHorizon(kp, data=data.points, col=c("red", "yellow"), num.parts=4, r0=autotrack(6, 6)$r0, r1=autotrack(6, 6)$r1)
#' 
#'
#' @export kpPlotHorizon
#' 


#QUESTION: How should axis and kpHorizon relate? Should we return the values in latest plot and help creating a legend for it? with no axis?

kpPlotHorizon <- function(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, num.parts=3, breaks=NULL, ymin=NULL, ymax=NULL,
                    data.panel=1, r0=0, r1=1, col="redblue6", border=NA, clipping=TRUE, ...) {
  #Check parameters
  if(!methods::is(karyoplot, "KaryoPlot")) stop(paste0("In kpPlotHorizon: 'karyoplot' must be a valid 'KaryoPlot' object"))
  
  #Preprocess the r's (needed to manipulate the later)
  rs <- preprocess_r0_r1(karyoplot = karyoplot, r0=r0, r1=r1, data.panel=data.panel)
  
  
  #Normalize the parameters
  pp <- prepareParameters2("kpPlotHorizon", karyoplot=karyoplot, data=data, chr=chr, x=x, y=y, 
                           ymin=0, ymax=1, r0=0, r1=1, data.panel=data.panel, ...)
  #And build a GRanges with the normalized data for easier management later on
  data <- toGRanges(pp$chr, pp$x, pp$x, y=pp$y)
  
  #Define undefined parameters
    #ymin and ymax
    if(is.null(ymin)) {
      ymin <- min(0, min(data$y))
    }
    if(is.null(ymax)) {
      ymax <- max(0, max(data$y))
    }
  
    #breaks: The y values to break the positive and gnegative curves
    if(is.null(breaks)) {
      if(is.null(num.parts)) stop("In kpPlotHorizon: If breaks is NULL, num.parts cannot be NULL")
      if(!is.numeric(num.parts) || (round(num.parts)!=num.parts) || num.parts<1) stop("In kpPlotHorizon: If breaks is NULL, num.parts must be a positive integer")
      breaks <- list(pos=seq_len(num.parts-1)*ymax/num.parts,
                     neg=seq_len(num.parts-1)*ymin/num.parts)
    } else {
      if(!is.list(breaks) || !setequal(names(breaks), c("pos", "neg")) || !all(lapply(breaks, methods::is, "numeric"))) {
        #If it's a numeric vector, arrange it into a valid list separating positive and negative values
        if(length(breaks)==0 || (length(breaks)>0 && all(is.numeric(breaks)))) {
          breaks <- list(pos=sort(unique(breaks[breaks>0])), neg=sort(unique(breaks[breaks<0])))
        } else {
          stop("In kpPlotHorizon: breaks must be either NULL, a numeric vector or a list with two numeric vectors called 'pos' and 'neg'")
        }
      }
    }
  

  #Find the intersections of the data lines with the breaks and 0 and 
  #inject them into the data
  data <- sort(data)
  for(thr in c(breaks$neg, 0, breaks$pos)) {
    isecs <- findIntersections(data, thr)
    data <- sort(c(data, isecs)) #It's important to keep data sorted since findIntersections assumes it is sorted
  }
  
  if(is.list(col) && c("pos", "neg" %in% names(col))) {
    if(all(is.color(col$neg)) && all(is.color(col$pos))) {
      colors <- col
    } else {
      stop("in kpPlotHorizon: col$neg and col$pos must be valid colors. ")
    }
  } else {
    colors <- horizonColors(col, max(length(breaks$pos), length(breaks$neg))+1) #num.parts)
  }
  
  #Iterate through the pos/neg regions
  for(posneg in c("pos", "neg")) {
    cols <- colors[[posneg]]
    for(nbreak in seq_len(length(breaks[[posneg]])+1)) {
      thr.1 <- c(0, breaks[[posneg]])[nbreak]
      thr.2 <- c(breaks[[posneg]], ifelse(posneg=="pos", ymax, ymin))[nbreak]
      
      d <- data
      if(posneg=="pos") {
        d$y[d$y>thr.2] <- thr.2
        d$y[d$y<thr.1] <- thr.1
        kpArea(karyoplot, d, ymin = thr.1, ymax=thr.2, col = cols[nbreak], border=border, base.y = thr.1, r0=rs$r0, r1=rs$r1)
      } else {
        d$y[d$y>thr.1] <- thr.1
        d$y[d$y<thr.2] <- thr.2
        kpArea(karyoplot, d, ymin = thr.2, ymax=thr.1, col = cols[nbreak], border=border, base.y = thr.1, r0=rs$r1, r1=rs$r0)
      }
    }
  }
  
 
  karyoplot$latest.plot <- list(funct="kpPlotHorizon", 
                                computed.values=list(breaks=breaks, 
                                                     colors=colors
                                                     )
  )
  
 
  invisible(karyoplot)
}

#' kpAddCytobands
#' 
#' @description 
#' 
#' Plots the chromosome cytobands in a karyoplot
#' 
#' @details 
#' 
#' Plots the cytobands representing the chromosome structure in a karyoplot. It extracts the 
#' cytobands from the \code{karyoplot} object it recieves as a parameter. It is possible to 
#' specify the colors used to plot the cytobands. 
#' 
#' @note In general, this function is automatically called by plotKaryotype
#' and the user never nees to call it. 
#' 
#' @usage kpAddCytobands(karyoplot, color.table=NULL, color.schema=c("circos", "biovizbase", "only.centromeres"), clipping=TRUE, ...)
#' 
#' @param karyoplot    a \code{karyoplot} object returned by a call to \code{plotKaryotype}
#' @param color.table  (named character vector) a table specifying the colors to plot the cytobands. If NULL, it gets the colors calling \code{getCytobandColors}. (defaults to NULL)
#' @param color.schema  (character) The name of the color schema to use: \code{circos}, \code{biovizBase}, \code{only.centromeres} (everything in gray, except for centromeres in red). (defaults to \code{circos})
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, cytoband representation will be not drawn out of the drawing are (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the cytobands representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param ...  any additional parameter to be passed to the functions called from kpAddCytobands.
#' 
#' @return
#' invisibly returns the given karyoplot object
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{getCytobandColors}}, \code{\link{kpAddBaseNumbers}}, \code{\link{kpAddCytobandLabels}}
#' 
#' @examples
#'
#' 
#' kp <- plotKaryotype(ideogram.plotter = NULL)
#' kpAddCytobands(kp)
#'  
#' @export kpAddCytobands
#' 



kpAddCytobands <- function(karyoplot, color.table=NULL, color.schema=c("circos", "biovizbase", "only.centromeres"), clipping=TRUE, ...) {
  
  #karyoplot
  if(missing(karyoplot)) stop("The parameter 'karyoplot' is required")
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  
  #If there are no cytobands, create a single "fake" cytoband to represent the whole chromosome
  if(!is.null(karyoplot$cytobands) && length(karyoplot$cytobands)>0) { 
    cyto <- karyoplot$cytobands  
  } else {
    cyto <- karyoplot$genome
    mcols(cyto) <- data.frame(name=seqnames(cyto), gieStain="gpos50", stringsAsFactors=FALSE)  
  }
  
  if(!methods::is(cyto, "GRanges")) stop("'cytobands' must be a GRanges object")
  
  
  #IDEA: Should we add the possibility of having a "color" column specifying 
  #the color of each cytoband? If present, it would take precendence over 
  #"gieStain". Maybe we could also add a separate parameter to specify the 
  #column name of the "gieStain" or color info... but That would grow the 
  #function quite a lot.
  #If the cytobands object does not have the "gieStain" attribute, 
  if(!("gieStain" %in% colnames(mcols(cyto)))) {
    warning("No 'gieStain' column found in cytobands. Using 'gpos50' (gray) for all of them")
    mcols(cyto) <- cbind(mcols(cyto), gieStain="gpos50")
  }
  
  #filter out the cytobands out of our chromosomes
  cyto <- filterChromosomes(cyto, keep.chr = karyoplot$chromosomes)
  
  
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  
  ccf <- karyoplot$coord.change.function
  pp <- karyoplot$plot.params
  mids <- karyoplot$ideogram.mid
    
  #extract the color.schema if it was passed in the dots
  color.table <- getCytobandColors(color.table=color.table, color.schema = color.schema)
  border <- ifelse("border" %in% names(color.table), color.table["border"], "black")
 
  #And plot them
  ybottom <- mids(as.character(seqnames(cyto))) - pp$ideogramheight/2
  ytop <- mids(as.character(seqnames(cyto))) + pp$ideogramheight/2
    
  xleft <- ccf(x=start(cyto), chr=as.character(seqnames(cyto)), data.panel="ideogram")$x
  xright <- ccf(x=end(cyto), chr=as.character(seqnames(cyto)), data.panel="ideogram")$x
    
  #col <- do.call(c, color.table[cyto$gieStain])
  col <- color.table[as.character(cyto$gieStain)]
  
  if(karyoplot$zoom==TRUE) {
    if(clipping==TRUE) {
      #get the plot coordinates of the cytobands drawing area
      clip.xleft <- ccf(x=start(karyoplot$plot.region), chr=as.character(seqnames(karyoplot$plot.region)), data.panel="ideogram")$x
      clip.xright <- ccf(x=end(karyoplot$plot.region), chr=as.character(seqnames(karyoplot$plot.region)), data.panel="ideogram")$x
      clip.ybottom <- ybottom - 10 #add a small margin to allow for the width of the lines
      clip.ytop <- ytop + 10
      graphics::clip(x1 = clip.xleft, x2 = clip.xright, y1 = clip.ybottom, y2=clip.ytop)
    }
  }
  graphics::rect(xleft=xleft, xright=xright, ybottom=ybottom, ytop=ytop, col=col, border=border, ...)      

  
  invisible(karyoplot)
}

############  Text related functions for karyoploteR   ###############


#change NA's to "" in a char vector
naToEmptyChar <- function(x) {
  x[is.na(x)] <- ""
  return(x)
}




#' getTextSize
#' 
#' @description 
#' Returns the size of character strings in bases and r's
#' 
#' @details 
#' Small utility function to get the size of text labels in usable units for
#' karyoploteR: bases for the width and r's for the height. The r units are the
#' ones passed to r0 and r1 and take into account that a data panel has always
#' total height of 1 r (from r0=0 to r1=1)
#' 
#' @usage getTextSize(karyoplot, labels, cex=1, data.panel="1")
#' @param karyoplot (KaryoPlot) A KaryoPlot object representing the current plot
#' @param labels  (character) The character strings to measure
#' @param cex (numeric) The cex value used to plot the text (defaults to 1)
#' @param data.panel (data panel identifier) The name of the data panel on which text was plotted. (defaults to "1")
#'
#' @return
#' Returns a list with two elements: width and height. Each of them is a numeric
#' vector of the same length as "labels" with the width in bases of each label
#' and the height in r units of each label.
#' 
#' @examples
#' 
#' pp <- getDefaultPlotParams(plot.type=2)
#' pp$data2height <- 50
#' 
#' kp <- plotKaryotype(chromosomes="chr1", plot.type=2, plot.params=pp)
#'  
#' label <- "Looooooong label"
#' kpText(kp, chr="chr1", x=70e6, y=0.5, labels=label)
#' text.size <- getTextSize(kp, labels=label)
#' kpRect(kp, chr="chr1", x0=70e6-text.size$width/2, x1=70e6+text.size$width/2,
#'            y0=0.5-text.size$height/2, y1=0.5+text.size$height/2)
#'  
#' label <- "SHORT"
#' text.size <- getTextSize(kp, labels=label, cex=3)
#' kpRect(kp, chr="chr1", x0=170e6-text.size$width/2, x1=170e6+text.size$width/2,
#'            y0=0.2-text.size$height/2, y1=0.2+text.size$height/2, col="gold")
#' kpText(kp, chr="chr1", x=170e6, y=0.2, labels=label, cex=3)
#'     
#' label <- c("two_labels", "in a small data.panel=2")
#' kpText(kp, chr="chr1", x=c(100e6, 170e6), y=c(0.4, 0.2), labels=label, cex=0.6, data.panel=2)
#' text.size <- getTextSize(kp, labels=label, cex=0.6, data.panel=2)
#' kpRect(kp, chr="chr1", x0=c(100e6, 170e6)-text.size$width/2, x1=c(100e6, 170e6)+text.size$width/2,
#'            y0=c(0.4, 0.2)-text.size$height/2, y1=c(0.4, 0.2)+text.size$height/2, data.panel=2)
#' 
#'     
#' @export getTextSize
#'


getTextSize <- function(karyoplot, labels, cex=1, data.panel="1") {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  
  if(length(labels)==0) return(NULL)
  if(!all(is.character(labels))) stop("'labels' must be a one or more character strings")
     
  #Compute the widths
    plot.width <- 1 - karyoplot$plot.params$leftmargin - karyoplot$plot.params$rightmargin - length(karyoplot$plot.region)*karyoplot$plot.params$ideogramlateralmargin
    plot.bases <- sum(width(karyoplot$plot.region))
    sw <- graphics::strwidth(s = labels, cex=cex, units = "figure")
    
    sw.in.bases <- (plot.bases/plot.width)*sw
  
  #Compute the heights
    plot.height <- karyoplot$plot.params[[paste0("data", data.panel, "height")]]/karyoplot$plot$ymax #Portion of the total height dedicated to the selected data.panel
    plot.runits <- 1  #tot r units of the data.panel (it's 1 by definition)
    sh <- graphics::strheight(s=labels, cex=cex, units = "figure")
  
    sh.in.runits <- (plot.runits/plot.height)*sh
    
  return(list(width=sw.in.bases, height=sh.in.runits))
}

#' kpPolygon
#' 
#' @description 
#' 
#' Plots the the given polygons along the genome
#' 
#' @details 
#'  
#' This is one of the functions from karyoploteR implementing the adaptation to the genome context 
#' of basic plot functions from R base graphics. 
#' Given a set of positions on the genome (chromosome, base and y), it plots the polygons 
#' defined by taking these position as vertices. 
#' Data can be provided via a \code{GRanges} object (\code{data}), independent
#' parameters for chr, x and y or a combination of both. A number of parameters can be used 
#' to define exactly where and how the polygon is drawn. In addition, via the ellipsis operator 
#' (\code{...}), \code{kpPolygon} accepts any parameter valid for \code{polygon} 
#' (e.g. \code{border}, \code{density}, \code{fillOddEven}, ...)
#'
#' @usage kpPolygon(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, ...) 
#' 
#' @inheritParams kpPoints
#' 
#' @return
#' 
#' Returns the original karyoplot object, unchanged. 
#'  
#'  
#' @note IMPORTANT: \code{kpPolygon} allows the creation of polygons 
#' encompassing multilple chromosomes. In some cases, when plotting only some
#' of the chromosomes or when zooming, the default data filtering automatically 
#' discards some points before plotting, altering the polygon shape. See example
#' below.
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpLines}}, \code{\link{kpPoints}}
#' @seealso \code{\link{kpPlotRegions}}
#' 
#' @examples
#'  
#' set.seed(1000)
#' x <- c(1,2,5,9,13,20,15,11,7,3)*10000000
#' y <- c(0,1,0.8,0.2,0.5,0.2,1,0.3,0.1,0.2)
#' 
#' kp <- plotKaryotype("hg19", plot.type=2, chromosomes=c("chr1", "chr2"))
#'   kpDataBackground(kp, data.panel=1)
#'   kpDataBackground(kp, data.panel=2)
#' 
#'   kpPolygon(kp, chr="chr1", x=x, y=y, col="red")
#'   kpPolygon(kp, chr="chr1", x=x, y=y, col="orange", r0=0.2, r1=0.8, density=30)

#'   #use kpPolygon to draw triangles at the specified positions
#'   chr2.x <- c(1,3,7,26,48,79,120, 124, 128)*1000000
#'   for(x in chr2.x) {
#'     kpPolygon(kp, chr="chr2", x=c(x-2000000, x+2000000, x), y=c(1,1,0), r0=0, r1=0.3, col="lightblue")
#'   }
#'   
#'   
#' #Effect of data filtering
#'   
#' dp <- toGRanges(data.frame(rep(paste0("chr", (1:2)), 3), 10e6*1:6, 10e6*1:6+5e5, y=c(0,0,1,1,0,0)))
#' kp <- plotKaryotype(chromosomes=c("chr1", "chr2"))
#' kpPolygon(kp, dp)
#' 
#' kp <- plotKaryotype(chromosomes=c("chr2"))
#' kpPolygon(kp, dp)
#' 
#'  
#' @export kpPolygon
#' 


kpPolygon <- function(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, ymin=NULL, ymax=NULL,
                      data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, ...) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  pp <- prepareParameters2("kpPolygon", karyoplot=karyoplot, data=data, chr=chr, x=x, y=y,
                           ymin=ymin, ymax=ymax, r0=r0, r1=r1, data.panel=data.panel, ...)
  ccf <- karyoplot$coord.change.function
    
  xplot <- ccf(chr=pp$chr, x=pp$x, data.panel=data.panel)$x
  yplot <- ccf(chr=pp$chr, y=pp$y, data.panel=data.panel)$y
  
  processClipping(karyoplot=karyoplot, clipping=clipping, data.panel=data.panel)  
  
  graphics::polygon(x=xplot, y=yplot, ...)
  
  invisible(karyoplot)
}

#' plotDefaultPlotParameters
#' 
#' @description 
#' 
#' Creates a karyoplot with the default parameters drawn.
#' 
#' @details 
#'  
#'  Given a plot.type, this function creates a new karyoplot with lines and arrows showing 
#'  the meaning and values of the plot.params
#'  
#' @usage plotDefaultPlotParams(plot.type=2, plot.params=NULL, ...)
#' 
#' @param plot.type (numeric) plot the params of this plot type. Currently, only plot types 2 and 3 are accepted. (defaults to 2)
#' @param plot.params (a plot params object) a plot params object such the one returned by \code{\link{getDefaultPlotParams}}. If specified, it will be used to create the plots.
#' @param ... The ellipsis operator can be used to pass any additional graphics parameter
#' 
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#'    
#' @seealso \code{\link{plotKaryotype}}
#' 
#' 
#' @examples
#' 
#' kp <- plotDefaultPlotParams(plot.type=2)
#'
#'  
#' @export plotDefaultPlotParams
#' 


plotDefaultPlotParams <- function(plot.type=2, plot.params=NULL,  ...) {
  
  #TODO: Implement plot for 4
  
  valid.plot.types <- c(1,2,3,5) #c(1:4)
  
  if(!plot.type %in% valid.plot.types) {
    stop(paste0("plot.type is not valid. Select a valid value: ", paste0(valid.plot.types, collapse=", ")))
  }
  
  annotateDataPanel <- function(dp, pp, ...) {
    dp.mid = (pp[[paste0("data", dp, "max")]] - pp[[paste0("data", dp, "min")]])/2
    dp.03 = (pp[[paste0("data", dp, "max")]] - pp[[paste0("data", dp, "min")]])*0.3
    kpDataBackground(kp, data.panel=dp, ...)
    kpText(kp, chr=c("chr21", "chr22"), x=chrlen/2, y=dp.mid, labels = paste0("data.panel=", dp), data.panel=dp, ...)
    
    kpSegments(kp, chr=c("chr21", "chr22"), x0=chrlen/10, x1=(chrlen/10)*1.2, y0=pp[[paste0("data", dp, "max")]], y1=pp[[paste0("data", dp, "max")]], data.panel=dp, ...)  
    kpText(kp, chr=c("chr21", "chr22"), x=(chrlen/10)*1.25, y=pp[[paste0("data", dp, "max")]], labels=paste0("data", dp, "max=", pp[[paste0("data", dp, "max")]]), data.panel=dp, pos=4, ...)  
    
    kpSegments(kp, chr=c("chr21", "chr22"), x0=chrlen/10, x1=(chrlen/10)*1.2, y0=pp[[paste0("data", dp, "min")]], y1=pp[[paste0("data", dp, "min")]], data.panel=dp, ...)  
    kpText(kp, chr=c("chr21", "chr22"), x=(chrlen/10)*1.25, y=pp[[paste0("data", dp, "min")]], labels=paste0("data", dp, "min=", pp[[paste0("data", dp, "min")]]), data.panel=dp, pos=4, ...)  
    
    kpArrows(kp, chr=c("chr21", "chr22"), x0=chrlen/10*8, x1=chrlen/10*8, y0=pp[[paste0("data", dp, "min")]], y1=pp[[paste0("data", dp, "max")]], data.panel=dp, code=3, length=0.07, ...)  
    kpText(kp, chr=c("chr21", "chr22"), x=(chrlen/10)*7.95, y=dp.03, labels=paste0("data", dp, "height=", pp[[paste0("data", dp, "height")]]), data.panel=dp, pos=2, ...)  
  }
  
  
  #TODO Implement the plot params for the other plot.types
  if(plot.type == 1) { #Horizontal. Data above the ideogram
    if(is.null(plot.params)) {
      plot.params <- getDefaultPlotParams(plot.type=plot.type)
    } 
    
    kp <- plotKaryotype(genome="hg19", chromosomes=c("chr21", "chr22"), plot.type=plot.type, plot.params = plot.params, ...)
    pp <- kp$plot.params
    
    chrlen <- end(kp$genome[1])
    
    
    annotateDataPanel(1, pp, ...)
    
    #mainmargins
    kp$beginKpPlot()
    graphics::abline(h=c(kp$plot.params$bottommargin, kp$plot.params$bottommargin + kp$chromosome.height, kp$plot.params$bottommargin + 2*kp$chromosome.height), ...)
    marg.x <- kp$plot$xmax /10 * 8
    graphics::arrows(x0 = marg.x, x1=marg.x, y0=0, y1=kp$plot.params$bottommargin, code=3, length=0.07, ...)
    graphics::text(x=marg.x, y=kp$plot.params$bottommargin/2,labels=paste0("bottommargin=", kp$plot.param$bottommargin), pos=2, ...)
    
    graphics::arrows(x0 = marg.x, x1=marg.x, y0=kp$plot$ymax, y1=kp$plot$ymax - kp$plot.params$topmargin, code=3, length=0.07, ...)
    graphics::text(x=marg.x, y=kp$plot$ymax - kp$plot.params$topmargin/2, labels=paste0("topmargin=", kp$plot.param$topmargin), pos=2, ...)
    
    #chromosome height
    ch.x <- kp$plot$xmax /10 * 9.2
    graphics::arrows(x0 = ch.x, x1=ch.x, y0=kp$plot.params$bottommargin + kp$chromosome.height, y1=kp$plot.params$bottommargin + 2*kp$chromosome.height, code=3, length=0.07, ...)
    graphics::text(x=ch.x, y=kp$plot.params$bottommargin + 1.5*kp$chromosome.height, labels=paste0("chromosome.height (computed)=", kp$chromosome.height), pos=2, ...)
    
    graphics::abline(v=c(kp$plot.params$leftmargin, kp$plot$xmax-kp$plot.params$rightmargin), lty=2, ...)
    marg.y <- kp$plot$ymax /10 * 8.5
    graphics::arrows(x0 = 0, x1=kp$plot.params$leftmargin, y0=marg.y, y1=marg.y, code=3, length=0.07, ...)
    graphics::text(x=kp$plot.params$leftmargin/2, y=marg.y, labels=paste0("leftmargin=", kp$plot.params$leftmargin), pos=3, ...)
    
    graphics::arrows(x0 = kp$plot$xmax - kp$plot.params$rightmargin, x1=kp$plot$xmax, y0=marg.y, y1=marg.y, code=3, length=0.07, ...)
    graphics::text(x= kp$plot$xmax - kp$plot.params$rightmargin/2, y=marg.y, labels=paste0("rightmargin=", kp$plot.params$rightmargin), pos=3, ...)
    
    ideoh.x <- kp$plot$xmax /10 * 5.5
    graphics::arrows(x0 = ideoh.x, x1=ideoh.x, y0=kp$ideogram.mid("chr21") - pp$ideogramheight/2, y1=kp$ideogram.mid("chr21") + pp$ideogramheight/2, code=3, length=0.07, ...)
    graphics::text(x= ideoh.x, y=kp$ideogram.mid("chr21"), labels=paste0("ideogramheight=", pp$ideogramheight), pos=4, ...)
    
    #in and out margins
    ideom.x <- kp$plot$xmax /10 * 7.2
    graphics::arrows(x0 = ideom.x, x1=ideom.x, y0=kp$ideogram.mid("chr21") + pp$ideogramheight/2 + pp$data1inmargin, y1=kp$ideogram.mid("chr21") + pp$ideogramheight/2, code=3, length=0.07, ...)
    graphics::text(x= ideom.x, y=kp$ideogram.mid("chr21") + pp$ideogramheight/2 + pp$data1inmargin/2, labels=paste0("data1inmargin=", pp$data1inmargin), pos=4, ...)

    outm.x <- kp$plot$xmax /10 * 7
    outm.y0 <- kp$ideogram.mid("chr21") + pp$ideogramheight/2 + pp$data1inmargin + pp$data1height
    outm.y1 <- outm.y0 + pp$data1outmargin
    if(pp$data1outmargin!=0) graphics::arrows(x0 = outm.x, x1=outm.x, y0=outm.y0, y1=outm.y1, code=3, length=0.07, ...)
    graphics::text(x= outm.x, y=mean(outm.y0, outm.y1), labels=paste0("data1outmargin=", pp$data1outmargin), pos=2, ...)

    kp$endKpPlot()
    
  } 
  if(plot.type == 2) { #Horizontal. Data above and below the ideogram
    
    if(is.null(plot.params)) {
      plot.params <- getDefaultPlotParams(plot.type=2)
    } 
    
    kp <- plotKaryotype(genome="hg19", chromosomes=c("chr21", "chr22"), plot.type=plot.type, plot.params = plot.params, ...)
    pp <- kp$plot.params
    
    chrlen <- end(kp$genome[1])
    
   
    annotateDataPanel(1, pp, ...)
    annotateDataPanel(2, pp, ...)
    
    
    #outmargins
    kp$beginKpPlot()
      graphics::abline(h=c(kp$plot.params$bottommargin, kp$plot.params$bottommargin + kp$chromosome.height, kp$plot.params$bottommargin + 2*kp$chromosome.height), ...)
      marg.x <- kp$plot$xmax /10 * 8
      graphics::arrows(x0 = marg.x, x1=marg.x, y0=0, y1=kp$plot.params$bottommargin, code=3, length=0.07, ...)
      graphics::text(x=marg.x, y=kp$plot.params$bottommargin/2,labels=paste0("bottommargin=", kp$plot.param$bottommargin), pos=2, ...)
      
      graphics::arrows(x0 = marg.x, x1=marg.x, y0=kp$plot$ymax, y1=kp$plot$ymax - kp$plot.params$topmargin, code=3, length=0.07, ...)
      graphics::text(x=marg.x, y=kp$plot$ymax - kp$plot.params$topmargin/2, labels=paste0("topmargin=", kp$plot.param$topmargin), pos=2, ...)
      
      ch.x <- kp$plot$xmax /10 * 9.2
      graphics::arrows(x0 = ch.x, x1=ch.x, y0=kp$plot.params$bottommargin + kp$chromosome.height, y1=kp$plot.params$bottommargin + 2*kp$chromosome.height, code=3, length=0.07, ...)
      graphics::text(x=ch.x, y=kp$plot.params$bottommargin + 1.5*kp$chromosome.height, labels=paste0("chromosome.height (computed)=", kp$chromosome.height), pos=2, ...)
      
      graphics::abline(v=c(kp$plot.params$leftmargin, kp$plot$xmax-kp$plot.params$rightmargin), lty=2, ...)
      marg.y <- kp$plot$ymax /10 * 8.5
      graphics::arrows(x0 = 0, x1=kp$plot.params$leftmargin, y0=marg.y, y1=marg.y, code=3, length=0.07, ...)
      graphics::text(x=kp$plot.params$leftmargin/2, y=marg.y, labels=paste0("leftmargin=", kp$plot.params$leftmargin), pos=3, ...)
      
      graphics::arrows(x0 = kp$plot$xmax - kp$plot.params$rightmargin, x1=kp$plot$xmax, y0=marg.y, y1=marg.y, code=3, length=0.07, ...)
      graphics::text(x= kp$plot$xmax - kp$plot.params$rightmargin/2, y=marg.y, labels=paste0("rightmargin=", kp$plot.params$rightmargin), pos=3, ...)
      
      ideoh.x <- kp$plot$xmax /10 * 5.5
      graphics::arrows(x0 = ideoh.x, x1=ideoh.x, y0=kp$ideogram.mid("chr21") - pp$ideogramheight/2, y1=kp$ideogram.mid("chr21") + pp$ideogramheight/2, code=3, length=0.07, ...)
      graphics::text(x= ideoh.x, y=kp$ideogram.mid("chr21"), labels=paste0("ideogramheight=", pp$ideogramheight), pos=4, ...)
      
      #in margins
      ideom.x <- kp$plot$xmax /10 * 7.2
      graphics::arrows(x0 = ideom.x, x1=ideom.x, y0=kp$ideogram.mid("chr21") - pp$ideogramheight/2 - pp$data2inmargin, y1=kp$ideogram.mid("chr21") - pp$ideogramheight/2, code=3, length=0.07, ...)
      graphics::text(x= ideom.x, y=kp$ideogram.mid("chr21") - pp$ideogramheight/2 - pp$data2inmargin/2, labels=paste0("data2inmargin=", pp$data2inmargin), pos=4, ...)
      
      graphics::arrows(x0 = ideom.x, x1=ideom.x, y0=kp$ideogram.mid("chr21") + pp$ideogramheight/2 + pp$data1inmargin, y1=kp$ideogram.mid("chr21") + pp$ideogramheight/2, code=3, length=0.07, ...)
      graphics::text(x= ideom.x, y=kp$ideogram.mid("chr21") + pp$ideogramheight/2 + pp$data1inmargin/2, labels=paste0("data1inmargin=", pp$data1inmargin), pos=4, ...)
      
      outm.x <- kp$plot$xmax /10 * 7
      outm.y0 <- kp$ideogram.mid("chr21") + pp$ideogramheight/2 + pp$data1inmargin + pp$data1height
      outm.y1 <- outm.y0 + pp$data1outmargin
      if(pp$data1outmargin!=0) graphics::arrows(x0 = outm.x, x1=outm.x, y0=outm.y0, y1=outm.y1, code=3, length=0.07, ...)
      graphics::text(x= outm.x, y=mean(outm.y0, outm.y1), labels=paste0("data1outmargin=", pp$data1outmargin), pos=2, ...)
      
      outm.x <- kp$plot$xmax /10 * 7
      outm.y0 <- kp$ideogram.mid("chr21") - pp$ideogramheight/2 - pp$data2inmargin - pp$data2height
      outm.y1 <- ifelse(pp$data2outmargin!=0, outm.y0 - pp$data2outmargin, outm.y0 - pp$data2outmargin - 0.001)
      if(pp$data2outmargin!=0) graphics::arrows(x0 = outm.x, x1=outm.x, y0=outm.y0, y1=outm.y1, code=3, length=0.07, ...)
      graphics::text(x= outm.x, y=mean(outm.y0, outm.y1), labels=paste0("data2outmargin=", pp$data2outmargin), pos=2, ...)
      
      
      
      
      kp$endKpPlot()
        
  } 
  
  if(plot.type == 3) { #Horizontal in a single line. Data above and below the ideogram
    
    if(is.null(plot.params)) {
      plot.params <- getDefaultPlotParams(plot.type=3)
      #plot.params$ideogramlateralmargin=0.01
    } 
    
    kp <- plotKaryotype(genome="hg19", chromosomes=c("chr21", "chr22"), plot.type=plot.type, plot.params = plot.params, ...)
    pp <- kp$plot.params

    chrlen <- end(kp$genome[1])
    
    annotateDataPanel(1, pp, ...)
    annotateDataPanel(2, pp, ...)
    
    #outmargins
    kp$beginKpPlot()
    graphics::abline(h=c(kp$plot.params$bottommargin, kp$plot.params$bottommargin + kp$chromosome.height, kp$plot.params$bottommargin + 2*kp$chromosome.height), ...)
    marg.x <- kp$plot$xmax /10 * 8
    graphics::arrows(x0 = marg.x, x1=marg.x, y0=0, y1=kp$plot.params$bottommargin, code=3, length=0.07, ...)
    graphics::text(x=marg.x, y=kp$plot.params$bottommargin/2,labels=paste0("bottommargin=", kp$plot.param$bottommargin), pos=2, ...)
    
    graphics::arrows(x0 = marg.x, x1=marg.x, y0=kp$plot$ymax, y1=kp$plot$ymax - kp$plot.params$topmargin, code=3, length=0.07, ...)
    graphics::text(x=marg.x, y=kp$plot$ymax - kp$plot.params$topmargin/2, labels=paste0("topmargin=", kp$plot.param$topmargin), pos=2, ...)
    
    ch.x <- kp$plot$xmax /10 * 9.2
    graphics::arrows(x0 = ch.x, x1=ch.x, y0=kp$plot.params$bottommargin, y1=kp$plot.params$bottommargin + 1*kp$chromosome.height, code=3, length=0.07, ...)
    graphics::text(x=ch.x, y=kp$plot.params$bottommargin + 0.7*kp$chromosome.height, labels=paste0("chromosome.height (computed)=", kp$chromosome.height), pos=2, ...)
    
    graphics::abline(v=c(kp$plot.params$leftmargin, kp$plot$xmax-kp$plot.params$rightmargin), lty=2, ...)
    marg.y <- kp$plot$ymax /10 * 8.5
    graphics::arrows(x0 = 0, x1=kp$plot.params$leftmargin, y0=marg.y, y1=marg.y, code=3, length=0.07, ...)
    graphics::text(x=kp$plot.params$leftmargin/2, y=marg.y, labels=paste0("leftmargin=", kp$plot.params$leftmargin), pos=3, ...)
    
    graphics::arrows(x0 = kp$plot$xmax - kp$plot.params$rightmargin, x1=kp$plot$xmax, y0=marg.y, y1=marg.y, code=3, length=0.07, ...)
    graphics::text(x= kp$plot$xmax - kp$plot.params$rightmargin/2, y=marg.y, labels=paste0("rightmargin=", kp$plot.params$rightmargin), pos=3, ...)
    
    #ideogram
    ideoh.x <- kp$plot$xmax /10 * 5.5
    graphics::arrows(x0 = ideoh.x, x1=ideoh.x, y0=kp$ideogram.mid("chr21") - pp$ideogramheight/2, y1=kp$ideogram.mid("chr21") + pp$ideogramheight/2, code=3, length=0.07, ...)
    graphics::text(x= ideoh.x, y=kp$ideogram.mid("chr21"), labels=paste0("ideogramheight=", pp$ideogramheight), pos=4, ...)
    
    #in margins
    ideom.x <- kp$plot$xmax /10 * 7.2
    graphics::arrows(x0 = ideom.x, x1=ideom.x, y0=kp$ideogram.mid("chr21") - pp$ideogramheight/2 - pp$data2inmargin, y1=kp$ideogram.mid("chr21") - pp$ideogramheight/2, code=3, length=0.07, ...)
    graphics::text(x= ideom.x, y=kp$ideogram.mid("chr21") - pp$ideogramheight/2 - pp$data2inmargin/2, labels=paste0("data2inmargin=", pp$data2inmargin), pos=4, ...)
    
    graphics::arrows(x0 = ideom.x, x1=ideom.x, y0=kp$ideogram.mid("chr21") + pp$ideogramheight/2 + pp$data1inmargin, y1=kp$ideogram.mid("chr21") + pp$ideogramheight/2, code=3, length=0.07, ...)
    graphics::text(x= ideom.x, y=kp$ideogram.mid("chr21") + pp$ideogramheight/2 + pp$data1inmargin/2, labels=paste0("data1inmargin=", pp$data1inmargin), pos=4, ...)
    
    outm.x <- kp$plot$xmax /10 * 7
    outm.y0 <- kp$ideogram.mid("chr21") + pp$ideogramheight/2 + pp$data1inmargin + pp$data1height
    outm.y1 <- ifelse(pp$data1outmargin!=0, outm.y0 + pp$data1outmargin, outm.y0 + pp$data1outmargin + 0.001)
    if(pp$data1outmargin!=0) graphics::arrows(x0 = outm.x, x1=outm.x, y0=outm.y0, y1=outm.y1, code=3, length=0.07, ...)
    graphics::text(x= outm.x, y=mean(outm.y0, outm.y1), labels=paste0("data1outmargin=", pp$data1outmargin), pos=2, ...)
    
    outm.x <- kp$plot$xmax /10 * 7
    outm.y0 <- kp$ideogram.mid("chr21") - pp$ideogramheight/2 - pp$data2inmargin - pp$data2height
    outm.y1 <- ifelse(pp$data2outmargin!=0, outm.y0 - pp$data2outmargin, outm.y0 - pp$data2outmargin - 0.001)
    if(pp$data2outmargin!=0) graphics::arrows(x0 = outm.x, x1=outm.x, y0=outm.y0, y1=outm.y1, code=3, length=0.07, ...)
    graphics::text(x= outm.x, y=mean(outm.y0, outm.y1), labels=paste0("data2outmargin=", pp$data2outmargin), pos=2, ...)
    
    
    #horizontal margin
    hmarg.y <- kp$coord.change.function(chr="chr21", y=pp$data1max*0.8, data.panel = 1)$y
    hmarg.x0 <- kp$coord.change.function(chr = "chr21", x = kp$chromosome.lengths[1], data.panel = 1)$x
    hmarg.x1 <- ifelse(pp$ideogramlateralmargin!=0, hmarg.x0 + pp$ideogramlateralmargin, hmarg.x0 + pp$ideogramlateralmargin+0.001)
    graphics::arrows(x0 = hmarg.x0, x1=hmarg.x1, y0=hmarg.y, y1=hmarg.y, code=3, length=0.03, ...)
    graphics::text(x= mean(hmarg.x0, hmarg.x1), y=hmarg.y, labels=paste0("ideogramlateralmargin=", pp$ideogramlateralmargin), pos=3, ...)

    
    kp$endKpPlot()
    
  } 
  
  
  
  if(plot.type == 5) { #Horizontal in a single line. Data above and below the ideogram
    
    if(is.null(plot.params)) {
      plot.params <- getDefaultPlotParams(plot.type=5)
      #plot.params$ideogramlateralmargin=0.01
    } 
    
    kp <- plotKaryotype(genome="hg19", chromosomes=c("chr21", "chr22"), plot.type=plot.type, plot.params = plot.params, ...)
    pp <- kp$plot.params
    
    chrlen <- end(kp$genome[1])
    
    annotateDataPanel(2, pp, ...)
    
    #outmargins
    kp$beginKpPlot()
    graphics::abline(h=c(kp$plot.params$bottommargin, kp$plot.params$bottommargin + kp$chromosome.height), ...)
    marg.x <- kp$plot$xmax /10 * 8
    graphics::arrows(x0 = marg.x, x1=marg.x, y0=0, y1=kp$plot.params$bottommargin, code=3, length=0.07, ...)
    graphics::text(x=marg.x, y=kp$plot.params$bottommargin/2,labels=paste0("bottommargin=", kp$plot.param$bottommargin), pos=2, ...)
    
    graphics::arrows(x0 = marg.x, x1=marg.x, y0=kp$plot$ymax, y1=kp$plot$ymax - kp$plot.params$topmargin, code=3, length=0.07, ...)
    graphics::text(x=marg.x, y=kp$plot$ymax - kp$plot.params$topmargin/2, labels=paste0("topmargin=", kp$plot.param$topmargin), pos=2, ...)
    
    ch.x <- kp$plot$xmax /10 * 9.2
    graphics::arrows(x0 = ch.x, x1=ch.x, y0=kp$plot.params$bottommargin, y1=kp$plot.params$bottommargin + 1*kp$chromosome.height, code=3, length=0.07, ...)
    graphics::text(x=ch.x, y=kp$plot.params$bottommargin + 0.7*kp$chromosome.height, labels=paste0("chromosome.height (computed)=", kp$chromosome.height), pos=2, ...)
    
    graphics::abline(v=c(kp$plot.params$leftmargin, kp$plot$xmax-kp$plot.params$rightmargin), lty=2, ...)
    marg.y <- kp$plot$ymax /10 * 8.5
    graphics::arrows(x0 = 0, x1=kp$plot.params$leftmargin, y0=marg.y, y1=marg.y, code=3, length=0.07, ...)
    graphics::text(x=kp$plot.params$leftmargin/2, y=marg.y, labels=paste0("leftmargin=", kp$plot.params$leftmargin), pos=3, ...)
    
    graphics::arrows(x0 = kp$plot$xmax - kp$plot.params$rightmargin, x1=kp$plot$xmax, y0=marg.y, y1=marg.y, code=3, length=0.07, ...)
    graphics::text(x= kp$plot$xmax - kp$plot.params$rightmargin/2, y=marg.y, labels=paste0("rightmargin=", kp$plot.params$rightmargin), pos=3, ...)
    
    #ideogram
    ideoh.x <- kp$plot$xmax /10 * 5.5
    graphics::arrows(x0 = ideoh.x, x1=ideoh.x, y0=kp$ideogram.mid("chr21") - pp$ideogramheight/2, y1=kp$ideogram.mid("chr21") + pp$ideogramheight/2, code=3, length=0.07, ...)
    graphics::text(x= ideoh.x, y=kp$ideogram.mid("chr21"), labels=paste0("ideogramheight=", pp$ideogramheight), pos=4, ...)
    
    #in margins
    ideom.x <- kp$plot$xmax /10 * 7.2
    graphics::arrows(x0 = ideom.x, x1=ideom.x, y0=kp$ideogram.mid("chr21") - pp$ideogramheight/2 - pp$data2inmargin, y1=kp$ideogram.mid("chr21") - pp$ideogramheight/2, code=3, length=0.07, ...)
    graphics::text(x= ideom.x, y=kp$ideogram.mid("chr21") - pp$ideogramheight/2 - pp$data2inmargin/2, labels=paste0("data2inmargin=", pp$data2inmargin), pos=4, ...)
    
    outm.x <- kp$plot$xmax /10 * 7
    outm.y0 <- kp$ideogram.mid("chr21") - pp$ideogramheight/2 - pp$data2inmargin - pp$data2height
    outm.y1 <- ifelse(pp$data2outmargin!=0, outm.y0 - pp$data2outmargin, outm.y0 - pp$data2outmargin - 0.001)
    if(pp$data2outmargin!=0) graphics::arrows(x0 = outm.x, x1=outm.x, y0=outm.y0, y1=outm.y1, code=3, length=0.07, ...)
    graphics::text(x= outm.x, y=mean(outm.y0, outm.y1), labels=paste0("data2outmargin=", pp$data2outmargin), pos=2, ...)
    
    
    #horizontal margin
    hmarg.y <- kp$coord.change.function(chr="chr21", y=pp$data2max*0.8, data.panel = 2)$y
    hmarg.x0 <- kp$coord.change.function(chr = "chr21", x = kp$chromosome.lengths[1], data.panel=1)$x
    hmarg.x1 <- ifelse(pp$ideogramlateralmargin!=0, hmarg.x0 + pp$ideogramlateralmargin, hmarg.x0 + pp$ideogramlateralmargin+0.001)
    graphics::arrows(x0 = hmarg.x0, x1=hmarg.x1, y0=hmarg.y, y1=hmarg.y, code=3, length=0.03, ...)
    graphics::text(x= mean(hmarg.x0, hmarg.x1), y=hmarg.y, labels=paste0("ideogramlateralmargin=", pp$ideogramlateralmargin), pos=3, ...)
    
    
    kp$endKpPlot()
    
  } 
  
  
  invisible(kp)
}

#Note: The function getCytobands is a memoised function. It's better to define it on package
#load so it does not get linked to the memoise version available at installation time.
#See comment by @mtmorgan at https://github.com/Bioconductor/Contributions/issues/199

getCytobands <- NULL

.onLoad <- function(libname, pkgname) {
  getCytobands <<- memoise::memoise(.getCytobands)
}

#' @keywords internal

#Return the coordinate change function mapping genomic to plot coordinates


#getCoordChangeFunctions <- function(plot.type, genome, plot.params)
getCoordChangeFunctions <- function(karyoplot)
{
  plot.params <- karyoplot$plot.params
  genome <- karyoplot$plot.region
  genome <- keepSeqlevels(genome, seqnames(genome)) #we need the seqlevels in genome to be the visible chromsomes only
  plot.type <- karyoplot$plot.type
  
  if(plot.type == 1) {
    genomic2plot <- genomic2plot_2HorizDataAboveAndBelowIdeogram
    ideoMid <- getIdeogramMidY_2HorizDataAboveAndBelowIdeogram
    chrHeight <- getChrHeight_2HorizDataAboveAndBelowIdeogram
    coordChangeFunction <- function(chr=NULL, x=NULL, y=NULL, data.panel=NULL) {
      
      if(!is.null(y)) {
        if(is.null(chr)) {
          stop("If y is not NULL, chr must be specified too")
        }
        if(length(y) != length(chr)) {
          stop("If y is not NULL, it have to have the same length as chr")
        }
      }
      if(is.null(data.panel) || data.panel==2) data.panel <- 1 #data.panel 2 is not visible in this plot.type
      return(genomic2plot(chr=chr, x=x, y=y, data.panel=data.panel, genome=genome, plot.params=plot.params))
    }
  }
  if(plot.type == 2) {
    genomic2plot <- genomic2plot_2HorizDataAboveAndBelowIdeogram
    ideoMid <- getIdeogramMidY_2HorizDataAboveAndBelowIdeogram
    chrHeight <- getChrHeight_2HorizDataAboveAndBelowIdeogram
    coordChangeFunction <- function(chr=NULL, x=NULL, y=NULL, data.panel=NULL) {
      if(is.null(data.panel)) stop("In coordChangeFunction: data.panel is required")
      if(!is.null(y)) {
        if(is.null(chr)) {
          stop("If y is not NULL, chr must be specified too")
        }
        if(length(y) != length(chr)) {
          stop("If y is not NULL, it have to have the same length as chr")
        }
      }
      return(genomic2plot(chr=chr, x=x, y=y, data.panel=data.panel, genome=genome, plot.params=plot.params))
    }
  }
  if(plot.type == 3) { #All chromosomes in a line with 2 data panels
    genomic2plot <- genomic2plot_3HorizAllChromosomesInOneLine
    ideoMid <- getIdeogramMidY_3HorizAllChromosomesInOneLine
    chrHeight <- getChrHeight_3HorizAllChromosomesInOneLine
    coordChangeFunction <- function(chr=NULL, x=NULL, y=NULL, data.panel=NULL) {
      if(is.null(data.panel)) stop("In coordChangeFunction: data.panel is required")
      if(!is.null(x)) {
        if(is.null(chr)) {
          stop("If x is not NULL, chr must be specified too")
        }
        if(length(x) != length(chr)) {
          stop("If x is not NULL, it have to have the same length as chr")
        }
      }
      return(genomic2plot(chr=chr, x=x, y=y, data.panel=data.panel, genome=genome, plot.params=plot.params))
    }
  }
  if(plot.type == 4) { #All chromosomes in a line with 1 data panel above
    genomic2plot <- genomic2plot_3HorizAllChromosomesInOneLine
    ideoMid <- getIdeogramMidY_3HorizAllChromosomesInOneLine
    chrHeight <- getChrHeight_3HorizAllChromosomesInOneLine
    coordChangeFunction <- function(chr=NULL, x=NULL, y=NULL, data.panel=NULL) {
      if(!is.null(x)) {
        if(is.null(chr)) {
          stop("If x is not NULL, chr must be specified too")
        }
        if(length(x) != length(chr)) {
          stop("If x is not NULL, it have to have the same length as chr")
        }
      }
      if(is.null(data.panel) || data.panel==2) data.panel <- 1 #data.panel 2 is not visible in this plot.type
      return(genomic2plot(chr=chr, x=x, y=y, data.panel=data.panel, genome=genome, plot.params=plot.params))
    }
  }
  if(plot.type == 5) { #All chromosomes in a line with 1 data panel below (Implemented as a special case of 3)
    genomic2plot <- genomic2plot_3HorizAllChromosomesInOneLine
    ideoMid <- getIdeogramMidY_3HorizAllChromosomesInOneLine
    chrHeight <- getChrHeight_3HorizAllChromosomesInOneLine
    coordChangeFunction <- function(chr=NULL, x=NULL, y=NULL, data.panel=NULL) {
      if(!is.null(x)) {
        if(is.null(chr)) {
          stop("If x is not NULL, chr must be specified too")
        }
        if(length(x) != length(chr)) {
          stop("If x is not NULL, it have to have the same length as chr")
        }
      }
      if(is.null(data.panel) || data.panel==1) data.panel <- 2 #data.panel 1 is not visible in this plot.type
      inv.y <- plot.params$data2max - (y - plot.params$data2min) #Invert the y so we get "standard" positioning in panel 2
      return(genomic2plot(chr=chr, x=x, y=inv.y, data.panel=data.panel, genome=genome, plot.params=plot.params))
    }
  }
  if(plot.type == 6) { #Plot only on the ideograms
    genomic2plot <- genomic2plot_2HorizDataAboveAndBelowIdeogram
    ideoMid <- getIdeogramMidY_2HorizDataAboveAndBelowIdeogram
    chrHeight <- getChrHeight_2HorizDataAboveAndBelowIdeogram
    coordChangeFunction <- function(chr=NULL, x=NULL, y=NULL, data.panel=NULL) {
      if(!is.null(y)) {
        if(is.null(chr)) {
          stop("If y is not NULL, chr must be specified too")
        }
        if(length(y) != length(chr)) {
          stop("If y is not NULL, it have to have the same length as chr")
        }
      }
      if(is.null(data.panel) || data.panel==1 || data.panel==2) data.panel <- "ideogram" #No data panels are visible in this plot.type
      return(genomic2plot(chr=chr, x=x, y=y, data.panel=data.panel, genome=genome, plot.params=plot.params))
    }
  }
  if(plot.type == 7) { #All chromosomes in a line and plot only in the ideograms
    genomic2plot <- genomic2plot_3HorizAllChromosomesInOneLine
    ideoMid <- getIdeogramMidY_3HorizAllChromosomesInOneLine
    chrHeight <- getChrHeight_3HorizAllChromosomesInOneLine
    coordChangeFunction <- function(chr=NULL, x=NULL, y=NULL, data.panel=NULL) {
      if(!is.null(x)) {
        if(is.null(chr)) {
          stop("If x is not NULL, chr must be specified too")
        }
        if(length(x) != length(chr)) {
          stop("If x is not NULL, it have to have the same length as chr")
        }
      }
      if(is.null(data.panel) || data.panel==1 || data.panel==2) data.panel <- "ideogram" #No data panels are visible in this plot.type
      return(genomic2plot(chr=chr, x=x, y=y, data.panel=data.panel, genome=genome, plot.params=plot.params))
    }
  }


  return(list(
    coordChangeFunction=coordChangeFunction,
    ideogramMid=function(chr) {
      return(ideoMid(chr=chr, genome=genome, plot.params=plot.params))
  },
    chr.height=chrHeight(plot.params)    
  ))
}




####################################################################################
#
#    Plot Type 1 - Horizontal with Data Above the Ideogram  (BEGIN)
#
####################################################################################

#Reimplemented as a special case of plot.type 2

# getIdeogramMidY_1HorizDataAboveIdeogram <- function(chr, genome, plot.params) {
#   pp <- plot.params
#   chr.height <- getChrHeight_1HorizDataAboveIdeogram(pp)
#   chr.names <- Seqinfo::seqlevels(genome)
#   chrs <- c(length(chr.names):1)
#   names(chrs) <- chr.names
#   chr.num <- chrs[chr]
#   return(pp$bottommargin + (chr.num - 1) * chr.height + pp$ideogramheight/2)
# }
# 
# getChrHeight_1HorizDataAboveIdeogram <- function(pp) {
#   chr.height <- pp$ideogramheight + pp$data1inmargin + pp$data1height + pp$data1outmargin
#   return(chr.height)
# }
# 
# #Build the function mapping genomic regions into plotting coordinates
# genomic2plot_1HorizDataAboveIdeogram <- function(chr=NULL, x=NULL, y=NULL, data.panel=1,
#                                                  genome, plot.params) {
#   
#   if(is.null(data.panel)) data.panel <- 1
#   if(data.panel != 1) {
#     data.panel <- 1 #This plot type has only one data.panel
#     warning("Specified data.panel does not exist. Plotting in data.panel 1")
#   }
#   
#   pp <- plot.params
#   
#   genome.width <- 1 - pp$leftmargin - pp$rightmargin
#   max.chr.len <- max(end(genome)) - min(start(genome))
#     
#   if(!is.null(x)) {
#     x.plot <- pp$leftmargin + ((x-start(genome[chr]))/max.chr.len)*genome.width
#   } else{
#     x.plot <- NULL
#   }
#   
#   if(is.null(chr)) {
#     y.plot <- NULL 
#   } else {
#     #chrs.y <- getChrLowestY(chr, genome, pp) 
#     chrs.y <- getIdeogramMidY_1HorizDataAboveIdeogram(chr, genome, pp) 
#     if(is.null(y)) { #if y is null, set y to the middle of the ideogram
#       y.plot <- chrs.y
#     } else { #Return the appropiate plot.y for the given original y
#       datayrange <- pp$data1max - pp$data1min 
#       yscaled <- ((y - pp$data1min) / datayrange) * pp$data1height
#       y.plot <- chrs.y + pp$ideogramheight/2 + pp$data1inmargin + yscaled
#     }
#   }   
#   return(list(x=x.plot, y=y.plot))
# }

  

#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#
#    Plot Type 1 - Horizontal with Data Above the Ideogram  (END)
#
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@





####################################################################################
#
#    Plot Type 2 - Horizontal with Data Above and Below the Ideogram  (BEGIN)
#
####################################################################################

getIdeogramMidY_2HorizDataAboveAndBelowIdeogram <- function(chr, genome, plot.params) {
  pp <- plot.params
  chr.height <- getChrHeight_2HorizDataAboveAndBelowIdeogram(pp)
  chr.names <- Seqinfo::seqlevels(genome)
  chrs <- c(length(chr.names):1)
  names(chrs) <- chr.names
  chr.num <- chrs[chr]
  return(pp$bottommargin + (chr.num - 1) * chr.height +
         pp$data2outmargin + pp$data2height + pp$data2inmargin + pp$ideogramheight/2)
}

getChrHeight_2HorizDataAboveAndBelowIdeogram <- function(pp) {
  chr.height <- (pp$data2outmargin + pp$data2height + pp$data2inmargin
                 + pp$ideogramheight
                 + pp$data1inmargin + pp$data1height + pp$data1outmargin)
  return(chr.height)
}

#Build the function mapping genomic regions into plotting coordinates
genomic2plot_2HorizDataAboveAndBelowIdeogram <- function(chr=NULL, x=NULL, y=NULL, data.panel,
                                                         genome, plot.params) {
  
  pp <- plot.params
  
  genome.width <- 1 - pp$leftmargin - pp$rightmargin
  max.chr.len <- max(end(genome) - start(genome))
  
  if(!is.null(x)) {
    x.plot <- pp$leftmargin + ((x-start(genome[chr]))/max.chr.len)*genome.width
  } else{
    x.plot <- NULL
  }
  
  if(is.null(chr)) {
    y.plot <- NULL 
  } else {
    chrs.y <- getIdeogramMidY_2HorizDataAboveAndBelowIdeogram(chr, genome, pp) 
    if(is.null(y)) { #if y is null, set y to the bottom of the chromosome
      y.plot <- chrs.y
    } else { #Return the appropiate plot.y for the given original y
      if(data.panel == "ideogram") {
        datayrange <- pp$dataideogrammax - pp$dataideogrammin 
        yscaled <- ((y - pp$dataideogrammin) / datayrange) * pp$ideogramheight
        y.plot <- chrs.y - pp$ideogramheight/2 + yscaled
      } else {
        if(data.panel == "all") {
          all.height <- getChrHeight_2HorizDataAboveAndBelowIdeogram(pp) - pp$data1outmargin - pp$data2outmargin
          datayrange <- pp$dataallmax - pp$dataallmin 
          yscaled <- ((y - pp$dataallmin) / datayrange) * all.height
          y.plot <- chrs.y - pp$ideogramheight/2 - pp$data2inmargin - pp$data2height + yscaled
        } else {
          if(data.panel == 1) {
            datayrange <- pp$data1max - pp$data1min 
            yscaled <- ((y - pp$data1min) / datayrange) * pp$data1height
            y.plot <- chrs.y + pp$ideogramheight/2 + pp$data1inmargin + yscaled
          } else {
            if(data.panel == 2) {
              datayrange <- pp$data2max - pp$data2min 
              yscaled <- ((y - pp$data2min) / datayrange) * pp$data2height
              y.plot <- chrs.y - pp$ideogramheight/2 - pp$data2inmargin - yscaled
            } else {
              stop("Invalid data.panel")
            }
          }
        }
      }
    }
  }   
  return(list(x=x.plot, y=y.plot))
}


#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#
#    Plot Type 2 - Horizontal with Data Above and Below the Ideogram  (END)
#
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



####################################################################################
#
#    Plot Type 3 - Horizontal, all chromosomes in one line (BEGIN)
#
####################################################################################

getIdeogramMidY_3HorizAllChromosomesInOneLine <- function(chr, genome, plot.params) {
  pp <- plot.params
  chr.height <- getChrHeight_3HorizAllChromosomesInOneLine(pp)
  ypos <- pp$bottommargin + pp$data2outmargin + pp$data2height + pp$data2inmargin + pp$ideogramheight/2
  #return(setNames(rep(ypos, length(chr)), chr))
  return(ypos) #It's a single value for all chromosomes!
}

getChrHeight_3HorizAllChromosomesInOneLine <- function(pp) {
  chr.height <- (pp$data2outmargin + pp$data2height + pp$data2inmargin
                 + pp$ideogramheight
                 + pp$data1inmargin + pp$data1height + pp$data1outmargin)
  return(chr.height)
}


#Build the function mapping genomic regions into plotting coordinates
genomic2plot_3HorizAllChromosomesInOneLine <- function(chr=NULL, x=NULL, y=NULL, data.panel,
                                                         genome, plot.params) {
  

  pp <- plot.params
  
  chr.names <- Seqinfo::seqlevels(genome)
  chrs <- stats::setNames(seq_along(chr.names), chr.names)
  chr.starts <- stats::setNames(start(genome), chr.names)
  chr.lens <- stats::setNames(as.numeric(end(genome) - start(genome)), chr.names)
  previous.chrs <- stats::setNames(Reduce(sum, c(0, chr.lens[-length(chr.lens)]), accumulate = TRUE), chr.names) #For each chromosome, the sum of the lengths of the previous chromosomes
  all.chr.len <- sum(chr.lens)
  
  genome.width <- 1 - pp$leftmargin - pp$rightmargin - pp$ideogramlateralmargin*length(genome)  #The space allowed for the genome plot
  
  if(is.null(chr) | is.null(x)) {
    x.plot <- NULL 
  } else {
    if(!is.numeric(x)) {
      x.plot <- NULL
    } else{
      x.plot <- pp$leftmargin + 
                pp$ideogramlateralmargin*(chrs[chr]-1) +
                ((previous.chrs[chr] + x - chr.starts[chr])/all.chr.len)*genome.width
    }
  }
  
  if(is.null(y) | !is.numeric(y)) {
    y.plot <- NULL 
  } else {
    chrs.y <- getIdeogramMidY_3HorizAllChromosomesInOneLine(chr, genome, pp) 
    if(is.null(y)) { #if y is null, set y to the bottom of the chromosome
      y.plot <- chrs.y #shouldn't happen. Just tested in the if above!
      
    } else { #Return the appropiate plot.y for the given original y
      if(data.panel == "ideogram") {
        datayrange <- pp$dataideogrammax - pp$dataideogrammin 
        yscaled <- ((y - pp$dataideogrammin) / datayrange) * pp$ideogramheight
        y.plot <- chrs.y - pp$ideogramheight/2 + yscaled
      } else {
        if(data.panel == "all") {
          all.height <- getChrHeight_2HorizDataAboveAndBelowIdeogram(pp) - pp$data1outmargin - pp$data2outmargin
          datayrange <- pp$dataallmax - pp$dataallmin 
          yscaled <- ((y - pp$dataallmin) / datayrange) * all.height
          y.plot <- chrs.y - pp$ideogramheight/2 - pp$data2inmargin - pp$data2height + yscaled
        } else {
          if(data.panel == 1) {
            datayrange <- pp$data1max - pp$data1min 
            yscaled <- ((y - pp$data1min) / datayrange) * pp$data1height
            y.plot <- chrs.y + pp$ideogramheight/2 + pp$data1inmargin + yscaled
          } else {
            if(data.panel == 2) {
              datayrange <- pp$data2max - pp$data2min 
              yscaled <- ((y - pp$data2min) / datayrange) * pp$data2height
              y.plot <- chrs.y - pp$ideogramheight/2 - pp$data2inmargin - yscaled
            } else {
              stop("Invalid data.panel")
            }
          }
        }
      }
    }
  }   
  return(list(x=x.plot, y=y.plot))
}



#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#
#    Plot Type 3 - Horizontal, all chromosomes in one line (BEGIN)
#
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



# ####################################################################################
# #
# #    Plot Type 4 - Vertical with Data Above and Below the Ideogram  (BEGIN)
# #
# ####################################################################################
# 
# getIdeogramMidY_4VerticalDataAboveAndBelowIdeogram <- function(chr, genome, plot.params) {
#   pp <- plot.params
#   chr.height <- getChrHeight_4VerticalDataAboveAndBelowIdeogram(pp)
#   chr.names <- Seqinfo::seqlevels(genome)
#   chrs <- c(length(chr.names):1)
#   names(chrs) <- chr.names
#   chr.num <- chrs[chr]
#   return(pp$bottommargin + (chr.num - 1) * chr.height +
#            pp$data2outmargin + pp$data2height + pp$data2inmargin + pp$ideogramheight/2)
# }
# 
# getChrHeight_4VerticalDataAboveAndBelowIdeogram <- function(pp) {
#   chr.height <- (pp$data2outmargin + pp$data2height + pp$data2inmargin
#                  + pp$ideogramheight
#                  + pp$data1inmargin + pp$data1height + pp$data1outmargin)
#   return(chr.height)
# }
# 
# #Build the function mapping genomic regions into plotting coordinates
# genomic2plot_4VerticalDataAboveAndBelowIdeogram <- function(chr=NULL, x=NULL, y=NULL, 
#                                                             data.panel, genome, plot.params) {
#   
#   pp <- plot.params
#   
#   genome.width <- 1 - pp$leftmargin - pp$rightmargin
#   max.chr.len <- max(end(genome)) - min(start(genome))
#   
#   if(!is.null(x)) {
#     x.plot <- pp$leftmargin + (x/max.chr.len)*genome.width
#   } else{
#     x.plot <- NULL
#   }
#   
#   if(is.null(chr)) {
#     y.plot <- NULL 
#   } else {
#     #chrs.y <- getChrLowestY(chr, genome, pp) 
#     chrs.y <- getIdeogramMidY_4VerticalDataAboveAndBelowIdeogram(chr, genome, pp) 
#     if(is.null(y)) { #if y is null, set y to the bottom of the chromosome
#       y.plot <- chrs.y
#     } else { #Return the appropiate plot.y for the given original y
#       if(data.panel == 1) {
#         datayrange <- pp$data1max - pp$data1min 
#         yscaled <- ((y - pp$data1min) / datayrange) * pp$data1height
#         y.plot <- chrs.y + pp$ideogramheight/2 + pp$data1inmargin + yscaled
#       } else {
#         if(data.panel == 2) {
#           datayrange <- pp$data2max - pp$data2min 
#           yscaled <- ((y - pp$data2min) / datayrange) * pp$data2height
#           y.plot <- chrs.y - pp$ideogramheight/2 - pp$data2inmargin - yscaled
#         } else {
#           stop("Invalid data.panel")
#         }
#       }
#     }
#   }   
#   return(list(x=y.plot, y=x.plot))
# }
# 
# 
# #@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
# #
# #    Plot Type 4 - Vertical with Data Above and Below the Ideogram  (END)
# #
# #@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

################################################################################
#  The functions in this file are utility functions to build the GenesData
#  structure needed by kpPlotGenes from different sources and to manage
#  the conversion of gene identifiers to gene symbols
################################################################################

#Dataframe tying the available OrgDb objects to the different identifiers of 
#the organism they annotate
#Data extracted from https://bioconductor.org/packages/release/BiocViews.html#___OrgDb
.OrganismToOrgDb <- data.frame(
  taxonomyId=c(9606, 10090, 7227),
  organism=c("Homo sapiens", "Mus musculus", "Drosophila melanogaster"),
  genome=c("hg", "mm", "dm"),
  package=c("org.Hs.eg.db", "org.Mm.eg.db", "org.Dm.eg.db"),
  stringsAsFactors=FALSE
)



#' makeGenesDataFromTxDb
#' 
#' @description 
#' 
#' This is a utility function that transforms a TxDb object into a custom 
#' object valid as input for \code{\link{kpPlotGenes}}.
#' 
#' @details 
#'  
#' This function creates a valid data object for \code{\link{kpPlotGenes}} 
#' starting from a TxDb object. The resulting object will contain only the
#' genes and transcripts ovelapping the plot region of the given Karyoplot 
#' object. 
#' 
#' @note \code{\link{kpPlotGenes}} accepts TxDb objects directly. This 
#' function is only expected to be used when the user want to manipulate the 
#' results somehow (i.e. removing some of the genes).
#' 
#' @usage makeGenesDataFromTxDb(txdb, karyoplot=NULL, plot.transcripts=TRUE, plot.transcripts.structure=TRUE)
#' 
#' @param txdb (a TxDb object) The transcript database object from which the data will be extracted.
#' @param karyoplot  (karyoplot object) A valid karyoplot object created by a call to \code{\link{plotKaryotype}}. If present, genes data will be restricted to the visible region in the plot. If NULL, all genes will be included. (defaults to NULL)
#' @param plot.transcripts (boolean) TRUE if transcripts are needed in addition to the genes. (defaults to TRUE)
#' @param plot.transcripts.structure (boolean) TRUE if the coding and non-coding exons are needed in addition to the genes and transcripts. (defaults to TRUE)
#' 
#' @return
#' 
#' Returns a list with at least one element called \code{genes}, a 
#' \code{GRanges} with all genes overlapping karyoplot. If 
#' \code{plot.transcripts} is TRUE, the returned list will have 
#' a \code{transcript} element, a list of \code{GRanges} objects, one per gene
#' (named with the gene ids),
#' with the transcripts of that gene. If \code{plot.transcripts.structure} is
#' TRUE, two more elements are present: \code{coding.exons} and 
#' \code{non.coding.exons}, each a list with one element per trascript 
#' (named with the transcript id), and each element the coding or non-coding
#' exons of that transcript.
#' 
#'  
#' @seealso \code{\link{kpPlotGenes}}
#' 
#' @examples
#'  
#' 
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' 
#' zoom <- toGRanges("chr17", 32.6e6, 33.2e6)
#' kp <- plotKaryotype(genome="hg19", zoom=zoom)
#' 
#' genes.data <- makeGenesDataFromTxDb(TxDb.Hsapiens.UCSC.hg19.knownGene, 
#'                  karyoplot=kp, plot.transcripts=TRUE, 
#'                  plot.transcripts.structure=TRUE)
#'   
#' @export makeGenesDataFromTxDb
#' 
#' @importFrom GenomicFeatures genes exons transcriptsBy cds organism
#' @importFrom IRanges subsetByOverlaps
#' @importFrom AnnotationDbi taxonomyId select
#' @importFrom Seqinfo genome
#'

makeGenesDataFromTxDb <- function(txdb, karyoplot=NULL, plot.transcripts=TRUE, plot.transcripts.structure=TRUE) {
  res <- list()
  
  #get the metadata
  res$metadata <- list()
  res$metadata$organism <- GenomicFeatures::organism(txdb)
  res$metadata$taxonomyId <- AnnotationDbi::taxonomyId(txdb)
  res$metadata$genome <- setNames(Seqinfo::genome(txdb)[1], NULL)
  
  
  #get the genes
  all.genes <- genes(txdb)
  if(!is.null(karyoplot)) { #Subset the genes to the visible region only
    res[["genes"]] <- subsetByOverlaps(all.genes, karyoplot$plot.region)
  } else { #If we have no karyoplot, use all genes
    res[["genes"]] <- all.genes
  }
  
  if(plot.transcripts==TRUE) {
    #Extract the transcripts of each gene
    res[["transcripts"]] <- as.list(transcriptsBy(txdb, by="gene")[names(res$genes)])
    
    if(plot.transcripts.structure==TRUE) {
      #extract the exons of each transcript
      res[["coding.exons"]] <- list()
      res[["non.coding.exons"]] <- list()
      #for every transcript, get the coding exons and compute the non coding ones
      all.trans <- as.character(Reduce(c, res$transcripts)$tx_id)
      for(tid in all.trans) {
        res$coding.exons[[tid]] <- cds(txdb, filter=list(tx_id=tid))
        complete.exons <- exons(txdb, filter=list(tx_id=tid))
        res$non.coding.exons[[tid]] <- subtractRegions(complete.exons, res$coding.exons[[tid]])
      }
    }
  }
  class(res) <- "GenesData"
  return(res)
}



#' addGeneNames
#' 
#' @description 
#' Adds the gene names (defaults to symbols) to a GenesData object to 
#' be used by kpPlotGenes
#' 
#' 
#' @details 
#' This function takes a valid data object and uses an OrgDb object to 
#' find the gene names (symbols by default) and add them. Names are added 
#' as a column named \code{names} to the \code{genes} element of GenesData 
#' and they replace anything that was present there before.
#' If no \code{ObjDb} object is given, the function will try to identify
#' the correct organism using the data in \code{GenesData$metadata} and
#' select the OrgDb object if available. If it cannot identify the organism 
#' or there's no valid OrgDb for that organism it will fail with an error.
#' Internally, the function uses a call to \code{AnnotationDbi::select} on
#' the OrgDb. It is possible to specify the keys and keytypes as well as
#' the column we want to use as names (defaults to SYMBOL for gene symbols).
#' 
#' @usage addGeneNames(genes.data, orgDb="auto", keys=NULL, keytype="ENTREZID", names="SYMBOL")
#' 
#' @param genes.data (GenesData object) A valid genes.dat object like the ones obtained by \code{\link{makeGenesDataFromTxDb}}
#' @param orgDb The orgDb object to use to extract the gene symbols. If "auto" the function will try to determine automatically the correct organism. See available obects at https://bioconductor.org/packages/release/BiocViews.html#___OrgDb (defaults to "auto")
#' @param keys (character vector ) The keys to be used in the internal select statement to get the names. If NULL, the first column of \code{mcols(GenesData$genes)} will be used. (defaults to NULL)
#' @param keytype (character) The keytype used in the internal select statement. (defaults to "ENTREZID", that is, gene_id)
#' @param names The column to extract from orgDb to use as gene names. (deafults to "SYMBOL")
#' 
#' 
#' @return
#' The original GenesData object with one additional column named "names" in 
#' \code{GenesData$genes$names}.
#' 
#'  
#' @seealso \code{\link{kpPlotGenes}}, \code{\link{makeGenesDataFromTxDb}}
#' 
#' @examples
#'  
#' 
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' 
#' zoom <- toGRanges("chr17:29e6-30e6")
#' kp <- plotKaryotype(genome="hg19", zoom=zoom)
#' genes.data <- makeGenesDataFromTxDb(TxDb.Hsapiens.UCSC.hg19.knownGene, 
#'                  karyoplot=kp, plot.transcripts=FALSE,
#'                  plot.transcripts.structure=FALSE)
#' genes.data <- addGeneNames(genes.data)
#' kpPlotGenes(kp, data=genes.data, r1=0.5, plot.transcripts=FALSE,
#'             gene.name.position = "left")
#'  
#'   
#' @export addGeneNames
#' 
addGeneNames <- function(genes.data, orgDb="auto", keys=NULL, keytype="ENTREZID", names="SYMBOL") {
  if(!methods::is(genes.data, "GenesData")) stop("genes.data must be a valid object of the GenesData class")
  #TODO: check it's a valid genes.data
  
  if(is.character(orgDb) && orgDb=="auto") {
    org <- NULL
    if(!is.null(genes.data$metadata$taxonomyId)) {
      org <- .OrganismToOrgDb[.OrganismToOrgDb$taxonomyId==genes.data$metadata$taxonomyId,]
    }
    if(is.null(org) && !is.null(genes.data$metadata$genome)) {
      
      #Use the genome name (prefix) to get the correct org line
    }
    
    
    if(!is.null(org)) {
      loaded <- require(org$package, character.only = TRUE)
      if(loaded==TRUE) orgDb <- get(org$package)
    } else {
      stop("It was not possible to identify the organism in order to select the appropiate OrgDb object. Please provide one manually")
    }
  }
  if(!methods::is(orgDb, "OrgDb")) stop("orgDb must be either a valid OrgDb object or 'auto'")
 
  #If we are here, we have a valid orgDb 
  if(is.null(keys)) keys <- mcols(genes.data$genes)[,1]
  
  ss <- suppressMessages(AnnotationDbi::select(orgDb, keys=keys, keytype=keytype, columns=names))
  
  genes.data$genes$name <- ss[,2]

  return(genes.data)  
}



#' mergeTranscripts
#' 
#' @description 
#' Merges the transcripts of each gene and creates one transcript per gene with
#' all exons and UTR regions combined
#' 
#' 
#' @details 
#' This function takes a valid data object and merges all transcripts from 
#' each gene into a single transcript. This is useful to reduce the plot
#' complexity while keeping partial information on transcript structure.#' 
#' In this transcript, any region that is a coding exon in any transcript,
#' will be an exon, any region that is a non-coding exon in any transcript
#' and is not an exon in any transcript, will be a non-coding exon. 
#' Anything between coding and non-coding exons will be introns.
#' 
#' @usage mergeTranscripts(genes.data)
#' 
#' @param genes.data (GenesData object) A valid genes.dat object like the ones obtained by \code{\link{makeGenesDataFromTxDb}}
#' 
#' @return
#' The original GenesData object with a single transcript per gene 
#' \code{GenesData$genes$names}.
#' 
#' @seealso \code{\link{kpPlotGenes}}, \code{\link{makeGenesDataFromTxDb}}
#' 
#' @examples
#'  
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' 
#' zoom <- toGRanges("chr17:29.4e6-29.8e6")
#' kp <- plotKaryotype(genome="hg19", zoom=zoom)
#' genes.data <- makeGenesDataFromTxDb(TxDb.Hsapiens.UCSC.hg19.knownGene, karyoplot=kp)
#' genes.data <- addGeneNames(genes.data)
#' kpPlotGenes(kp, data=genes.data, r1=0.5, plot.transcripts=TRUE, gene.name.position = "left")
#' genes.data.merged <- mergeTranscripts(genes.data)
#' kpPlotGenes(kp, data=genes.data.merged, r0=0.6, r1=0.8, plot.transcripts=TRUE, gene.name.position = "left")
#'  
#' @export mergeTranscripts
mergeTranscripts <- function(genes.data) { 
  if(!methods::is(genes.data, "GenesData")) stop("genes.data must be a valid object of the GenesData class")
  #TODO: check it's a valid genes.data
  
  if(is.null(genes.data$transcripts)) stop("genes.data must have transcript information. If created with makeGenesDataFromTxDb,  plot.transcripts must be set to TRUE")
  if(is.null(genes.data$coding.exons)) stop("genes.data must have exons information. If created with makeGenesDataFromTxDb,  plot.transcripts.structure must be set to TRUE")

  merged.data <- list()
  class(merged.data) <- "GenesData"
  merged.data$genes <- genes.data$genes
  merged.data$transcripts <- list()
  merged.data$coding.exons <- list()
  merged.data$non.coding.exons <- list()
  
  for(ngene in seq_len(length(genes.data$genes))) {
    g <- genes.data$genes[ngene]
  
    #Get the transcripts and get the total region overlapping any of them
    tx <- genes.data$transcripts[[names(g)]]
    
    merged.tx <- regioneR::joinRegions(tx, 0)
    merged.tx_id <- paste0(names(g), ".merged")
    merged.tx$tx_id <- merged.tx_id
    
    merged.data$transcripts[[names(g)]] <- merged.tx
    
    #Get all coding exons and merge them
    cod.ex <- do.call("c", lapply(tx$tx_id, function(tx_id) return(genes.data$coding.exons[[as.character(tx_id)]])))
    cod.ex <- regioneR::joinRegions(cod.ex, 0)
    
    merged.data$coding.exons[[merged.tx_id]] <- cod.ex
    
    #Get all non-coding exons and merge them
    ncod.ex <- do.call("c", lapply(tx$tx_id, function(tx_id) return(genes.data$non.coding.exons[[as.character(tx_id)]])))
    ncod.ex <- regioneR::joinRegions(ncod.ex, 0)
    
    merged.data$non.coding.exons[[merged.tx_id]] <- ncod.ex
  }
  return(merged.data) 
}



#TODO
isValidData <- function(...) {
  return(TRUE)
}





getGeneNames <- function(genes, gene.names) {
  if(!is.null(gene.names)) {
    return(naToEmptyChar(as.character(gene.names[names(genes)])))
  } else {
    if("name" %in% names(mcols(genes))) {
      return(naToEmptyChar(genes$name))
    } else {
      if(length(mcols(genes))>0) {
        return(naToEmptyChar(as.character(mcols(genes)[,1])))
      } else {
        return(naToEmptyChar(as.character(names(genes))))
      }
    }
  }
}

getTranscriptNames <- function(transcripts, transcript.names) {
  if(!is.null(transcript.names)) {
    return(as.character(transcript.names[names(transcripts)]))
  } else {
    return(as.character(names(transcripts)))
  }
}

#' kpArrows
#' 
#' @description 
#' 
#' Plots segments at the specified genomic positions. 
#' 
#' @details 
#'  
#' This is one of the functions from karyoploteR implementing the adaptation to the genome 
#' context of basic plot functions from R base graphics. 
#' Given a set of positions on the genome (chromosome, x0 and x1) and values 
#' (y0 and y1) for each of them, it plots arrows going from (x0, y0) to (x1, y1). Data can be 
#' provided via a \code{GRanges} object (\code{data}), independent parameters for chr, 
#' x0, x1, y0 and y1, or a combination of both.
#' A number of parameters can be used to define exactly where and how the arrows are drawn.
#' In addition, via the ellipsis operator (\code{...}), \code{kpSegments} accepts any parameter 
#' valid for \code{segments} (e.g. \code{code}, \code{lwd}, \code{lty}, \code{col}, ...)
#'
#' @usage kpArrows(karyoplot, data=NULL, chr=NULL, x0=NULL, x1=NULL, y0=NULL, y1=NULL, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, ...) 
#' 
#' @inheritParams kpRect 
#' 
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpRect}}, \code{\link{kpPoints}},
#' @seealso \code{\link{kpPlotRegions}}
#' 
#' @examples
#'  
#' set.seed(1000)
#' data.points <- sort(createRandomRegions(nregions=500, length.mean=2000000, mask=NA))
#' y <- runif(500, min=0, max=0.8)
#' mcols(data.points) <- data.frame(y0=y, y1=y+0.2)
#' 
#' kp <- plotKaryotype("hg19", plot.type=2, chromosomes=c("chr1", "chr2"))
#'   kpDataBackground(kp, data.panel=1)
#'   kpDataBackground(kp, data.panel=2)
#' 
#'   kpArrows(kp, data=data.points, col="black", lwd=2, length=0.04)
#'   
#'   kpArrows(kp, data=data.points, y0=0, y1=1,  r0=0.2, r1=0.8, col="lightblue", data.panel=2)
#'   
#' 
#'  
#' @export kpArrows
#' 



kpArrows <- function(karyoplot, data=NULL, 
                     chr=NULL, x0=NULL, x1=NULL, y0=NULL, y1=NULL,
                     ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL,
                     clipping=TRUE, ...) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  pp <- prepareParameters4("kpArrows", karyoplot=karyoplot, data=data, chr=chr, x0=x0, x1=x1,
                           y0=y0, y1=y1, ymin=ymin, ymax=ymax, r0=r0, r1=r1,
                          data.panel=data.panel, ...)
  
  ccf <- karyoplot$coord.change.function
  
  x0plot <- ccf(chr=pp$chr, x=pp$x0, data.panel=data.panel)$x
  x1plot <- ccf(chr=pp$chr, x=pp$x1, data.panel=data.panel)$x
  y0plot <- ccf(chr=pp$chr, y=pp$y0, data.panel=data.panel)$y
  y1plot <- ccf(chr=pp$chr, y=pp$y1, data.panel=data.panel)$y
  
  processClipping(karyoplot=karyoplot, clipping=clipping, data.panel=data.panel)  
  
  #Filter the additional parameters using the 'filter' vector returned by prepareParameters4
  dots <- filterParams(list(...), pp$filter, pp$original.length)
  
  #And call the base plotting function with both the standard parameters and the modified dots parameters
  params <- c(list(x0=x0plot, x1=x1plot, y0=y0plot, y1=y1plot), dots)
  do.call(graphics::arrows, params)
  #graphics::arrows(x0=x0plot, x1=x1plot, y0=y0plot, y1=y1plot, ...)
  invisible(karyoplot) 
}

#' kpPlotBAMDensity
#' 
#' @description 
#' 
#' Plots the density of features along the genome
#' 
#' @details 
#'  
#' \code{kpPlotBAMDensity} plots the read density of a BAM file. It does not
#' plot the coverage but the read density as the number of reads overlapping 
#' a every window. It uses \code{\link{Rsamtools}} to efficiently access the
#' BAM file. The BAM file must be indexed.
#' 
#' There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
#' 
#' @usage kpPlotBAMDensity(karyoplot, data=NULL, window.size=1e6, normalize=FALSE, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, col="gray80", border=NA,  clipping=TRUE, ...)
#' 
#' @param karyoplot    (a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.
#' @param data    (a \code{BamFile} or character) The path to a bam file (must be indexed) or a \code{BamFile} object.
#' @param window.size (numeric) The size of the windows for wich the density is computed. (Defaults to 1e6, one megabase windows)
#' @param normalize (boolean) Specifies if the density values should be normalized by the total number of mapped reads in the bam file. (Defaults to FALSE)
#' @param data.panel    (numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param r0    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param r1    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param ymin    (numeric) The minimum value to be plotted on the data panel. If NULL, it is set to 0. (deafults to NULL)
#' @param ymax    (numeric) The maximum value to be plotted on the data.panel. If NULL the maximum density is used. (defaults to NULL)
#' @param col  (color) The background color to plot. If NULL, it will be a lighter version of 'border' or 'black' if border is null. (Defaults to "gray80")
#' @param border (color) The color to use to plot the borders of the bars. If NULL, it will be a darker version of 'col'. If NA, no border will be plotted. (Defaults to NULL)
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param ...    The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions. In particular \code{col} and \code{border} can be used to set the colors used.
#'   
#' @return
#' 
#' Returns the original karyoplot object with the data computed (windows and density) stored at \code{karyoplot$latest.plot}
#' 
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpPlotRibbon}}, \code{\link{kpPlotCoverage}}
#' 
#' @examples
#' 
#' library(pasillaBamSubset) #A package with 2 example bam files
#' un1.bam.file <- untreated1_chr4() # get the name of the first bam
#' un3.bam.file <- untreated3_chr4() #and the name of the second
#' 
#' window.size <- 1e4 #compute the density with 10kb windows
#' 
#' kp <- plotKaryotype(genome="dm6", chromosomes="chr4") #The pasilla data comes from drosophila
#' kp <- kpAddBaseNumbers(kp, tick.dist = 1e5)
#' kp <- kpPlotBAMDensity(kp, data = un1.bam.file, window.size = window.size, r0=0.5, r1=1, ymax=50000, col="darkorange")
#' kp <- kpPlotBAMDensity(kp, data = un3.bam.file, window.size = window.size, r0=0.5, r1=0, ymax=50000, col="darkorchid") #using r0>r1 we can flip the plot
#' kpAxis(kp, ymin=0, ymax=50000, r0=0.5, r1=1, labels = c("0", "25K", "50K"))
#' kpAxis(kp, ymin=0, ymax=50000, r0=0.5, r1=0, labels = c("0", "25K", "50K"))
#' 
#' kpText(kp, chr = "chr4", x=7e5, y=0.85, labels = paste0("Untreated 1 (reads per ", window.size, " bases)"))
#' kpText(kp, chr = "chr4", x=7e5, y=0.15, labels = paste0("Untreated 3 (reads per ", window.size, " bases)"))
#' 
#' 
#' 
#' #Or normalizing by the number of mapped reads
#' kp <- plotKaryotype(genome="dm6", chromosomes="chr4") #The pasilla data comes from drosophila
#' kp <- kpAddBaseNumbers(kp, tick.dist = 1e5)
#' kp <- kpPlotBAMDensity(kp, data = un1.bam.file, window.size = window.size, normalize=TRUE, r0=0.5, r1=1, ymax=0.2, col="darkorange")
#' kp <- kpPlotBAMDensity(kp, data = un3.bam.file, window.size = window.size, normalize=TRUE, r0=0.5, r1=0, ymax=0.2, col="darkorchid") #using r0>r1 we can flip the plot
#' 
#' 
#' @export kpPlotBAMDensity
#' @importFrom Rsamtools BamFile countBam idxstatsBam ScanBamParam
#' @importFrom Seqinfo Seqinfo


kpPlotBAMDensity <- function(karyoplot, data=NULL, window.size=1e6, normalize=FALSE, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, col="gray80", border=NA, clipping=TRUE,...) {

  if(!methods::is(karyoplot, "KaryoPlot")) stop(paste0("In kpPlotBAMDensity: 'karyoplot' must be a valid 'KaryoPlot' object"))
  if(is.character("data")) {
    data <- Rsamtools::BamFile(file = data)
  }
  if(!methods::is(data, "BamFile")) stop(paste0("In kpPlotBAMDensity: 'data' must be a character or a 'BamFile' object."))
  
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  

  #use tileGenome to create windows only on the visible part of the genome, that
  #is in the karyoplot$plot.region
  plot.region.lengths <- setNames(width(karyoplot$plot.region), as.character(seqnames(karyoplot$plot.region)))
  windows <- tileGenome(plot.region.lengths, tilewidth = window.size, cut.last.tile.in.chrom = TRUE)
  seqinfo(windows) <- Seqinfo::Seqinfo(seqnames=seqlevels(windows)) #remove the seqlength info from seqinfo to avoid a potential out-of-bounds warning when shifting the windows
  
  #Now, move the windows start(karyoplot$plor.region) bases to the right. 
  #It's only necessary when zoomed or with chromosomes not starting at position 1
  windows <- shift(windows, shift=start(karyoplot$plot.region[seqnames(windows)])-1)
  
  
  #Count the number of read in the bam overlapping each window
  dens <- Rsamtools::countBam(data, param=Rsamtools::ScanBamParam(which = windows))$records
  
  if(normalize==TRUE) {
    total.reads <- sum(Rsamtools::idxstatsBam(file=data)$mapped)
    dens <- dens/total.reads
  }
  
  if(is.null(ymax)) {
    ymax <- max(dens)
  }
  
  #Specify the missing colors if possible
  if(is.null(border) & !is.null(col) & !is.na(col)) {
    border=darker(col, amount = 100)
  }
  if(is.null(col) & !is.null(border) & !is.na(col)) {
    col=lighter(border)
  }
  if(is.na(col) & is.null(border)) {
    border <- "black"
  }
  
  karyoplot <- kpBars(karyoplot, data=windows, y0=0, y1=dens,ymin=ymin, ymax=ymax, data.panel=data.panel, r0=r0, r1=r1, border=border, col=col, clipping=clipping, ...)
  
  karyoplot$latest.plot <- list(funct="kpPlotBAMDensity", computed.values=list(density=dens, windows=windows, max.density=max(dens)))

  invisible(karyoplot)
}

#' kpText
#' 
#' @description 
#' 
#' Plots the text given in \code{labels} at the positions defined by chr, x and y along the genome.
#' 
#' @details 
#'  
#' This is one of the functions from karyoploteR implementing the adaptation to the genome context 
#' of basic plot functions
#' from R base graphics. Given a set of positions on the genome (chromosome and base), a 
#' value (y) for each of them and a label, it plots the label at the position specified by the 
#' data point. Data can be provided via a \code{GRanges} object (\code{data}), independent
#' parameters for chr, x and y or a combination of both. A number of parameters can be used 
#' to define exactly where 
#' and how the text is drawn. In addition, via the ellipsis operator (\code{...}), \code{kpText}
#' accepts any parameter valid for \code{text} (e.g. \code{cex}, \code{col}, ...)
#'
#' @usage kpText(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, labels=NULL, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, ...)
#' 
#' @param labels    (a character vector) The labels to be plotted. (defaults to NULL)
#' @inheritParams kpPoints
#'
#' @return
#' 
#' Returns the original karyoplot object, unchanged. 
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpLines}}, \code{\link{kpPoints}}
#' @seealso \code{\link{kpPlotRegions}}
#' 
#' @examples
#'  
#' set.seed(1000)
#' data.points <- sort(createRandomRegions(nregions=500, mask=NA))
#' mcols(data.points) <- data.frame(y=runif(500, min=0, max=1))
#' 
#' kp <- plotKaryotype("hg19", plot.type=2, chromosomes=c("chr1", "chr2"))
#'   kpDataBackground(kp, data.panel=1)
#'   kpDataBackground(kp, data.panel=2)
#' 
#'   kpLines(kp, data=data.points, col="red")
#' 
#'   #Three ways of specifying the exact same data.points
#'   kpPoints(kp, data=data.points)
#'   kpPoints(kp, data=data.points, y=data.points$y, pch=16, col="#CCCCFF", cex=0.6)
#'   kpPoints(kp, chr=as.character(seqnames(data.points)), 
#'            x=(start(data.points)+end(data.points))/2,
#'            y=data.points$y, pch=".", col="black", cex=1)
#' 
#'   #plotting in the data.panel=2 and using r0 and r1, ymin and ymax
#'   kpLines(kp, data=data.points, col="red", r0=0, r1=0.3, data.panel=2)
#'   kpText(kp, data=data.points, labels=as.character(1:500), r0=0, r1=0.3, data.panel=2, pch=".", cex=3)
#' 
#'   kpLines(kp, data=data.points, col="blue", r0=0.4, r1=0.7, data.panel=2)
#'   kpLines(kp, data=data.points, col="blue", y=-1*(data.points$y), ymin=-1, ymax=0, r0=0.7, r1=1, data.panel=2)
#'   #It is also possible to "flip" the data by giving an r0 > r1
#'   kpPoints(kp, data=data.points, col="red", y=(data.points$y), r0=1, r1=0.7, data.panel=2, pch=".", cex=2)  
#' 
#' 
#'  
#' @export kpText
#' 


kpText <- function(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, labels=NULL,
                   ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, ...) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  pp <- prepareParameters2("kpText", karyoplot=karyoplot, data=data, chr=chr, x=x, y=y,
                           ymin=ymin, ymax=ymax, r0=r0, r1=r1, data.panel=data.panel, ...)
  ccf <- karyoplot$coord.change.function
    
  xplot <- ccf(chr=pp$chr, x=pp$x, data.panel=data.panel)$x
  yplot <- ccf(chr=pp$chr, y=pp$y, data.panel=data.panel)$y
  
  processClipping(karyoplot=karyoplot, clipping=clipping, data.panel=data.panel)  
  
  #Filter the additional parameters using the 'filter' vector returned by prepareParameters2
  dots <- filterParams(list(...), pp$filter, pp$original.length)
  labels <- filterParams(labels, pp$filter, pp$original.length)
  
  #And call the base plotting function with both the standard parameters and the modified dots parameters
  params <- c(list(x=xplot, y=yplot, labels=labels), dots)
  do.call(graphics::text, params)
  #graphics::text(x=xplot, y=yplot, labels=labels, ...)      
  
  invisible(karyoplot)
}

#' kpPlotCoverage
#' 
#' @description 
#' 
#' Given a \code{GRanges} object, plot the coverage along the genome. 
#' 
#' @details 
#'  
#'  This is one of the high-level, or specialized, plotting functions of karyoploteR.
#'  It takes a \code{GRanges} object and plots it's coverage, that is, the number of regions
#'  overlapping each genomic position. The input can also be a \code{SimpleRleList} resulting
#'  from computing the coverage with \code{coverage(data)}. In contrast with the low-level 
#'  functions such as \code{\link{kpRect}}, it is not possible to specify the data using 
#'  independent numeric vectors and the function only takes in the expected object types.
#'  
#'  There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
#'
#' @usage kpPlotCoverage(karyoplot, data, show.0.cov=TRUE, data.panel=1, r0=NULL, r1=NULL, col="#0e87eb", border=NULL, ymax=NULL, clipping=TRUE, ...)
#' 
#' @param karyoplot    (a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.
#' @param data    (a \code{GRanges} or a coverage object) A GRanges object from wich the coverage will be computed or a \code{SimpleRleList} result of computing the coverage.
#' @param show.0.cov (boolean) Wether to plot a thin line representing the regions with no coverage at all. (defaults to TRUE, plot the line)
#' @param data.panel    (numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param r0    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param r1    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param col    (color) The background color of the regions. (defaults to "#0e87eb")
#' @param border (color) The color of the border used to plot the coverage. If NULL, NA (no border) is used. (defaults to NULL)
#' @param ymax    (numeric) The maximum value to be plotted on the data.panel. If NULL the maximum coverage is used. (defaults to NULL)
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param ...    The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions. 
#' 
#' 
#' @return
#' 
#' Returns the original karyoplot object with the data computed (max.coverage, ymax) stored in latest.plot.
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpPlotRegions}}, \code{\link{kpBars}},  \code{\link{kpPlotBAMCoverage}}, \code{\link{kpPlotDensity}}
#' 
#' 
#' @examples
#'  
#'  set.seed(1000)
#'  
#  #Example 1: create 20 sets of non-overlapping random regions and plot them all. Add a coverage plot on top.
#  kp <- plotKaryotype("hg19", plot.type=1, chromosomes=c("chr1", "chr2"))
#  
#  all.regs <- GRanges()
# 
#  nreps <- 20
#  for(i in 1:nreps) {
#    regs <- createRandomRegions(nregions = 100, length.mean = 10000000, length.sd = 1000000,
#                                non.overlapping = TRUE, genome = "hg19", mask=NA)
#    all.regs <- c(all.regs, regs)
#    kpPlotRegions(kp, regs, r0 = (i-1)*(0.8/nreps), r1 = (i)*(0.8/nreps), col="#AAAAAA")
#  }
# 
#  kpPlotCoverage(kp, all.regs, ymax = 20, r0=0.8,  r1=1, col="#CCCCFF")
#  kpAxis(kp, ymin = 0, ymax= 20, numticks = 2, r0 = 0.8, r1=1)
# 
#   
#'  #Example 2: Do the same with a single bigger set of possibly overlapping regions
#'  
#'  kp <- plotKaryotype("hg19", plot.type=1, chromosomes=c("chr1", "chr2"))
#'  
#'  regs <- createRandomRegions(nregions = 1000, length.mean = 10000000, length.sd = 1000000,
#'                              non.overlapping = FALSE, genome = "hg19", mask=NA)
#'  kpPlotRegions(kp, regs, r0 = 0, r1 = 0.8, col="#AAAAAA")
#'  
#'  kpPlotCoverage(kp, regs, ymax = 20, r0=0.8,  r1=1, col="#CCCCFF")
#'  kpAxis(kp, ymin = 0, ymax= 20, numticks = 2, r0 = 0.8, r1=1)
#'  
#'  
#'@export kpPlotCoverage
#'@importFrom IRanges IntegerList
#'@importFrom GenomicRanges coverage
#'

kpPlotCoverage <- function(karyoplot, data, show.0.cov=TRUE, data.panel=1, r0=NULL, r1=NULL, col="#0e87eb", border=NULL, ymax=NULL, clipping=TRUE, ...) {
  #Check parameters
  #karyoplot
  if(missing(karyoplot)) stop("The parameter 'karyoplot' is required")
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  #data
  if(missing(data)) stop("The parameter 'data' is required")
  #TODO: If data is not a SimpleRleList, try to convert it to a GRanges before testing with is so other Region Set formats can be used
  if(!methods::is(data, "GRanges") && !methods::is(data, "SimpleRleList")) {
    data <- tryCatch(toGRanges(data), error=function(e) {stop("'data' must be a GRanges object or a SimpleRleList")})
  }  
  #Compute (if needed) the coverage
  #If its not a coverage object,  it's a GRanges. Compute the coverage
  if(!methods::is(data, "SimpleRleList")) { 
    #remove any region not in the currently used genome
    data <- data[as.character(Seqinfo::seqnames(data)) %in% karyoplot$chromosomes,]
       #Old version, problems when data had no seqinfo - data <- GenomeInfoDb::keepSeqlevels(data, karyoplot$chromosomes, pruning.mode="coarse")
    #Remove any unused seq level from the GRanges to fix problems with coverage and witdh
    Seqinfo::seqlevels(data) <- karyoplot$chromosomes
 
    #the width parameter is needed so the coverage extends to the end of the chromosomes
    data <- GenomicRanges::coverage(data, width=karyoplot$chromosome.lengths[Seqinfo::seqlevels(data)]) 
  }
  coverage.gr <- toGRanges(data)
 
  if(show.0.cov==FALSE) {
    coverage.gr <- coverage.gr[coverage.gr$coverage!=0]
  }
  
  if(is.null(ymax)) ymax <- max(max(coverage.gr$coverage))
  
  if(is.null(border)) border <- col
  
  # kpBars(karyoplot=karyoplot, data=coverage.gr,
  #        y0=0, y1=coverage.gr$coverage, ymin=0, ymax=ymax,
  #        r0=r0, r1=r1, data.panel=data.panel,
  #        col=col, border=border, clipping=clipping, ...)

  
  #To get kpArea to plot the real coverage (flat tops), we need to build a
  #GRanges with two elements per range, one at the start and one at the end
  #NOTE: this breaks the show.cov.0=FALSE. 
  #TODO: Make kpArea and kpLines deal with NAs in the data and set coverage=0 
  #to NA here
  cov.start <- coverage.gr
  end(cov.start) <- start(cov.start)
  cov.end <- coverage.gr
  start(cov.end) <- end(cov.end)
  cov.to.plot <- sort(c(cov.start, cov.end))
  
  kpArea(karyoplot=karyoplot, data=cov.to.plot, y=cov.to.plot$coverage, 
         base.y = 0, ymin=0, ymax=ymax,
         r0=r0, r1=r1, data.panel=data.panel,
         col=col, border=border, clipping=clipping, ...)
  
  karyoplot$latest.plot <- list(funct="kpPlotCoverage", computed.values=list(max.coverage=max(max(coverage.gr$coverage)),
                                                                            coverage=coverage.gr,
                                                                            ymax=ymax))
  
  invisible(karyoplot)
}

# 
# 
# #Given a color, returns a lighter one
# #TODO: Is there a better way to do that?
# lighter <- function(col, amount=150) {
#   col <- (col2grDevices::rgbcol)+amount)/255
#   col[col[,1]>1,1] <- 1
#   return(grDevices::rgbt(col)))  
# }
# 
# #Helper Function
# #From: http://stackoverflow.com/questions/20519431/finding-point-of-intersection-in-r
# # segment-segment intersection code
# # http://paulbourke.net/geometry/pointlineplane/
# ssi <- function(x1, x2, x3, x4, y1, y2, y3, y4){
#   
#   denom <- ((y4 - y3)*(x2 - x1) - (x4 - x3)*(y2 - y1))
#   denom[abs(denom) < 1e-10] <- NA # parallel lines
#   
#   ua <- ((x4 - x3)*(y1 - y3) - (y4 - y3)*(x1 - x3)) / denom
#   ub <- ((x2 - x1)*(y1 - y3) - (y2 - y1)*(x1 - x3)) / denom
#   
#   x <- x1 + ua * (x2 - x1)
#   y <- y1 + ua * (y2 - y1)
#   inside <- (ua >= 0) & (ua <= 1) & (ub >= 0) & (ub <= 1)
#   data.frame(x = ifelse(inside, x, NA), 
#              y = ifelse(inside, y, NA))
#   
# }
# 
# 
# kpPlot2Lines <- function(karyoplot, adata=NULL, achr=NULL, ax=NULL, ay=NULL, 
#                          bdata=NULL, bchr=NULL, bx=NULL, by=NULL, 
#                          ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, 
#                          acol="red", bcol="blue", afill=NULL, bfill=NULL, ...) {
# 
#   app <- prepareParameters2("kpPlot2Lines", karyoplot=karyoplot, data=adata, chr=achr, x=ax, y=ay, ymin=ymin, ymax=ymax, r0=r0, r1=r1, data.panel=data.panel) , ...)
#   bpp <- prepareParameters2("kpPlot2Lines", karyoplot=karyoplot, data=bdata, chr=bchr, x=bx, y=by, ymin=ymin, ymax=ymax, r0=r0, r1=r1, data.panel=data.panel) , ...)
#   
#   ccf <- karyoplot$coord.change.function
#   
#   #Define the colors 
#   if(is.null(afill)) afill <- lighter(acol, amount=200)
#   if(is.null(bfill)) bfill <- lighter(bcol, amount=200)
#   
# 
#   #Process separately for every chromosome
#   
#   aline <- data.frame(chr=app$chr, x=app$x, y=app$y, stringsAsFactors=FALSE)
#   bline <- data.frame(chr=bpp$chr, x=bpp$x, y=bpp$y, stringsAsFactors=FALSE)
# 
#   
#   for(chr in karyoplot$chromosomes) {
#     #Filter A data
#       a.in.chr <- app$chr == chr
#       chr.aline <- aline[a.in.chr,]
#       a.len <- nrow(chr.aline)
#     #Filter B data  
#       b.in.chr <- bpp$chr == chr
#       chr.bline <- bline[b.in.chr,]
#       b.len <- nrow(chr.bline)
#       
#     #Find the intersection points between the 2 lines
#     intersections <- ssi(x1=chr.aline$x[-a.len], x2=chr.aline$x[-1], y1=chr.aline$y[-a.len], y2=chr.aline$y[-1], #<- segments defined by line A
#                          x3=chr.bline$x[-b.len], x4=chr.bline$x[-1], y3=chr.bline$y[-b.len], y4=chr.bline$y[-1]) # <- segments defined by line B
#     intersections <- intersections[!is.na(intersections$x),]
#     intersections <- intersections[!duplicated(intersections$x),]
#       
#     if(nrow(intersections)==0) { #If there are no intersections, simply plot a single polygon filing the space between the lines
#         xpol <- c(chr.ax, rev(chr.bx))
#         ypol <- c(chr.ay, rev(chr.by))
#         #decide the color
#         if(mean(chr.ay)>mean(chr.by)) {
#           fillcol <- afill
#         } else {
#           fillcol <- bfill
#         }
#         #and plot the polygon
#         kpPolygon(karyoplot=karyoplot, chr=chr, x=xpol, y=ypol, col=fillcol, border=NA, ymin=ymin, ymax=ymax, r0=r0, r1=r1, data.panel=data.panel)  
#     } else {
#       #If there are intersections, plot a polygon for every region they define
#       na.a <- which(is.na(r$a$x) | is.nan(r$a$x) | is.na(r$a$y) | is.nan(r$a$y))
#       na.b <- which(is.na(r$b$x) | is.nan(r$b$x) | is.na(r$b$y) | is.nan(r$b$y))
#       cuts <- c(intersections$x, r$a$x[na.a], r$b$x[na.b])
#       cuts <- cuts[!is.na(cuts) & !is.nan(cuts)]
#       cuts <- sort(cuts)
#       cuts <- cuts[!duplicated(cuts)]
#       
#       #WARNING: We are ignoring the x=NA and x=NaN
#       
#       #break the lines using the cuts
#       ca <- chr.aline
#       cb <- chr.bline
#       
#       ca <- ca[-na.a,]
#       cb <- cb[-nb.b,]
#       
#       regions <- list()
#       for(x.cut in cuts) {
#         print(as.character(x.cut))
#         
#         #a line
#         a.before <- which(ca$x<=x.cut)
#         if(length(a.before)>0) {
#           reg.aline <- ca[a.before,]
#           print(paste0("ca: ", nrow(ca), "  a.before=", length(a.before), "   new ca:", nrow(ca[-a.before,])))
#           ca <- ca[-a.before,]
#         }
#         b.before <- which(cb$x<=x.cut)
#         if(length(b.before)>0) {
#           reg.bline <- ca[b.before,]
#           cb <- cb[-b.before,]
#         }
#         if(length(a.before)>0 | length(b.before)>0) {
#           regions[[as.character(x.cut)]] <- list(a=reg.aline, b=reg.bline)  
#         }
#       }
#       
#       
#       regions
#       
#       chr.aline$x
#       
#       
#       
#       
#       
#       #split the lines in contiguos regions using a) the intersection points b)the NA and NaN values
#       ca <- chr.aline
#       cb <- chr.bline
#       last.int <- NULL
#       regions <- list()
#       for(n in c(1:nrow(intersections))) {
#         ix <- intersections$x[n]
#         #a line
#           a.before <- which(ca$x<=ix)
#           if(length(a.before)>0) {
#             a.cut <- a.before[length(a.before)]
#             reg.aline <- ca[c(1:a.cut),]
#             ca <- ca[-c(1:a.cut),]
#           }
#         #a line
#           b.before <- which(cb$x<ix)
#           if(length(b.before)>0) {
#             b.cut <- b.before[length(b.before)]
#             reg.bline <- cb[c(1:b.cut),]
#             cb <- cb[-c(1:b.cut),]  
#           }
#         if(length(a.before)>0 | length(b.before)>0) {
#           regions[[as.character(n)]] <- list(a=reg.aline, b=reg.bline, ibefore=last.int, iafter=intersections[n,])  
#         }
#         last.int <- intersections[n,]
#       }
#       if(nrow(ca)>0 | nrow(cb)>0) {
#         regions[[as.character(n+1)]] <- list(a=ca, b=cb, ibefore=last.int, iafter=NULL)  
#       }
#       
#       #after that, split at NA and NaN to get the real regions to plot the polygons
#       final.regions <- list()
#       for(n in names(regions)) {
#         r <- regions[[n]]
#         na.a <- which(is.na(r$a$x) | is.nan(r$a$x) | is.na(r$a$y) | is.nan(r$a$y))
#         na.b <- which(is.na(r$b$x) | is.nan(r$b$x) | is.na(r$b$y) | is.nan(r$b$y))
#         if(length(na.a)>0 | length(na.b) > 0) { #If there are NAs or NaNs, split the region as needed
#           if(1 %in% na.a) { #if the first value of any of the lines is NA, forget the intersection point
#             na.a <- na.a[-1]
#             r$ibefore <- NULL
#           }
#           if(1 %in% na.b) {
#             na.b <- na.b[-1]
#             r$iafter <- NULL
#           }
#           
#           if(length(na.a)>0 | length(na.b) > 0) { #If there are still NAs
#             x.cuts <- sort(c(r$a$x[na.a-1], r$b$x[na.b-1]))
#             ra <- r$a[-na.a,]
#             rb <- r$b[-na.b,]        
#             
#             for(i in c(1:length(x.cuts))) {
#               x <- x.cuts[i]
#               if(is.na(x) | is.nan(x)) next; #do nothing with it
#               a.before <- which(ra$x <= x)
#               if(length(a.before)>0) {
#                 a <- ra[a.before,]
#                 ra <- ra[-a.before]
#               }
#               b.before <- which(rb$x <= x)
#               if(length(a.before)>0) {
#                 a <- ra[a.before,]
#                 ra <- ra[-a.before]
#               }
#               if(length(a)>1 & length(b)>1) { #If we cannot draw at least a 4 sided polygon, ignore the region and draw nothing (only lines)
#                                                 
#               } #else, do nothing. 
#             }  
#             
#             
#           } else {
#             final.regions[[n]] <- r
#           }
#         } else { #If there are no NAs or NaNs in the region, keep ot as is
#           final.regions[[n]] <- r
#         }
#         
#       }
#       
#       
#       n <- "8"
#       
#       #First, add a finall intersection point to plot the last polygon
#       intersections <- rbind(intersections, c(x=mean(c(chr.ax[a.len], chr.bx[b.len])), y=mean(c(chr.ay[a.len], chr.by[b.len]))))
#       #kpPoints(karyoplot, chr=chr, x=intersections$x, y=intersections$y)
#           
#       #These intersection points break the lines in regions where A is above B and regions where B is above A
#       #Define these regions and plot the polygons defined by the 2 lines in the correct color
#       old.ix <- NULL
#       old.iy <- NULL
#       for(n in c(1:nrow(intersections))) {
#         ix <- intersections$x[n]
#         iy <- intersections$y[n]
#         if(is.null(old.ix)) { #If it's the first region
#           a.in.region <- chr.ax < ix 
#           b.in.region <- chr.bx < ix 
#         } else { 
#           a.in.region <- chr.ax <= ix & chr.ax >= old.ix
#           b.in.region <- chr.bx <= ix & chr.ax >= old.ix
#         }
#         if(length(a.in.region)>0) { 
#           #Prepare x coordinates
#             xpol <- numeric()
#             if(!is.null(old.ix)) xpol <- old.ix
#             xpol <- c(xpol, chr.ax[a.in.region], ix, rev(chr.bx[b.in.region]))
#           #Prepare y coordinates
#             ypol <- numeric()
#             if(!is.null(old.iy)) ypol <- old.iy
#             ypol <- c(ypol, chr.ay[a.in.region], iy, rev(chr.by[b.in.region]))
#           #decide the color
#             if(mean(chr.ay[a.in.region])>mean(chr.by[b.in.region])) {
#               fillcol <- afill
#             } else {
#               fillcol <- bfill
#             }
#           #and plot the polygon
#             kpPolygon(karyoplot=karyoplot, chr=chr, x=xpol, y=ypol, col=fillcol, border=NA, ymin=ymin, ymax=ymax, r0=r0, r1=r1, data.panel=data.panel)
#         }
#         old.ix <- ix
#         old.iy <- iy
#       }
#     } 
#     #And finally, plot the lines
#       #Plot the line A
#       kpLines(karyoplot=karyoplot, chr=app$chr, x=app$x, y=app$y, col=acol, ymin=ymin, ymax=ymax, r0=r0, r1=r1, data.panel=data.panel, ...)
#     #Plot the line B
#       kpLines(karyoplot=karyoplot, chr=bpp$chr, x=bpp$x, y=bpp$y, col=bcol, ymin=ymin, ymax=ymax, r0=r0, r1=r1, data.panel=data.panel, ...)
#   }
#     
# }

#' kpPlotLoess
#' 
#' @description 
#' 
#' Plot a LOESS smoothed line with confidence intervals given a list of points.
#' 
#' @details 
#'  
#' Given a set of data points (specified in any way accepted by \code{\link{kpPoints}}),
#' plot a LOESS smoothed line with optional confidence intervals. LOESS is
#' computed independently per each chromosome and data points are sorted before
#' fitting. It is possible to adjust the confidence interval with 
#' \code{conf.interval} and setting it to NULL or NA will plot no CI. It is also
#' possible to control the smoothing level with \code{span}. In addition to 
#' the standard plotting parameters, it is possible to control independently the
#' color of the fitting line and CI area and CI borders. It is also possible to
#' adjust the line type and line width of the fitting line and CI border.
#' 
#' @usage kpPlotLoess(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, conf.interval=0.95, span=0.5, data.panel=1, r0=NULL, r1=NULL, ymin=NULL, ymax=NULL, col="black", lty=1, lwd=1, ci.col="#888888AA", ci.border=NA, ci.border.lty=1, ci.border.lwd=1, clipping=TRUE, ...)
#'  
#' @inheritParams kpPoints 
#' @param conf.interval The confidence interval to plot. If a number in (0,1), the confidence interval is plotted. Else, no confidence interval is plotted. (defaults to 0.95)
#' @param span A parameter to control the smoothing level. It is passed to underlying function \code{\link[stats]{loess}}. (deafults to 0.5)
#' @param col The color of the fitting line. (defaults to "black")
#' @param lty The line type (dashed, dotted...) of the fitting line (defaults to 1, solid)
#' @param lwd The line width of the fitting line (defaults to 1)
#' @param ci.col The color of the area representing the confidence interval. If NA no CI is plotted. (defaults to #888888AA, transparent gray)
#' @param ci.border The color of line marking the border of the confidence interval. If NA, it's not plotted. (defaults to NA)
#' @param ci.border.lty The line type of line marking the border of the confidence interval. (defaults to 1, solid)
#' @param ci.border.lwd The line width of line marking the border of the confidence interval. (defaults to 1)
# @param smooth A boolean indicating if the ribbon should be smoothed (with a spline approximation) before plotting (defaults to FALSE)
#'     
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#' 
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpPoints}}, \code{\link{kpLines}}, \code{\link{kpPlotRibbon}}
#' 
#' @examples
#' 
#' 
#' set.seed(1000)
#' 
#' dd <- data.frame(chr="chr1", x=1:48*5e6, y=rnorm(n=48, 0.5, 0.1 ))
#' 
#' kp <- plotKaryotype(chromosomes="chr1")
#' kpPoints(kp, chr=dd$chr, x=dd$x, y=dd$y)
#' kpPlotLoess(kp, chr=dd$chr, x=dd$x, y=dd$y, col="red", conf.interval = 0.99, ci.col = "#FAAAAAAA")
#' 
#' 
#' @importFrom stats qt
#' @importFrom stats predict
#' @importFrom stats loess
#' 
#' @export kpPlotLoess
#' 
#' 


kpPlotLoess <- function(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, conf.interval=0.95, span=0.5, data.panel=1, r0=NULL, r1=NULL, ymin=NULL, ymax=NULL, col="black", lty=1, lwd=1, ci.col="#888888AA", ci.border=NA, ci.border.lty=1, ci.border.lwd=1, clipping=TRUE, ...) {

  if(!methods::is(karyoplot, "KaryoPlot")) stop(paste0("In kpPlotLoess: 'karyoplot' must be a valid 'KaryoPlot' object"))

  #Use prepare parameters to normalize the input but do not rescale or filter it
  pp <- prepareParameters2("kpPlotLoess", karyoplot=karyoplot, data=data, chr=chr, x=x, y=y,
                           ymin=0, ymax=1, r0=0, r1=1, data.panel=1, filter.data = FALSE, ...)
  
  #Prepare the arrays to accumulate the data for every chromosome to return in the karyoplot
  all.chr <- character()
  all.x <- integer()
  all.fit <- numeric()
  all.upper <- numeric()
  all.lower <- numeric()
  
  for(chr.name in karyoplot$chromosomes) {
    
    in.chr <- pp$chr==chr.name
    chr.chr <- pp$chr[in.chr]
    x.chr <- pp$x[in.chr]
    y.chr <- pp$y[in.chr]
    
    #sort the data
    ord <- order(x.chr)
    x.chr <- x.chr[ord]
    y.chr <- y.chr[ord]
    
    #compute the loess fitting with CI 
    #adapted from https://stackoverflow.com/questions/22717930/how-to-get-the-confidence-intervals-for-lowess-fit-using-r
    l.fit <- predict(loess(y.chr ~ x.chr, span=span, ...), se=TRUE)

    #Compute (and plot) the confidence interval 
    if(is.numeric(conf.interval)) {
      if(conf.interval>=1 | conf.interval<=0) {stop("Invelid value for confidence interval. Should be (0,1). Is: ", conf.interval)}
      qtile <- 1 - ((1 - conf.interval)/2)
      upper.ci <- l.fit$fit + qt(qtile, l.fit$df)*l.fit$se
      lower.ci <- l.fit$fit - qt(qtile, l.fit$df)*l.fit$se
      
      kpPlotRibbon(karyoplot=karyoplot, chr=chr.chr, x0=x.chr, x1=x.chr, y0=lower.ci, y1=upper.ci, 
                   col=ci.col, border=ci.border, lty=ci.border.lty, lwd=ci.border.lwd,
                   data.panel=data.panel, ymin=ymin, ymax=ymax, r0=r0, r1=r1,
                   clipping=clipping, ...)
    } else {
      upper.ci <- NULL
      lower.ci <- NULL
    }
    
    #And plot the fitting
    kpLines(karyoplot=karyoplot, chr=chr.chr, x=x.chr, y=l.fit$fit,
            col=col, lty=lty, lwd=lwd,
            data.panel=data.panel, ymin=ymin, ymax=ymax, r0=r0, r1=r1,
            clipping=clipping, ...)

    all.chr <- c(all.chr, chr.chr)
    all.x <- c(all.x, x.chr)
    all.fit <- c(all.fit, l.fit)
    all.upper <- c(all.upper, upper.ci)
    all.lower <- c(all.lower, upper.ci)
    
  }
    
  karyoplot$latest.plot <- list(funct="kpPlotLoess", 
                                computed.values=list(chr=all.chr,
                                                     x=all.x,
                                                     loess=all.fit, 
                                                     upper.ci=all.upper,
                                                     lower.ci=all.lower)
  )
    
  invisible(karyoplot)
}

#' kpHeatmap
#' 
#' @description 
#' 
#' Plots the given data as a heatmap along the genome
#' 
#' @details 
#'  
#' Given regions of the genome with a start, end and a value, draws a heatmap-like
#' representation, with the color of the region determined by its value. It is important to 
#' note that \code{kpHeatmap} will not extend the regions in any way, so if regions are not 
#' contiguous, they will appear as a series of rectangles and not as a continuous plot.
#' 
#' @usage kpHeatmap(karyoplot, data=NULL, chr=NULL, x0=NULL, x1=x0, y=NULL, ymax=NULL, ymin=NULL, r0=NULL, r1=NULL, data.panel=1, colors=c("blue", "white", "yellow"), clipping=TRUE, ...)
#'  
#' @inheritParams kpPoints
#' @param x0 (numeric) the position (in base pairs) where the data region starts
#' @param x1 (numeric) the position (in base pairs) where the data region ends
#' @param colors    (colors) A set of color used to determine the color associated with each value. Internally, it uses \code{\link[grDevices]{colorRamp}}. (defaults to c("blue", "white", "yellow"))
#'     
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#' 
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpRect}}, \code{\link{kpLines}}
#' 
#' @examples
#'   
#' dd <- toGRanges(data.frame(chr="chr1", start=4980000*(0:49), end=4980000*(1:50)))
#' y <- sin(x=c(1:length(dd))/2)
#' 
#' kp <- plotKaryotype("hg19", plot.type=1, chromosomes=c("chr1", "chr2"))
#' 
#' kpLines(kp, dd, y=y, r0=0.4, r1=0.6, ymin=-1, ymax=1)
#' kpAxis(kp, r0=0.4, r1=0.6, ymin=-1, ymax=1, cex=0.5)
#' 
#' kpHeatmap(kp, dd, y=y, colors = c("red", "black", "green"), r0=0, r1=0.2)
#' kpHeatmap(kp, dd, y=y, colors = c("green", "black", "red"), r0=0.2, r1=0.4)
#' 
#' #or we can provide all data into a single GRanges object
#' mcols(dd) <- data.frame(y=y)
#' 
#' kpHeatmap(kp, dd, r0=0.6, r1=0.8)
#' #non-contiguous regions appear as solitary rectangles
#' kpHeatmap(kp, sample(x = dd, 10), r0=0.8, r1=1, color=c("orange", "black", "purple", "green"))
#' 
#' 
#'@export kpHeatmap

kpHeatmap <- function(karyoplot, data=NULL, chr=NULL, x0=NULL, x1=x0, y=NULL, 
                      ymax=NULL, ymin=NULL, r0=NULL, r1=NULL, 
                      data.panel=1, 
                      colors=c("blue", "white", "yellow"), clipping=TRUE, ...) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  
 
  #Manually process "y" since in this track it is not affected by r0, r1, etc...
  if(!is.null(data)) {
    if(is.null(y)) {
      if("value" %in% names(mcols(data))) {
        y <- data$value
      } else {
        if("y" %in% names(mcols(data))) {
          y <- data$y
        } else {
          stop("No y value specified. It is needed to provide ymax or a column named 'y' in data")
        }
      }
    }
  } 
  
  if(is.null(ymin)) ymin <- min(y)
  if(is.null(ymax)) ymax <- max(y)
  
  if(ymin == ymax) {
    ymin <- karyoplot$plot.params[[paste0("data", data.panel, "min")]]
    ymax <- karyoplot$plot.params[[paste0("data", data.panel, "max")]]
  }
      
  #Standardize the values to the [0,1] range to plot it with colorRamp
  y <- y - ymin
  y <- y/(ymax - ymin)
  
  
  #Create the colorRamp
  cr <- grDevices::colorRamp(colors=colors)
  
  invisible(kpRect(karyoplot=karyoplot, data=data, chr=chr, x0=x0, x1=x1, y0=0, y1=1,
                   ymin=0, ymax=1, r0=r0, r1=r1, 
                   col=grDevices::rgb(cr(y), max=255), border=NA,
                   data.panel=data.panel, clipping=clipping, ...))
  
  
 
}

#internal
#Utility functions used only within the package


#Recycle the arguments as needed.
#Taken from:
# http://stackoverflow.com/questions/9335099/implementation-of-standard-recycling-rules
recycle <- function(...){
  dotList <- list(...)
  max.length <- max(vapply(dotList, length, FUN.VALUE=0))
  lapply(dotList, rep, length=max.length)
}


#Only recycles the first argument and returns it
recycle.first <- function(...){
  dotList <- list(...)
  max.length <- max(vapply(dotList, length, FUN.VALUE = 0))
  return(rep_len(dotList[[1]], length.out=max.length))
}




#' filterParams
#' 
#' @description 
#' Given a list, select just only the valid.elements from each member. Also 
#' works with vectors instead of lists
#' 
#' @details 
#' This function is used in filtering the graphical parameters when plotting
#' only a part of the genome. For each element of the list, if it has the 
#' exact specified length, filters it using the 'valid.elements' parameter.
#' 
#' @usage filterParams(p, valid.elements, orig.length)
#' 
#' @param p a list or a single vector
#' @param valid.elements a boolean vector with the elements to keep
#' @param orig.length the length of the elements on which to apply the filtering
#' 
#' @return
#' p with some members filtered
#' 
#' 
#' @examples
#'  
#' a <- 1:10
#' b <- 3:5
#' c <- 2
#' 
#' filterParams(list(a,b,c), c(rep(TRUE,5), rep(FALSE,5)), 10)
#' filterParams(a, c(rep(TRUE,5), rep(FALSE,5)), 10)
#'  
#' @export filterParams
#' 
filterParams <- function(p, valid.elements, orig.length) {
  if(methods::is(p, "list")) { #If p is a list, filter each element independently
    for(i in seq_len(length(p))) {
      if(length(p[[i]])==orig.length) {
        p[[i]] <- p[[i]][valid.elements]
      }
    }
  } else { #else, filter p as a single element
    if(length(p)==orig.length) {
      p <- p[valid.elements]
    }
  }
  return(p)
}


############  Clipping   ###############
#' processClipping
#' 
#' @description 
#' Sets image clipping if needed
#' 
#' @details 
#' Small utility function to help manage clipping. If the current plot is
#' a zoomed plot and clipping is TRUE, activate the clip to the current 
#' data.panel. This will hide any plotting ocurring out of the data.panel
#' region.
#' 
#' @note Users wont usually use this function. It is used by the plotting functions 
#' to set the clipping if needed
#' 
#' @usage processClipping(karyoplot, clipping, data.panel) 
#' 
#' @param karyoplot (KaryoPlot) A KaryoPlot object representing the current plot
#' @param clipping (logical) Wheter clipping should be activated or not
#' @param data.panel (data panel identifier) The name of the data panel on which the plot should be allowed. Anything plotted outside it will be hidden (if clipping==TRUE and the plot is a zoom plot)
#' 
#' @return
#' Returns the original karyoplot object, unchanged.
#' 
#' @examples
#' 
#' kp <- plotKaryotype()
#' processClipping(kp, TRUE, 1)
#'
#'  
#' @export processClipping
#'
processClipping <- function(karyoplot, clipping, data.panel) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")

  if(karyoplot$zoom==TRUE) {
    if(clipping==TRUE) {
      dpbb <- getDataPanelBoundingBox(karyoplot, data.panel)
      graphics::clip(x1 = dpbb$x0, x2 = dpbb$x1, y1 = dpbb$y0, y2=dpbb$y1)
    }
  }
  invisible(karyoplot)
}


############  Autotrack  ###############

#' autotrack
#' 
#' @description 
#' Computes r0 and r1 given track definition
#' 
#' @details 
#' Small utility function to help compute r0 and r1 given the total number of tracks 
#' and the track(s) the current plot will occupy. It also takes into account a margin
#' between tracks and original r0 and r1, so we can say something like, "Out of 5 
#' tracks between 0 and 0.5, this plot will be at track 2", and it will return
#' r0=0.1 and r1=0.2
#' 
#' 
#' @usage autotrack(current.track, total.tracks, margin=0.05, r0=0, r1=1)
#' 
#' @param current.track (numeric) The track or tracks the current plot will occupy, starting from 1. If more than one value is provided, the plot will expand from min(current.track) to max(current.track).
#' @param total.tracks (numeric) The total number of tracks
#' @param margin (numeric) The margin is specified as the part of a track, by default 0.05, 5 percent of the track height. 
#' @param r0 (numeric) the original r0
#' @param r1 (numeric) the original r1
#' 
#' @return
#' A list of two numerics: r0 and r1
#' 
#' @examples
#'
#' #first track out of 4  
#' autotrack(1, 4)
#'
#' #the same, but without margin
#' autotrack(1, 4, 0)
#' 
#' #first and second tracks out of 4
#' autotrack(c(1,2), 4)
#' 
#' #The first track out of 4, fitting the four track between 0 and 0.5
#' autotrack(1, 4, r0=0, r1=0.5)
#'  
#' @export autotrack
#'

autotrack <- function(current.track, total.tracks, margin=0.05, r0=0, r1=1) {
  if(!methods::is(current.track, "numeric")) stop("current.track must be numeric")
  if(!methods::is(total.tracks, "numeric")) stop("total.tracks must be numeric")
  if(length(total.tracks)>1) {
    warning("total.tracks has more than one value. Using only the first one.")
    total.tracks <- total.tracks[1]  
  }
  if(!methods::is(margin, "numeric")) stop("margin must be numeric")
  if(length(margin)>1) {
    warning("margin has more than one value. Using only the first one.")
    margin <- margin[1]  
  }
  if(!methods::is(r0, "numeric")) stop("r0 must be numeric")
  if(!methods::is(r1, "numeric")) stop("r1 must be numeric")
  
  
  at.current.min <- min(current.track)
  at.current.max <- max(current.track)
  
  tr.height <- (r1-r0)/total.tracks
  r0 <- r0+(at.current.min-1)*tr.height
  r1 <- r0+(at.current.max-at.current.min+1)*tr.height-tr.height*margin
  
  return(list(r0=r0, r1=r1))
}





#Internal function. Not exported. Used to validate and preprocess r0 and r1
preprocess_r0_r1 <- function(karyoplot, r0, r1, data.panel) {
  
  if(!is.null(r0) && is.null(r1)) { #Maybe r0 contains the r0 and r1 information
    #It might be a list
    if(is.list(r0) && 
       utils::hasName(r0, "r0") && utils::hasName(r0, "r1") &&
       (is.null(r0$r0) || is.numeric(r0$r0)) && (is.null(r0$r1) || is.numeric(r0$r1))) {
      r1 <- r0$r1
      r0 <- r0$r0
    } else {
      #It might be a two element array
      if(is.numeric(r0) && length(r0)>=2) {
        if(all(c("r0", "r1") %in% names(r0))) {
          r1 <- setNames(r0["r1"], NULL)
          r0 <- setNames(r0["r0"], NULL)
        } else {
          r1 <- setNames(r0[2], NULL)
          r0 <- setNames(r0[1], NULL)
        }
      }
    }
  } 
  if(is.null(r0)) {
    r0 <- karyoplot$plot.params[[paste0("data", data.panel, "min")]]
  }
  if(is.null(r1)) {
    r1 <- karyoplot$plot.params[[paste0("data", data.panel, "max")]]
  }
  
  
  #Finally, check that r0 and r1 are valid numbers
  if(!(is.numeric(r0) && length(r0)==1)) stop("Invalid r0 specification. Check karyoploteR's documentation for more information.")
  if(!(is.numeric(r1) && length(r1)==1)) stop("Invalid r1 specification. Check karyoploteR's documentation for more information.")
  
  return(list(r0=r0, r1=r1))  
}



############  Intersections  ###############


#' findIntersections
#' 
#' @description 
#' Finds the intersections of a data line with a given threshold
#' 
#' @details 
#' Given a GRanges with an mcol with name "y" representing the values. This function
#' will return a GRanges with the points intersecting a specific value "thr". 
#' 
#' @note Important: It will only return the intersection points where the line crosses
#'  the threshold but not if a data point lies exactly at the threshold.
#' 
#' @usage findIntersections(data, thr)
#' 
#' @param data  (GRanges with y mcol) A GRanges with the data points
#' @param thr  (numeric) The value at wich we want to calculate the intersections
#'
#' @return
#' A GRanges representing the intersection points between the data line and the threshold.
#' It will return an empty GRanges if the line does not intersect the threshold.  
#' 
#' @examples
#'
#' d <- toGRanges(c("1:1-1", "1:5-5", "1:15-15"))
#' d$y <- c(-2, 3, 1)
#'  
#' findIntersections(d, 1.5)  
#' findIntersections(d, 0)  
#' findIntersections(d, 5)  
#'
#' @export findIntersections
#' @importFrom IRanges which
findIntersections <- function(data, thr) {
  #we nee IRanges which because the logical query return an Rle encoded logical
  isec <- IRanges::which((data$y>thr & shiftl(data$y<thr) | data$y<thr & shiftl(data$y>thr))
                & (Seqinfo::seqnames(data)==Seqinfo::seqnames(data+1)))
  if(length(isec)==0) return(GRanges())
  ydist <- data$y[isec+1] - data$y[isec]
  xdist <- GenomicRanges::start(data)[isec+1] - GenomicRanges::start(data)[isec]
  pos.isec <- GenomicRanges::start(data)[isec] + (thr-data$y[isec])/ydist*xdist
  return(regioneR::toGRanges(data.frame(as.character(Seqinfo::seqnames(data[isec])), pos.isec, pos.isec, y=thr)))
}

#shiftl: Utility function to shift logical vectors one position to the left
shiftl <- function(l) {return(c(l[2:length(l)], FALSE))}


#Internal function. Check if the chromosome name styles match between data and genome
checkChromosomeStyle <- function(data.chr, genome.chr) {
  if(length(data.chr)>0 & length(genome.chr)>0 &
     !any(data.chr %in% genome.chr) & 
     any(gsub(pattern = "chr", replacement = "", x = data.chr, ignore.case = TRUE) %in% gsub(pattern = "chr", replacement = "", x = genome.chr, ignore.case = TRUE))) {
    message("Chromosome name styles in data (\"", data.chr[1], "\") and genome (\"", genome.chr[1], "\") do not match.
They must match exactly for karyoploteR to plot anything. It seems it may be a problem with 'chr' in the names?")
  }
}

library(karyoploteR)
context("utils.R functions")


test_that("preprocess_r0_r1 works as expected", {
  
  #Create the needed kp
  kp <- plotKaryotype()
  
  #Correct specifications
  expect_equal(preprocess_r0_r1(kp, r0=0.2, r1=0.8, data.panel = 1), list(r0=0.2, r1=0.8))
  expect_equal(preprocess_r0_r1(kp, r0=list(r0=0.2, r1=0.8), r1=NULL, data.panel = 1), list(r0=0.2, r1=0.8))
  expect_equal(preprocess_r0_r1(kp, r0=c(r0=0.2, r1=0.8), r1=NULL, data.panel = 1), list(r0=0.2, r1=0.8))
  expect_equal(preprocess_r0_r1(kp, r0=c(r1=0.8, r0=0.2), r1=NULL, data.panel = 1), list(r0=0.2, r1=0.8))
  expect_equal(preprocess_r0_r1(kp, r0=c(Other.name=2, r1=0.8, r0=0.2), r1=NULL, data.panel = 1), list(r0=0.2, r1=0.8))
  expect_equal(preprocess_r0_r1(kp, r0=c(0.2, 0.8), r1=NULL, data.panel = 1), list(r0=0.2, r1=0.8))
  expect_equal(preprocess_r0_r1(kp, r0=c(0.2, 0.8, r4=4), r1=NULL, data.panel = 1), list(r0=0.2, r1=0.8))
  
  #Correct including NULL
  expect_equal(preprocess_r0_r1(kp, r0=NULL, r1=0.8, data.panel = 1), list(r0=0, r1=0.8))
  expect_equal(preprocess_r0_r1(kp, r0=NULL, r1=NULL, data.panel = 1), list(r0=0, r1=1))
  expect_equal(preprocess_r0_r1(kp, r0=0.2, r1=NULL, data.panel = 1), list(r0=0.2, r1=1))
  expect_equal(preprocess_r0_r1(kp, r0=list(r0=NULL, r1=0.8), r1=NULL, data.panel = 1), list(r0=0, r1=0.8))
  expect_equal(preprocess_r0_r1(kp, r0=list(r0=NULL, r1=NULL), r1=NULL, data.panel = 1), list(r0=0, r1=1))
  expect_equal(preprocess_r0_r1(kp, r0=list(r0=0.2, r1=NULL), r1=NULL, data.panel = 1), list(r0=0.2, r1=1))
  
  
  #Errors
  #TODO: some of these will error on condition (for is.na) longer than 1 in if. Could return better error messages
  expect_error(preprocess_r0_r1(kp, r0=NA, r1=0.8, data.panel = 1))
  expect_error(preprocess_r0_r1(kp, r0=NA, r1=NA, data.panel = 1))
  expect_error(preprocess_r0_r1(kp, r0=0.2, r1=NA, data.panel = 1))
  expect_error(preprocess_r0_r1(kp, r0=list(r0=NA, r1=0.8), r1=NA, data.panel = 1))
  expect_error(preprocess_r0_r1(kp, r0=list(r0=NA, r1=NA), r1=NA, data.panel = 1))
  expect_error(preprocess_r0_r1(kp, r0=list(r0=0.2, r1=NA), r1=NA, data.panel = 1))
  
  expect_error(preprocess_r0_r1(kp, r0=list(r0=0.2, r1=0.8), r1=1, data.panel = 1))
  expect_error(preprocess_r0_r1(kp, r0=c(r0=0.2, r1=0.8), r1=1, data.panel = 1))
  expect_error(preprocess_r0_r1(kp, r0=c(r0="a", r1=0.8), r1=1, data.panel = 1))
  expect_error(preprocess_r0_r1(kp, r0=list(r0="a", r1=0.8), r1=1, data.panel = 1))
  expect_error(preprocess_r0_r1(kp, r0=c(r0=0.2, r1=0.8), r1="a", data.panel = 1))
  expect_error(preprocess_r0_r1(kp, r0=list(r0=0.2, r1=0.8), r1="a", data.panel = 1))
  
    
})    
    
    

#' kpAddCytobandLabels
#' 
#' @description 
#' 
#' Plots the base numbers along the chromosome ideograms
#' 
#' @details 
#'  
#' This function can be used to add labels idenfifying the cytobands. It gets the
#' labels from the cytobands information stored in the karyoplot object and it will
#' only plot the labels that fit inside the available space. This means than in some 
#' cases (such as when plotting a complete genome with default parameters) it is 
#' possible that no labels at all are added.
#' 
#' @usage kpAddCytobandLabels(karyoplot, cex=0.5, force.all=FALSE, clipping=TRUE, ...)
#' 
#' @param karyoplot  (karyoplot object) A valid karyoplot object created by a call to \code{\link{plotKaryotype}}
#' @param cex  (numeric) The cex parameter for the cytoband labels
#' @param force.all  (boolean) If true, all cytoband labels are plotted, even if they do not fit into the cytobands (Defaults to FALSE)
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, the name will be not drawn out of the drawing are (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the labels may overflow into the margins of the plot. (defaults to TRUE)
#' @param ...  Any other parameter to be passed to internal function calls. Specially useful for graphic parameters.
#' 
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#'  
#' @seealso \code{\link{plotKaryotype}}
#' 
#' @examples
#'   
#' kp <- plotKaryotype()
#' kpAddBaseNumbers(kp)
#' kpAddCytobandLabels(kp)
#' 
#' kp <- plotKaryotype(chromosomes="chr17")
#' kpAddBaseNumbers(kp, tick.dist=10000000, minor.tick.dist=1000000)
#' kpAddCytobandLabels(kp)
#' 
#'  
#' @export kpAddCytobandLabels
#' 


#TODO: Reimplement using kpText on data.panel="ideogram" (keep the "check if fits" code) before that

#TODO: With the change above, add the possibility to adjust the cytoband labels y position
kpAddCytobandLabels <- function(karyoplot, cex=0.5, force.all=FALSE, clipping=TRUE, ...) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  
  ccf <- karyoplot$coord.change.function
  pp <- karyoplot$plot.params
      
  if(!is.null(karyoplot$cytobands)) {
    if(length(karyoplot$cytobands)>0) { #If there are cytobands to plot, plot them
  
      labels <- karyoplot$cytobands$name
      bands.chr <- as.character(seqnames(karyoplot$cytobands))
      
      ylabel <- karyoplot$ideogram.mid(bands.chr)
      
      bandxleft <- ccf(x=start(karyoplot$cytobands), chr=bands.chr, data.panel="ideogram")$x
      bandxright <- ccf(x=end(karyoplot$cytobands), chr=bands.chr, data.panel="ideogram")$x
      
      bandmids <- (bandxleft +(bandxright-bandxleft)/2)
      
      label.width <- graphics::strwidth(labels, cex=cex)
      
      if(force.all == FALSE) {
        do.fit <- label.width < (bandxright - bandxleft)
      } else {
        do.fit <- rep(TRUE, length(labels))
      }    
      
      if(any(do.fit)) {
        if(karyoplot$zoom==TRUE) {
          if(clipping==TRUE) {
            #get the plot coordinates of the cytobands drawing area
            clip.xleft <- ccf(x=start(karyoplot$plot.region), chr=as.character(seqnames(karyoplot$plot.region)), data.panel="ideogram")$x
            clip.xright <- ccf(x=end(karyoplot$plot.region), chr=as.character(seqnames(karyoplot$plot.region)), data.panel="ideogram")$x
            clip.ybottom <- karyoplot$plot$ymin #We do not want to clip the text above or below the ideograms
            clip.ytop <- karyoplot$plot$ymax
            graphics::clip(x1 = clip.xleft, x2 = clip.xright, y1 = clip.ybottom, y2=clip.ytop)
          }
        }
        graphics::text(x=bandmids[do.fit], y=ylabel[do.fit], labels=labels[do.fit], cex=cex, ...)
      }
      
    }
  }
  #If no cytobands are available, do nothing
  
  invisible(karyoplot)
}

library(karyoploteR)
context("Cytobands and Cytoband Labels")

#Test getCytobands
test_that("getCytobands returns the expected cytobands", {
  cytobands.hg19 <- getCytobands("hg19")
  expect_is(cytobands.hg19, "GRanges")
  expect_equal(names(mcols(cytobands.hg19)), c("name", "gieStain"))
  
  cytobands.hg19 <- filterChromosomes(cytobands.hg19, chr.type = "canonical", organism = "hg")
  expect_equal(length(cytobands.hg19), 862)
  
  cytobands.hg19.chr17 <- filterChromosomes(cytobands.hg19, keep.chr = "chr17")
  expect_equal(cytobands.hg19.chr17$name, 
               c('p13.3','p13.2','p13.1','p12','p11.2','p11.1','q11.1','q11.2','q12','q21.1','q21.2','q21.31','q21.32','q21.33','q22','q23.1','q23.2','q23.3','q24.1','q24.2','q24.3','q25.1','q25.2','q25.3')
  )

 
  
  #Check null values  
  expect_equal(length(getCytobands(NULL)), 0)
  expect_silent(getCytobands(NULL))
  expect_equal(length(getCytobands(genome=NA)), 0)
  expect_silent(getCytobands(genome=NA))
  expect_equal(length(getCytobands(genome=NULL)), 0)
  expect_silent(getCytobands(genome=NULL))
  
  #Check with invalid genomes
  #FIXIT: The error should be trapped by tryCatch and not propagate! expect_message(getCytobands(genome="INVALID_GENOME"))
  
  
})

#kpAddCytobands
test_that("kpAddCytobands does not error. Not checking correct plotting.", {
  #Note: We are not testing that the generated image is correct!
  
  #all standard
  kp <- plotKaryotype()
  expect_silent(kpAddCytobandLabels(kp))
  expect_silent(kpAddCytobandLabels(kp, force.all = TRUE, cex = 1, srt=90))
    
  #with only some chromosomes
  kp <- plotKaryotype(chromosomes = "chr2")
  expect_silent(kpAddCytobandLabels(kp))
  expect_silent(kpAddCytobandLabels(kp, force.all = TRUE, cex = 1, srt=90))
  
  
  #with a custom genome
  custom.genome <- toGRanges(data.frame(chr="A", start=0, end=1000))
  kp <- plotKaryotype(genome=custom.genome)
  expect_silent(kpAddCytobandLabels(kp))
  
  #Bug in kpAddCytobands: fails if plot.type  %in% 3,4,5
  kp <- plotKaryotype(plot.type = 4)
  expect_silent(kpAddCytobandLabels(kp))
  
  
  
})

############  Colors  ###############

############ Constants ##############

#This structure contains the different color schemas used in karyoploteR
.karyoploter.colors <- list(
  cytobands=list(
    schemas=list(
      circos=c(gneg="#FFFFFF",
               gpos25="#C8C8C8",
               gpos33="#D2D2D2",
               gpos50="#C8C8C8",
               gpos66="#A0A0A0",
               gpos75="#828282",
               gpos100="#000000",
               gpos="#000000",
               stalk="#647FA4", #repetitive areas
               acen="#D92F27", #centromeres
               gvar="#DCDCDC",
               border="black"),
      only.centromeres=c(gneg="#C8C8C8",
                         gpos25="#C8C8C8",
                         gpos33="#C8C8C8",
                         gpos50="#C8C8C8",
                         gpos66="#C8C8C8",
                         gpos75="#C8C8C8",
                         gpos100="#C8C8C8",
                         gpos="#C8C8C8",
                         stalk="#C8C8C8", #repetitive areas
                         acen="#D92F27", #centromeres
                         gvar="#C8C8C8",
                         border=NA),
      biovizbase=c(gneg = "grey100", stalk = "brown3", acen = "brown4", gpos = "grey0", 
                   gvar = "grey0", gpos1 = "#FFFFFF", gpos2 = "#FCFCFC", gpos3 = "#F9F9F9", 
                   gpos4 = "#F7F7F7", gpos5 = "#F4F4F4", gpos6 = "#F2F2F2", gpos7 = "#EFEFEF", 
                   gpos8 = "#ECECEC", gpos9 = "#EAEAEA", gpos10 = "#E7E7E7", gpos11 = "#E5E5E5", 
                   gpos12 = "#E2E2E2", gpos13 = "#E0E0E0", gpos14 = "#DDDDDD", gpos15 = "#DADADA", 
                   gpos16 = "#D8D8D8", gpos17 = "#D5D5D5", gpos18 = "#D3D3D3", gpos19 = "#D0D0D0", 
                   gpos20 = "#CECECE", gpos21 = "#CBCBCB", gpos22 = "#C8C8C8", gpos23 = "#C6C6C6", 
                   gpos24 = "#C3C3C3", gpos25 = "#C1C1C1", gpos26 = "#BEBEBE", gpos27 = "#BCBCBC", 
                   gpos28 = "#B9B9B9", gpos29 = "#B6B6B6", gpos30 = "#B4B4B4", gpos31 = "#B1B1B1", 
                   gpos32 = "#AFAFAF", gpos33 = "#ACACAC", gpos34 = "#AAAAAA", gpos35 = "#A7A7A7", 
                   gpos36 = "#A4A4A4", gpos37 = "#A2A2A2", gpos38 = "#9F9F9F", gpos39 = "#9D9D9D", 
                   gpos40 = "#9A9A9A", gpos41 = "#979797", gpos42 = "#959595", gpos43 = "#929292", 
                   gpos44 = "#909090", gpos45 = "#8D8D8D", gpos46 = "#8B8B8B", gpos47 = "#888888", 
                   gpos48 = "#858585", gpos49 = "#838383", gpos50 = "#808080", gpos51 = "#7E7E7E", 
                   gpos52 = "#7B7B7B", gpos53 = "#797979", gpos54 = "#767676", gpos55 = "#737373", 
                   gpos56 = "#717171", gpos57 = "#6E6E6E", gpos58 = "#6C6C6C", gpos59 = "#696969", 
                   gpos60 = "#676767", gpos61 = "#646464", gpos62 = "#616161", gpos63 = "#5F5F5F", 
                   gpos64 = "#5C5C5C", gpos65 = "#5A5A5A", gpos66 = "#575757", gpos67 = "#545454", 
                   gpos68 = "#525252", gpos69 = "#4F4F4F", gpos70 = "#4D4D4D", gpos71 = "#4A4A4A", 
                   gpos72 = "#484848", gpos73 = "#454545", gpos74 = "#424242", gpos75 = "#404040", 
                   gpos76 = "#3D3D3D", gpos77 = "#3B3B3B", gpos78 = "#383838", gpos79 = "#363636", 
                   gpos80 = "#333333", gpos81 = "#303030", gpos82 = "#2E2E2E", gpos83 = "#2B2B2B", 
                   gpos84 = "#292929", gpos85 = "#262626", gpos86 = "#242424", gpos87 = "#212121", 
                   gpos88 = "#1E1E1E", gpos89 = "#1C1C1C", gpos90 = "#191919", gpos91 = "#171717", 
                   gpos92 = "#141414", gpos93 = "#121212", gpos94 = "#0F0F0F", gpos95 = "#0C0C0C", 
                   gpos96 = "#0A0A0A", gpos97 = "#070707", gpos98 = "#050505", gpos99 = "#020202", 
                   gpos100 = "#000000", border = "black")
    )
  ),
  chromosomes=list(
    schemas=list(
      "2grays"=c("#888888", "#444444"),
      "2blues"=c("#6caeff", "#2b5d9b"),
      "blackgreen"=c("black", "green"),
      "greengray"=c("#c6ffb7", "#888888"),
      "brewer.set1"=c("#E41A1C", "#377EB8", "#4DAF4A", "#984EA3", "#FF7F00", "#FFFF33", "#A65628", "#F781BF", "#999999"),
      "brewer.set2"=c("#66C2A5", "#FC8D62", "#8DA0CB", "#E78AC3", "#A6D854", "#FFD92F", "#E5C494", "#B3B3B3"),
      "brewer.set3"=c("#8DD3C7", "#FFFFB3", "#BEBADA", "#FB8072", "#80B1D3", "#FDB462", "#B3DE69", "#FCCDE5", "#D9D9D9", "#BC80BD", "#CCEBC5", "#FFED6F"),
      "brewer.pastel1"=c("#FBB4AE", "#B3CDE3", "#CCEBC5", "#DECBE4", "#FED9A6", "#FFFFCC", "#E5D8BD", "#FDDAEC", "#F2F2F2"),
      "brewer.pastel2"=c("#B3E2CD", "#FDCDAC", "#CBD5E8", "#F4CAE4", "#E6F5C9", "#FFF2AE", "#F1E2CC", "#CCCCCC")
    )
  )
  ,
  variants=list(
    schemas=list(
      cell21breast=c("C>A"="#4c64ae",
        "C>G"="#000000",
        "C>T"="#e40611",
        "T>A"="#bf4a96",
        "T>C"="#fbe800",
        "T>G"="#6eb529",
        "other"="#888888")
    )
  ),
  horizon=list(
    schemas=list(
      redblue6=c("#b51010", "#e73131", "#f7ad9c", "#ffffff", "#a5c6de", "#4284c6", "#005aad"),
      bluepurple10=c("#CAE5FF", "#AAD6FF", "#89C6FF", "#AAD6FF", "#CAE5FF", "#AFD2E9", "#9D96B8", "#9a7197", "#886176", "#7C5869"),
      bluegold3=c("#4284c6", "white", "gold"),
      greenorange=c("olivedrab3", "white", "orange2"),
      greenred=c("green", "white", "red"),
      greenblackred=c("green", "black", "red"),
      blueorange=c("deepskyblue", "white", "orangered"),
      blueblackorange=c("deepskyblue", "black", "orangered"),
      purplegreen=c("darkorchid1", "white", "chartreuse3"),
      purpleblackgreen=c("darkorchid1", "black", "chartreuse3")
    )
  )
)


#' getColorSchemas
#' 
#' @description 
#' Return a structure with the color schemas included in karyoploteR
#' 
#' @usage getColorSchemas()
#' 
#' @return
#' A list with the color schemas included in karyoploteR for cytobands,
#' variants, horizons...
#' 
#' @examples
#'  
#' getColorSchemas()
#'  
#' @export getColorSchemas
getColorSchemas <- function() {
  return(.karyoploter.colors)
}


#' plotPalette
#' 
#' @description 
#' Create a plot of the palette.
#' 
#' @details 
#' Creates a simple plot with a rectangle for every color of every palette.
#' cols must be either a vector of colors (in any format accepted by 
#' karyoploteR::"is.color") or a list of such vectors.
#' The names of the list elements will be treated as the palette names, if
#' the list has no names, palettes will be called "Pallete1", "Palette2", ...
#' 
#' @usage plotPalettes(cols, add.color.name=TRUE, border=NA, palette.names.col="black", palette.names.cex=1, palette.names.srt=0, color.names.col="auto", color.names.cex=1, color.names.srt=0, ...)
#' 
#' @param cols (color vector or list of color vectors) The colors to plot
#' @param add.color.name (logical) Wether to add or not the names of the colors, their definition.
#' @param palette.names.col (color) The color of the palette names (defaults to "black")
#' @param palette.names.cex (numeric) The cex value (size) for the palette names (defaults to 1)
#' @param palette.names.srt (numeric) The srt value (rotation) for the palette names (defaults to 0)
#' @param color.names.col (color) The color of the color names. If auto, it will be blak for light colors and white for the dark ones (defaults to "auto")
#' @param color.names.cex (numeric) The cex value (size) for the color names  (defaults to 1)
#' @param color.names.srt (numeric) The srt value (rotation) for the color names (defaults to 0)
#' @param border (color) The color of the border of the palette rectangles. If NA, no border. (defaults to NA)
#' @param ... Any additional plotting parameters
#' 
#' @return
#' nothing
#' 
#' 
#' @examples
#'  
#' plotPalettes(c("red", "blue", "yellow", "green"))
#' palettes <- list("P1"=c("red", "#000000", lighter("gold")), 
#'                  "P2"=c("orchid", "yellow"))
#' plotPalettes(palettes, color.names.col=c("blue", "green", "red"), border="black", color.names.srt=45)
#' plotPalettes(palettes, color.names.col="auto", border="black", color.names.srt=45)
#' 
#' @export plotPalettes
#' 
plotPalettes <- function(cols, add.color.name=TRUE, border=NA, palette.names.col="black", palette.names.cex=1, palette.names.srt=0, color.names.col="auto", color.names.cex=1, color.names.srt=0, ...) {
  if(!is.list(cols)) {
    cols <- list(cols)
  }
  if(any(!unlist(lapply(cols, is.color)))) stop("All elements in cols must be valid colors.")
  
  #Set the palette names if not available
  if(is.null(names(cols))) names(cols) <- paste0("Palette", seq_along(cols))
  
  #create an empty plot
  graphics::plot(x=0, type="n", 
       xlim=c(0, 10*max(unlist(lapply(cols, length)))), ylim=c(0, 10*length(cols)),
       ylab="", xlab="", axes=FALSE, xaxs="i", yaxs="i")
  
  #Add the names of the palettes as y labels
  graphics::axis(2, at = 4+(seq_along(cols)-1)*10, labels=rev(names(cols)), las=2, 
                 lwd = 0, cex=palette.names.cex, col=palette.names.col, srt=palette.names.srt)   
  
  #Plot the palettes as rectangles
  for(npal in seq_along(cols)) {
    pp <- cols[[length(cols) - npal + 1]]
    graphics::rect(xleft=10*(seq_along(pp)-1), xright=8+10*(seq_along(pp)-1), 
         ybottom = (npal-1)*10, ytop = 8+(npal-1)*10, col=pp, border = border, ...)
    if(add.color.name) {
      #if name colors are auto set as: black as default, white for darker colors
      if(length(color.names.col)==1 && color.names.col=="auto") {
        names.col <- rep("black", length(pp))
        names.col[colSums(col2rgb(pp))<100] <- "white"
      } else {
        names.col <- color.names.col
      }
      graphics::text(x=4+10*(seq_along(pp)-1), y=4+(npal-1)*10, 
                     labels=as.character(pp), col=names.col,
                     cex=color.names.cex, srt=color.names.srt)
    }
  }
}

#' lighter
#' 
#' @description 
#' Given a color, return a lighter one
#' 
#' @details 
#' Very simple utility function to create lighter colors. Given a color, it
#' transforms it to rgb space, adds a set amount to all chanels and transforms
#' it back to a color.
#' 
#' @usage lighter(col, amount=150)
#' 
#' @param col (color) The original color. Might be specified as a color name or a "#RRGGBB(AA)" hex color definition.
#' @param amount (integer, [0-255]) The fixed amount to add to each RGB channel (Defaults to 150).
#' 
#' @return
#' A lighter color
#' 
#' @seealso \code{\link{darker}}
#' 
#' @examples
#'  
#' lighter("red")
#' lighter("#333333")
#' lighter(c("red", 3, "#FF00FF"))
#'  
#' @export lighter
#' 

lighter <- function(col, amount=150) {
  #Colors must be specified by name or #RRGGBB(AA)
  if(!all(is.color(col))) stop("All elements in col must be valid colors. Use is.col(col) to check it.")
  if(!methods::is(amount, "numeric") || length(amount)!=1) stop("amount must be a single number")
  if(amount>255 || amount<0) stop("amount must be a number between 0 and 255")
  .lighter <- function(col, amount) {
    if(is.na(col)) return(NA)
    new.col <- ((grDevices::col2rgb(col))+amount)/255
    new.col[new.col[,1]>1,1] <- 1
    return(grDevices::rgb(t(new.col)))  
  }
  
  return(unlist(lapply(col, .lighter, amount)))
}

#' darker
#' 
#' @description 
#' Given a color, return a darker one
#' 
#' @details 
#' Very simple utility function to create darker colors. Given a color, it
#' transforms it to rgb space, adds a set amount to all chanels and transforms
#' it back to a color.
#' 
#' @usage darker(col, amount=150)
#' 
#' @param col (color) The original color. Might be specified as a color name or a "#RRGGBB(AA)" hex color definition.
#' @param amount (integer, [0-255]) The fixed amount to subtract to each RGB channel (Defaults to 150).
#' 
#' @return
#' A darker color
#' 
#' @seealso \code{\link{lighter}}
#' 
#' @examples
#'  
#' darker("red")
#' darker("#333333")
#' darker(c("red", 3, "#FF00FF"))
#'  
#' @export darker
#'

#Given a color, returns a darker one
darker <- function(col, amount=150) {
  #Colors must be specified by name or #RRGGBB(AA)
  if(!all(is.color(col))) stop("All elements in col must be valid colors. Use is.col(col) to check it.")
  if(!methods::is(amount, "numeric") || length(amount)!=1) stop("amount must be a single number")
  if(amount>255 || amount<0) stop("amount must be a number between 0 and 255")
  
  .darker <- function(col, amount) {
    if(is.na(col)) return(NA)
    new.col <- ((grDevices::col2rgb(col))-amount)/255
    new.col[new.col[,1]<0, 1] <- 0
    return(grDevices::rgb(t(new.col)))
  }
  
  return(unlist(lapply(col, .darker, amount)))
}


#' transparent
#' 
#' @description 
#' Given a color, return a transparent one
#' 
#' @details 
#' Very simple utility function to create transparent colors. Given a color, it
#' transforms it to rgb space, adds a set amount to all chanels and transforms
#' it back to a color.
#' 
#' @usage transparent(col, amount=0.5)
#' 
#' @param col (color) The original color. Might be specified as a color name or a "#RRGGBB(AA)" hex color definition.
#' @param amount (number, [0-1]) The amount of transparency. 0 for completely visible, 1 for completely transparent. (Defaults to 0.5).
#' 
#' @return
#' A transparent color
#' 
#' @seealso \code{\link{lighter}}
#' 
#' @examples
#'  
#' transparent("red")
#' transparent("#333333")
#'  
#' @export transparent
#' @importFrom grDevices adjustcolor

#Given a color, returns a transparent one
transparent <- function(col, amount=0.5) {
  #Colors must be specified by name or #RRGGBB(AA)
  if(!methods::is(col, "character")) stop("Unknown color definition.")
  if(!methods::is(amount, "numeric") || length(amount)!=1) stop("amount must be a single number")
  if(amount>1 || amount<0) stop("amount must be a number between 0 and 1")
  
  transp.col <- grDevices::adjustcolor(col, alpha.f = (1-amount))
  transp.col[is.na(col)] <- NA
  return(transp.col)
}



#' colByChr
#' 
#' @description 
#' Given a set of data elements, return a color for each one based on their chromosome
#' 
#' @details 
#' Returns a color for each data element based on its chromosome. The returned colors might
#' com from one of the predefined color sets or passed in as a parameter.
#' 
#' If \code{colors} is the name of one of the available color sets, it the color set is used. 
#' If it's a named character vector with the chromosome as names, they will be assigned by name
#' and any missing chromosome will be \code{default.col}. If it's a non-named chraracter vector,
#' will be used in order and recycled if necessary.
#' 
#' Data might be either a GRanges object or a vector of chromosomes.
#' 
#' @usage colByChr(data, colors="2grays", all.chrs=NULL, default.col="black")
#' 
#' @param data Either a vector of characters or a GRanges object
#' @param colors The name of a color set ("2grays", "blackgreen", "rainbow"...) or a vector of colors. If the vector is named, names are expected to be the chromosome names. (defaults to "2grays")
#' @param all.chrs A vector with all possible chromosomes. If NULL, the list will be extracted from data (using seqlevels if available). (defaults to NULL)
#' @param default.col The default color to return when something is unavailable
#' 
#'
#' @return
#' A vector of colors
#'
#' @note 
#' Available color.sets:
#' "2grays"=c("#888888", "#444444"),
#' "2blues"=c("#6caeff", "#2b5d9b")
#' "blackgreen"=c("black", "green"),
#' "greengray"=c("#c6ffb7", "#888888"),
#' "brewer.set1"=c("#E41A1C", "#377EB8", "#4DAF4A", "#984EA3", "#FF7F00", "#FFFF33", "#A65628", "#F781BF", "#999999")
#' "brewer.set2"=c("#66C2A5", "#FC8D62", "#8DA0CB", "#E78AC3", "#A6D854", "#FFD92F", "#E5C494", "#B3B3B3")
#' "brewer.set3"=c("#8DD3C7", "#FFFFB3", "#BEBADA", "#FB8072", "#80B1D3", "#FDB462", "#B3DE69", "#FCCDE5", "#D9D9D9", "#BC80BD", "#CCEBC5", "#FFED6F")
#' "brewer.pastel1"=c("#FBB4AE", "#B3CDE3", "#CCEBC5", "#DECBE4", "#FED9A6", "#FFFFCC", "#E5D8BD", "#FDDAEC", "#F2F2F2"),
#' "brewer.pastel2"=c("#B3E2CD", "#FDCDAC", "#CBD5E8", "#F4CAE4", "#E6F5C9", "#FFF2AE", "#F1E2CC", "#CCCCCC"),
#' "rainbow"=rainbow(n=length(all.chrs))
#'   
#' @seealso \code{\link{kpPoints}}
#' 
#' @examples
#' 
#' chrs <- c("chr1", "chr2", "chr2", "chr1", "chr5")
#' points <- toGRanges(paste0("chr", c(1:22, "X", "Y")), rep(10e6, 24), rep(10e6, 24))
#' 
#' colByChr(chrs)
#' colByChr(points)
#' 
#' kp <- plotKaryotype(plot.type=4, labels.plotter=NULL, ideogram.plotter=NULL)
#' kpAddChromosomeNames(kp, srt=45)
#' kpAddChromosomeSeparators(kp)
#' 
#' total.tracks <- 6
#' 
#' kpPoints(kp, points, col=colByChr(points), y=0.5, cex=1, r0=autotrack(1,total.tracks)$r0, r1=autotrack(1,total.tracks)$r1)
#' colors <- NULL
#' kpPoints(kp, points, y=0.5, col=colByChr(points, colors=colors), cex=1, r0=autotrack(2,total.tracks)$r0, r1=autotrack(2,total.tracks)$r1)
#' colors <- c("red", "blue")
#' kpPoints(kp, points, y=0.5, col=colByChr(points, colors=colors), cex=1, r0=autotrack(3,total.tracks)$r0, r1=autotrack(3,total.tracks)$r1)
#' colors <- c(chr1="red", chr7="blue")
#' kpPoints(kp, points, y=0.5, col=colByChr(points, colors=colors), cex=1, r0=autotrack(4,total.tracks)$r0, r1=autotrack(4,total.tracks)$r1)
#' kpPoints(kp, points, y=0.5, col=colByChr(points, colors=colors, default.col="green"), cex=1, r0=autotrack(5,total.tracks)$r0, r1=autotrack(5,total.tracks)$r1)
#' colors <- c("red", "yellow", 3, "orchid", "blue")
#' kpPoints(kp, points, y=0.5, col=colByChr(points, colors=colors), cex=1, r0=autotrack(6,total.tracks)$r0, r1=autotrack(6,total.tracks)$r1)
#' 
#' #Color sets
#' pp <- getDefaultPlotParams(plot.type=4)
#' pp$leftmargin <- 0.2
#' kp <- plotKaryotype(plot.type=4, labels.plotter=NULL, ideogram.plotter=NULL, plot.params=pp)
#' kpAddChromosomeNames(kp, srt=45)
#' kpAddChromosomeSeparators(kp)
#' 
#' color.sets <- c( "2grays", "2blues", "blackgreen", "greengray", "brewer.set1",
#'                    "brewer.set2", "brewer.set3", "brewer.pastel1", "brewer.pastel2", "rainbow" )
#' total.tracks <- length(color.sets)
#' for(i in seq_len(length(color.sets))) {
#'     kpPoints(kp, points, y=0.5, col=colByChr(points, colors=color.sets[i]), cex=1, r0=autotrack(i,total.tracks)$r0, r1=autotrack(i,total.tracks)$r1)
#'     kpAddLabels(kp, labels=color.sets[i], cex=0.7, r0=autotrack(i,total.tracks)$r0, r1=autotrack(i,total.tracks)$r1)
#' }
#' 
#' @export colByChr
#' @importFrom grDevices rainbow
#'

colByChr <- function(data, colors="2grays", all.chrs=NULL, default.col="black") {
  #Process data
  chrs <- NULL
  if(is.character(data)) {
    chrs <- data
  } else { #It's not a vector of chromosomes, try to extract them for other typical objects
    #GRanges
    chrs <- tryCatch(as.character(seqnames(data)), error=function(e) {return(NULL)})
    #TODO: VCF (we'll need to odepend on variant annotation)
    #if(is.null(chrs)) chrs <- tryCatch(as.character(seqnames(rowRanges(data))), error=function(e) {return(NULL)})
    #TODO: Summarized Experiment?
  }
  
  if(is.null(chrs)) {
    stop("Unknown data type passed to colByChr.")
  }
  
  #Try to get the chromosomes "in the right order" if possible
  if(is.null(all.chrs)) {
    all.chrs <- tryCatch(as.character(seqlevels(data)), error=function(e) {return(NULL)})
    if(is.null(all.chrs)) { #If it's not been possible, just get them in any order
      all.chrs <- unique(chrs)
    }
  }
  
  #Process color
  cols <- NULL
  if(!is.null(colors)) {
    color.sets <- .karyoploter.colors$chromosomes$schemas
    #And add rainbow, which depends on the number of chromosomes
    color.sets[["rainbow"]] <- rainbow(n=length(all.chrs))

    if(is.character(colors) && length(colors)==1L && colors %in% names(color.sets)) { #Name of a color set
      colors <- color.sets[[colors]]
    } 
    
    #Named color vector
    if(!is.null(names(colors))) {
      missing.chrs <- all.chrs[!(all.chrs %in% names(colors))] 
      cols <- c(colors, setNames(rep(default.col, length(missing.chrs)), missing.chrs))
    } else {
      cols <- setNames(rep(colors, length = length(all.chrs)), all.chrs)
    }   
  }
  if(is.null(cols)) cols <- setNames(rep(default.col, length(all.chrs)), all.chrs)
  
  #We now have chrs and cols, return thee colors per chromosome
  return(cols[chrs])
}




#' colByRegion
#' 
#' @description 
#' Given a set of data elements, return a color for each one based on whether 
#' they overlap a given set of regions. This might be useful, for example,  to
#' set a different color for data points overlapping a certain region of
#' interest.
#' 
#' @details 
#' Given a set of data elements, return a color for each one based on whether 
#' they overlap a given set of regions. The colors might be different for each
#' region and can be specified either in the regions object itself or in 
#' a separate \code{colors} parameter. If specified in \code{colors}, the values
#' will be recycled as needed. Data points not in the specified region can
#' take either a default color or keep their "original.color" if given. This
#' is useful when using colByRegion to highlight data points as in 
#' kpPlotManhattan.
#' 
#' 
#' @usage colByRegion(data, regions, colors=NULL, original.colors=NULL, default.col="black")
#' 
#' @param data Either a vector of characters or a GRanges object
#' @param regions (GRanges or equivalent) A set of regions where the color will be modified. Internally it will be converted into a Genomic Ranges object by \code{\link[regioneR]{toGRanges}} (from regioneR package) and so it can be either a GRanges, a data.frame, a character or any other value type accepted by that function. If \code{colors} is NULL (the default) and regions has additional columns in addition to chr, start and end, if any has a name in c("color", "colors", "col", "cols") it will be used. Otherwise the first additional column will be used.
#' @param colors (color) The colors to be used for each region. The content will be recycled if needed. If NULL, the colors are assumed to be available in the regions object. (defaults to NULL)
#' @param original.colors (color vector) The original colors of the data points. They will be use instead of the default color for data points not overlapping the regions. If NULL, the default color will be used. (defaults to NULL)
#' @param default.col The default color to return for data elements not overlapping the regions. Only used if original.colors is NULL (defaults to "black")
#' 
#'
#' @return
#' A vector of colors
#'
#' @seealso \link{kpPoints}, \link{colByChr}, \link[regioneR]{toGRanges}
#' 
#' @examples
#' 
#' data <- toGRanges("chr1", c(1e6*1:245), c(1e6*1:245)+10)
#' data$y <- rnorm(n = length(data), mean = 0.5, sd = 0.15)
#' 
#' regions <- toGRanges(c("chr1:10e6-20e6", "chr1:100e6-150e6"))
#' regions$col <- c("red", "blue")
#' 
#' kp <- plotKaryotype(chromosomes="chr1")
#' kpPoints(kp, data=data, r0=0, r1=0.2)
#' kpPoints(kp, data=data, r0=0.2, r1=0.4, col=colByRegion(data, regions = regions) )
#' kpText(kp, data=data, r0=0.4, r1=0.6, col=colByRegion(data, regions = regions), label="A", cex=0.5 )
#' kpBars(kp, data=data, y0=0, y1=data$y, r0=0.6, r1=0.8, border=colByRegion(data, regions = regions))
#' #It might not work wor objects where R expects a single color such as lines. Segments should be used instead
#' kpLines(kp, data=data, r0=0.8, r1=1, col=colByRegion(data, regions = regions) )
#' 
#' 
#' kp <- plotKaryotype(chromosomes="chr1")
#' kpPoints(kp, data=data, r0=0, r1=0.25)
#' kpPoints(kp, data=data, r0=0.25, r1=0.5, col=colByRegion(data, regions = regions, colors="green") )
#' kpText(kp, data=data, r0=0.5, r1=0.75, col=colByRegion(data, regions = regions, color=c("gray", "gold")), label="A", cex=0.5 )
#' kpBars(kp, data=data, y0=0, y1=data$y, r0=0.75, r1=1, border=colByRegion(data, regions = regions))
#' 
#' @export colByRegion
#'
#' @importFrom  GenomeInfoDb seqlevelsStyle

colByRegion <- function(data, regions, colors=NULL, original.colors=NULL, default.col="black") {
  data <- toGRanges(data)
  
  regions <- toGRanges(regions)
  
  #Get the colors if needed
  if(is.null(colors)) {
    #Get the color from the regions GRanges
    if(length(mcols(regions))>0) {
      colors.column <- which(names(mcols(regions)) %in% c("color", "colors", "col", "cols"))[1]
      #if no column has a valid name, use the first one
      if(is.na(colors.column)) colors.column <- 1
      colors <- mcols(regions)[,colors.column]
    }
  } else {
    colors <- rep(colors, length.out=length(regions))
  }
  
  if(!all(is.color(colors))) { stop("A valid color specification is needed. Either as a column of regions or in the 'colors' parameter") }
  
  #Make regions and data comparable
  #WARNING: We are doing this here but nowhere else in the package. Should we?
  GenomeInfoDb::seqlevelsStyle(regions) <- GenomeInfoDb::seqlevelsStyle(data)
  
  #Assign everything the default color and then change it for the data
  #overlapping the regions
  cols <- rep(default.col, length(data))
  for(num.reg in seq_len(length(regions))) {
    cols[overlapsAny(data, regions[num.reg])] <- colors[num.reg]
  }
  
  return(cols)
}


#' colByValue
#' 
#' @description 
#' Given a set of values, return a color for each of them based on their numeric
#' value.
#' 
#' @details 
#' A color ramp (similar to a gradient) will be built using the colors in the 
#' `colors` parameter using \code{\link[grDevices]{colorRamp}}.
#' Values will be normalized to [0,1] using `min` and `max`
#' (if NULL, min(value) will be 0 and max(value) will be 1) and these values
#' will be used to determine the color. It uses 
#' 
#' @note Alpha values (transparency) are also used in the color computation
#' (see examples)
#' 
#' @usage colByValue(value, colors, min=NULL, max=NULL) 
#' 
#' @param value A vector of numeric values
#' @param colors (color) The colors to built the color ramp. Refer to \code{\link[grDevices]{colorRamp}} for more details.
#' @param min (NULL or numeric) The min value used to normalize the values. If NULL, min(value) will be used. (defaults to NULL)
#' @param max (NULL or numeric) The max value used to normalize the values. If NULL, max(value) will be used. (defaults to NULL)
#' 
#'
#' @return
#' A vector of colors
#'
#' @seealso \link{kpPoints}, \link{colByChr}
#' 
#' @examples
#' 
#' colByValue(c(0,0.25,0.5,0.75,1), colors=c("red", "green"))
#' colByValue(c(0,0.25,0.5,0.75,1), colors=c("#00000000", "#00000011"))
#' 
#' data <- toGRanges("chr1", c(1e6*1:245), c(1e6*1:245)+10)
#' data$y <- rnorm(n = length(data), mean = 0.5, sd = 0.15)
#' 
#' kp <- plotKaryotype(chromosomes="chr1")
#' kpPoints(kp, data=data, r0=0, r1=0.3)
#' kpPoints(kp, data=data, r0=0.35, r1=0.65, col=colByValue(data$y, colors=c("black", "green")) )
#' kpPoints(kp, data=data, r0=0.7, r1=1, col=colByValue(data$y, colors=c("black", "green"), min=0.4, max=0.6))
#' 
#' kp <- plotKaryotype(chromosomes="chr1")
#' kpPoints(kp, data=data, r0=0, r1=0.3, col=colByValue(data$y, colors=c("#00000000", "#000000FF")))
#' kpPoints(kp, data=data, r0=0.35, r1=0.65, col=colByValue(data$y, colors=c("black", "orange", "green")) )
#' kpPoints(kp, data=data, r0=0.7, r1=1, col=colByValue(data$y, colors=c("red", "#00000022","#00000022", "green"),min=0.4, max=0.6))
#
#' 
#' @export colByValue
colByValue <- function(value, colors, min=NULL, max=NULL) {
  if(!is.numeric(value)) stop("value must be numeric")
  if(!all(is.color(colors))) stop("colors must be  a vector of valid colors")
  if(length(colors)<2) stop("at least 2 colors are required")
  if(is.null(min) && is.null(max) && length(value)<2) stop("if min and max are NULL, at least two values are needed")
  
  if(is.null(min)) min <- min(value)
  if(is.null(max)) max <- max(value)
  norm.value <- (value - min)/(max-min)
  norm.value[norm.value<0] <- 0
  norm.value[norm.value>1] <- 1
  ramp <- grDevices::colorRamp(colors, alpha=TRUE)
  cols <- ramp(norm.value)/255
  cols <- grDevices::rgb(cols, alpha = cols[,4])
  return(cols)
}


#' colByCategory
#' 
#' @description 
#' Given a vector of categorical values, assign a color to each one bases on 
#' its category
#' 
#' @details 
#' The vector of values will be first transformed into a factor (if it's not
#' already a factor) and then colors will be selected from the palette in the
#' order defined by the factor levels. If more colors than the ones available in
#' the palette are needed, they will be reused. If the color vector is named 
#' using the factor levels and all levels are included, the link bewteen
#' levels and colors will be honored.
#' If the color palette is set to "auto", it will create a palette using 
#' "rainbow".
#' 
#' @usage colByCategory(categories, colors) 
#' 
#' @param categories A vector of categories. Will be transformed into a factor if it's not one (if characters, integers, etc...)
#' @param colors (color vector, possibly named) The colors to to use for the different categories. If "auto", a rainbow palette will be used. (defaults to "auto")
#' 
#'
#' @return
#' A vector of colors of the same length as value
#'
#' @seealso \link{kpAddColorRect}, \link{colByValue}
#' 
#' @examples
#' 
#' colByCategory(c("A", "A", "C", "A", "C", "B"))
#' #The order of the colors is defined by the order of the factor, not the "natural order" of the elements
#' colByCategory(c("A", "A", "C", "A", "C", "B"), colors=c("red", "green", "blue"))
#' #integer categories plus reuse of colors
#' colByCategory(categories=c(3,3,1,2,1,4,2,3,2,1), colors=c("red", "green", "blue"))
#' 
#' @export colByCategory

colByCategory <- function(categories, colors="auto") {
  if(!is.factor(categories)) {
    categories <- tryCatch(as.factor(categories), error=function(e) {stop("Could not transform categories into a factor. ", e)})
  }
  
  if(length(colors)==1 && colors=="auto") {
    colors <- rainbow(length(levels(categories)))  
  }
  if(!all(is.color(colors))) stop('colors must be  a vector of valid colors or "auto"')
  
  if(length(colors)<length(levels(categories))) colors <- recycle.first(colors, levels(categories))
  if(is.null(names(colors)) || !all(levels(categories) %in% names(colors))) {
    names(colors) <- levels(categories)
  }
  return(colors[categories])
}




#' is.color
#' 
#' @description 
#' Test if something is a valid color
#' 
#' @details 
#' This function tests if something is a valid color. Returns TRUE or FALSE. 
#' The function is vectorised. 
#' 
#' 
#' @usage is.color(x)
#' 
#' @param x The element to test
#' 
#' @return
#' TRUE is x is a valid color, FALSE otherwise
#' 
#' 
#' @examples
#'  
#' is.color("red")
#' is.color("#333333")
#' is.color(NA)
#' is.color(NULL)
#' is.color("not_a_color")
#' is.color(3)
#' 
#' is.color(c("not_a_color", "red", 3, "#FF0000"))
#'  
#' @export is.color
#' 
#' @importFrom grDevices col2rgb
#' 
#'
# Adapted from https://stackoverflow.com/questions/13289009/check-if-character-string-is-a-valid-color-representation

is.color <- function(x) {
  if(is.null(x)) return(FALSE)
  return(setNames(vapply(x, function(X) {
    tryCatch(is.matrix(grDevices::col2rgb(X)), 
             error = function(e) FALSE)
  },
  FUN.VALUE = TRUE), NULL))
}






#TODO: Document and export?

#Preprocess col and border to assign one based on the other if any is NULL
preprocessColors <- function(col=NULL, border=NULL, default.col="gray70", amount=100) {
  #If both NULL, return the default values
  if(is.null(col) && is.null(border)) {
    return(list(col=default.col, border=darker(default.col, amount = amount)))
  }
  
  if(is.null(border)) {
    if(all(is.na(col))) {
      border <- darker(default.col, amount = amount)
    } else {
      border <- darker(col, amount = amount)
    }
  }
  
  if(is.null(col)) {
    if(all(is.na(border))) {
      col <- default.col
    } else {
      col <- lighter(border, amount = amount)
    }
  }
  

  return(list(col=col, border=border))
}








############################# Function specific color seleectors ##############################
#' horizonColors
#' 
#' @description 
#' Returns the color structure needed by kpPlotHorizon
#' 
#' @details 
#' This function transforms an array of colors into a list of colors 
#' **internally** needed by kpPlotHorizon: a list with two elements, "neg" 
#' and "pos", each an array of colors of length num.parts. If col is 
#' a character of length one, it is interpreted as the name of a color scheme.
#' 
#' 
#' horizonColors(col, num.parts) 
#' 
#' @param col (array of colors) An array of colors
#' @param num.parts (positive integer) The number of colors to generate for pos and neg
#' 
#' @return
#' A list with 2 elements, pos and neg, each with num.parts colors
#' 
#' 
#' @examples
#'  
#' horizonColors("redblue6", 3)
#' horizonColors("redblue6", 6)
#' horizonColors("bluegold3", 2)
#' horizonColors(c("red", "blue"), 3)
#' horizonColors(c("red", "#FFFFFF00", "blue"), 3)
#'  
#' @export horizonColors
#' @importFrom grDevices colorRamp
#' 
horizonColors <- function(col, num.parts) {
  if(is.character(col) && length(col)==1) col <- .karyoploter.colors$horizon$schemas[[col]]
  ramp <- grDevices::colorRamp(col, alpha=TRUE)
  num.cols <- num.parts*2
  cols <- ramp(1/(num.cols)*c(0:num.cols))/255
  cols <- grDevices::rgb(cols, alpha = cols[,4])
  return(list(neg=rev(cols[1:num.parts]),
              pos=cols[(num.parts+2):(2*num.parts+1)]
  ))
}

library(karyoploteR)
context("colors.R functions")


test_that("preprocessColors works correctly", {
  
  expect_equal(preprocessColors(col="red", border="green"), list(col="red", border="green"))
  expect_equal(preprocessColors(col="red", border=NA), list(col="red", border=NA))
  expect_equal(preprocessColors(col=NA, border="green"), list(col=NA, border="green"))
  expect_equal(preprocessColors(col=NA, border=NA), list(col=NA, border=NA))
  expect_equal(preprocessColors(col=c(NA, "red"), border=c("green", NA)), list(col=c(NA, "red"), border=c("green", NA)))
  expect_equal(preprocessColors(col=c(NA, "red"), border=NULL), list(col=c(NA, "red"), border=c(NA, "#9B0000")))
  expect_equal(preprocessColors(col=NULL, border=c("green", NA)), list(col=c("#64FF64", NA), border=c("green", NA)))
  expect_equal(preprocessColors(col=NULL, border=NULL), list(col="gray70", border="#4F4F4F"))
  
  
})    
  

test_that("darker, lighter and transparent work correctly", {
  
  expect_equal(darker(c("red", "#00FF00", NA, "black")), c("#690000", "#006900", NA, "#000000"))
  expect_equal(darker(c("red", "#00FF00", NA, "black"), amount=20), c("#EB0000", "#00EB00", NA, "#000000"))
  expect_error(darker(c("red", "#00FF00", NA, "black"), amount=-1), "amount must be a number between 0 and 255")
  expect_error(darker(c("red", "#00FF00", NA, "black"), amount=FALSE), "amount must be a single number")
  expect_error(darker(c("red", "#00FF00", NA, "black"), amount="GREEN"), "amount must be a single number")
  
  expect_equal(lighter(c("red", "#00FF00", NA, "white")), c("#FF9696", "#96FF96", NA, "#FFFFFF"))
  expect_equal(lighter(c("red", "#00FF00", NA, "white"), amount=20), c("#FF1414", "#14FF14", NA, "#FFFFFF"))
  expect_error(lighter(c("red", "#00FF00", NA, "black"), amount=-1), "amount must be a number between 0 and 255")
  expect_error(lighter(c("red", "#00FF00", NA, "black"), amount=FALSE), "amount must be a single number")
  expect_error(lighter(c("red", "#00FF00", NA, "black"), amount="GREEN"), "amount must be a single number")
  
  expect_equal(transparent(c("red", "#00FF00", NA, "black")), c("#FF000080", "#00FF0080", NA, "#00000080"))
  expect_equal(transparent(c("red", "#00FF00", NA, "white"), amount=0.2), c("#FF0000CC", "#00FF00CC", NA, "#FFFFFFCC"))
  expect_error(transparent(c("red", "#00FF00", NA, "black"), amount=-1), "amount must be a number between 0 and 1")
  expect_error(transparent(c("red", "#00FF00", NA, "black"), amount=FALSE), "amount must be a single number")
  expect_error(transparent(c("red", "#00FF00", NA, "black"), amount="GREEN"), "amount must be a single number")
   
})  
    

#' kpAddMainTitle
#' 
#' @description 
#' 
#' Plots the chromosome names in the karyoplot
#' 
#' @details 
#' 
#' Given a KaryoPlot object and a character string, plot the character strings
#' as the main title of the plot. This function is usually automatically
#' called by plotKaryotype unless.
#' 
#' @usage kpAddMainTitle(karyoplot, main=NULL, ...)
#' 
#' @param karyoplot    a \code{karyoplot} object returned by a call to \code{plotKaryotype}
#' @param main (character) the main title of the plot
#' @param ...  any additional parameter to be passed to the text plotting. All R base graphics params are passed along.
#' 
#' @return
#' invisibly returns the given karyoplot object
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{getMainTitleBoundingBox}}
#' 
#' @examples
#'
#' kp <- plotKaryotype(labels.plotter = NULL)
#' kpAddMainTitle(kp, col="red", srt=30)
#'  
#' @export kpAddMainTitle
#' 

kpAddMainTitle <- function(karyoplot, main=NULL, ...) {
  
  if(!is.null(main)) {
    karyoplot$beginKpPlot()
    on.exit(karyoplot$endKpPlot())
    
    bb <- getMainTitleBoundingBox(karyoplot)
    
    x <- (bb$x0+bb$x1)/2
    y <- (bb$y0+bb$y1)/2
    
    graphics::text(x=x, y=y, labels=main, ...)
    
  }
  
  invisible(karyoplot)
}

#' kpPlotLinks
#' 
#' @description 
#' 
#' Given 2 \code{GRanges} objects, plot lines or ribbons between region pairs
#' 
#' @details 
#'  
#'  This is one of the high-level, or specialized, plotting functions of karyoploteR.
#'  It takes two \code{GRanges} objects (or a single specially crafted one) and
#'  plots links (either lines or ribbons) between region pairs. Links are 
#'  plotted bewteen the first region of both objects, between the second one, etc...
#'  and therefore both objects need to have the same length. Specifying a region
#'  as negative strand, will "flip" it, so the the start of a region can be 
#'  linked to the end of its pair.
#'  
#' @note 
#'   For a link to be plotted BOTH ends must be visible in the karyoplot. In 
#'   particular, if a chromosome is not included in the plot (due to not
#'   being specified in \code{chromosomes}, for example) any link with an end
#'   on it will NOT be plotted. The same is true for zoomed in plots, where only
#'   intrachromosomal links will be visible. No warning or message will be
#'   generated.
#' 
#'
#' @usage kpPlotLinks(karyoplot, data, data2=NULL, y=0, arch.height=NULL, data.panel=1, r0=NULL, r1=NULL, ymin=NULL, ymax=NULL, col="#8e87eb", border=NULL, clipping=TRUE, ...)
#' 
#' @param karyoplot    (a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.
#' @param data    (a \code{GRanges}) A GRanges object with link start regions. If data2 is NULL, mcols(data) should be a bed-like structure with "link.chr", "link.start", "link.end" and optionally a "link.strand" columns. The first thee columns can have any name and the strand information will be extracted from the first column with "strand" in its name.
#' @param data2  (a \code{GRanges}) A GRanges object with the link end regions. If null, the end of the regions will be extracted from mcols(data). (Defaults to NULL)
#' @param y    (numeric) The y value where the origin and end of the links should be plotted (Defaults to 0)
#' @param arch.height    (numeric) The approximate arch height in links in the same chromosome in "y" scale. If NULL, it defaults to the whole span of the data panel.Also affects the curvature of links between chromosomes (Defaults to NULL)
#' @param data.panel    (numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param r0    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param r1    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param ymin    (numeric) The minimum value to be plotted on the data panel. If NULL, it is set to 0. (deafults to NULL)
#' @param ymax    (numeric) The maximum value to be plotted on the data.panel. If NULL the maximum density is used. (defaults to NULL)
#' @param col    (color) The background color of the links. If NULL and border is specified, it defaults to a lighter version of border.
#' @param border  (color) The border color of the links. If NULL and col is specified, it defaults to a darker version of col.
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param ...    The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions. 
#' 
#' 
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpPlotRibbon}}, \code{\link{kpSegments}}
#' 
#' @examples
#'  
#'  
#'  set.seed(222)
#'  
#'  starts <- sort(createRandomRegions(nregions = 15))
#'  ends <- sort(createRandomRegions(nregions = 15))
#'  
#'  kp <- plotKaryotype()
#'  kpPlotLinks(kp, data=starts, data2=ends)
#'  
#'  #Create larger regions, so they look like ribbons
#'  starts <- sort(createRandomRegions(nregions = 15, length.mean = 8e6, length.sd = 5e6))
#'  ends <- sort(createRandomRegions(nregions = 15, length.mean = 8e6, length.sd = 5e6))
#'  
#'  kp <- plotKaryotype()
#'  kpPlotLinks(kp, data=starts, data2=ends)
#'  
#'  #flip some of them to represent inversions
#'  strand(ends) <- sample(c("+", "-"), length(ends), replace = TRUE)
#'  
#'  kp <- plotKaryotype()
#'  kpPlotLinks(kp, data=starts, data2=ends)
#'  
#'
#'@importFrom bezier bezier
#'  
#'@export kpPlotLinks


kpPlotLinks <- function(karyoplot, data, data2=NULL, y=0, arch.height=NULL, data.panel=1, r0=NULL, r1=NULL, ymin=NULL, ymax=NULL, col="#8e87eb", border=NULL, clipping=TRUE, ...) {
  #Check parameters
  #karyoplot
  if(missing(karyoplot)) stop("The parameter 'karyoplot' is required")
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  #data
  if(missing(data)) stop("The parameter 'data' is required")
  if(!methods::is(data, "GRanges") && !methods::is(data, "SimpleRleList")) stop("'data' must be a GRanges object or a SimpleRleList")
  
  #Assign complex default values
  #arc.height
  if(is.null(arch.height)) {
    arch.height <- karyoplot$plot.params[[paste0("data", data.panel, "max")]] - karyoplot$plot.params[[paste0("data", data.panel, "min")]]
  }
  
  #colors
  prep.cols <- preprocessColors(col=col, border=border)
  col <- prep.cols$col
  border <- prep.cols$border
  
  
  #Define the link ends
  if(!is.null(data2) && !any(is.na(data2))) {
    if(!methods::is(data2, "GRanges")) {
      stop("If present, data2 must be a GRanges object")
    } else {
      if(length(data) != length(data2)) {
        stop("data and data2 must have the same length")
      }
    }
  } else {
    #if data2 is not defined, try to define it from the mcols of data
    tryCatch(data2 <- toGRanges(data.frame(mcols(data))),
             error=function(e) {stop("It was not possible to create data2 from mcols(data). ", e)})
    strand.col <- which(grepl(pattern = "strand", names(mcols(data2))))[1]
    if(length(strand.col)>0) {
      strand(data2) <- mcols(data2)[[strand.col]]
    }
  }
  
  
  #remove any links with at least one end out of the plotted regions
  to.keep <- overlapsAny(data, karyoplot$genome) & overlapsAny(data2, karyoplot$genome)
  if(any(!to.keep)) {
    data <- data[to.keep]
    data2 <- data2[to.keep]
  }
 
  
  if(length(data)==0) invisible(karyoplot) #return fast if no links will be plotted
  
  #Filter the additional arguments
  #NOTE: in this case we do not use the filter returned by prepareParameters
  #because we have a specific filtering logic due to links having two genomic 
  #regions
  dots <- filterParams(list(...), to.keep, length(to.keep))
  col <- filterParams(col, to.keep, length(to.keep))
  border <- filterParams(border, to.keep, length(to.keep))
  y <- filterParams(y, to.keep, length(to.keep))
  arch.height <- filterParams(arch.height, to.keep, length(to.keep))
  
  
  
  
  #Prepare the coordinates
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  ccf <- karyoplot$coord.change.function
  
  #Transform the coordinates of the starts
  pp.start <- prepareParameters4("kpPlotLinks", karyoplot=karyoplot, data=data, chr=NULL, x0=NULL, x1=NULL,
                                 y0=y, y1=y, ymin=ymin, ymax=ymax, r0=r0, r1=r1,
                                 data.panel=data.panel, ...)
  
  #Transform the coordinates of the starts
  pp.end <- prepareParameters4("kpPlotLinks", karyoplot=karyoplot, data=data2, chr=NULL, x0=NULL, x1=NULL,
                               y0=y, y1=y, ymin=ymin, ymax=ymax, r0=r0, r1=r1,
                               data.panel=data.panel, ...)
  
  x0.start <- ccf(chr=pp.start$chr, x=pp.start$x0, data.panel=data.panel)$x
  x1.start <- ccf(chr=pp.start$chr, x=pp.start$x1, data.panel=data.panel)$x
  y.start <- ccf(chr=pp.start$chr, y=pp.start$y0, data.panel=data.panel)$y
  
  #swap the order of the regions in the negative strand
  aux <- numeric(length(data))
  neg.strand.start <- which(as.logical(strand(data)=="-"))
  aux[neg.strand.start] <- x0.start[neg.strand.start]
  x0.start[neg.strand.start] <- x1.start[neg.strand.start]
  x1.start[neg.strand.start] <- aux[neg.strand.start]
  
  x0.end <- ccf(chr=pp.end$chr, x=pp.end$x0, data.panel=data.panel)$x
  x1.end <- ccf(chr=pp.end$chr, x=pp.end$x1, data.panel=data.panel)$x
  y.end <- ccf(chr=pp.end$chr, y=pp.end$y0, data.panel=data.panel)$y
  
  #swap the order of the regions in the negative strand
  neg.strand.end <- which(as.logical(strand(data2)=="-"))
  aux[neg.strand.end] <- x0.end[neg.strand.end]
  x0.end[neg.strand.end] <- x1.end[neg.strand.end]
  x1.end[neg.strand.end] <- aux[neg.strand.end]
  
  
  #transform the arch height to the plot coords using ccf and prepare parameters2 to take into account r0 and r1, ymin and ymax, etc
  y.min <- prepareParameters2("kpPlotLinks", karyoplot = karyoplot, data=NULL, chr=karyoplot$chromosomes[1], x=0, y=0, r0=r0, r1=r1, ymin=ymin, ymax=ymax, data.panel=data.panel)$y
  y.max <- prepareParameters2("kpPlotLinks", karyoplot = karyoplot, data=NULL, chr=karyoplot$chromosomes[1], x=0, y=arch.height, r0=r0, r1=r1, ymin=ymin, ymax=ymax, data.panel=data.panel)$y
  
  y.ctrl <- abs(ccf(chr=rep(karyoplot$chromosomes[1], length(y.min)), x=0, y=y.min, data.panel=data.panel)$y - ccf(chr=rep(karyoplot$chromosomes[1], length(y.max)), x=0, y=y.max, data.panel=data.panel)$y)
  
  #recycle parameters
  col <- recycle.first(col, data)
  border <- recycle.first(border, data)
  y.ctrl <- recycle.first(y.ctrl, data)
  
  
  #TODO: Make this 50 a parameter (num.bezier.segments=50) and document
  t <- seq(0, 1, length=50)
  for(i in seq_along(data)) {
    #The position of the control points (above or below the start and end points) depend on the relative position of start and end and in some cases on the data.panel
    if(y.start[i]>y.end[i]) { #if the start is above the end
      bezier_points_1 <- bezier(t=t, p=list(c(x0.start[i],x0.start[i], x0.end[i], x0.end[i]), c(y.start[i],y.start[i]-y.ctrl[i],y.end[i]+y.ctrl[i],y.end[i])))
      bezier_points_2 <- bezier(t=t, p=list(c(x1.start[i],x1.start[i], x1.end[i], x1.end[i]), c(y.start[i],y.start[i]-y.ctrl[i],y.end[i]+y.ctrl[i],y.end[i])))
    } else if(y.start[i]<y.end[i]) { #if start is below the end
      bezier_points_1 <- bezier(t=t, p=list(c(x0.start[i],x0.start[i], x0.end[i], x0.end[i]), c(y.start[i],y.start[i]+y.ctrl[i],y.end[i]-y.ctrl[i],y.end[i])))
      bezier_points_2 <- bezier(t=t, p=list(c(x1.start[i],x1.start[i], x1.end[i], x1.end[i]), c(y.start[i],y.start[i]+y.ctrl[i],y.end[i]-y.ctrl[i],y.end[i])))
    } else {
      #if they are in the same chromosome, detect whether we are in an upward or downward data panel
      if(ccf(chr=as.character(seqnames(data[1])), x=0, y=0, data.panel=data.panel)$y <
         ccf(chr=as.character(seqnames(data[1])), x=0, y=1, data.panel=data.panel)$y) {
        #it's upwards
        bezier_points_1 <- bezier(t=t, p=list(c(x0.start[i],x0.start[i], x0.end[i], x0.end[i]), c(y.start[i],y.start[i]+y.ctrl[i],y.end[i]+y.ctrl[i],y.end[i])))
        bezier_points_2 <- bezier(t=t, p=list(c(x1.start[i],x1.start[i], x1.end[i], x1.end[i]), c(y.start[i],y.start[i]+y.ctrl[i],y.end[i]+y.ctrl[i],y.end[i])))
      } else {
        #it's downwards
        bezier_points_1 <- bezier(t=t, p=list(c(x0.start[i],x0.start[i], x0.end[i], x0.end[i]), c(y.start[i],y.start[i]-y.ctrl[i],y.end[i]-y.ctrl[i],y.end[i])))
        bezier_points_2 <- bezier(t=t, p=list(c(x1.start[i],x1.start[i], x1.end[i], x1.end[i]), c(y.start[i],y.start[i]-y.ctrl[i],y.end[i]-y.ctrl[i],y.end[i])))
      }
    }
    
    processClipping(karyoplot=karyoplot, clipping=clipping, data.panel=data.panel)  
    graphics::polygon(x = c(bezier_points_1[,1], rev(bezier_points_2[,1])), y=c(bezier_points_1[,2], rev(bezier_points_2[,2])), col=col[i], border=NA, ...)
    if(!is.na(border[i])) {
      graphics::lines(bezier_points_1, col=border[i], ...)
      graphics::lines(bezier_points_2, col=border[i], ...)
    }
  }
  
  
  invisible(karyoplot)
}

#' kpRect
#' 
#' @description 
#' 
#' Plots rectangles at the specified genomic positions. 
#' 
#' @details 
#'  
#' This is one of the functions from karyoploteR implementing the adaptation to the genome context 
#' of basic plot functions
#' from R base graphics. Given a set of positions on the genome (chromosome, x0 and x1) and values 
#' (y0 and y1) for each of them, it plots rectangles going from (x0, y0) to (x1, y1). Data can be 
#' provided via a \code{GRanges} object (\code{data}), independent parameters for chr, 
#' x0, x1, y0 and y1, or a combination of both.
#' A number of parameters can be used to define exactly where and how the rectangles are drawn.
#' In addition, via the ellipsis operator (\code{...}), \code{kpRect} accepts any parameter 
#' valid for \code{rect} (e.g. \code{border}, \code{col}, ...)
#' 
#' There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
#'
#' @usage kpRect(karyoplot, data=NULL, chr=NULL, x0=NULL, x1=x0, y0=NULL, y1=NULL, ymax=NULL, ymin=NULL, r0=NULL, r1=NULL, data.panel=1, clipping=TRUE, ...) 
#' 
#' @param karyoplot    (a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.
#' @param data    (a \code{GRanges}) A GRanges object with the data. If \code{data} is present, \code{chr} will be set to \code{seqnames(data)}, \code{x0} to \code{start(data)} and x1 to \code{end(data)}. If no parameter \code{y0} is specified and \code{data} has a column named \code{y0}, this column will be used. The same for \code{y1}. (defaults to NULL)
#' @param chr    (a charecter vector) A vector of chromosome names specifying the chromosomes of the data points. If \code{data} is not NULL, \code{chr} is ignored. (defaults to NULL)
#' @param x0    (a numeric vector) A numeric vector of x left positions (in base pairs). If \code{data} is not NULL, \code{x0}. (defaults to NULL)
#' @param x1    (a numeric vector) A numeric vector of x right positions (in base pairs). If \code{data} is not NULL, \code{x1}. (defaults to NULL)
#' @param y0    (a numeric vector) A numeric vector of y bottom positions. If \code{y} is not NULL, it is used instead of any data column in \code{data}. (defaults to NULL)
#' @param y1    (a numeric vector) A numeric vector of y top positions. If \code{y} is not NULL, it is used instead of any data column in \code{data}. (defaults to NULL)
#' @param ymin    (numeric) The minimum value of \code{y} to be plotted. If NULL, it is set to the min value of the selected data panel. (defaults to NULL)
#' @param ymax    (numeric) The maximum value of \code{y} to be plotted. If NULL, it is set to the max value of the selected data panel. (defaults to NULL)
#' @param data.panel    (numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param r0    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param r1    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param ...    The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions. 
#' 
#'  
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpLines}}, \code{\link{kpPoints}}
#' @seealso \code{\link{kpPlotRegions}}
#' 
#' @examples
#'  
#' set.seed(1000)
#' data.points <- sort(createRandomRegions(nregions=500, length.mean=2000000, mask=NA))
#' y <- runif(500, min=0, max=0.8)
#' mcols(data.points) <- data.frame(y0=y, y1=y+0.2)
#' 
#' kp <- plotKaryotype("hg19", plot.type=2, chromosomes=c("chr1", "chr2"))
#'   kpDataBackground(kp, data.panel=1)
#'   kpDataBackground(kp, data.panel=2)
#' 
#'   kpRect(kp, data=data.points, col="black")
#'   kpRect(kp, data=randomizeRegions(data.points, mask=NA), y0=0, y1=1,  r0=0, r1=0.2, border=NA, col="lightblue", data.panel=2)
#'   kpRect(kp, data=randomizeRegions(data.points, mask=NA), y0=0, y1=1,  r0=0.3, r1=0.5, border=NA, col="lightgreen", data.panel=2)
#'   kpRect(kp, data=randomizeRegions(data.points, mask=NA), y0=0, y1=1,  r0=0.6, r1=0.8, border=NA, col="purple", data.panel=2)
#'   
#' 
#'  
#' @export kpRect
#' 


kpRect <- function(karyoplot, data=NULL, chr=NULL, x0=NULL, x1=x0, y0=NULL, y1=NULL, 
                   ymax=NULL, ymin=NULL, r0=NULL, r1=NULL,
                   data.panel=1, clipping=TRUE, ...) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  pp <- prepareParameters4("kpRect", karyoplot=karyoplot, data=data, chr=chr, x0=x0, x1=x1,
                           y0=y0, y1=y1, ymin=ymin, ymax=ymax, r0=r0, r1=r1, 
                           data.panel=data.panel, ...)
  
  ccf <- karyoplot$coord.change.function
  
  x0plot <- ccf(chr=pp$chr, x=pp$x0, data.panel=data.panel)$x
  x1plot <- ccf(chr=pp$chr, x=pp$x1, data.panel=data.panel)$x
  y0plot <- ccf(chr=pp$chr, y=pp$y0, data.panel=data.panel)$y
  y1plot <- ccf(chr=pp$chr, y=pp$y1, data.panel=data.panel)$y
  
  processClipping(karyoplot=karyoplot, clipping=clipping, data.panel=data.panel)  
  
  #Filter the additional parameters using the 'filter' vector returned by prepareParameters4
  dots <- filterParams(list(...), pp$filter, pp$original.length)
  
  #And call the base plotting function with both the standard parameters and the modified dots parameters
  params <- c(list(xleft=x0plot, xright=x1plot, ytop=y1plot, ybottom=y0plot), dots)
  do.call(graphics::rect, params)
  
  #graphics::rect(xleft=x0plot, xright=x1plot, ytop=y1plot, ybottom=y0plot, ...)
  
  invisible(karyoplot)
}

#' kpAddChromosomeNames
#' 
#' @description 
#' 
#' Plots the chromosome names in the karyoplot
#' 
#' @details 
#' 
#' Given a KaryoPlot object, plot the names of the depicted chromosomes. This 
#' function is usually automatically called by plotKaryotype unless 
#' \code{labels.plotter} is NULL.
#' 
#' @usage kpAddChromosomeNames(karyoplot, chr.names=NULL, xoffset=0, yoffset=0, ...)
#' 
#' @param karyoplot    a \code{karyoplot} object returned by a call to \code{plotKaryotype}
#' @param chr.names      (character vector) the names to use for the chromosomes. If NULL, the chromosome names in the original genome will be used. (defaults to NULL)
#' @param xoffset    (numeric) a number of units to move the the chromosome names on the x axis with respect to their standard position (defaults to 0)
#' @param yoffset    (numeric) a number of units to move the the chromosome names on the y axis with respect to their standard position (defaults to 0)
#' @param ...  any additional parameter to be passed to the text plotting. All R base graphics params are passed along.
#' 
#' @return
#' invisibly returns the given karyoplot object
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{getChromosomeNamesBoundingBox}}
#' 
#' @examples
#'
#' kp <- plotKaryotype(labels.plotter = NULL)
#' kpAddChromosomeNames(kp, col="red", srt=30)
#'  
#' @export kpAddChromosomeNames
#' 

kpAddChromosomeNames <- function(karyoplot, chr.names=NULL, xoffset=0, yoffset=0, ...) {
  #Validate parameters
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  
  if(is.null(chr.names)) chr.names <- karyoplot$chromosomes
  if(length(chr.names)==0) stop("In kpAddChromosomeNames: chr.names must have at least one element.")
  if(!all(methods::is(chr.names, "character"))) stop("In kpAddChromosomeNames: all elements of chr.names must be characters.")

  #Begin plotting
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  bb <- getChromosomeNamesBoundingBox(karyoplot)
  
  x <- (bb$x0+bb$x1)/2 + xoffset
  y <- (bb$y0+bb$y1)/2 + yoffset
  
  graphics::text(x=x, y=y, labels=chr.names, ...)
  
  invisible(karyoplot)
}

#' kpPlotMarkers
#' 
#' @description 
#' 
#' Plots markers on the genome as a line with a label on top.
#' 
#' @details 
#'  
#' This function plots markers on the genome. It implements an interative
#' algorithm to avoid ovelapping between the labels of different markers. Since
#' labels might be plotted in a different position than the original points, 
#' a line with three parts (a vertical, a diagonal and another vertical) is 
#' plotted to link the label with the original position. It is possible to plot
#' labels in horizontal or vertical text and to specify different colors for the
#' marker line and label.
#' 
#' There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
#' 
#' @note The iterative algorithm is not guaranteed to suceed and might end up
#' with overlapping labels if labels are too dense or if too few iterations 
#' allowed. With many markers, the algorithm might be slow.
#'
#' @usage kpPlotMarkers(karyoplot, data=NULL, chr=NULL, x=NULL, y=0.75, labels=NULL, 
#'                      adjust.label.position=TRUE,  ignore.chromosome.ends=FALSE,
#'                      label.margin=0.001, max.iter=150, label.dist=0.001,
#'                      marker.parts = c(0.8,0.1, 0.1), text.orientation ="vertical",
#'                      ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL,
#'                      line.color="black", label.color="black",
#'                      pos=NULL, srt=NULL, offset=NULL, clipping=TRUE, ...)
#' 
#' @param karyoplot    (a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.
#' @param data    (a \code{GRanges}) A GRanges object with the data. If \code{data} is present, \code{chr} will be set to \code{seqnames(data)} and \code{x} to the midpoints of the rages in data. If no parameter \code{y} is specified and \code{data} has a column named \code{y} or \code{value} this column will be used to define the \code{y} value of each data point. (defaults to NULL)
#' @param chr    (a charecter vector) A vector of chromosome names specifying the chromosomes of the data points. If \code{data} is not NULL, \code{chr} is ignored. (defaults to NULL)
#' @param x    (a numeric vector) A numeric vector with the positions (in base pairs) of the data points in the chromosomes. If \code{data} is not NULL, \code{x} is ignored. (defaults to NULL)
#' @param y    (a numeric vector) A numeric vector with the values of the data points. If \code{y} is not NULL, it is used instead of any data column in \code{data}. (defaults to 0.75)
#' @param labels    (a character vector) The labels to be plotted. (defaults to NULL)
#' @param adjust.label.position (logical) whether to adjust the label positions to avoid label overlapping (defaults to TRUE)
#' @param ignore.chromosome.ends (logical) If TRUE, when adjusting label position marker labels can move beyond the chromosome ends. (defaults to FALSE, do not move out of origin chromosome)
#' @param label.margin  (numeric) The vertical margin to leave between the ens of the marker line and the marker label. In plot coordinates. (defaults to 0.001)
#' @param max.iter  (numeric) The maximum number of iterations in the iterative algorithm to adjust the label positioning. (defaults to 150)
#' @param label.dist  (numeric) The minimum distance between labels to consider them as non-overlapping (defaults to 0.001)
#' @param marker.parts   (numeruc vector of three elements) The portion of the distance between 0 and y to be filled with a: vertical, diagonal of vertical part of the marker line. (defaults to c(0.8,0.1,0.1), long vertical stem, small diagonal and small vertical on top)
#' @param text.orientation  ("vertical" or "horizontal) How should the text be plotted. Forced values of srt and pos take precedence. (defaults to "vertical")
#' @param ymin    (numeric) The minimum value of \code{y} to be plotted. If NULL, it is set to the min value of the selected data panel. (defaults to NULL)
#' @param ymax    (numeric) The maximum value of \code{y} to be plotted. If NULL, it is set to the max value of the selected data panel. (defaults to NULL)
#' @param data.panel    (numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param r0    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param r1    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param line.color  (color) The color of marker line. (defaults to "black")
#' @param label.color  (color) The color of the label (defaults to "black")
#' @param pos (1,2,3,4) The standard pos graphical parameter. If NULL, it's automatically set depending on "text.orientation". (defaults to NULL)
#' @param srt  (numeric) The standard srt graphical parameter. If NULL, it's automatically set depending on "text.orientation". (defaults to NULL)
#' @param offset  (numeric) The standard offset graphical parameter. If NULL, it's automatically set depending on "text.orientation". (defaults to NULL)
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param ... The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions. 
#'
#' @return
#' 
#' Returns the original karyoplot object with the data computed (adjusted label positioning) stored at \code{karyoplot$latest.plot}
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpLines}}, \code{\link{kpText}}
#' 
#' @examples
#'  
#' 
#' data <- toGRanges(data.frame(c("chr1", "chr1", "chr1"), c(20e6, 21e6, 22e6), c(20.01e6, 21.01e6, 22.01e6), labels=c("GeneA", "GeneB", "GeneC")))
#' 
#' kp <- plotKaryotype("hg19", plot.type=1, chromosomes = "chr1", main="Default markers")
#' kpPlotMarkers(kp, data)
#' 
#' kp <- plotKaryotype("hg19", plot.type=2, chromosomes = "chr1", main="Markers Horizontal")
#' kpPlotMarkers(kp, data, text.orientation = "horizontal")
#' kpPlotMarkers(kp, data, text.orientation = "horizontal", label.dist = 0.02, data.panel=2)
#' 
#' kp <- plotKaryotype("hg19", plot.type=2, chromosomes = "chr1", main="Different Marker parts")
#' kpPlotMarkers(kp, data, text.orientation = "horizontal", marker.parts=c(0, 1, 0), line.color="red")
#' kpPlotMarkers(kp, data, text.orientation = "horizontal", marker.parts=c(0.1, 0.2, 0.4), label.dist = 0.02, data.panel=2, label.color="blue")
#' 
#' 
#'  
#' @export kpPlotMarkers
#' @importFrom digest digest
#' @importFrom graphics strwidth
#' @importFrom IRanges IRanges

#TODO: Adjust the positioning algorithm when zoom is active so labels do not fall out of the plot.region
#TODO: Implement vertical label displacement to accomodate more labels in the same plot
kpPlotMarkers <- function(karyoplot, data=NULL, chr=NULL, x=NULL, y=0.75, labels=NULL, 
                   adjust.label.position=TRUE, ignore.chromosome.ends=FALSE, label.margin=0.001, max.iter=150, label.dist=0.001,
                   marker.parts = c(0.8,0.1, 0.1), text.orientation ="vertical",
                   ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL,
                   line.color="black", label.color="black",
                   pos=NULL, srt=NULL, offset=NULL, clipping=TRUE, ...) {
  
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  text.orientation <- match.arg(text.orientation, c("horizontal", "vertical"))
  
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  if(!is.null(data)) {
    if("labels" %in% names(mcols(data))) {
      if(is.null(labels) & (!is.null(data) & (is(mcols(data)[,"labels"], "factor") | is(mcols(data)[,"labels"], "character")))) {
        labels <- as.character(mcols(data)[,"labels"])
      }
      if(is.null(labels) & (!is.null(data) & (is(mcols(data)[,1], "factor") | is(mcols(data)[,1], "character")))) {
        labels <- as.character(mcols(data)[,1])
      }
    }
  }
  if(is.null(labels)) {
    stop("labels is NULL and no valid labels found in data")
  }
  
  #Important to set filter.data to FALSE so we can keep each marker linked to its label.
  #If some markers were filtered out for being in other chromosomes than the plotted ones
  #we wouldn't know what marked goes with each label
  pp <- prepareParameters2("kpPlotMarkers", karyoplot=karyoplot, data=data, chr=chr, x=x, y=y,
                           ymin=ymin, ymax=ymax, r0=r0, r1=r1,
                           data.panel=data.panel, filter.data = FALSE, ...)
  ccf <- karyoplot$coord.change.function
  
  #Filter the data so we only have the data in the plot.region
  valid <- which(overlapsAny(GRanges(pp$chr, IRanges(pp$x, pp$x)), karyoplot$plot.region))
  if(length(valid)==0) { #If there are no markers in the plot region, just return
    karyoplot$latest.plot <- list(funct="kpPlotMarkers", computed.values=list(label.position=integer(0)))
    return(invisible(karyoplot))
  }
  
  valid.chr <- pp$chr[valid]
  valid.x <- pp$x[valid]
  valid.y <- pp$y[valid]
  valid.labels <- labels[valid]
  
  #Filter out the additional parameters, either explicit or in the ellipsis (...)
  #so they are kept in sync with the 
  dots <- filterParams(list(...), valid, length(pp$chr))
  label.color <- filterParams(label.color, valid, length(pp$chr))
  line.color <- filterParams(line.color, valid, length(pp$chr))
  pos <- filterParams(pos, valid, length(pp$chr))
  offset <- filterParams(offset, valid, length(pp$chr))
  
  
  #Sort everything by chr and start
  #(We need it sorted for the non overlapping algorithm)
  ord <- order(valid.chr, valid.x) #Will be problematic with non UCSC genes? the chr order?
  valid.chr <- valid.chr[ord]
  valid.x <- valid.x[ord]
  valid.y <- valid.y[ord]
  valid.labels <- valid.labels[ord]
  if(length(label.color)==length(ord)) label.color <- label.color[ord]
  if(length(line.color)==length(ord)) line.color <- line.color[ord]
  if(length(pos)==length(ord)) pos <- pos[ord]
  if(length(offset)==length(ord)) offset <- offset[ord]
  
  #TODO: Should reorder other parameters? Specially any parameter passed at 
  # "dots", only if the same length as data.points
  
  
  #Transform to plot coordinates  
  xplot <- ccf(chr=valid.chr, x=valid.x, data.panel=data.panel)$x
  yplot <- ccf(chr=valid.chr, y=valid.y, data.panel=data.panel)$y
  
  if(adjust.label.position==TRUE) {
      
    #Now, move the text as needed (only horizontally) to avoid overlapping
    xlabels <- xplot
    
    #TODO: we do it per chromosome. This will be problematic in dense plots. 
    #IDEA: If we can get a reverse function for ccf, we could work on all labels
    #at the same time and then reverse transform from plot coordinates to
    #genome coordinates and call the plotting functions.
    for(current.chr in karyoplot$chromosomes) {
      in.chr <- valid.chr==current.chr
      
      if(any(in.chr)) {
        
        xp <- xlabels[in.chr]
        chr.labels <- valid.labels[in.chr]
        
        if(text.orientation == "horizontal") {
          sw <- strwidth(chr.labels, units = "user") + label.dist
        } else {
          sw <- strwidth(rep("M", length(chr.labels)), units = "user") + label.dist
        }
        delta <- strwidth("a", units = "user")/4
        
        #to be sure that we do not enter a loop, store a hash of the all old positions
        old.pos <- digest::digest(xp)
    
        for(iter in seq_len(max.iter)) {
          for(i in seq_len(length(chr.labels)-1)) {
            #Test for overlap with the next label
            if((xp[i]+sw[i]/2) > (xp[i+1]-sw[i+1]/2)) {
              #Decide what to move
              
              #If it's the first label
              if(i==1) {
                #if it will not fall out of the chromosome, move the label to the left
                if((xp[i]-sw[i]/2-delta) > ccf(chr=current.chr, x=0, data.panel=data.panel)$x || ignore.chromosome.ends==TRUE) {
                  xp[i] <- xp[i]-delta
                } else {
                  #if it will not fall out of the chromosome by the right side
                  if(xp[i+1]+delta < ccf(chr=current.chr, x=karyoplot$chromosome.lengths[current.chr], data.panel=data.panel)$x || ignore.chromosome.ends==TRUE) {
                    #move the next label to right
                    xp[i+1] <- xp[i+1]+delta  
                  } else {
                    #do nothing
                  }
                }
              } else { #if it's not the first label
                #if it will not overlap with the previous one, move to the left
                if(!((xp[i]-sw[i]/2-delta) < (xp[i-1]+sw[i-1]/2))) { 
                  xp[i] <- xp[i]-delta
                } else {
                  #if it will not fall out of the chromosome by the right side
                  if(xp[i+1]+delta < ccf(chr=current.chr, x=karyoplot$chromosome.lengths[current.chr], data.panel=data.panel)$x  || ignore.chromosome.ends==TRUE) {
                    #move the next label to right
                    xp[i+1] <- xp[i+1]+delta  
                  } else {
                    #do nothing
                  }
                }
              }
            }
          }
          dd <- digest::digest(xp)
          if(dd %in% old.pos) { #We have either found a valid position or entered a loop
            break; 
          } else {
            old.pos <- c(old.pos, dd)
          }
        }
        
        xlabels[in.chr] <- xp
      }
    }
  } else { #if we do not reposition the labels, the label position is the same as the original one
    xlabels <- xplot
  }
  #Finished repositioning labels

  processClipping(karyoplot=karyoplot, clipping=clipping, data.panel=data.panel)  
  
  #Plot the labels
  #detect if the data.panel is an inverted one
  is.inverted <- ccf(chr=karyoplot$chromosomes[1], y=0, data.panel=data.panel)$y > ccf(chr=karyoplot$chromosomes[1], y=1, data.panel=data.panel)$y
  if(text.orientation == "horizontal") {
    srt <- ifelse(is.null(srt), 0, srt)
    offset <- ifelse(is.null(offset), 0, offset)
    if(is.inverted==FALSE) {
      pos <- ifelse(is.null(pos), 3, pos)
      label.y <- yplot+label.margin
    } else {
      pos <- ifelse(is.null(pos), 1, pos)
      label.y <- yplot-label.margin
    }
    params <- c(list(x=xlabels, y=label.y, labels=valid.labels, pos=pos, srt=srt, offset=offset, col=label.color), dots)
    do.call(graphics::text, params)
    #graphics::text(x=xlabels, y=label.y, labels=valid.labels, pos=pos, col=label.color, ...)
  } else {
    srt <- ifelse(is.null(srt), 90, srt)
    offset <- ifelse(is.null(offset), 0, offset)
    if(is.inverted==FALSE) {
      pos <- ifelse(is.null(pos), 4, pos)
      label.y <- yplot+label.margin
    } else {
      pos <- ifelse(is.null(pos), 2, pos)
      label.y <- yplot-label.margin
    }
    params <- c(list(x=xlabels, y=label.y, labels=valid.labels, pos=pos, srt=srt, offset=offset, col=label.color), dots)
    do.call(graphics::text, params)
    #graphics::text(x=xlabels, y=label.y, labels=valid.labels, pos=pos, srt=srt, offset=offset, col=label.color, ...)

  }
  #and plot the markers
  if(marker.parts[2]==0 & adjust.label.position==TRUE) { #If no diagonal part is allowed, warn the user
    if(!isTRUE(all.equal(valid.x, xlabels))) {
      warning("Markers labels have been repositioned, but the diagonal part of the marker line is set to 0. For better results set the second value of 'marker.parts' to something different than 0.")
    }
  }
  
  #divide the vertical space according to the proportions of the parts
  my <- marker.parts*1/sum(marker.parts)
  
  #and plot them
    #Determine the y of the value y=0 to start the marker there
      pp2 <- prepareParameters2("kpPlotMarkers", karyoplot=karyoplot, data=NULL, chr=pp$chr, x=pp$x, y=0, ymin=ymin, ymax=ymax, r0=r0, r1=r1, data.panel=data.panel, filter.data = FALSE, ...)
      y0 <-  ccf(chr=pp2$chr[valid][ord], y=pp2$y[valid][ord], data.panel=data.panel)$y
    #markers
    if(marker.parts[1]>0) {
      params <- c(list(x0 = xplot, x1=xplot, y0 = y0, y1=y0+my[1]*(yplot-y0), col=line.color), dots)
      do.call(graphics::segments, params)
      #graphics::segments(x0 = xplot, x1=xplot, y0 = y0, y1=y0+my[1]*(yplot-y0), col=line.color, ... )
    }
    if(marker.parts[2]>0) {
      params <- c(list(x0 = xplot, x1=xlabels, y0 = y0+my[1]*(yplot-y0), y1=y0+(my[1]+my[2])*(yplot-y0), col=line.color), dots)
      do.call(graphics::segments, params)
      #graphics::segments(x0 = xplot, x1=xlabels, y0 = y0+my[1]*(yplot-y0), y1=y0+(my[1]+my[2])*(yplot-y0), col=line.color, ...)
    }
    if(marker.parts[3]>0) {
      params <- c(list(x0 = xlabels, x1=xlabels, y0 = yplot - my[3]*(yplot-y0), y1=yplot, col=line.color), dots)
      do.call(graphics::segments, params)
      #graphics::segments(x0 = xlabels, x1=xlabels, y0 = yplot - my[3]*(yplot-y0), y1=yplot, col=line.color, ...)
    }
    
  karyoplot$latest.plot <- list(funct="kpPlotMarkers", computed.values=list(label.position=xlabels))
    
  invisible(karyoplot)
}

#' getCytobandColors
#' 
#' @description 
#' 
#' Returns a named character vector with the colors of associated with the cytoband names
#' 
#' @details 
#'  
#' The function returns a named character vector with the colors of associated with the 
#' cytoband names. Two color schemas are available: circos (which copies the colors used by 
#' Circos) and biovizbase (that gets the cytoband colors from the biovizBase Bioconductor 
#' package). If a color.table is given, it is returned untouched.
#' 
#' @usage getCytobandColors(color.table=NULL, color.schema=c("circos", "biovizbase", "only.centromeres")) 
#' 
#' @param color.table   (named character vector) if present, it's returned as-is. Useful to specify your own color.tables.
#' @param color.schema  (character) The name of the color schema to use: \code{circos}, \code{biovizBase}, \code{only.centromeres} (everything in gray, except for centromeres in red). (defaults to \code{circos})
#' 
#' @return
#' a named character vector with the colors associated to each cytoband name
#' 
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpAddCytobands}}
#' 
#' @examples
#'  
#' getCytobandColors()
#' getCytobandColors(color.schema="biovizbase")
#'  
#' @export getCytobandColors
#' 


getCytobandColors <- function(color.table=NULL, color.schema=c("circos", "biovizbase", "only.centromeres")) {
  
  color.schema <- match.arg(color.schema)
  
  if(!is.null(color.table)) {
    #TODO: Should we check if it makes sense or leave it to the user?
    return(color.table)
  } else {
    if(color.schema %in% names(.karyoploter.colors$cytobands$schemas)) {
      return(.karyoploter.colors$cytobands$schemas[[color.schema]])
    } else {
      stop("Unknown color.schema. Available schemas for cytobands are: ", paste0(names(.karyoploter.colors$cytobands$schemas), collapse = ", "))
    }
  }
  #We should never reach this point. 
  stop("Error in getCytobandColors")
}

#' kpPlotRegions
#' 
#' @description 
#' 
#' Plots rectangles along the genome representing the regions (or intervals) specified by a \code{GRanges} object
#' 
#' @details 
#'  
#'  This is one of the high-level, or specialized, plotting functions of karyoploteR. It takes a \code{GRanges} object and
#'  plots its content. Overlapping regions can be stacked and the number of layers for overlapping regions can be set.
#'  In contrast with the low-level functions such as \code{\link{kpRect}}, it is not possible to specify the data using 
#'  independent numeric vectors and the function only takes in \code{GRanges}.
#'
#' @usage kpPlotRegions(karyoplot, data, data.panel=1, r0=NULL, r1=NULL, col="black", border=NULL, avoid.overlapping=TRUE, num.layers=NULL, layer.margin=0.05, clipping=TRUE, ...)
#' 
#' @param karyoplot    (a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.
#' @param data    (a \code{GRanges} or equivalent) It can be any of the formats accepted by the \code{\link[regioneR]{toGRanges}} function from the package \href{http://bioconductor.org/packages/release/bioc/html/regioneR.html}{regioneR}.
#' @param data.panel    (numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param r0    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param r1    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param col    (color) The background color of the regions. (defaults to black)
#' @param border    (color) The color used to draw the border of the regions. If NULL, no border is drawn. (defaults to NULL)
#' @param avoid.overlapping    (boolean) Whether overlapping regions should be drawn as stacks (TRUE) on drawing one occluding the other in a single layer (FALSE). (defaults to TRUE)
#' @param num.layers    (numeric) The number of layers the plotting space should be divided into to allow for plotting overlapping regions. The lotting region will be divided into this many pieces regardless if any overlapping regions actually exist. If NULL, the maximum number of regions overlapping a single point in the genome. (defaults to NULL)
#' @param layer.margin    (numeric) The blank space left between layers of regions. (defaults to 0.05)
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param ...    The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions. 
#' 
#'  
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpRect}}, \code{\link{kpSegments}}
#' 
#' @examples
#'  
#'  
#'  set.seed(1000)
#'  
#'  #Example 1: create 20 sets of non-overlapping random regions and plot them all. Add a coverage plot on top.
#'  kp <- plotKaryotype("hg19", plot.type=1, chromosomes=c("chr1", "chr2"))
#'  
#'  all.regs <- GRanges()
#'  
#'  nreps <- 20
#'  for(i in 1:nreps) {
#'    regs <- createRandomRegions(nregions = 100, length.mean = 10000000, length.sd = 1000000,
#'                                non.overlapping = TRUE, genome = "hg19", mask=NA)
#'    all.regs <- c(all.regs, regs)
#'    kpPlotRegions(kp, regs, r0 = (i-1)*(0.8/nreps), r1 = (i)*(0.8/nreps), col="#AAAAAA")
#'  }
#'  
#'  kpPlotCoverage(kp, all.regs, ymax = 20, r0=0.8,  r1=1, col="#CCCCFF")
#'  kpAxis(kp, ymin = 0, ymax= 20, numticks = 2, r0 = 0.8, r1=1)
#'  
#'  
#'  #Example 2: Do the same with a single bigger set of possibly overlapping regions
#'  
#'  kp <- plotKaryotype("hg19", plot.type=1, chromosomes=c("chr1", "chr2"))
#'  
#'  regs <- createRandomRegions(nregions = 1000, length.mean = 10000000, length.sd = 1000000,
#'                              non.overlapping = FALSE, genome = "hg19", mask=NA)
#'                              
#'  kpPlotRegions(kp, regs, r0 = 0, r1 = 0.8, col="#AAAAAA")
#'  
#'  kpPlotCoverage(kp, regs, ymax = 20, r0=0.8,  r1=1, col="#CCCCFF")
#'  kpAxis(kp, ymin = 0, ymax= 20, numticks = 2, r0 = 0.8, r1=1)
#'  
#'  
#'  
#'@export kpPlotRegions


kpPlotRegions <- function(karyoplot, data, data.panel=1, r0=NULL, r1=NULL, 
                          col="black", 
                          border=NULL, avoid.overlapping=TRUE, num.layers=NULL,
                          layer.margin=0.05, clipping=TRUE, ...) {
  #karyoplot
    if(missing(karyoplot)) stop("The parameter 'karyoplot' is required")
    if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  #data
    if(missing(data)) stop("The parameter 'data' is required")
  
    data <- toGRanges(data)
    if(!methods::is(data, "GRanges")) stop("'data' must be a GRanges object or something accepted by toGRanges")
  
  #if there's nothing to plot, return
  if(length(data)==0) {
    return(invisible(karyoplot))
  }
  
  
  #TODO: update to use toGRanges internally. But if the file is a bed file and
  # a tabix index is available, load only the regions visible in the plot.region
  # using rtracklayer::import. We might not need to check if the index is available,
  # since no overhead is expected in trying to load only a part of the bed file.
  
  if(is.null(border)) border <- col
    
  chr <- as.character(seqnames(data))
  x0 <- start(data)
  x1 <- end(data)
    
    
  #If needed, determine the y values using disjointBins to avoid region overlapping
  if(avoid.overlapping==TRUE) {
    #get the binning to avoid the overlapping
    bins <- disjointBins(data)
    if(is.null(num.layers)) num.layers <- max(bins)
    layer.height <- (1-((num.layers-1)*layer.margin))/num.layers
    y0 <- (layer.height+layer.margin) * (bins-1)
    y1 <- layer.height * (bins) + layer.margin * (bins-1)
  } else {
    #All regions in the same layer going from 0 to 1
    y0 <- 0
    y1 <- 1
  }
    
    
    
  kpRect(karyoplot=karyoplot, chr=chr, x0=x0, x1=x1, y0=y0, y1=y1, ymin=0, ymax=1, 
         r0=r0, r1=r1, data.panel=data.panel, col=col,
         border=border, clipping=clipping, ... )
  
  invisible(karyoplot)
}

#' kpBars
#' 
#' @description 
#' 
#' Plot bars along the genome
#' 
#' @details 
#'  
#' \code{kpBars} plots bars (rectangles) along the genome. It is very similar to 
#' \code{\link{kpRect}} except that if \code{y0} is missing, it's automatically set 
#' to \code{ymin} so all bars start from the base of the plotting region.
#' 
#' @usage kpBars(karyoplot, data=NULL, chr=NULL, x0=NULL, x1=x0, y1=NULL, y0=NULL, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, ...)
#'  
#' @inheritParams kpRect 
#'     
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#' 
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpRect}}, \code{\link{kpLines}}
#' 
#' @examples
#' 
#' 
#' set.seed(1000)
#' 
#' data <- toGRanges(data.frame(chr="chr1", start=10000000*(0:23), end=10000000*(1:24)))
#' y1 <- ((sin(start(data)) + rnorm(n=24, mean=0, sd=0.1))/5)+0.5
#' y0 <- y1 - rnorm(n=24, mean = 0, sd = 0.15)
#'  
#' kp <- plotKaryotype("hg19", plot.type=2, chromosomes=c("chr1", "chr2"))
#' 
#' #We can specify all data values separately. If missing y0, it defaults to ymin
#' kpBars(kp, chr=as.character(seqnames(data)), x0=start(data), x1=end(data), y1=y1,
#'        col="#FFBBBB", border="#EEAAAA")
#' kpLines(kp, data=data, y=y1, col="red")
#' 
#' #or we can provide all data into a single GRanges object
#' mcols(data) <- data.frame(y0=y0, y1=y1)
#' kpBars(kp, data[data$y0>data$y1], col="orange", border="orange", data.panel=2)
#' kpBars(kp, data[data$y0<=data$y1], col="purple", border="purple", data.panel=2)
#' 
#' kpLines(kp, data, y=data$y1, data.panel=2, col="red")
#' kpLines(kp, data, y=data$y0, data.panel=2, col="blue")
#' 
#' kpAxis(kp, data.panel = 1, cex=0.8, numticks = 5, col="#777777")
#' kpAxis(kp, data.panel = 2, cex=0.8, numticks = 5, col="#777777")
#' 
#' @export kpBars


kpBars <- function(karyoplot, data=NULL, chr=NULL, x0=NULL, x1=x0, y1=NULL, y0=NULL,
                   ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, 
                   clipping=TRUE, ...) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop(paste0("In kpBars: 'karyoplot' must be a valid 'KaryoPlot' object"))

  
  #If y0 is not specified with any of the valid methods, set it to the min of the data.panel
  if(is.null(y0)) {
    if(is.null(data)) {
      y0=karyoplot$plot.params[[paste0("data", data.panel, "min")]]
    } else {
      if(!("y0" %in% names(mcols(data)))) {
        y0=karyoplot$plot.params[[paste0("data", data.panel, "min")]]
      }
    }
  }
  
  invisible(kpRect(karyoplot=karyoplot, data=data, chr=chr, x0=x0, x1=x1, y0=y0, y1=y1,
                   ymin=ymin, ymax=ymax, r0=r0, r1=r1,
                   data.panel=data.panel, clipping=clipping, ...))
  
}

#' prepareParameters2
#' 
#' @description 
#' Prepare and normalize the parameters for functions with x and y parameters
#'  
#' @details 
#' This function prepares and normalizes the parameters for plotting functions  
#' with x and y parameters (as opposed to x0, x1, y0 and y1) so functions can
#' offer a richer interface while internally dealing only with standard and 
#' simple code. It extracts the 
#' positions from \code{data} if available and applies the \code{r0} and 
#' \code{r1} scaling. It returns the ready to plot values in a list with
#' only \code{chr}, \code{x} and \code{y}. Individual parameters (\code{chr},
#' \code{x} and \code{y}) take precedence over \code{data}. All parameters are 
#' interpreted and used as explained in \code{\link{kpPoints}}. It also filters
#' out any data points corresponding to chromosomes not present in the current 
#' karyoplot.
#'  
#' @note This function is only useful when creating custom plotting functions. 
#' It is not intended to the general user.
#' 
#' @note For detailed documentation on the parameters, see \code{\link{kpPoints}}
#'  
#' @usage prepareParameters2(function.name, karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, ymax=NULL, ymin=NULL, r0=NULL, r1=NULL, data.panel=1, filter.data=TRUE, ...)
#'  
#' @param function.name (character) The name of the function calling \code{prepareParameters2}. Only user for error reporting.
#' @param karyoplot (KaryoPlot) A karyoplot object.
#' @param data A GRanges. It can be NULL or a GRanges.
#' @param chr A character representing the chromosome names.
#' @param x The position in the chromosome in number of bases.
#' @param y The value to be plotted.
#' @param ymax The maximum value of y
#' @param ymin The minimum value of y
#' @param r0 The start of the range to use for plotting
#' @param r1 The end of the range to use for plotting
#' @param data.panel The data panel to use
#' @param filter.data A boolean indicating if data should be filtered so only data in visible chromosomes is kept. (defaults to TRUE, filter data)
#' @param ... Any additional parameter
#'
#' @return 
#' A list with three values: \code{chr}, \code{x} and \code{y}. Each of them 
#' a vector of the same length with the normalized values to plot.
#'
#'
#' @seealso \code{\link{kpPoints}}
#' 
#' @examples
#' 
#' kp <- plotKaryotype()
#' prepareParameters2("TestFunc", kp, data=NULL, chr="chr1", x=c(10, 20, 30), y=c(0, 1, 2), r0=0, r1=0.5, ymin=0, ymax=2)
#' 
#'  
#' @export prepareParameters2
#' 


prepareParameters2 <- function(function.name, karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, ymax=NULL, ymin=NULL, r0=NULL, r1=NULL, data.panel=1, filter.data=TRUE, ...) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop(paste0("In ", function.name, ": 'karyoplot' must be a valid 'KaryoPlot' object"))
    
  
  rs <- preprocess_r0_r1(karyoplot = karyoplot, r0=r0, r1=r1, data.panel=data.panel)
  
  if(is.null(ymin)) ymin <- karyoplot$plot.params[[paste0("data", data.panel, "min")]]
  if(is.null(ymax)) ymax <- karyoplot$plot.params[[paste0("data", data.panel, "max")]]
  
  if(is.na(ymin)) ymin <- karyoplot$plot.params[[paste0("data", data.panel, "min")]]
  if(is.na(ymax)) ymax <- karyoplot$plot.params[[paste0("data", data.panel, "max")]]
  
 
  if(!is.null(data)) {
    if(all(!is.na(data))) {
      if(!methods::is(data, "GRanges")) stop("Is data is not NULL it must be a GRanges object. Maybe toGRanges can be useful for this.")
      #use the values in 'data' only if the individual parameters (chr, x and y) are nothing (null or NA)
      if(is.null(chr) || all(is.na(chr))) {
        chr <- as.character(seqnames(data))
      }
      if(is.null(x) || all(is.na(x))) {
        x <- start(data) + (end(data) - start(data))/2 #Get the midpoints of the regions
      }
      
      if(is.null(y) || all(is.na(y))) {
        if("y" %in% names(mcols(data))) {
          y <- data$y
        } else {
          if("value" %in% names(mcols(data))) {
            y <- data$value
          } else {
            stop("No y value specified. Parameter y or a column named 'y' or 'value' in data must be provided")  
          }
        }
      } 
    }
  } 
  
  if(is.null(chr)) stop("chr must be specified, either by the 'chr' parameter or by providing a 'data' object")
  #if(any(is.na(chr))) stop("chr cannot be NA")   
  if(is.null(x)) stop("x must be specified, either by the 'x' parameter or by providing a 'data' object")
  #if(any(is.na(x))) stop("x cannot be NA")   
  if(is.null(y)) stop("y must be specified, either by the 'y' parameter or by providing a 'data' object with a column names 'value' or 'y'")
  #if(any(is.na(y))) stop("y cannot be NA")   
  
  #transform chr to a character
  chr <- as.character(chr)
  
  #Check the classes
  if(!base::is.character(chr)) stop("chr must be a character vector")   
  if(!base::is.numeric(x)) stop("x must be a numeric vector")
  if(!base::is.numeric(y)) stop("y must be a numeric vector")   
  
  
  #Recicle any values as needed
  chr <- recycle.first(chr, x, y)
  x <- recycle.first(x, chr, y)
  y <- recycle.first(y, chr, x)
  
  original.length <- length(chr) #this is only required for the return object
  
  #Scale it with ymin and ymax
  y <- (y - ymin)/(ymax - ymin)
  
  
  #scale y to fit in the [r0, r1] range
  y <- (y*(rs$r1-rs$r0))+rs$r0
  
  #Test if there's a problem with the chromosome names
  checkChromosomeStyle(data.chr = chr, genome.chr = karyoplot$chromosomes)
  
  if(filter.data) {
    in.visible.chrs <- chr %in% karyoplot$chromosomes
    chr <- chr[in.visible.chrs]
    x <- x[in.visible.chrs]
    y <- y[in.visible.chrs]
  } else {
    in.visible.chrs <- rep(TRUE, original.length)
  }
    
  return(list(chr=chr, x=x, y=y, filter=in.visible.chrs, original.length=original.length))
  
}

library(karyoploteR)
context("prepareParameters functions")

test_that("prepareParameters handles missing parameters", {
  
  dd <- data.frame(chr=c("chr1", "chr2", "chr3"),
                   start=c(1, 100, 1000), end=c(1, 200, 10000),
                   y0=c(-1, 0, 1), y1=c(0, 1, 2))
  dd.gr <- toGRanges(dd)  
  
  #create a plot so we get the karyoplot object
  kp <- plotKaryotype()
  
  #Check errors when values are missing. It expects all values to be passed.
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, r1=1, ymin=0, ymax=1))
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, r1=1, ymin=0))
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, r1=1, ymax=1))
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, ymin=0, ymax=1))
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r1=1, ymin=0, ymax=1))
  expect_error(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, r0=0, r1=1, ymin=0, ymax=1))
  expect_error(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, y=dd$y0, r0=0, r1=1, ymin=0, ymax=1))
  expect_error(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, x=dd$start, y=dd$y0, r0=0, r1=1, ymin=0, ymax=1))
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, r1=1, ymin=0, ymax=1))
  expect_error(prepareParameters2(function.name = "Test", data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, r1=1, ymin=0, ymax=1))
  
  #But most of them can be null or NA
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, r1=1, ymin=0, ymax=1))
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, r1=1, ymin=0, ymax=NA))
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, r1=1, ymin=NA, ymax=1))
  expect_error(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, r1=NA, ymin=0, ymax=1))
  expect_error(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=NA, r1=1, ymin=0, ymax=1))
  expect_error(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=NA, r0=0, r1=1, ymin=0, ymax=1))
  expect_error(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=NA, y=dd$y0, r0=0, r1=1, ymin=0, ymax=1))
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=NA, x=dd$start, y=dd$y0, r0=0, r1=1, ymin=0, ymax=1))
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NA, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, r1=1, ymin=0, ymax=1))
  
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, r1=1, ymin=0, ymax=NULL))
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, r1=1, ymin=NULL, ymax=1))
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=0, r1=NULL, ymin=0, ymax=1))
  expect_silent(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=dd$y0, r0=NULL, r1=1, ymin=0, ymax=1))
  expect_error(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=dd$start, y=NULL, r0=0, r1=1, ymin=0, ymax=1))
  expect_error(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=dd$chr, x=NULL, y=dd$y0, r0=0, r1=1, ymin=0, ymax=1))
  expect_error(prepareParameters2(function.name = "Test", karyoplot=kp, data=NULL, chr=NULL, x=dd$start, y=dd$y0, r0=0, r1=1, ymin=0, ymax=1))
  
  
  #TODO: Do the same for prepareParameters4
  
})


test_that("prepareParameters has correct argument precedence", {
  
  dd <- data.frame(chr=c("chr1", "chr2", "chr3"),
                   start=c(1, 100, 1000), end=c(1, 200, 10000),
                   y=c(-1, 0, 1), y0=c(-1, 0, 1), y1=c(0, 1, 2))
  dd.gr <- toGRanges(dd)  
  
  #create a plot so we get the karyoplot object
  kp <- plotKaryotype()
  
  #PrepareParameters2
    #chr
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$chr, c("chr1", "chr2", "chr3"))
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c("chr1", "chr1", "chr1"), r0=0, r1=1, ymin=0, ymax=1)$chr, c("chr1", "chr1", "chr1"))
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c("chr1", "chr1", NA), r0=0, r1=1, ymin=0, ymax=1)$chr, c("chr1", "chr1"))
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c("chr1", "chr1", NA), r0=0, r1=1, ymin=0, ymax=1, filter.data = FALSE)$chr, c("chr1", "chr1", NA))
    #x
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$x, c(1, 150, 5500))
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, x=c(1,2,3), r0=0, r1=1, ymin=0, ymax=1)$x, c(1,2,3))
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, x=c(1,2,NA), r0=0, r1=1, ymin=0, ymax=1)$x, c(1,2,NA))
    #y
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y, c(-1, 0, 1))
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, y=c(1,2,3), r0=0, r1=1, ymin=0, ymax=1)$y, c(1,2,3))
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, y=c(1,2,NA), r0=0, r1=1, ymin=0, ymax=1)$y, c(1,2,NA))
    
  #PrepareParameters4
    #chr
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$chr, c("chr1", "chr2", "chr3"))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c("chr1", "chr1", "chr1"), r0=0, r1=1, ymin=0, ymax=1)$chr, c("chr1", "chr1", "chr1"))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c("chr1", "chr1", NA), r0=0, r1=1, ymin=0, ymax=1)$chr, c("chr1", "chr1"))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c("chr1", "chr1", NA), r0=0, r1=1, ymin=0, ymax=1, filter.data = FALSE)$chr, c("chr1", "chr1", NA))
    #x0
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$x0, c(1, 100, 1000))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, x0=c(1,2,3), r0=0, r1=1, ymin=0, ymax=1)$x0, c(1,2,3))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, x0=c(1,2,NA), r0=0, r1=1, ymin=0, ymax=1)$x0, c(1,2,NA))
    #x1
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$x1, c(1, 200, 10000))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, x1=c(1,2,3), r0=0, r1=1, ymin=0, ymax=1)$x1, c(1,2,3))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, x1=c(1,2,NA), r0=0, r1=1, ymin=0, ymax=1)$x1, c(1,2,NA))
    #y0
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y0, c(-1, 0, 1))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, y0=c(1,2,3), r0=0, r1=1, ymin=0, ymax=1)$y0, c(1,2,3))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, y0=c(1,2,NA), r0=0, r1=1, ymin=0, ymax=1)$y0, c(1,2,NA))
    #y1
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y1, c(0,1,2))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, y1=c(1,2,3), r0=0, r1=1, ymin=0, ymax=1)$y1, c(1,2,3))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, y1=c(1,2,NA), r0=0, r1=1, ymin=0, ymax=1)$y1, c(1,2,NA))
    
})



test_that("prepareParameters returns the correct classes", {
  dd <- data.frame(chr=c("chr1", "chr2", "chr3"),
                   start=c(1, 100, 1000), end=c(1, 200, 10000),
                   y=c(-1, 0, 1), y0=c(-1, 0, 1), y1=c(0, 1, 2))
  dd.gr <- toGRanges(dd)  
  
  #create a plot so we get the karyoplot object
  kp <- plotKaryotype()
  
  #PrepareParameters2
  expect_is(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$chr, "character")
  expect_is(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$x, "numeric")
  expect_is(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y, "numeric")
  
  expect_is(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c(1,2,3), r0=0, r1=1, ymin=0, ymax=1, filter.data = FALSE)$chr, "character")
  expect_error(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, x=c("1", "1", "1"), r0=0, r1=1, ymin=0, ymax=1))
  expect_error(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, y=c("1", "1", "1"), r0=0, r1=1, ymin=0, ymax=1))
  
  #PrepareParameters4
  expect_is(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$chr, "character")
  expect_is(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$x0, c("numeric", "integer"))
  expect_is(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y0, c("numeric", "integer"))
  expect_is(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$x1, c("numeric", "integer"))
  expect_is(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y1, c("numeric", "integer"))
  
  expect_is(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c(1,2,3), r0=0, r1=1, ymin=0, ymax=1, filter.data = FALSE)$chr, "character")
  expect_error(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, x0=c("1", "1", "1"), r0=0, r1=1, ymin=0, ymax=1))
  expect_error(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, y0=c("1", "1", "1"), r0=0, r1=1, ymin=0, ymax=1))
  expect_error(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, x1=c("1", "1", "1"), r0=0, r1=1, ymin=0, ymax=1))
  expect_error(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, y1=c("1", "1", "1"), r0=0, r1=1, ymin=0, ymax=1))
  
})



test_that("prepareParameters return correct values", {
  
  dd <- data.frame(chr=c("chr1", "chr2", "chr3"),
                   start=c(1, 100, 1000), end=c(1, 200, 10000),
                   y=c(-1, 0, 1), y0=c(-1, 0, 1), y1=c(0, 1, 2))
  dd.gr <- toGRanges(dd)  
  
  #create a plot so we get the karyoplot object
  kp <- plotKaryotype()
  kp2 <- plotKaryotype(chromosomes = "chr1")
  
  #PrepareParameters2
    #chr has already been tested elsewhere and not affected by additional parameters
    #x has already been tested elsewhere and not affected by additional parameters
    #y 
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y, c(-1, 0, 1))
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=0.5, ymin=0, ymax=1)$y, c(-0.5, 0, 0.5))
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=1, r1=0.5, ymin=0, ymax=1)$y, c(1.5, 1, 0.5))
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0.5, r1=0.5, ymin=0, ymax=1)$y, c(0.5, 0.5, 0.5))
    
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=0.5)$y, c(-2, 0, 2))
    expect_equal(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=1, ymax=0.5)$y, c(4, 2, 0))
    expect_true(all(is.infinite(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0.5, ymax=0.5)$y)))

    expect_equal(length(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y), 3)
    expect_equal(length(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c("chr1", "chr2", "chr3", "chr4"), r0=0, r1=1, ymin=0, ymax=1)$y), 4)
    expect_equal(length(prepareParameters2(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c("chr1", "chr2"), r0=0, r1=1, ymin=0, ymax=1)$y), 3)

    expect_equal(length(prepareParameters2(function.name = "Test", karyoplot=kp2, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y), 1)
    expect_equal(length(prepareParameters2(function.name = "Test", karyoplot=kp2, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1, filter.data=FALSE)$y), 3)
    

  #PrepareParameters4
    #chr has already been tested elsewhere and not affected by additional parameters
    #x has already been tested elsewhere and not affected by additional parameters
    #y0
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y0, c(-1, 0, 1))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=0.5, ymin=0, ymax=1)$y0, c(-0.5, 0, 0.5))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=1, r1=0.5, ymin=0, ymax=1)$y0, c(1.5, 1, 0.5))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0.5, r1=0.5, ymin=0, ymax=1)$y0, c(0.5, 0.5, 0.5))
    
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=0.5)$y0, c(-2, 0, 2))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=1, ymax=0.5)$y0, c(4, 2, 0))
    expect_true(all(is.infinite(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0.5, ymax=0.5)$y0)))
    
    expect_equal(length(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y0), 3)
    expect_equal(length(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c("chr1", "chr2", "chr3", "chr4"), r0=0, r1=1, ymin=0, ymax=1)$y0), 4)
    expect_equal(length(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c("chr1", "chr2"), r0=0, r1=1, ymin=0, ymax=1)$y0), 3)
    
    expect_equal(length(prepareParameters4(function.name = "Test", karyoplot=kp2, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y0), 1)
    expect_equal(length(prepareParameters4(function.name = "Test", karyoplot=kp2, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1, filter.data=FALSE)$y0), 3)
    
    #y1
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y1, c(0, 1, 2))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=0.5, ymin=0, ymax=1)$y1, c(0, 0.5, 1))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=1, r1=0.5, ymin=0, ymax=1)$y1, c(1, 0.5, 0))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0.5, r1=0.5, ymin=0, ymax=1)$y1, c(0.5, 0.5, 0.5))
    
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=0.5)$y1, c(0, 2, 4))
    expect_equal(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=1, ymax=0.5)$y1, c(2, 0, -2))
    expect_true(all(is.infinite(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0.5, ymax=0.5)$y1)))
    
    expect_equal(length(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y1), 3)
    expect_equal(length(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c("chr1", "chr2", "chr3", "chr4"), r0=0, r1=1, ymin=0, ymax=1)$y1), 4)
    expect_equal(length(prepareParameters4(function.name = "Test", karyoplot=kp, data=dd.gr, chr=c("chr1", "chr2"), r0=0, r1=1, ymin=0, ymax=1)$y1), 3)
    
    expect_equal(length(prepareParameters4(function.name = "Test", karyoplot=kp2, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1)$y1), 1)
    expect_equal(length(prepareParameters4(function.name = "Test", karyoplot=kp2, data=dd.gr, r0=0, r1=1, ymin=0, ymax=1, filter.data=FALSE)$y1), 3)
    
})    
    
    

#' getVariantsColors
#' 
#' @description 
#' 
#' Given the reference and alternative for a set of variants, assigns a color 
#' to each of them
#' 
#' @details 
#'  
#' The function creates an nucleotide substitution identifier with for each 
#' variant and uses it to query the color.table lookup table. If color.table
#' is NULL, a color.table based in the selected color.schema is used. All 
#' unkwonwn nucleotide substitutions are assigned a gray color. Color table 
#' needs to have entries for C>A, C>G, C>T, T>A, T>C and T>G (and optionally 
#' "others"), since other changes can be reverse complemented to these.
#' 
#' @usage getVariantsColors(ref, alt, color.table=NULL, color.schema=c("cell21breast"))
#' 
#' @param ref (character vector) The reference nucleotides of the variants. It has to have the same length as \code{alt}.
#' @param alt (character vector) The alternative nucleotides of the variants. It has to have the same length as \code{ref}
#' @param color.table   (named character vector) if present, its used to assign colors to the nucleotide substitutions.
#' @param color.schema  (character) The name of the color schema to use: \code{cell21breast} (the color schema used in "Mutational Processes Molding the Genomes of 21 Breast Cancers" by S. Nik-Zainal, Cell, 2012). (defaults to \code{cell21breast})
#' 
#' @return
#' a named character vector with the colors associated to each variant
#'   
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpPlotRainfall}}
#' 
#' @examples
#'  
#' ref <- c("A", "A", "C", "T", "G", "A")
#' alt <- c("G", "C", "T", "A", "A", "-")
#' getVariantsColors(ref, alt)
#' 
#' col.table <- c("C>A"="#FF0000", "C>G"="#000000", "C>T"="#00FF00", "T>A"="#0000FF", "T>C"="#BB00BB", "T>G"="#00BBBB", "other"="#888888")
#' getVariantsColors(ref, alt, col.table)
#' 
#' 
#' @export getVariantsColors
#' 


getVariantsColors <- function(ref, alt, color.table=NULL, color.schema=c("cell21breast")) {
  
  if(!methods::is(ref, "character")) stop(paste0("In getVariantsColors: 'ref' must be a valid character object"))
  if(!methods::is(alt, "character")) stop(paste0("In getVariantsColors: 'alt' must be a valid character object"))
  if(length(ref) != length(alt)) stop(paste0("In getVariantsColors: 'ref' and 'alt' must have the same length"))
  
  if(is.null(color.table)) {
    color.schema <- match.arg(color.schema)
    
    if(color.schema %in% names(.karyoploter.colors$variants$schemas)) {
      color.table <- .karyoploter.colors$variants$schemas[[color.schema]]
    } else {
      stop("Unknown color.schema. Available schemas for variants are: ", paste0(names(.karyoploter.colors$variants$schemas), collapse = ", "))
    }
  }
    
  comp <- c(G="C", A="T", C="G", T="A")
  
  #complement if necessary
  to.comp <- which(ref=="A" | ref=="G")
  ref[to.comp] <- comp[ref[to.comp]]
  alt[to.comp] <- comp[alt[to.comp]]
  
  var.cols <- color.table[paste0(ref, ">", alt)]
  if(!is.null(color.table["other"])) {
    var.cols[which(is.na(var.cols))] <- color.table["other"]
  } else {
    var.cols[which(is.na(var.cols))] <- "#888888"
  }
  
  return(var.cols)
}

## ----include=FALSE------------------------------------------------------------
library(knitr)
library(karyoploteR)
library(regioneR)
library(magrittr)
opts_chunk$set(concordance=FALSE)
set.seed(21666641)

## -----------------------------------------------------------------------------
  gains <- toGRanges(data.frame(chr=c("chr1", "chr5", "chr17", "chr22"), start=c(1, 1000000, 4000000, 1),
                      end=c(5000000, 3200000, 80000000, 1200000)))
  losses <- toGRanges(data.frame(chr=c("chr3", "chr9", "chr17"), start=c(80000000, 20000000, 1),
                       end=c(170000000, 30000000, 25000000)))
  kp <- plotKaryotype(genome="hg19")
  kpPlotRegions(kp, gains, col="#FFAACC")
  kpPlotRegions(kp, losses, col="#CCFFAA")


## -----------------------------------------------------------------------------
  kp <- plotKaryotype(genome="mm10", plot.type=1, main="The mm10 genome")

## -----------------------------------------------------------------------------
  kp <- plotKaryotype(genome="hg19", plot.type=2, chromosomes=c("chr1", "chr2", "chr3"))

## -----------------------------------------------------------------------------
  rand.data <- createRandomRegions(genome="hg19", nregions=1000, length.mean=1, length.sd=0,
                      mask=NA, non.overlapping=TRUE) 
  rand.data <- toDataframe(sort(rand.data))
  rand.data <- cbind(rand.data, y=runif(n=1000, min=-1, max=1))
  
  #Select some data points as "special ones"
  sel.data <- rand.data[c(7, 30, 38, 52),] 
  head(rand.data)

## -----------------------------------------------------------------------------
  kp <- plotKaryotype(genome="hg19", plot.type=2, chromosomes=c("chr1", "chr2", "chr3"))
  
  kpDataBackground(kp, data.panel = 1, r0=0, r1=0.45)
  kpAxis(kp, ymin=-1, ymax=1, r0=0.05, r1=0.4, col="gray50", cex=0.5)
  kpPoints(kp, chr=rand.data$chr, x=rand.data$start, y=rand.data$y,
           ymin=-1, ymax=1, r0=0.05, r1=0.4, col="black", pch=".", cex=2)
  kpPoints(kp, chr=sel.data$chr, x=sel.data$start, y=sel.data$y,
           ymin=-1, ymax=1, r0=0.05, r1=0.4, col="red")
  kpText(kp, chr=sel.data$chr, x=sel.data$start, y=sel.data$y,
         ymin=-1, ymax=1, r0=0.05, r1=0.4, labels=c("A", "B", "C", "D"), col="red",
         pos=4, cex=0.8)
  
  
  #Upper part: data.panel=1
  kpDataBackground(kp, data.panel = 1, r0=0.5, r1=1)
  kpAxis(kp, ymin=-1, ymax=1, r0=0.5, r1=1, col="gray50", cex=0.5, numticks = 5)
  kpAbline(kp, h=c(-0.5, 0, 0.5), col="gray50", ymin=-1, ymax=1, r0=0.5, r1=1)
  kpLines(kp, chr=rand.data$chr, x=rand.data$start, y=rand.data$y,
          col="#AA88FF", ymin=-1, ymax=1, r0=0.5, r1=1)
  #Use kpSegments to add small tic to the line
  kpSegments(kp, chr=rand.data$chr, x0=rand.data$start, x1=rand.data$start,
             y0=rand.data$y-0.1, y1=rand.data$y+0.1,
             col="#8866DD", ymin=-1, ymax=1, r0=0.5, r1=1)
  #Plot the same line but inverting the data by pssing a r0>r1
  kpLines(kp, chr=rand.data$chr, x=rand.data$start, y=rand.data$y,
          col="#FF88AA", ymin=-1, ymax=1, r0=1, r1=0.5)
  
  
  #Lower part: data.panel=2
  kpDataBackground(kp, r0=0, r1=0.29, color = "#EEFFEE", data.panel = 2)
  kpAxis(kp, col="#AADDAA", ymin=-1, ymax=1, r0=0, r1=0.29, data.panel = 2,
         numticks = 2, cex=0.5, tick.len = 0)
  kpAbline(kp, h=0, col="#AADDAA", ymin=-1, ymax=1, r0=0, r1=0.29, data.panel = 2)
  kpBars(kp, chr=rand.data$chr, x0=rand.data$start, x1=rand.data$end, y1 = rand.data$y,
          col="#AADDAA", ymin=-1, ymax=1, r0=0, r1=0.29, data.panel = 2, border="#AADDAA" )
  
  kpDataBackground(kp, r0=0.34, r1=0.63, color = "#EEEEFF", data.panel = 2)
  kpAxis(kp, col="#AAAADD", ymin=-1, ymax=1, r0=0.34, r1=0.63, data.panel = 2, 
         numticks = 2, cex=0.5, tick.len = 0)
  kpAbline(kp, h=0, col="#AAAADD", ymin=-1, ymax=1, r0=0.34, r1=0.63, data.panel = 2)
  kpSegments(kp, chr=rand.data$chr, x0=rand.data$start, x1=rand.data$end, 
             y0=rand.data$y-0.2, y1=rand.data$y, 
             col="#AAAADD", ymin=-1, ymax=1, r0=0.34, r1=0.63, data.panel = 2, lwd=2)
  
  kpDataBackground(kp, r0=0.68, r1=0.97, color = "#FFEEEE", data.panel = 2)
  kpAxis(kp, col="#DDAAAA", ymin=-1, ymax=1, r0=0.68, r1=0.97, data.panel = 2,
         numticks = 2, cex=0.5, tick.len = 0)
  kpPoints(kp, chr=rand.data$chr, x=rand.data$start, y=rand.data$y,
          col="#DDAAAA", ymin=-1, ymax=1, r0=0.68, r1=0.97, data.panel = 2, pch=".", cex=3)
 

## -----------------------------------------------------------------------------
  kp <- plotKaryotype()

## -----------------------------------------------------------------------------
  kp <- plotKaryotype(chromosomes=c("autosomal"))

## -----------------------------------------------------------------------------
  kp <- plotKaryotype(genome="mm10", chromosomes=c("chr10", "chr13", "chr2"))

## -----------------------------------------------------------------------------
  kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 1)
  kpDataBackground(kp, data.panel = 1)

## -----------------------------------------------------------------------------
 kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 2)
 kpDataBackground(kp, data.panel = 1)
 kpDataBackground(kp, data.panel = 2)

## -----------------------------------------------------------------------------
 kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 3)
 kpDataBackground(kp, data.panel = 1)
 kpDataBackground(kp, data.panel = 2)

## -----------------------------------------------------------------------------
 kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 4)
 kpDataBackground(kp, data.panel = 1)

## -----------------------------------------------------------------------------
 kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 5)
 kpDataBackground(kp, data.panel = 1)

## ----eval=FALSE---------------------------------------------------------------
#  # NOT RUN
#  pt <- permTest(A=my.regions, B=repeats, randomize.function=randomizeRegions,
#  evaluate.function=overlapRegions)

## -----------------------------------------------------------------------------
  kp <- plotKaryotype(chromosomes=c("chr1", "chr2"), plot.type=2)
 
  #data.panel=1
  kpDataBackground(kp)
  #Default axis
    kpAxis(kp) 
  #Axis on the right side of the data.panel
    kpAxis(kp, side = 2) 
  
  #data.panel=2
  kpDataBackground(kp, r1=0.47, data.panel=2)
  #Changing the limits and having more ticks, with a smaller font size
  kpAxis(kp, r1=0.47, ymin=-5000, ymax = 5000, numticks = 5, cex=0.5, data.panel=2)  
  #and a different scale on the right
  kpAxis(kp, r1=0.47, ymin=-2, ymax = 2, numticks = 3, cex=0.5, data.panel=2, side=2)
  
  kpDataBackground(kp, r0=0.53, data.panel=2)
  #Changing the colors and labels and tick positions
  kpAxis(kp, r0=0.53, tick.pos = c(0.3, 0.6, 1), labels = c("A", "B", "C"), col="#66AADD",
         cex=0.5, data.panel=2)
  

## -----------------------------------------------------------------------------
plotDefaultPlotParams(plot.type=2)

## -----------------------------------------------------------------------------
plotDefaultPlotParams(plot.type=3)

## -----------------------------------------------------------------------------
plot.params <- getDefaultPlotParams(plot.type=2)
plot.params$ideogramheight <- 5
plot.params$data2height <- 50
plot.params$leftmargin <- 0.05
plot.params$bottommargin <- 20
plot.params$topmargin <- 20

plotDefaultPlotParams(plot.type=2, plot.params=plot.params)

## -----------------------------------------------------------------------------
plot.params <- getDefaultPlotParams(plot.type=3)
plot.params$ideogramheight <- 50
plot.params$data1height <- 50
plot.params$data1inmargin <- 1
plot.params$data2height <- 400

plotDefaultPlotParams(plot.type = 3, plot.params=plot.params)


## -----------------------------------------------------------------------------
  data.points <- data.frame(chr="chr1", pos=(1:240)*1e6, value=rnorm(240, 0.5, 0.1))
  kp <- plotKaryotype(plot.type = 4, chromosomes = "chr1")
  kpDataBackground(kp, data.panel = 1)
  kpAddBaseNumbers(kp)
  kpPoints(kp, chr = data.points$chr, x=data.points$pos, y=data.points$value, col=rainbow(240))

## -----------------------------------------------------------------------------
  detail.region <- toGRanges(data.frame("chr1", 180e6, 240e6))
  data.points <- data.frame(chr="chr1", pos=(1:240)*1e6, value=rnorm(240, 0.5, 0.1))
  kp <- plotKaryotype(plot.type = 4, zoom=detail.region)
  kpDataBackground(kp, data.panel = 1)
  kpAddBaseNumbers(kp)
  kpPoints(kp, chr = data.points$chr, x=data.points$pos, y=data.points$value, col=rainbow(240))

## -----------------------------------------------------------------------------
  kp <- plotKaryotype(plot.type = 4, chromosomes = "chr1")
  kpDataBackground(kp, data.panel = 1)
  kpAddBaseNumbers(kp)
  kpPoints(kp, chr = "chr1", x=180e6, y=0.5, pch=16, cex=8, col="#FAC67A", clipping=TRUE)
  kpArrows(kp, chr = "chr1", x0 = 50e6, x1=170e6, y0=0.2, y1=1.1)
  kpArrows(kp, chr = "chr1", x0 = 160e6, x1=240e6, y0=0.9, y1=0.5)

## -----------------------------------------------------------------------------
  detail.region <- toGRanges(data.frame("chr1", 135e6, 180e6))
  kp <- plotKaryotype(plot.type = 4, zoom = detail.region)
  kpDataBackground(kp, data.panel = 1)
  kpAddBaseNumbers(kp)
  kpPoints(kp, chr = "chr1", x=180e6, y=0.5, pch=16, cex=8, col="#FAC67A")
  kpArrows(kp, chr = "chr1", x0 = 50e6, x1=170e6, y0=0.2, y1=1.1)
  kpArrows(kp, chr = "chr1", x0 = 160e6, x1=240e6, y0=0.9, y1=0.5)

## -----------------------------------------------------------------------------
  detail.region <- toGRanges(data.frame("chr1", 135e6, 180e6))
  kp <- plotKaryotype(plot.type = 4, zoom = detail.region)
  kpDataBackground(kp, data.panel = 1)
  kpAddBaseNumbers(kp)
  kpPoints(kp, chr = "chr1", x=180e6, y=0.5, pch=16, cex=8, col="#FAC67A")
  kpArrows(kp, chr = "chr1", x0 = 50e6, x1=170e6, y0=0.2, y1=1.1, clipping=FALSE)
  kpArrows(kp, chr = "chr1", x0 = 160e6, x1=240e6, y0=0.9, y1=0.5, clipping=FALSE)

## -----------------------------------------------------------------------------
  kp <- plotKaryotype(chromosomes=c("chr1"))
  kpDataBackground(kp)
  kpAxis(kp)
  kpPoints(kp, chr="chr1", x=30000000, y=0.2)  
  kpRect(kp, chr="chr1", x0=100000000, x1=120000000, y0=0.2, y1=0.4)

## -----------------------------------------------------------------------------
  dd <- toGRanges(data.frame(chr="chr1", start=30000000, end=30000000, y=0.2))
  dd2 <- toGRanges(data.frame(chr="chr1", start=100000000, end=120000000, y0=0.2, y1=0.4))
  
  kp <- plotKaryotype(chromosomes=c("chr1")) 
  kpDataBackground(kp)
  kpAxis(kp)
  kpPoints(kp, data=dd)
  kpPoints(kp, data=dd, y=0.8)  
  kpRect(kp, data=dd2)
  

## -----------------------------------------------------------------------------
  pp <- getDefaultPlotParams(plot.type = 1)
  pp$data1height=600
  
  tr.i <- 1/11
  tr.o <- 1/10
  
  kp <- plotKaryotype(chromosomes=c("chr1"), plot.params = pp) 
  
  dd <- toGRanges(data.frame(chr="chr1", start=end(kp$genome[1])/50*(0:49), end=end(kp$genome[1])/50*(1:50)))
  mcols(dd) <- data.frame(y=((sin(start(dd)) + rnorm(n=50, mean=0, sd=0.1))/5)+0.5)
  
  tn <- 0
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpPoints(kp, dd, r0=tr.o*tn, r1=tr.o*tn+tr.i, pch=".", cex=2)
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpPoints", cex=0.7)
  
  tn <- 1
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpLines(kp, dd, r0=tr.o*tn, r1=tr.o*tn+tr.i, pch=".", cex=2)
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpLines", cex=0.7)
  
  tn <- 2
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpBars(kp, dd, y1=dd$y, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#AAFFAA", border="#66DD66")
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpBars", cex=0.7)
  
  tn <- 3
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpRect(kp, dd, y0=dd$y-0.3, y1=dd$y, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#AAAAFF", border="#6666DD")
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpRect", cex=0.7)
  
  tn <- 4
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpText(kp, dd, labels=as.character(1:50), cex=0.5, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#DDAADD")
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpText", cex=0.7)
  
  tn <- 5
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpSegments(kp, dd, y0=dd$y-0.3, y1=dd$y, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpSegments", cex=0.7)

  tn <- 6
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpArrows(kp, dd, y0=dd$y-0.3, y1=dd$y, r0=tr.o*tn, r1=tr.o*tn+tr.i, length=0.04)
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpArrows", cex=0.7)

  tn <- 7
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpHeatmap(kp, dd, r0=tr.o*tn+tr.i/4, r1=tr.o*tn+tr.i-tr.i/4, colors = c("green", "black", "red"))
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpHeatmap", cex=0.7)

  tn <- 8
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpPolygon(kp, dd, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpPolygon", cex=0.7)
  
  tn <- 9
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpAbline(kp, h=c(0.25, 0.5, 0.75), v=start(dd), r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpAbline", cex=0.7)
  
  

## ----eval=FALSE---------------------------------------------------------------
#   kp <- plotKaryotype(genome="hg19")
#   kpDataBackground(kp)
#   kpAxis(kp)
#   kpPlotRegions(kp, gains, col="#FFAACC")
#   kpPlotRegions(kp, losses, col="#CCFFAA")
# 

## ----eval=FALSE---------------------------------------------------------------
#   library(magrittr)
#   kp <- plotKaryotype(genome="hg19") %>% kpDataBackground() %>%  kpAxis() %>%
#     kpPlotRegions(gains, col="#FFAACC") %>%
#     kpPlotRegions(losses, col="#CCFFAA")

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#' getChromosomeNamesBoundingBox
#' 
#' @description 
#' 
#' Return the regions where the chromosome names should be placed
#' 
#' @details 
#' 
#' Given a KaryoPlot object, return the regions where the chromosome labels 
#' should be placed. The positions will depend on the plot type used.
#' 
#' @note In general, this function is automatically called by karyoploteR
#' and the user never needs to call it. 
#' 
#' @usage getChromosomeNamesBoundingBox(karyoplot)
#' 
#' @param karyoplot    a \code{karyoplot} object returned by a call to \code{plotKaryotype}
#' 
#' @return
#' Returns a list with four elements (x0, x1, y0 and y1), each of them a named
#' vector of integers with one coordinatefor every chromosome in the plot.
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpAddChromosomeNames}}
#' 
#' @examples
#'
#' kp <- plotKaryotype()
#' bb <- getChromosomeNamesBoundingBox(kp)
#'  
#' @export getChromosomeNamesBoundingBox
#' 


getChromosomeNamesBoundingBox <- function(karyoplot) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  
  if(karyoplot$plot.type %in% c(1,2,6)) {
    chr.labels <- karyoplot$chromosomes
    
    y0 <- karyoplot$ideogram.mid(chr=chr.labels) - karyoplot$plot.params$ideogramheight
    y1 <- karyoplot$ideogram.mid(chr=chr.labels) + karyoplot$plot.params$ideogramheight
    x0 <- stats::setNames(rep(0, length(chr.labels)), chr.labels)
    x1 <- stats::setNames(rep(karyoplot$plot.params$leftmargin, length(chr.labels)), chr.labels)
  
    return(list(x0=x0, x1=x1, y0=y0, y1=y1))  
  }
  if(karyoplot$plot.type %in% c(3, 5,7)) {
    #position the labels centered in the chromosome and in the top margin
    chr.labels <- as.character(seqnames(karyoplot$plot.region))
    
    y1 <- stats::setNames(rep(karyoplot$plot$ymax - karyoplot$plot.params$topmargin/2, length(chr.labels)), chr.labels) #the top half of the top margin is reserved for the main title
    y0 <- stats::setNames(rep(karyoplot$plot$ymax - karyoplot$plot.params$topmargin, length(chr.labels)), chr.labels)
    
    #use the coordinates change function to get the x positioning
    ccf <- karyoplot$coord.change.function
    x0 <- ccf(chr=chr.labels, x=start(karyoplot$plot.region), data.panel=1)$x
    x1 <- ccf(chr=chr.labels, x=end(karyoplot$plot.region), data.panel=1)$x
    
    return(list(x0=x0, x1=x1, y0=y0, y1=y1))  
  }
  if(karyoplot$plot.type %in% c(4)) {
    #position the labels centered in the chromosome and in the bottom margin
    chr.labels <- as.character(seqnames(karyoplot$plot.region))
    
    y1 <- stats::setNames(rep(karyoplot$plot.params$bottommargin, length(chr.labels)), chr.labels)
    y0 <- stats::setNames(rep(0, length(chr.labels)), chr.labels)
    
    #use the coordinates change function to get the x positioning
    ccf <- karyoplot$coord.change.function
    x0 <- ccf(chr=chr.labels, x=start(karyoplot$plot.region), data.panel=1)$x
    x1 <- ccf(chr=chr.labels, x=end(karyoplot$plot.region), data.panel=1)$x
    
     
    return(list(x0=x0, x1=x1, y0=y0, y1=y1))  
  }
  
  #Else
  stop("Unknown plot type")
}

#' kpPlotBAMCoverage
#' 
#' @description 
#' 
#' Plots the coverage of a BAM file along the genome
#' 
#' @details 
#'  
#' \code{kpPlotBAMCoverage} plots the read coverage of a BAM file, that is, the 
#' number of reads overlapping each position. It uses the 
#' \code{\link{bamsignals}} package to efficiently access the BAM file.
#' The BAM file must be indexed. This function is only recommended when 
#' plotting small parts of the genome. For larger plots consider using 
#' \code{\link{kpPlotBAMDensity}}.
#' 
#' There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
#' 
#' @note Since the plotting the exact coverage for large
#' regions of the genome may be unfeasable, it includes a safety mechanism
#' causing it to raise a warning and do nothing if the region is larger than 
#' a threshold specified by \code{max.valid.region.size}.
#' 
#' @usage kpPlotBAMCoverage(karyoplot, data=NULL, max.valid.region.size=1e6, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, col=NULL, border=NA, clipping=TRUE,...)
#' 
#' @param karyoplot    (a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.
#' @param data    (a character) The path to a bam file (must be indexed).
#' @param max.valid.region.size    (numeric) If the length of plotted region exceeds this number, nothing will be plotted. It's a safety mechanism to from excessive memory usage. (Defaults to 1e6, 1 milion bases)
#' @param data.panel    (numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param r0    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param r1    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param ymin    (numeric) The minimum value to be plotted on the data panel. If NULL, it is set to 0. (deafults to NULL)
#' @param ymax    (numeric) The maximum value to be plotted on the data.panel. If NULL the maximum density is used. (defaults to NULL)
#' @param col  (color) The fill color to plot. If NULL the color will be assigned automatically, either a lighter version of the color used for the outer line or gray if the line color is not defined. If NA no area will be drawn. (defaults to NULL)
#' @param border (color) The color to use to plot the borders of the bars. If NULL, it will be a darker version of 'col'. If NA, no border will be plotted. (Defaults to NA)
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param ...    The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions. In particular \code{col} and \code{border} can be used to set the colors used.
#'   
#' @return
#' 
#' Returns the original karyoplot object with the data computed (max.coverage) stored at \code{karyoplot$latest.plot}
#' 
#' @seealso \code{\link{kpPlotBAMDensity}}, \code{\link{kpPlotCoverage}}
#' 
#' @examples
#' 
#' library(pasillaBamSubset) #A package with 2 example bam files
#' un1.bam.file <- untreated1_chr4() # get the name of the first bam
#' un3.bam.file <- untreated3_chr4() #and the name of the second
#' 
#' kp <- plotKaryotype(genome="dm6", chromosomes="chr4") #The pasilla data comes from drosophila
#' kp <- kpAddBaseNumbers(kp, tick.dist = 1e5)
#' kp <- kpPlotBAMCoverage(kp, data = un1.bam.file) #Warning and does not plot. region too large.
#' kp <- kpPlotBAMCoverage(kp, data = un1.bam.file, max.valid.region.size=2000000)
#'
#' #Use zoom to plot a smaller region to see the coverage with more detail
#' kp <- plotKaryotype(genome="dm6", zoom=toGRanges("chr4", 340000, 350000))
#' kp <- kpAddBaseNumbers(kp, tick.dist = 1e3)
#' kp <- kpPlotBAMCoverage(kp, data = un1.bam.file)
#' 
#' 
#' #Change the colors and borders and compare  two bams
#' kp <- plotKaryotype(genome="dm6", zoom=toGRanges("chr4", 340000, 350000))
#' kp <- kpAddBaseNumbers(kp, tick.dist = 1e3)
#' kp <- kpPlotBAMCoverage(kp, data = un1.bam.file, r0=0.5, r1=1, border="orange")
#' kp <- kpPlotBAMCoverage(kp, data = un3.bam.file, r0=0.5, r1=0, border="darkgreen") #r1 < r0 will flip the plot
#' kpAbline(kp, h=0.5, col="darkgray")
#' 
#' 
#' 
#' @export kpPlotBAMCoverage
#' @importFrom bamsignals bamCoverage


kpPlotBAMCoverage <- function(karyoplot, data=NULL, max.valid.region.size=1e6,
                              ymin=NULL, ymax=NULL, data.panel=1,
                              r0=NULL, r1=NULL, 
                              col=NULL, border=NA, clipping=TRUE,...) {

  if(!methods::is(karyoplot, "KaryoPlot")) stop(paste0("In kpPlotBAMCoverage: 'karyoplot' must be a valid 'KaryoPlot' object"))

  if(!is.character(data)) stop(paste0("In kpPlotBAMCoverage: 'data' must be a character indicating the path to an indexed BAM file."))
  if(!file.exists(data)) stop(paste0("In kpPlotBAMCoverage: File ", data, " does not exists"))
  if(!file.exists(paste0(data, ".bai"))) stop(paste0("In kpPlotBAMCoverage: Index file ", paste0(data, ".bai"), " does not exists. The BAM file must be indexed."))

  if(sum(width(karyoplot$plot.region))>max.valid.region.size) {
    warning("In kpPlotBAMCoverage: Skipping BAM coverage plot. 
The genomic region in your plot is larger than the maximum
valid size. Plotting coverage in a very large region would 
probably result in very large memory usage and potentially 
crash your R session while creating not very informative 
plots. For larger regions, kpPlotBAMDensity is recommended.
If you want to plot the coverage in a large region,
please supply a larger value for 'max.valid.region.size'
parameter.")
    karyoplot$latest.plot <- list(funct="kpPlotBAMCoverage", computed.values=list(max.coverage=NA))
    return(invisible(karyoplot))
  }
  
  #Everything look correct. Start plotting.
  
  #Get the coverage
  bam.cov <- bamsignals::bamCoverage(data, karyoplot$plot.region, verbose=FALSE)
  #bam.cov has a numeric vector for each entry in plot.region
  
  max.cov <- max(unlist(lapply(bam.cov, max)))
  if(is.null(ymax)) {
    ymax <- max.cov
  }
  
  for(i in seq_len(length(karyoplot$plot.region))) {
    r <- karyoplot$plot.region[i]
    kpArea(karyoplot, chr=seqnames(r), x=seq.int(start(r), end(r)), 
           y=bam.cov[i], ymin=ymin, ymax=ymax, data.panel=data.panel, 
           r0=r0, r1=r1, border=border, col=col, clipping=clipping, ...)
  }
  
  karyoplot$latest.plot <- list(funct="kpPlotBAMCoverage", computed.values=list(max.coverage=max.cov))

  invisible(karyoplot)
}

#' getDefaultParameters
#' 
#' @description 
#' 
#' Returns the default parameters for the given plot.type
#' 
#' @details 
#'  
#'  Given a plot.type, this function returns a list suitable as a valid \code{plot.params} object.
#'  The user can then proceed to change the parameter values as needed and supply the modified 
#'  list to the plotKaryotype function.#'
#'  
#' @usage getDefaultPlotParams(plot.type)
#'  
#' @param plot.type   (integer) the required plot type. can be any valid plot type (see \code{\link{plotKaryotype}})
#'
#' @return 
#' 
#' A valid \code{plot.params} object with the default values for the plotting parameters and 
#' ready to be used in the \code{plotKaryotype}
#'
#' @seealso \code{\link{plotKaryotype}}
#' 
#' @examples
#' 
#' pp <- getDefaultPlotParams(plot.type=2)
#' pp
#'
#' #Change the ideogramheight param to create thicker ideograms 
#' pp$ideogramheight <- 150
#' 
#' plotKaryotype(genome="hg19", plot.type=2, plot.params=pp) 
#' 
#'  
#' @export getDefaultPlotParams
#' 


getDefaultPlotParams <- function(plot.type) {
  valid.plot.types <- c(1,2,3,4,5,6,7) 
  
  if(!plot.type %in% valid.plot.types) {
    stop(paste0("plot.type is not valid. Select a valid value: ", 
                paste0(valid.plot.types, collapse=", ")))
  }
  
  if(plot.type == 1) { #Horizontal. Data above the ideogram
    plot.params <- list(leftmargin=0.1, rightmargin=0.05, topmargin=120, bottommargin=100,
                        ideogramheight=50, ideogramlateralmargin=0,
                        data1height=200, data1inmargin=20, data1outmargin=20,
                        data1min=0, data1max=1,
                        data2height=0, data2inmargin=0, data2outmargin=0, #make the panel invisible
                        data2min=0, data2max=1                        
    )
  } 
  if(plot.type == 2) { #Horizontal. Data above and below the ideogram
    plot.params <- list(leftmargin=0.1, rightmargin=0.05, topmargin=120, bottommargin=100,
                        ideogramheight=50, ideogramlateralmargin=0,
                        data1height=200, data1inmargin=20, data1outmargin=20,
                        data1min=0, data1max=1,
                        data2height=200, data2inmargin=20, data2outmargin=20,
                        data2min=0, data2max=1
    )
  }
  if(plot.type == 3) { #Horizontal. All ideograms in a single line with 2 data panels
    plot.params <- list(leftmargin=0.05, rightmargin=0.05, topmargin=30, bottommargin=30,
                        ideogramheight=10, ideogramlateralmargin=0.003,
                        data1height=200, data1inmargin=10, data1outmargin=0,
                        data1min=0, data1max=1,
                        data2height=200, data2inmargin=10, data2outmargin=0,
                        data2min=0, data2max=1
    )
  }
  if(plot.type == 4) { #Horizontal. All ideograms in a single line 1 panel above
    plot.params <- list(leftmargin=0.05, rightmargin=0.05, topmargin=30, bottommargin=30,
                        ideogramheight=10, ideogramlateralmargin=0.003,
                        data1height=200, data1inmargin=10, data1outmargin=0,
                        data1min=0, data1max=1,
                        data2height=0, data2inmargin=0, data2outmargin=0, #make the panel invisible
                        data2min=0, data2max=1
    )
  }
  if(plot.type == 5) { #Horizontal. All ideograms in a single line 1 panel below
    plot.params <- list(leftmargin=0.05, rightmargin=0.05, topmargin=30, bottommargin=30,
                        ideogramheight=10, ideogramlateralmargin=0.003,
                        data1height=0, data1inmargin=0, data1outmargin=0, #make this panel invisible
                        data1min=0, data1max=1,
                        data2height=200, data2inmargin=10, data2outmargin=0,
                        data2min=0, data2max=1
    )
  }
  if(plot.type == 6) { #Horizontal. No data panels.
    plot.params <- list(leftmargin=0.1, rightmargin=0.05, topmargin=120, bottommargin=100,
                        ideogramheight=50, ideogramlateralmargin=0,
                        data1height=0, data1inmargin=0, data1outmargin=5, #make the panel invisible
                        data1min=0, data1max=1,
                        data2height=0, data2inmargin=0, data2outmargin=5, #make the panel invisible
                        data2min=0, data2max=1                        
    )
  }
  if(plot.type == 7) {  #Horizontal. All ideograms in a single line. No data panels
    plot.params <- list(leftmargin=0.1, rightmargin=0.05, topmargin=30, bottommargin=30,
                        ideogramheight=200, ideogramlateralmargin=0.003,
                        data1height=0, data1inmargin=0, data1outmargin=5, #make the panel invisible
                        data1min=0, data1max=1,
                        data2height=0, data2inmargin=0, data2outmargin=5, #make the panel invisible
                        data2min=0, data2max=1                        
    )
  } 
  
  
  
  #Add the additional "ideogram" and "all" data.panels
  plot.params <- c(plot.params,
                   list(dataideogrammin=0, dataideogrammax=1, #plotting in the ideogram
                        dataallmin=0, dataallmax=1 #plotting above the whole chromosome space
                   ))
                        
  
  return(plot.params)
}

#' kpAddLabels
#' 
#' @description 
#' 
#' Add labels to identify the data in the plot
#' 
#' @details 
#' 
#' Given a KaryoPlot object, plot labels on the side of the data panels to help identify the different types of data plotted
#' 
#' @usage kpAddLabels(karyoplot, labels, label.margin=0.01,  side="left", pos=NULL, offset=0, r0=NULL, r1=NULL, data.panel=1, ...) 
#' 
#' @param karyoplot    a \code{karyoplot} object returned by a call to \code{plotKaryotype}
#' @param labels   (character) the text on the labels
#' @param label.margin    (numeric) the additional the margin between the labels the first base of the chromosome. In plot coordinates. Usual value might be 0.05. Can be negative. (defaults to 0.01)
#' @param side ("left" or "right") The side of the plot where to plot the labels. (defaults to "left") 
#' @param pos   (numeric) The standard graphical parameter. See \code{\link[graphics]{text}}. If NULL, pos will be selected automatically based on "side" (Defaults to NULL)
#' @param offset  (numeric) The standard graphical parameter. See \code{\link[graphics]{text}}. (Defaults to 0)
#' @param r0    (numeric) r0 and r1 define the vertical range of the data panel to be used to position the label. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param r1    (numeric) r0 and r1 define the vertical range of the data panel to be used to position the label. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param data.panel    (numeric) The identifier of the data panel where the labels are to be added. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param ...  any additional parameter to be passed to the text plotting. All R base graphics params are passed along.
#' 
#' @return
#' invisibly returns the given karyoplot object
#'  
#' @seealso \code{\link{plotKaryotype}}
#' 
#' @examples
#'
#' plot.params <- getDefaultPlotParams(plot.type=2)
#' plot.params$leftmargin <- 0.2
#' plot.params$rightmargin <- 0.2
#' 
#' #In standard whole karyotypes, labels are drawn for all chromosomes
#' 
#' kp <- plotKaryotype("hg19", chromosomes=c("chr1", "chr2"), plot.type=2, plot.params = plot.params)
#' #data panel 1
#' kpDataBackground(kp, r0=0, r1=0.5, col="#FFDDDD")
#' kpDataBackground(kp, r0=0.5, r1=1, col="#DDFFDD")
#' kpAddLabels(kp, "Everything", label.margin = 0.12, srt=90, pos=3, cex=0.8)
#' kpAddLabels(kp, "Red", r0=0, r1=0.5, cex=0.6)
#' kpAddLabels(kp, "Green", r0=0.5, r1=1, cex=0.6)
#' #data panel 2
#' kpDataBackground(kp, col="#DDDDFF", data.panel = 2)
#' kpAddLabels(kp, "BLUE", data.panel=2)
#' 
#' #Plot on the right
#' #data panel 1
#' kpAddLabels(kp, "Everything", label.margin = 0.12, srt=90, pos=1, cex=0.8, side="right")
#' kpAddLabels(kp, "Red", r0=0, r1=0.5, cex=0.6, side="right")
#' kpAddLabels(kp, "Green", r0=0.5, r1=1, cex=0.6, side="right")
#'  
#'  
#'  
#' #In karyotypes with all chromosomes in a single line, 
#' #labels are added on the first (side="left") or last (side="right") chromosome
#' 
#' kp <- plotKaryotype("hg19", chromosomes=c("chr1", "chr2", "chr3"), plot.type=3, plot.params = plot.params)
#' #data panel 1
#' kpDataBackground(kp, r0=0, r1=0.5, col="#FFDDDD")
#' kpDataBackground(kp, r0=0.5, r1=1, col="#DDFFDD")
#' kpAddLabels(kp, "Everything", label.margin = 0.12, srt=90, pos=3, cex=0.8)
#' kpAddLabels(kp, "Red", r0=0, r1=0.5, cex=0.6)
#' kpAddLabels(kp, "Green", r0=0.5, r1=1, cex=0.6)
#' #data panel 2
#' kpDataBackground(kp, col="#DDDDFF", data.panel = 2)
#' kpAddLabels(kp, "BLUE", data.panel=2)
#' 
#' #Plot on the right
#' #data panel 1
#' kpAddLabels(kp, "Everything", label.margin = 0.12, srt=90, pos=1, cex=0.8, side="right")
#' kpAddLabels(kp, "Red", r0=0, r1=0.5, cex=0.6, side="right")
#' kpAddLabels(kp, "Green", r0=0.5, r1=1, cex=0.6, side="right")
#'
#'
#'
#' #In Zoomed regions, they are placed at the correct position too
#' kp <- plotKaryotype("hg19", zoom="chr1:20000000-40000000", plot.type=2, plot.params = plot.params)
#' kpAddBaseNumbers(kp, tick.dist=5000000, add.units=TRUE)
#' #data panel 1
#' kpDataBackground(kp, r0=0, r1=0.5, col="#FFDDDD")
#' kpDataBackground(kp, r0=0.5, r1=1, col="#DDFFDD")
#' kpAddLabels(kp, "Everything", label.margin = 0.12, srt=90, pos=3, cex=0.8)
#' kpAddLabels(kp, "Red", r0=0, r1=0.5, cex=0.6)
#' kpAddLabels(kp, "Green", r0=0.5, r1=1, cex=0.6)
#' #data panel 2
#' kpDataBackground(kp, col="#DDDDFF", data.panel = 2)
#' kpAddLabels(kp, "BLUE", data.panel=2)
#' 
#' #Plot on the right
#' #data panel 1
#' kpAddLabels(kp, "Everything", label.margin = 0.12, srt=90, pos=1, cex=0.8, side="right")
#' kpAddLabels(kp, "Red", r0=0, r1=0.5, cex=0.6, side="right")
#' kpAddLabels(kp, "Green", r0=0.5, r1=1, cex=0.6, side="right")
#' 
#' 
#' 
#' 
#' @export kpAddLabels
#' 

kpAddLabels <- function(karyoplot, labels, label.margin=0.01,  side="left", pos=NULL, offset=0, r0=NULL, r1=NULL, data.panel=1, ...) {
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  #Determine the position of the labels
  
  #Depending on the plot type, the labels will be printed once or multiple times
  if(karyoplot$plot.type %in% c(1,2,6)) {
    chrs <- karyoplot$chromosomes
  } 
  if(karyoplot$plot.type %in% c(3,4,5,7)) {
    if(side=="left") {
      chrs <- karyoplot$chromosomes[1]
    } else {
      chrs <- karyoplot$chromosomes[length(karyoplot$chromosomes)]
    }
  }
  
  #Compute the bounding boxes
  adj.y <- prepareParameters2("kpAddLabels", karyoplot, data=NULL, chr=chrs, 
                              x=0, y=c(0,1), ymax=1, ymin=0, r0=r0, r1=r1, 
                              data.panel=data.panel)$y
  #Compute the vertical position of the labels
  y0 <- karyoplot$coord.change.function(chr = chrs, x = 0, y=rep(adj.y[1], length(chrs)), data.panel = data.panel)$y
  y1 <- karyoplot$coord.change.function(chr = chrs, x = 0, y=rep(adj.y[2], length(chrs)), data.panel = data.panel)$y
  y <- (y0+y1)/2
  
  #Compute the horizontal position of the labels
  if(side == "left") { #if side="left", plot them on the left
    #The right end of the left-side margin minus the label.margin
    x <- rep(karyoplot$plot.params$leftmargin, length(chrs)) - label.margin
    if(is.null(pos)) pos <- 2
  } else {  #if side="right", plot them on the right
    #The last position of each chrs plus the label.margin
    x <- karyoplot$coord.change.function(chr = chrs, 
                                         x = end(karyoplot$plot.region[chrs]),
                                         y=rep(adj.y[1], length(chrs)), 
                                         data.panel = data.panel)$x + label.margin
    if(is.null(pos)) pos <- 4
  }

  graphics::text(x=x, y=y, labels=labels, pos=pos, offset=0, ...)

  invisible(karyoplot)
}

#' kpPoints
#' 
#' @description 
#' 
#' Plots data points along the genome.
#' 
#' @details 
#'  
#' This is one of the functions from karyoploteR implementing the adaptation to the genome context 
#' of basic plot functions
#' from R base graphics. Given a set of positions on the genome (chromosome and base) and a 
#' value (y) for each of them, it plots the set of points representing them. Data can be provided 
#' via a \code{GRanges} object (\code{data}), independent parameters for chr, x and y or a 
#' combination of both. A number of parameters can be used to define exactly where 
#' and how the points are drawn. In addition, via the ellipsis operator (\code{...}), \code{kpPoints}
#' accepts any parameter valid for \code{points} (e.g. \code{pch}, \code{cex}, \code{col}, ...)
#' 
#' There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
#'
#' @usage kpPoints(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, pch=16, cex=0.5, ...)
#' 
#' @param karyoplot    (a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.
#' @param data    (a \code{GRanges}) A GRanges object with the data. If \code{data} is present, \code{chr} will be set to \code{seqnames(data)} and \code{x} to the midpoints of the rages in data. If no parameter \code{y} is specified and \code{data} has a column named \code{y} or \code{value} this column will be used to define the \code{y} value of each data point. (defaults to NULL)
#' @param chr    (a charecter vector) A vector of chromosome names specifying the chromosomes of the data points. If \code{data} is not NULL, \code{chr} is ignored. (defaults to NULL)
#' @param x    (a numeric vector) A numeric vector with the positions (in base pairs) of the data points in the chromosomes. If \code{data} is not NULL, \code{x} is ignored. (defaults to NULL)
#' @param y    (a numeric vector) A numeric vector with the values of the data points. If \code{y} is not NULL, it is used instead of any data column in \code{data}. (defaults to NULL)
#' @param ymin    (numeric) The minimum value of \code{y} to be plotted. If NULL, it is set to the min value of the selected data panel. (defaults to NULL)
#' @param ymax    (numeric) The maximum value of \code{y} to be plotted. If NULL, it is set to the max value of the selected data panel. (defaults to NULL)
#' @param data.panel    (numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param r0    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param r1    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param pch    (numeric) the glyph to represent the points as specified in \code{\link{par}}. (defaults to 16, a solid circle)
#' @param cex    (numeric) the relative size of the glyphs as defined at \code{\link{par}}. (defaults to 0.5)
#' @param ...    The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions. 
#' 
#' 
#' @note The parameter r0 can be used to specify r0 and r1 together. If r1 is 
#' NULL and r0 is either a list with two elements called r0 and r1 or a numeric
#' vector of length 2, this values will be used for r0 and r1. This might be
#' useful when working with \code{\link{autotrack}} to compute r0 and r1.
#'  
#' @return
#' 
#' Returns the original karyoplot object, unchanged.  
#' 
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpLines}}, \code{\link{kpText}}
#' @seealso \code{\link{kpPlotRegions}}
#' 
#' @examples
#'  
#' set.seed(1000)
#' data.points <- sort(createRandomRegions(nregions=500, mask=NA))
#' mcols(data.points) <- data.frame(y=runif(500, min=0, max=1))
#' 
#' kp <- plotKaryotype("hg19", plot.type=2, chromosomes=c("chr1", "chr2"))
#'   kpDataBackground(kp, data.panel=1)
#'   kpDataBackground(kp, data.panel=2)
#' 
#'   kpLines(kp, data=data.points, col="red")
#' 
#'   #Three ways of specifying the exact same data.points
#'   kpPoints(kp, data=data.points, cex=0.5)
#'   kpPoints(kp, data=data.points, y=data.points$y, pch=16, col="#CCCCFF", cex=0.6)
#'   kpPoints(kp, chr=as.character(seqnames(data.points)), 
#'            x=(start(data.points)+end(data.points))/2, 
#'            y=data.points$y, pch=".", col="black", cex=1)
#' 
#'   #plotting in the data.panel=2 and using r0 and r1, ymin and ymax
#'   kpLines(kp, data=data.points, col="red", r0=0, r1=0.3, data.panel=2)
#'   #and we can specify r0 and r1 in r0
#'   kpPoints(kp, data=data.points, r0=list(r0=0, r1=0.3), data.panel=2, pch=".", cex=3)
#'   kpLines(kp, data=data.points, col="blue", r0=0.4, r1=0.7, data.panel=2)
#'   kpLines(kp, data=data.points, col="blue", y=-1*(data.points$y),
#'           ymin=-1, ymax=0, r0=0.7, r1=1, data.panel=2)
#'   #It is also possible to "flip" the data by giving an r0 > r1
#'   kpPoints(kp, data=data.points, col="red", y=(data.points$y), 
#'            r0=1, r1=0.7, data.panel=2, pch=".", cex=2)  
#' 
#' 
#'  
#' @export kpPoints
#' 


kpPoints <- function(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, ymin=NULL, ymax=NULL, 
                     data.panel=1, r0=NULL, r1=NULL,
                     clipping=TRUE, pch=16, cex=0.5, ...) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  pp <- prepareParameters2("kpPoints", karyoplot=karyoplot, data=data, chr=chr, x=x, y=y, 
                           ymin=ymin, ymax=ymax, r0=r0, r1=r1, data.panel=data.panel, ...)
  ccf <- karyoplot$coord.change.function
  
  xplot <- ccf(chr=pp$chr, x=pp$x, data.panel=data.panel)$x
  yplot <- ccf(chr=pp$chr, y=pp$y, data.panel=data.panel)$y
  
  processClipping(karyoplot=karyoplot, clipping=clipping, data.panel=data.panel)  
  
  #Filter the additional parameters using the 'filter' vector returned by prepareParameters2
  #Filter only the arguments (explicit or from the ellipsis (...)) that match the original number of data points.
  #WARNING: This will solve the filtering problem when the user provides a value
  #for every data point or a single value for all of them, but will give unexpected
  #results when partially recycling parameters
  dots <- filterParams(list(...), pp$filter, pp$original.length)
  pch <- filterParams(pch, pp$filter, pp$original.length)
  cex <- filterParams(cex, pp$filter, pp$original.length)
  
  
  #And call the base plotting function with both the standard parameters and the modified dots parameters
  params <- c(list(x=xplot, y=yplot, pch=pch, cex=cex), dots)
  do.call(graphics::points, params)
  #graphics::points(x=xplot, y=yplot, pch=pch, cex=cex, ...)  
  
  invisible(karyoplot)
}

#' getMainTitleBoundingBox
#' 
#' @description 
#' 
#' Return the regions where the chromosome names should be placed
#' 
#' @details 
#' 
#' Given a KaryoPlot object, return the regions where the main plot
#' should be placed. The position will depend on the plot type used.
#' 
#' @note In general, this function is automatically called by karyoploteR
#' and the user never needs to call it. 
#' 
#' @usage getMainTitleBoundingBox(karyoplot)
#' 
#' @param karyoplot    a \code{karyoplot} object returned by a call to \code{plotKaryotype}
#' 
#' @return
#' Returns a list with four elements (x0, x1, y0 and y1), each of them an 
#' integer with the coordinates for the main title
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpAddMainTitle}}
#' 
#' @examples
#'
#' kp <- plotKaryotype()
#' bb <- getMainTitleBoundingBox(kp)
#'  
#' @export getMainTitleBoundingBox
#' 


getMainTitleBoundingBox <- function(karyoplot) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  
  if(karyoplot$plot.type %in% c(1,2,4,6,7)) {
    y0 <- karyoplot$plot$ymax - karyoplot$plot.params$topmargin
    y1 <- karyoplot$plot$ymax
    x0 <- karyoplot$plot$xmin
    x1 <- karyoplot$plot$xmax
  
    return(list(x0=x0, x1=x1, y0=y0, y1=y1))  
  }
  if(karyoplot$plot.type %in% c(3, 5)) {
    y0 <- karyoplot$plot$ymax - karyoplot$plot.params$topmargin/2 #The bottom part of the top margin is used by the chromosome names
    y1 <- karyoplot$plot$ymax
    x0 <- karyoplot$plot$xmin
    x1 <- karyoplot$plot$xmax
    return(list(x0=x0, x1=x1, y0=y0, y1=y1))  
  }
 
  
  #Else
  stop("Unknown plot type: ", karyoplot$plot.type)
}

#' kpLines
#' 
#' @description 
#' 
#' Plots a line joining the data points along the genome.
#' 
#' @details 
#'  
#' This is one of the functions from karyoploteR implementing the adaptation to the genome 
#' context of basic plot functions
#' from R base graphics. Given a set of positions on the genome (chromosome and base) and a 
#' value (y) for each of them, it plots a line joining them. Data can be provided 
#' via a \code{GRanges} object (\code{data}), independent parameters for chr, x and y or a 
#' combination of both. A number of parameters can be used to define exactly where 
#' and how the lines are drawn. In addition, via the ellipsis operator (\code{...}),
#' \code{kpLines} accepts any parameter valid for \code{\link[graphics]{lines}} 
#' (e.g. \code{lwd}, \code{lty}, \code{col}, ...) The lines are drawn in a per chromosome 
#' basis, so it is not possible to draw lines encompassing more than one chromosome.
#'
#' @usage kpLines(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, ...)
#' 
#' @inheritParams kpPoints 
#' 
#' 
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpLines}}, \code{\link{kpText}}, \code{\link{kpPlotRegions}}
#' 
#' @examples
#'  
#' set.seed(1000)
#' data.points <- sort(createRandomRegions(nregions=500, mask=NA))
#' mcols(data.points) <- data.frame(y=runif(500, min=0, max=1))
#' 
#' kp <- plotKaryotype("hg19", plot.type=2, chromosomes=c("chr1", "chr2"))
#'   kpDataBackground(kp, data.panel=1)
#'   kpDataBackground(kp, data.panel=2)
#' 
#'   kpLines(kp, data=data.points, col="red")
#' 
#'   #Three ways of specifying the exact same data.points
#'   kpPoints(kp, data=data.points)
#'   kpPoints(kp, data=data.points, y=data.points$y, pch=16, col="#CCCCFF", cex=0.6)
#'   kpPoints(kp, chr=as.character(seqnames(data.points)), 
#'            x=(start(data.points)+end(data.points))/2, y=data.points$y, pch=".",
#'            col="black", cex=1)
#' 
#'   #plotting in the data.panel=2 and using r0 and r1, ymin and ymax
#'   kpLines(kp, data=data.points, col="red", r0=0, r1=0.3, data.panel=2)
#'   kpPoints(kp, data=data.points, r0=0, r1=0.3, data.panel=2, pch=".", cex=3)
#' 
#'   kpLines(kp, data=data.points, col="blue", r0=0.4, r1=0.7, data.panel=2)
#'   kpLines(kp, data=data.points, col="blue", y=-1*(data.points$y), 
#'           ymin=-1, ymax=0, r0=0.7, r1=1, data.panel=2)
#'   #It is also possible to "flip" the data by giving an r0 > r1
#'   kpPoints(kp, data=data.points, col="red", y=(data.points$y), 
#'            r0=1, r1=0.7, data.panel=2, pch=".", cex=2)  
#' 
#' 
#'  
#' @export kpLines
#' 



kpLines <- function(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, ymin=NULL, ymax=NULL,
                    data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, ...) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  pp <- prepareParameters2("kpLines", karyoplot=karyoplot, data=data, chr=chr, x=x, y=y, 
                           ymin=ymin, ymax=ymax, r0=r0, r1=r1, 
                           data.panel=data.panel, ...)
  ccf <- karyoplot$coord.change.function
  
  ss <- lapply(karyoplot$chromosomes, function(current.chr) {
    in.chr <- which(pp$chr==current.chr)
    xplot <- ccf(chr=pp$chr[in.chr], x=pp$x[in.chr], data.panel=data.panel)$x
    yplot <- ccf(chr=pp$chr[in.chr], y=pp$y[in.chr], data.panel=data.panel)$y
    processClipping(karyoplot=karyoplot, clipping=clipping, data.panel=data.panel)
    graphics::lines(x=xplot, y=yplot, ...)      
  })
  
  
  
  invisible(karyoplot)
}

#' kpPlotNames
#' 
#' @description 
#' 
#' Plots text labels with positioning relative to rectangles along the genome. 
#' 
#' @details 
#'  
#'  This is a simple wrapper around \code{\link{kpText}} that positions the 
#'  text relative to the rectangles defined by its arguments. They may be
#'  used to name or label different graphical elements in the plot.
#'  The rectangles may be specified as in \code{\link{kpRect}} the relative 
#'  positions accepted are: "left", "right", "top", "bottom", "center". 
#'  It is possible to specify and empty label (\code{labels=""}) to leave an
#'  element without name.
#'
#' @usage kpPlotNames(karyoplot, data=NULL, chr=NULL, x0=NULL, x1=x0, y0=NULL, y1=NULL, labels=NULL, position="left", ymax=NULL, ymin=NULL, r0=NULL, r1=NULL,  data.panel=1, clipping=TRUE, ...)
#'
#' @inheritParams kpRect
#' @param position (character) The position of the text relative to the rectangle. Can be "left", "right", "top", "bottom" or "center". Defaults to "left".
#' @param labels  (character) The labels to use in the plot. They will be associated to the rectangles by its order and recycled as needed. 
#'  
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#'  
#' @seealso \code{\link{kpText}}, \code{\link{kpRect}}
#' 
#' @examples
#'  
#'  
#'  regs <- toGRanges(data.frame(chr=c("chr1", "chr1", "chr1"),
#'                   start=c(20e6, 100e6, 200e6),
#'                   end=c(40e6, 170e6, 210e6),
#'                   y0=c(0.1, 0.5, 0.7),
#'                   y1=c(0.5, 0.6, 0.95)))
#'  
#'  kp <- plotKaryotype(genome="hg19", chromosomes="chr1")
#'  kpRect(kp, data=regs)  
#'  
#'  kpPlotNames(kp, data=regs, labels=c("R1", "R2", "R3"))
#'  kpPlotNames(kp, data=regs, labels=c("R1", "R2", "R3"), position="top", cex=2)    
#'  kpPlotNames(kp, data=regs, labels=c("R1", "", "R3"), position="right", col="red")
#'  kpPlotNames(kp, data=regs, labels="bottom", position="bottom", col=rainbow(3))
#'  kpPlotNames(kp, data=regs, labels="o", position="center", col=rainbow(3), cex=1)                
#'  
#'@export kpPlotNames


kpPlotNames <- function(karyoplot, data=NULL, chr=NULL, x0=NULL, x1=x0, y0=NULL, y1=NULL, 
                        labels=NULL, position="left",
                        ymax=NULL, ymin=NULL, r0=NULL, r1=NULL, 
                        data.panel=1, clipping=TRUE, ...) {

  
  #karyoplot
    if(missing(karyoplot)) stop("The parameter 'karyoplot' is required")
    if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  #position
  position <- match.arg(position, c("left", "right", "top", "bottom", "center"))
  
  if(length(data)==0 && length(chr)==0) return(invisible(karyoplot))

  #Note: we use r0=0 and r1=1 (and ymin=0 and ymax=1) so we only use data input normalization (data, chr, etc...) but not normalization of r0, ymins, etc...  
  pp <- prepareParameters4("kpPlotNames", karyoplot=karyoplot, data=data, chr=chr, x0=x0, x1=x1,
                           y0=y0, y1=y1, ymin=0, ymax=1, r0=0, r1=1, 
                           data.panel=data.panel, ...)
  
  #if there's nothing to plot, return
  if(length(pp$chr)==0) {
    invisible(karyoplot)
  }
  
  #Now decide how to plot (with respect to the rectangles), and call kpText with the appropiate parameters
  switch(position,  
    left=kpText(karyoplot, chr=pp$chr, x=pp$x0, y=pp$y0+(pp$y1-pp$y0)/2, labels=labels, pos=2, ymin=ymin, ymax=ymax, r0=r0, r1=r1, clipping=clipping, data.panel=data.panel, ...),
    right=kpText(karyoplot, chr=pp$chr, x=pp$x1, y=pp$y0+(pp$y1-pp$y0)/2, labels=labels, pos=4, ymin=ymin, ymax=ymax, r0=r0, r1=r1, clipping=clipping, data.panel=data.panel, ...),
    top=kpText(karyoplot, chr=pp$chr, x=pp$x0+(pp$x1-pp$x0)/2, y=pp$y1, labels=labels, pos=3,  ymin=ymin, ymax=ymax, r0=r0, r1=r1, clipping=clipping, data.panel=data.panel, ...),
    bottom=kpText(karyoplot, chr=pp$chr, x=pp$x0+(pp$x1-pp$x0)/2, y=pp$y0, labels=labels, pos=1,  ymin=ymin, ymax=ymax, r0=r0, r1=r1, clipping=clipping, data.panel=data.panel, ...),
    center=kpText(karyoplot, chr=pp$chr, x=pp$x0+(pp$x1-pp$x0)/2, y=pp$y0+(pp$y1-pp$y0)/2, labels=labels, ymin=ymin, ymax=ymax, r0=r0, r1=r1, clipping=clipping, data.panel=data.panel, ...)
  )  

  invisible(karyoplot)
}

#' prepareParameters4
#' 
#' @description 
#' Prepare and normalize the parameters for functions with x0, x1 and y0, y1 parameters
#'  
#' @details 
#' This function prepares and normalizes the parameters for plotting functions  
#' with x0, x1, y0 and y1 parameters (as opposed to x and y) so functions can
#' offer a richer interface while internally dealing only with standard and 
#' simple code. It extracts the 
#' positions from \code{data} if available and applies the \code{r0} and 
#' \code{r1} scaling. It returns the ready to plot values in a list with
#' only \code{chr}, \code{x0}, \code{x1}, \code{y0} and \code{y1}. 
#' Individual parameters (\code{chr}, \code{x0}, \code{x1}, \code{y0} and 
#' All parameters are interpreted and used as explained in \code{\link{kpRect}}.
#' It also filters out any data points corresponding to chromosomes not present
#' in the current karyoplot.
#'  
#' @note This function is only useful when creating custom plotting functions. 
#' It is not intended to the general user.
#' 
#' @note For detailed documentation on the parameters, see \code{\link{kpRect}}
#'  
#' @usage prepareParameters4(function.name, karyoplot, data=NULL, chr=NULL, x0=NULL, x1=NULL, y0=NULL, y1=NULL, ymax=NULL, ymin=NULL, r0=NULL, r1=NULL, data.panel=1, filter.data=TRUE, ...)
#'  
#' @param function.name (character) The name of the function calling \code{prepareParameters4}. Only user for error reporting.
#' @param karyoplot (KaryoPlot) A karyoplot object.
#' @param data A GRanges
#' @param chr A character representing the chromosome names.
#' @param x0 The position in the chromosome in number of bases.
#' @param x1 The position in the chromosome in number of bases.
#' @param y0 The value to be plotted.
#' @param y1 The value to be plotted.
#' @param ymax The maximum value of y
#' @param ymin The minimum value of y
#' @param r0 The start of the range to use for plotting
#' @param r1 The end of the range to use for plotting
#' @param data.panel The data panel to use
#' @param filter.data A boolean indicating if data should be filtered so only data in visible chromosomes is kept. (defaults to TRUE, filter data)
#' @param ... Any additional parameter
#'
#' @return 
#' A list with five values: \code{chr}, \code{x0}, \code{x1}, \code{y0} and \code{y1}. Each of them 
#' a vector of the same length with the normalized values to plot.
#'
#'
#' @seealso \code{\link{kpRect}}
#' 
#' @examples
#' 
#' kp <- plotKaryotype()
#' prepareParameters4("TestFunc", kp, data=NULL, chr="chr1", x0=c(10, 20, 30), x1=c(20, 30, 40), y0=c(0, 1, 2), y1=c(0.5, 1.5, 3), r0=0, r1=0.5, ymin=0, ymax=3)
#' 
#'  
#' @export prepareParameters4
#' 


prepareParameters4 <- function(function.name, karyoplot, data=NULL, chr=NULL, x0=NULL, x1=NULL, y0=NULL, y1=NULL, ymax=NULL, ymin=NULL, r0=NULL, r1=NULL, data.panel=1, filter.data=TRUE, ...) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop(paste0("In ", function.name, ": 'karyoplot' must be a valid 'KaryoPlot' object"))
  
  rs <- preprocess_r0_r1(karyoplot = karyoplot, r0=r0, r1=r1, data.panel=data.panel)
  
  if(is.null(ymin)) ymin <- karyoplot$plot.params[[paste0("data", data.panel, "min")]]
  if(is.null(ymax)) ymax <- karyoplot$plot.params[[paste0("data", data.panel, "max")]]
  
  if(is.na(ymin)) ymin <- karyoplot$plot.params[[paste0("data", data.panel, "min")]]
  if(is.na(ymax)) ymax <- karyoplot$plot.params[[paste0("data", data.panel, "max")]]
  
 
  if(!is.null(data)) {
    if(all(!is.na(data))) {
      if(!methods::is(data, "GRanges")) stop("Is data is not NULL it must be a GRanges object. Maybe toGRanges can be useful for this.")
      if(is.null(chr) || all(is.na(chr))) {
        chr <- as.character(seqnames(data))
      }
      if(is.null(x0) || all(is.na(x0))) {
        x0 <- start(data)
      }
      if(is.null(x1) || all(is.na(x1))) {
        x1 <- end(data)
      }
      
      if(is.null(y0) || all(is.na(y0))) {
        if("y0" %in% names(mcols(data))) {
          y0 <- data$y0
        } else {
          stop("No y0 value specified. Parameter y0 or a column named 'y0' in data must be provided")
        }
      }
      if(is.null(y1) || all(is.na(y1))) {
        if("y1" %in% names(mcols(data))) {
          y1 <- data$y1
        } else {
          stop("No y1 value specified. Parameter y1 or a column named 'y1' in data must be provided")
        }
      }
    }
  } 
    
  if(is.null(chr)) stop("chr must be specified, either by the 'chr' parameter or by providing a 'data' object")
  #if(any(is.na(chr))) stop("chr cannot be NA")   
  if(is.null(x0)) stop("x0 must be specified, either by the 'x0' parameter or by providing a 'data' object")
  #if(any(is.na(x0))) stop("x0 cannot be NA")   
  if(is.null(y0)) stop("y0 must be specified, either by the 'y0' parameter or by providing a 'data' object with a column named 'y0'")
  #if(any(is.na(y0))) stop("y0 cannot be NA")   
  if(is.null(x1)) stop("x1 must be specified, either by the 'x1' parameter or by providing a 'data' object")
  #if(any(is.na(x1))) stop("x1 cannot be NA")   
  if(is.null(y1)) stop("y1 must be specified, either by the 'y1' parameter or by providing a 'data' object with a column named 'y1'")
  #if(any(is.na(y1))) stop("y1 cannot be NA")   
  
  #transform chr to a character
  chr <- as.character(chr)

  #Check the classes
  if(!base::is.character(chr)) stop("chr must be a character vector")   
  if(!base::is.numeric(x0)) stop("x0 must be a numeric vector")
  if(!base::is.numeric(x1)) stop("x1 must be a numeric vector")
  if(!base::is.numeric(y0)) stop("y0 must be a numeric vector")
  if(!base::is.numeric(y1)) stop("y1 must be a numeric vector")   
  
    
  #Recicle any values as needed
  chr <- recycle.first(chr, x0, x1, y0, y1)
  x0 <- recycle.first(x0, chr, x1, y0, y1)
  x1 <- recycle.first(x1, chr, x0, y0, y1)
  y0 <- recycle.first(y0, chr, x0, x1, y1)
  y1 <- recycle.first(y1, chr, x0, x1, y0)

  
  original.length <- length(chr) #this is only required for the return object
  
  
  #Scale it with ymin and ymax
  y0 <- (y0 - ymin)/(ymax - ymin)
  y1 <- (y1 - ymin)/(ymax - ymin)
  
  #scale y to fit in the [r0, r1] range
  y0 <- (y0*(rs$r1-rs$r0))+rs$r0
  y1 <- (y1*(rs$r1-rs$r0))+rs$r0
  
  #Test if there's a problem with the chromosome names
  checkChromosomeStyle(data.chr = chr, genome.chr = karyoplot$chromosomes)
  
  if(filter.data) {
    in.visible.chrs <- chr %in% karyoplot$chromosomes
    chr <- chr[in.visible.chrs]
    x0 <- x0[in.visible.chrs]
    x1 <- x1[in.visible.chrs]
    y0 <- y0[in.visible.chrs]
    y1 <- y1[in.visible.chrs]
  } else {
    in.visible.chrs <- rep(TRUE, original.length)
  }
  
  return(list(chr=chr, x0=x0, x1=x1, y0=y0, y1=y1, filter=in.visible.chrs, original.length=original.length))
  
}

#' kpPlotTranscripts
#' 
#' @description 
#' 
#' Plot gene transcripts on the genome, with options to add strand markers and
#' to differentiate between coding and non-coding exons.
#' 
#' @details 
#'  
#'  This is one of the high-level, or specialized, plotting functions of
#'  karyoploteR. It takes a list with the transcripts, coding and non-coding 
#'  exons and creates a traditional boxes and line representation of the
#'  transcripts. With y0 and y1, it is possible to specify a different vertical 
#'  position and different height for each transcript. 
#'  It can add little arrows,
#'  strand marks, along the introns to show the transcript strand. The marks 
#'  appearance can be customized using 4 different parameters specifying the 
#'  height (relative to the height of the transcript), width of each mark 
#'  (relative to the height), distance between marks (relative to the width) and
#'  color of the marks. Marks are centered on the space they have available and
#'  if the available space to too tight for a single mark, no mark will be 
#'  plotted. The direction of the marks is based on the transcript strand as
#'  specified in \code{data$transcripts} object.
#'  Two detail levels are available: \code{detail.level=1} will represent 
#'  transcripts as solid boxes (optionally with strand marks along the whole
#'  transcript); \code{detail.level=2} will represent the internal structure of 
#'  the transcripts -coding and non coding exons, introns, and optionally the
#'  strand marks only in the introns.
#'  
#' @note IMPORTANT: The direction of the strand marks is taken from the strand
#' information in the \code{data$transcripts} object. If transcripts have no
#' strand information there (they have \code{strand="*"}), no marks will be 
#' drawn.
#' 
#' 
#' 
#' @usage kpPlotTranscripts(karyoplot, data, y0=NULL, y1=NULL, non.coding.exons.height=0.5, 
#' detail.level=2,
#' add.strand.marks=TRUE, mark.height=0.20, mark.width=1, mark.distance=4,
#' add.transcript.names=TRUE, transcript.names=NULL, transcript.name.position="left", transcript.name.cex=1,
#' col="black", border=NULL, coding.exons.col=NULL, coding.exons.border.col=NULL, 
#' non.coding.exons.col=NULL, non.coding.exons.border.col=NULL, 
#' introns.col=NULL, marks.col=NULL, transcript.name.col=NULL,
#' ymax=NULL, ymin=NULL, r0=NULL, r1=NULL, 
#' data.panel=1, clipping=TRUE, ...) 
#' 
#' @param karyoplot (a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.
#' @param data  (a \code{list}) data must be a list with an element called 'transcripts' with a \code{GRanges} with all transcripts to be plotted. Additionally, to plot the transcript structure it needs two other elements, 'coding.exons' and 'non.coding.exons', each a list with an element for every transcript with \code{GRanges} objects representing the transcript exons. An example of the data structure needed can be seen in the function examples.
#' @param y0  (numeric) The bottom of the transcripts in the y axis. It can have a different value for each transcript and values will be recycled if needed. If null, it will be set to the minimum y value in the data.panel, usually 0. (Defaults to NULL)
#' @param y1  (numeric) The top of the transcripts in the y axis. It can have a different value for each transcript and values will be recycled if needed. If null, it will be set to the maximum y value in the data.panel, usually 1. (Defaults to NULL)
#' @param non.coding.exons.height  (numeric) The height of the non.coding exons relative to the transcript height. For example, if 0.5, non-coding exons will have a height half the size of the coding ones. (default 0.5) 
#' @param detail.level (numeric: 1 or 2) The detail level of the transcript representation: 1 will plot only boxes representing the transcripts, 2 will plot detailed structure of the trasncripts (coding and non-coding exons and introns). (Defaults to 2)
#' @param add.strand.marks  (boolean) Whether strand marks should be plotted or not. Strand marks are small arrows along the introns (or whole transcripts if detail level=1). (defaults to TRUE)
#' @param mark.height (numeric) The height of the strand marks in "coding exons heights", that is, if mark.height is 0.5, the mark will have a height of half the height of an exon. (defaults to 0.2)
#' @param mark.width  (numeric) The width of the strand marks, in mark heights. mark.width=1 will produce arrow heads with a slope pf 45 degrees. A value higher than 1 will produce smaller angles and a value below 1 larger angles with more vertical lines. (defaults to 1, 45 degrees)
#' @param mark.distance  (numeric) The distance between marks, in mark widths. A distance of 2, will add a space of 2*mark.width between consecutive marks. (defaults to 4)
#' @param add.transcript.names (boolean) Whether to add transcript names to the plot (defailts to TRUE)
#' @param transcript.names  (named character) A named character vector with the labels of the transcripts. If not null, it will be used as a dictionary, so transcript ids should be names and desired labels the values. If NULL, the transcript ids will be used as labels. (defaults to null)
#' @param transcript.name.position  (character) The position of the text relative to the rectangle. Can be "left", "right", "top", "bottom" or "center". (Defaults to "left")
#' @param transcript.name.cex  (numeric) The cex value to plot the transcript labels. (defaults to 1)
#' @param col  (color) The color of the transcripts and labels. It is possible to specify different colors for each element class (transcript names, exons, strand marks...). All elements with no explicit color will be plotted using col. (defaults to "black) 
#' @param border  (color) The color of the border of rectangles representing genes, transcripts and exons. Every element class may have its own specific color using the appropiate parameters. The ones with no explicit color will use border. At the same time, if border is NULL, it will default to col. (fesults to NULL)
#' @param coding.exons.col  (color) The fill color of the rectangles representing the coding exons. If NULL, it will use col. (defaults to NULL)
#' @param coding.exons.border.col  (color) The color of the border of the coding exons. If NULL, it will use border. (defaults to NULL)
#' @param non.coding.exons.col  (color) The fill color of the rectangles representing the non-coding exons. If NULL, it will use col. (defaults to NULL)
#' @param non.coding.exons.border.col  (color) The color of the border of the non-coding exons. If NULL, it will use border. (defaults to NULL)
#' @param introns.col (color) The color of the lines representing the introns. If NULL, it will use col. (defaults to NULL) 
#' @param marks.col   (color) The color of the arrows representing the strand. If NULL, it will use col. (defaults to NULL) 
#' @param transcript.name.col  (color) The color of the transcript labels. If NULL, it will use col. (defaults to NULL)
#' @param ymax  (numeric) The maximum value of \code{y} to be plotted. If NULL, it is set to the max value of the selected data panel. (defaults to NULL)
#' @param ymin  (numeric) The minimum value of \code{y} to be plotted. If NULL, it is set to the min value of the selected data panel. (defaults to NULL) 
#' @param r0  (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL) 
#' @param r1  (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL) 
#' @param data.panel (numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param clipping (boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param ...  The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions. 
#' 
#' 
#'  
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#'  
#' @seealso \code{\link{kpPlotGenes}}
#' 
#' @examples
#'  
#' #Build the data objet expected by transcripts
#' 
#' transcripts <- c(toGRanges("chr1", 100, 1000),
#'                  toGRanges("chr1", 1500, 3000))
#' names(transcripts) <- c("T1", "T2")
#' strand(transcripts) <- c("+", "-")
#' 
#' coding.exons <- list("T1"=c(toGRanges("chr1", 200, 300),
#'                             toGRanges("chr1", 500, 800),
#'                             toGRanges("chr1", 900, 950)),
#'                      "T2"=c(toGRanges("chr1", 2200, 2300),
#'                             toGRanges("chr1", 2500, 2510),
#'                             toGRanges("chr1", 2700, 2800)))
#' 
#' 
#' non.coding.exons <- list("T1"=c(toGRanges("chr1", 100, 199),
#'                                 toGRanges("chr1", 951, 1000)),
#'                          "T2"=c(toGRanges("chr1", 1500, 1700),
#'                                 toGRanges("chr1", 1900, 1950),
#'                                 toGRanges("chr1", 2100, 2199),
#'                                 toGRanges("chr1", 2801, 3000)))
#' 
#' data <- list(transcripts=transcripts, coding.exons=coding.exons, non.coding.exons=non.coding.exons)
#' 
#' #Create a simple example plot
#' karyoplot <- plotKaryotype(zoom=toGRanges("chr1", 0, 3200))
#' kpAddBaseNumbers(karyoplot, tick.dist = 400)
#' kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0, r1=0.1)
#' 
#' 
#' #Create a plot with different variants of the transcripts
#' karyoplot <- plotKaryotype(zoom=toGRanges("chr1", 0, 3200))
#' kpAddBaseNumbers(karyoplot, tick.dist = 400)
#' #Standard
#' kpPlotTranscripts(karyoplot, data=data, r0=0, r1=0.1)
#' #Customize colors
#' kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0.11, r1=0.21, transcript.name.position = "right", non.coding.exons.col = "#888888", non.coding.exons.border.col = "#888888", marks.col="#CC6666", transcript.name.col="#CC6666")
#' #Change vertical position and transcript height
#' kpPlotTranscripts(karyoplot, data=data, y0=c(0, 0.4), y1=c(0.2, 1), r0=0.25, r1=0.8, add.transcript.names = TRUE, transcript.name.position = "left", add.strand.marks = TRUE, clipping=FALSE)
#' #Change detail level, colors and transcript names
#' kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0.9, r1=1, detail.level = 1, add.transcript.names = TRUE, transcript.name.position = "top", add.strand.marks = TRUE, clipping=FALSE, col="blue", marks.col="white", transcript.names=list(T1="Transcript 1", T2="Transcript 2"))
#'
#' #Create a plot with different variants of the strand marks
#' karyoplot <- plotKaryotype(zoom=toGRanges("chr1", 0, 3200))
#' kpAddBaseNumbers(karyoplot, tick.dist = 400)
#' #Standard
#' kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0, r1=0.1)
#' #No marks
#' kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0.15, r1=0.25, add.strand.marks=FALSE)
#' #Change the strand marks height
#' kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0.3, r1=0.4, mark.height=1)
#' #Change the mark width
#' kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0.45, r1=0.55, mark.width=2)
#' #Change the mark distance
#' kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0.6, r1=0.7, mark.distance=1.5)
#'
#'  
#'  
#' @export kpPlotTranscripts
#'
#' @importFrom graphics par segments




kpPlotTranscripts <- function(karyoplot, data, y0=NULL, y1=NULL, non.coding.exons.height=0.5, 
                              detail.level=2,
                              add.strand.marks=TRUE, mark.height=0.20, mark.width=1, mark.distance=4,
                              add.transcript.names=TRUE, transcript.names=NULL, transcript.name.position="left", transcript.name.cex=1,
                              col="black", border=NULL, coding.exons.col=NULL, coding.exons.border.col=NULL, 
                              non.coding.exons.col=NULL, non.coding.exons.border.col=NULL, 
                              introns.col=NULL, marks.col=NULL, transcript.name.col=NULL,
                              ymax=NULL, ymin=NULL, r0=NULL, r1=NULL, 
                              data.panel=1, clipping=TRUE, ...) {
  

  #karyoplot
    if(missing(karyoplot)) stop("The parameter 'karyoplot' is required")
    if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  #data
    if(missing(data)) stop("The parameter 'data' is required")
    #TODO: Check data is valid
  #detail.level
    if(is.null(detail.level)) detail.level <- 2
    if(!(detail.level %in% c(1,2))) warning("Detail level must be 1 (only boxes) or 2 (whole transcript structure). Setting it to 2.")
  
     
  #if null, get the r0 and r1
  if(is.null(r0)) r0 <- karyoplot$plot.params[[paste0("data", data.panel, "min")]]
  if(is.null(r1)) r1 <- karyoplot$plot.params[[paste0("data", data.panel, "max")]]
  
  #if null, get y0 and y1 to occupy the whole data panel
  if(is.null(y0)) y0 <- karyoplot$plot.params[[paste0("data", data.panel, "min")]]
  if(is.null(y1)) y1 <- karyoplot$plot.params[[paste0("data", data.panel, "max")]]


  #Set the colors if needed
  if(is.null(border)) border <- col
  if(is.null(coding.exons.col)) coding.exons.col <- col
  if(is.null(coding.exons.border.col)) coding.exons.border.col <- border
  if(is.null(non.coding.exons.col)) non.coding.exons.col <- col
  if(is.null(non.coding.exons.col)) non.coding.exons.border.col <- border
  if(is.null(introns.col)) introns.col <- col
  if(is.null(marks.col)) marks.col <- col
  if(is.null(transcript.name.col)) transcript.name.col <- col
  
  #Extend y0 and y1 to the length of the transcripts
  y0 <- rep(y0, length.out=length(data$transcripts))
  y1 <- rep(y1, length.out=length(data$transcripts))

  #And start plotting
  for(nt in seq_len(length(data$transcripts))) {
    transcript <- data$transcripts[nt]
    chr <- as.character(seqnames(transcript))
    t.y0 <- y0[nt]
    t.y1 <- y1[nt]
    mid.transcript <- t.y0 + (t.y1-t.y0)/2
    transcript.height <- t.y1-t.y0
  
    if(detail.level==1) { #plot only boxes
      kpRect(karyoplot, data=transcript, y0=t.y0, y1=t.y1, col=col, border=border, ymax=ymax, ymin=ymin, r0=r0, r1=r1, data.panel=data.panel, clipping=clipping)
      
      if(add.strand.marks==TRUE) {
        addStrandMarks(karyoplot, transcript, transcript.height=transcript.height, mid.transcript = mid.transcript, mark.height=mark.height, mark.width=mark.width, mark.distance=mark.distance, marks.col=marks.col, r0=r0, r1=r1, ymin=ymin, ymax=ymax, data.panel=data.panel, clipping=clipping)
      }
    } else if(detail.level==2) {
      coding.exons <- data$coding.exons[[names(transcript)]]
      non.coding.exons <- data$non.coding.exons[[names(transcript)]]
      
      #Plot introns, non coding exons and coding exons in that order so overlapping margins do not enter the larger figures

      #introns
      introns <- setdiff(transcript, c(coding.exons, non.coding.exons, ignore.mcols=TRUE), ignore.strand=TRUE)
      strand(introns) <- strand(transcript)

      kpSegments(karyoplot, data=introns, y0=mid.transcript, y1=mid.transcript, col=introns.col, ymin=ymin, ymax=ymax, r0=r0, r1=r1, data.panel=data.panel, clipping=clipping)

      if(add.strand.marks==TRUE) {
        addStrandMarks(karyoplot, introns, transcript.height=transcript.height, mid.transcript = mid.transcript, mark.height=mark.height, mark.width=mark.width, mark.distance=mark.distance, marks.col=marks.col, r0=r0, r1=r1, ymin=ymin, ymax=ymax, data.panel=data.panel, clipping=clipping)
      }
      
            
      #non-coding exons 
      nc.y0 <- mid.transcript-(t.y1-t.y0)*non.coding.exons.height/2
      nc.y1 <- mid.transcript+(t.y1-t.y0)*non.coding.exons.height/2
      
      kpRect(karyoplot, data=non.coding.exons, y0=nc.y0, y1=nc.y1, col=non.coding.exons.col, border=non.coding.exons.border.col, ymin=ymin, ymax=ymax, r0=r0, r1=r1, data.panel=data.panel, clipping=clipping)
      
      #coding exons
      kpRect(karyoplot, data=coding.exons, y0=t.y0, y1=t.y1, col=coding.exons.col, border=coding.exons.border.col, ymin=ymin, ymax=ymax, r0=r0, r1=r1, data.panel=data.panel, clipping=clipping)
      
    }
    
    #plot the transcript name
    if(add.transcript.names==TRUE) {
      if(!is.null(transcript.names)) {
        transcript.labels <- transcript.names[names(transcript)]
      } else {
        transcript.labels <- names(transcript)
      }
      kpPlotNames(karyoplot, data = transcript, y0 = t.y0, y1=t.y1, labels = transcript.labels, position = transcript.name.position, cex=transcript.name.cex, col=transcript.name.col, r0=r0, r1=r1, ymin=ymin, ymax=ymax, clipping=clipping, data.panel = data.panel)
    }
  }    
  
  invisible(karyoplot)
}

#Note: the code assumes all regs are in the same chromosome and the same strand
addStrandMarks <- function(karyoplot, regs, transcript.height, mid.transcript,
                           mark.height, mark.width=NULL, mark.distance=NULL, marks.col=NULL,
                           r0=NULL, r1=NULL,
                           ymin=NULL, ymax=NULL, data.panel=NULL, clipping=NULL) {
  #if there are no regions to add marks to, simply return
  if(length(regs)==0) return()
  #since the strand marks are plotted sith direct calls to base R graphics, if clipping is TRUE, cut them with the plotting region
  #intersect removes with ignore.strand==TRUE removes the strand, so get it before
  st <- as.character(strand(regs)[1])
  if(clipping==TRUE) {
    regs <- intersect(regs, karyoplot$plot.region, ignore.strand=TRUE)
    strand(regs) <- st 
  }
  #if after clipping there are no regions to add marks to, simply return
  if(length(regs)==0) return()
  #if the marks would be invisible (height=0, simply return)
  if(mark.height==0) return()
  
  #We'll be plotting something, so begin kpPlot
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  #Assume all regs are in the same chromosome
  chr <- as.character(seqnames(regs))[1]
  
  #Transform mid.transcript and transcript.height to account for r0/r1, ymin, ymax, etc..
  pp <- prepareParameters2(karyoplot, function.name = "addStrandMarks", data = NULL,
                           chr = rep(chr, 3), x=c(0,0,0), y=c(mid.transcript, 0, transcript.height),
                           r0=r0, r1=r1, ymin=ymin, ymax=ymax, data.panel = data.panel)
  mid.transcript <- pp$y[1]
  transcript.height <- abs(pp$y[2]-pp$y[3])
  
  #This function works in plot coordinates, to allow for aspect ratio corrections
  ccf <- karyoplot$coord.change.function
  
  #strand marks height
  t.mark.height <- transcript.height*mark.height/2
  plot.mark.height <- abs(diff(ccf(chr = c(chr, chr), x=c(0,0), y=c(0, t.mark.height), data.panel=data.panel)$y))
  
  #Compute the mark.width relative to the mark.height. 
  #Adjust for the aspcet ratio of the plot coordinates (in points)
  asp.usr <- diff(par("usr")[c(1,2)])/diff(par("usr")[c(3,4)])
  #Adjust for the aspect ratio of the canvas (in "inches")
  asp.pin <- par("pin")[2]/par("pin")[1]
  
  plot.mark.width <- plot.mark.height*asp.usr*asp.pin*mark.width
  

  for(nr in seq_len(length(regs))) {
    reg <- regs[nr]
    if(st=="*") {
      #NOTE: If transcripts have strand "*", should we just NOT plot any mark
      return()
    }
    #Now, given the regions, determine if how many marks we should plot and where
    plot.coords <- ccf(chr=c(chr, chr), x=c(start(reg), end(reg)), y=c(mid.transcript, mid.transcript), data.panel=data.panel)
    
    reg.width <- diff(plot.coords$x)
    if(reg.width > 1.4*plot.mark.width) {
      num.marks <- (reg.width-plot.mark.width)%/%(plot.mark.width*mark.distance)+1
      left.margin <- (reg.width-((num.marks-1)*plot.mark.width*mark.distance)-plot.mark.width)/2
      mark.starts <- plot.coords$x[1]+left.margin+plot.mark.width/2+plot.mark.width*mark.distance*c(0:(num.marks-1))
      
      if(st=="-") {
        segments(x0 = mark.starts-plot.mark.width/2, x1=mark.starts+plot.mark.width/2, y0=plot.coords$y[1], y1=plot.coords$y[1]+plot.mark.height, col=marks.col)
        segments(x0 = mark.starts-plot.mark.width/2, x1=mark.starts+plot.mark.width/2, y0=plot.coords$y[1], y1=plot.coords$y[1]-plot.mark.height, col=marks.col)
      } else {
        segments(x0 = mark.starts-plot.mark.width/2, x1=mark.starts+plot.mark.width/2, y0=plot.coords$y[1]+plot.mark.height, y1=plot.coords$y[1], col=marks.col)
        segments(x0 = mark.starts-plot.mark.width/2, x1=mark.starts+plot.mark.width/2, y0=plot.coords$y[1]-plot.mark.height, y1=plot.coords$y[1], col=marks.col)
      }
    }
  }
}

#' getDataPanelBoundingBox
#' 
#' @description 
#' 
#' Return the bounding box of a data panel in plot coordinates
#' 
#' @details 
#' 
#' Given a KaryoPlot object and a data.panel name, return the region 
#' where the data panel is placed. The returned values are in plot
#' coordinates, that is, the coord.change.function has been applied.
#' 
#' @note A user is not expected to need this function. It is mainly
#' used by plotting functions, specially when clipping the plot in 
#' a zoomed region.
#' 
#' @usage getDataPanelBoundingBox(karyoplot, data.panel)
#' 
#' @param karyoplot    a \code{karyoplot} object returned by a call to \code{plotKaryotype}
#' @param data.panel   a valid data panel name (i.e. 1, 2, "ideogram", "all")
#' 
#' @return
#' Returns a list with four elements (x0, x1, y0 and y1), each of them an 
#' integer with the plot coordinates for the data.panel
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpDataBackground}}
#' 
#' @examples
#'
#' kp <- plotKaryotype(plot.type=2)
#' dp1 <- getDataPanelBoundingBox(kp, 1)
#'  
#' @export getDataPanelBoundingBox
#' 


getDataPanelBoundingBox <- function(karyoplot, data.panel) {
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  
  if(is.null(karyoplot$plot.params[[paste0("data", data.panel, "min")]])) stop("data panel ", data.panel, " is not available in the current plot.type")
  
  x0 <- karyoplot$coord.change.function(chr=as.character(seqnames(karyoplot$plot.region)), x=start(karyoplot$plot.region), data.panel=data.panel)$x
  x1 <- karyoplot$coord.change.function(chr=as.character(seqnames(karyoplot$plot.region)), x=end(karyoplot$plot.region), data.panel=data.panel)$x
  y0 <- karyoplot$coord.change.function(chr=as.character(seqnames(karyoplot$plot.region)), y=rep(karyoplot$plot.params[[paste0("data", data.panel, "min")]], length(karyoplot$plot.region)), data.panel=data.panel)$y
  y1 <- karyoplot$coord.change.function(chr=as.character(seqnames(karyoplot$plot.region)), y=rep(karyoplot$plot.params[[paste0("data", data.panel, "max")]], length(karyoplot$plot.region)), data.panel=data.panel)$y
  return(list(x0=x0, x1=x1, y0=y0, y1=y1))
}

#' kpPlotGenes
#' 
#' @description 
#' 
#' Plot genes and transcripts in the genome. Can get the genes and trancripts information from TxDb or from custom objects.
#' 
#' @details 
#'
#'  This is one of karyoploteR's higher level functions. It takes a transcript 
#'  database (\code{TxDb}) object or a custom object with a specific structure 
#'  and plots the genes along the genome. It's possible to plot genes as 
#'  a whole using rectangle for each gene or to plot each transcript 
#'  independently. If transcripts are drawn, it's possible to plot them as
#'  single boxes or to plot the detailed structure, differentiating 
#'  coding exons, non-coding exons and introns. Transcripts may have, in 
#'  addition, little arrows to mark the trascript strand (plus or minus). These
#'  strand marks are plotted in introns if the transcript structure is shown 
#'  or on the whole transcript length if transcripts are plotted as boxes. 
#'  Finally, it's possible to add labels to genes and transcripts. By default 
#'  genes and transcripts identifiers in the input data structure will be used
#'  as labels, but it's possible to provide named character vectors to be 
#'  used as dictionaries to change id's to better names.
#'    
#'  The genes and transcripts representations are customizable. It's possible
#'  to change the colors of the different elements individually (i.e. to 
#'  have red coding exons, blue non-coding exons and green introns); it's 
#'  possible to change the relative height of the non-coding exons and to 
#'  change the slate and density of the strand marks.
#'  
#'  The data stating the positions of genes, transcripts and exons in the 
#'  genome and their relations (which transcripts belong to which genes) 
#'  can be given as a standard transcript database (\code{TxDb}) object or
#'  as a custom list with the following elements: \code{genes},
#'  \code{transcripts}, \code{coding.exons} and \code{non.coding.exons}.
#'  
#'  
#' @note Plotting transcripts, specially plotting their structure might get 
#' quite slow in comparison to the usual speed of plotting in karyoploteR. It
#' is not advised to plot genes and transcripts on the whole genome or in 
#' large regions of it. These functions have been designed to work with
#' zoomed in karyoplots.
#'
#' @usage kpPlotGenes(karyoplot, data, gene.margin=0.3, gene.col=NULL, gene.border.col=NULL,
#'                        add.gene.names=TRUE, gene.names=NULL, gene.name.position="top", gene.name.cex=1, gene.name.col=NULL,
#'                        plot.transcripts=TRUE, transcript.margin=0.5, transcript.col=NULL, transcript.border.col=NULL,
#'                        add.transcript.names=FALSE, transcript.names=NULL, transcript.name.position="left", transcript.name.cex=0.6, transcript.name.col=NULL,
#'                        plot.transcripts.structure=TRUE,
#'                        non.coding.exons.height=0.5, 
#'                        add.strand.marks=TRUE, mark.height=0.20, mark.width=1, mark.distance=4,
#'                        coding.exons.col=NULL, coding.exons.border.col=NULL, 
#'                        non.coding.exons.col=NULL, non.coding.exons.border.col=NULL, 
#'                        introns.col=NULL, marks.col=NULL,
#'                        data.panel=1, r0=NULL, r1=NULL, col="black", 
#'                        border=NULL, avoid.overlapping=TRUE, clipping=TRUE, ...)
#' 
#' 
#' @param karyoplot (a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.
#' @param data  (a \code{TxDb} object or a list with the required elements) A \code{TxDb} object with information on genes, transcripts and exons and their position on the genome.
#' @param gene.margin  (numeric) If whole genes (as oposed to transcripts) are plotted (\code{plot.transcripts=FALSE}), the vertical margin between overlapping genes. The value is with respect to the gene height. A value of 0.5 will create a space above the genes with half the height of the genes themselves. (defaults to 0.3)
#' @param gene.col  (color) If whole genes (as oposed to transcripts) are plotted (\code{plot.transcripts=FALSE}), the color used to fill the rectangles representing the genes. If NULL, the value of \code{col} will be used. (Defaults to NULL)
#' @param gene.border.col  (color) If whole genes (as oposed to transcripts) are plotted (\code{plot.transcripts=FALSE}), the color used in the border of the rectangles representing the genes. If NULL, the value of \code{col} will be used. If NA, no border is drawn. (Defaults to NULL)
#' @param add.gene.names  (boolean) Whether to add the names of the genes to the plot.
#' @param gene.names  (named character vector) A named character vector with the labels of the genes. If not NULL, it will be used as a dictionary, so gene ids should be names and desired labels the values. If NULL, if genes.data$genes$name exists, it will use it, otherwise it will use the mcols(genes.data$genes)[,1] as labels. (defaults to NULL) 
#' @param gene.name.position (character) The position of the gene name text relative to the rectangle. Can be "left", "right", "top", "bottom" or "center". (Defaults to "top")
#' @param gene.name.cex (numeric) The cex value to plot the gene names (defaults to 1)
#' @param gene.name.col (color) The color of the gene labels. If NULL, it will use col. (defaults to NULL)
#' @param plot.transcripts (boolean) Whether to plot the individual transcripts (TRUE) or a single rectangle to represent the whole gene (FALSE). (Defaults to TRUE)
#' @param transcript.margin (numeric) If transcripts are plotted (\code{plot.transcripts=TRUE}), the vertical margin between overlapping transcripts. The value is with respect to the transcript height. A value of 0.5 will create a space above the transcripts with half the height of the transcripts themselves. (defaults to 0.5)
#' @param transcript.col (color) If transcripts are plotted (\code{plot.transcripts=TRUE}), the color used to fill the rectangles representing the transcripts. If NULL, the value of \code{col} will be used. (Defaults to NULL)  
#' @param transcript.border.col (color) If transcripts are plotted (\code{plot.transcripts=TRUE}), the color used in the border the rectangles representing the transcripts. If NULL, the value of \code{col} will be used. If NA, no border will be drawn. (Defaults to NULL)  
#' @param add.transcript.names (boolean) Whether to add the names of the tramscripts to the plot. (defaults to FALSE)
#' @param transcript.names (named character) A named character vector with the labels of the transcripts. If not null, it will be used as a dictionary, so transcript ids should be names and desired labels the values. If NULL, the transcript ids will be used as labels. (defaults to null)
#' @param transcript.name.position (character) The position of the transcript name text relative to the rectangle. Can be "left", "right", "top", "bottom" or "center". (Defaults to "left")
#' @param transcript.name.cex (numeric) The cex value to plot the transcript names (defaults to 0.6)
#' @param transcript.name.col (color) The color of the transcript labels. If NULL, it will use col. (defaults to NULL)
#' @param plot.transcripts.structure (boolean) Whether to draw the transcripts as single rectangles (FALSE) or to show the complete transcript structure (introns and exons) (TRUE). (Defaults to TRUE)
#' @param non.coding.exons.height  (numeric) The height of the non.coding exons relative to the transcript height. For example, if 0.5, non-coding exons will have a height half the size of the coding ones. (default 0.5) 
#' @param add.strand.marks  (boolean) Whether strand marks should be plotted or not. Strand marks are small arrows along the introns (or whole transcripts if plot.transcript.structure=FALSE). (defaults to TRUE)
#' @param mark.height (numeric) The height of the strand marks in "coding exons heights", that is, if mark.height is 0.5, the mark will have a height of half the height of an exon. (defaults to 0.2)
#' @param mark.width (numeric) The width of the strand marks, in mark heights. mark.width=1 will produce arrow heads with a slope pf 45 degrees. A value higher than 1 will produce smaller angles and a value below 1 larger angles with more vertical lines. (defaults to 1, 45 degrees)
#' @param mark.distance   (numeric) The distance between marks, in mark widths. A distance of 2, will add a space of 2*mark.width between consecutive marks. (defaults to 4)
#' @param coding.exons.col  (color) The fill color of the rectangles representing the coding exons. If NULL, it will use col. (defaults to NULL)
#' @param coding.exons.border.col  (color) The color of the border of the coding exons. If NULL, it will use border. (defaults to NULL)
#' @param non.coding.exons.col  (color) The fill color of the rectangles representing the non-coding exons. If NULL, it will use col. (defaults to NULL)
#' @param non.coding.exons.border.col  (color) The color of the border of the non-coding exons. If NULL, it will use border. (defaults to NULL)
#' @param introns.col (color) The color of the lines representing the introns. If NULL, it will use col. (defaults to NULL) 
#' @param marks.col   (color) The color of the arrows representing the strand. If NULL, it will use col. (defaults to NULL) 
#' @param data.panel (numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param r0  (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL) 
#' @param r1  (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL) 
#' @param col  (color) The color of the genes, transcripts and labels. It is possible to specify different colors for each element class (transcript names, exons, strand marks...). All elements with no explicit color will be plotted using col. (Defaults to "black") 
#' @param border  (color) The color of the border of rectangles representing genes, transcripts and exons. Every element class may have its own specific color using the appropiate parameters. The ones with no explicit color will use border. At the same time, if border is NULL, it will default to col. (Defaults to NULL)
#' @param avoid.overlapping (boolean) If two or more regions (genes, transcripts) overlap in the genome (even partially), they can be drawn in two different layers (TRUE) or in the same layer, with superposing representations (FALSE). (Defaults to TRUE, draw non-overlapping elements)
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param ...  The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions. 
#' 
#'
#'  
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#'  
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpRect}}, \code{\link{kpSegments}}, \code{\link{kpPlotTranscripts}}
#' 
#' @examples
#'  
#'  
#'  library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#'  txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
#'  
#'  zoom <- toGRanges("chr2", 47986268, 48147403)
#'  gene.names <- c("2956"="MSH6", "80204"="FBXO11")
#'  
#'  kp <- plotKaryotype(genome="hg19", zoom=zoom)
#'  kpPlotGenes(kp, data=txdb, add.transcript.names = FALSE, gene.names=gene.names, r1=0.6)
#' 
#'  kp <- plotKaryotype(genome="hg19", zoom=zoom)
#'  kpPlotGenes(kp, data=txdb, plot.transcripts=FALSE, gene.names=gene.names, r1=0.6)
#'
#'  kp <- plotKaryotype(genome="hg19", zoom=zoom)
#'  kpPlotGenes(kp, data=txdb, plot.transcripts.structure=FALSE, add.transcript.names=FALSE, gene.names=gene.names, r1=0.8, col="blue", marks.col="white", gene.name.col="black")
#'  
#'  library(TxDb.Mmusculus.UCSC.mm10.knownGene)
#'  kp <- plotKaryotype(genome="mm10", zoom="chr1:10.5e6-12.5e6")
#'  genes.data <- makeGenesDataFromTxDb(txdb=TxDb.Mmusculus.UCSC.mm10.knownGene, karyoplot=kp)
#'  genes.data <- addGeneNames(genes.data)
#'  genes.data <- mergeTranscripts(genes.data)
#'  kpPlotGenes(kp, genes.data, r1=0.25, mark.height = 0.5, gene.name.position = "left")
#'  
#'  
#'@export kpPlotGenes


kpPlotGenes <- function(karyoplot, data, gene.margin=0.3, gene.col=NULL, gene.border.col=NULL,
                        add.gene.names=TRUE, gene.names=NULL, gene.name.position="top", gene.name.cex=1, gene.name.col=NULL,
                        plot.transcripts=TRUE, transcript.margin=0.5, transcript.col=NULL, transcript.border.col=NULL,
                        add.transcript.names=FALSE, transcript.names=NULL, transcript.name.position="left", transcript.name.cex=0.6, transcript.name.col=NULL,
                        plot.transcripts.structure=TRUE,
                        non.coding.exons.height=0.5, 
                        add.strand.marks=TRUE, mark.height=0.20, mark.width=1, mark.distance=4,
                        coding.exons.col=NULL, coding.exons.border.col=NULL, 
                        non.coding.exons.col=NULL, non.coding.exons.border.col=NULL, 
                        introns.col=NULL, marks.col=NULL,
                        data.panel=1, r0=NULL, r1=NULL,  col="black", 
                        border=NULL, avoid.overlapping=TRUE, clipping=TRUE, ...) {
  
  #karyoplot
    if(missing(karyoplot)) stop("The parameter 'karyoplot' is required")
    if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")
  #data
    if(missing(data)) stop("The parameter 'data' is required")
  
  
  #If data is a TxDb object, build a list from it with the expected format
  if(methods::is(data, "TxDb")) {
    data <- tryCatch(makeGenesDataFromTxDb(data, karyoplot=karyoplot, plot.transcripts, plot.transcripts.structure),
                     error=function(e) {stop("Error: There was an error extracting the information from the TxDb object. ", e)})
  }
  
  if(!isValidData(data)) {
    stop("'data' must be either a TxDb object or a list with the required slots. See ?kpPlotGenes for more information")  
  }
  
  
  #if there's nothing to plot, return
  if(length(data$genes)==0) {
    #add an empty "latest.plot" information
    #TODO
    #and return
    return(invisible(karyoplot))
  }
  
  if(length(data$genes)>20 & plot.transcripts==TRUE & plot.transcripts.structure==TRUE) {
    message("NOTE: Plotting many genes with detailed transcript structure may take a long time. You can set 'plot.transcripts' and 'plot.transcripts.structure' to FALSE to speed up the process reducing the detail level.")
  }
  
  #if null, get the r0 and r1
  if(is.null(r0)) r0 <- karyoplot$plot.params[[paste0("data", data.panel, "min")]]
  if(is.null(r1)) r1 <- karyoplot$plot.params[[paste0("data", data.panel, "max")]]
  
  total.height <- 1
  
  #Set the colors for the unspecified entities
  if(is.null(border)) {border <- col}
  if(is.null(gene.col)) { gene.col<- col}
  if(is.null(gene.border.col)) { gene.border.col<- border}
  if(is.null(gene.name.col)) { gene.name.col<- col}
  if(is.null(transcript.col)) { transcript.col<- col}
  if(is.null(transcript.border.col)) { transcript.border.col<- border}
  if(is.null(transcript.name.col)) { transcript.name.col<- col}
  if(is.null(coding.exons.col)) { coding.exons.col<- col}
  if(is.null(coding.exons.border.col)) { coding.exons.border.col<- border} 
  if(is.null(non.coding.exons.col)) { non.coding.exons.col<- col} 
  if(is.null(non.coding.exons.border.col)) { non.coding.exons.border.col<- border} 
  if(is.null(introns.col)) { introns.col<- col}
  if(is.null(marks.col)) { marks.col <- col}

  
  #Get the gene.names if necessary
  if(add.gene.names==TRUE) {
    gene.labels <- getGeneNames(data$genes, gene.names)
    gene.label.sizes <- getTextSize(karyoplot, labels=gene.labels, cex=gene.name.cex, data.panel = data.panel)
  } else {
    gene.labels <- character(0)
  }
  
  
  #All parameters processed. Start working
  gene.pos <- list()
  transcript.pos <- list()
  
  
  if(plot.transcripts==FALSE) {
    #Plot only the genes, with one rectangle per gene. Automatically position genes so they do not overlap if requested
    if(avoid.overlapping==TRUE) {
      genes.for.coverage <- data$genes
      strand(genes.for.coverage) <- "*"
      
      if(add.gene.names==TRUE) {
        if(gene.name.position=="left") {
          genes.for.coverage <- regioneR::extendRegions(genes.for.coverage, extend.start = gene.label.sizes$width*1.3)
        }
        if(gene.name.position=="right") {
          genes.for.coverage <- regioneR::extendRegions(genes.for.coverage, extend.end = gene.label.sizes$width*1.3)
        }
      }
      
      bins <- disjointBins(genes.for.coverage)
      num.layers <- max(bins)
      layer.height <- total.height/num.layers
      gene.height <- layer.height/(1+gene.margin)
      y0 <- layer.height * (bins-1)
      y1 <- y0 + gene.height
    } else {
      y0 <- 0
      y1 <- 1 - gene.margin
    }
    kpRect(karyoplot, data=data$genes, y0=y0, y1=y1, col=gene.col, border=gene.border.col, r0=r0, r1=r1, data.panel=data.panel, clipping=clipping, ...)
    if(add.gene.names==TRUE) {
      kpPlotNames(karyoplot, data=data$genes, y0=y0, y1=y1, labels=gene.labels, position=gene.name.position, col=gene.name.col, cex=gene.name.cex, r0=r0, r1=r1, clipping=clipping, data.panel=data.panel, ...)
    }
    
  } else { #if plot.transcripts==TRUE
    #Compute the position of each transcript (and the height dedicated to each 
    # gene depending on the numbre of transcripts it has) and then, plot them
    
    if(avoid.overlapping==FALSE) {
      #All transcripts span the whole vertical space
      all.transcript.names <- as.character(unlist(GRangesList(data$transcripts))$tx_id)
      for(t in all.transcript.names) {
        transcript.pos[[t]] <- list(y0=0, y1=1)
      }
    } else { #Get the positions of the transcripts so they don't overlap
      #TODO: Add the transcript name length to avoid overlapping?
      
      #Treat all genes as if they have the same length as the gene, so each genes has its own "rectangular space" preserved
      num.transcripts.per.gene <- lengths(data$transcripts)
      genes.for.coverage <- data$genes
      if(add.gene.names==TRUE) {
        if(gene.name.position=="left") {
          genes.for.coverage <- regioneR::extendRegions(genes.for.coverage, extend.start = gene.label.sizes$width*1.3)
        }
        if(gene.name.position=="right") {
          genes.for.coverage <- regioneR::extendRegions(genes.for.coverage, extend.end = gene.label.sizes$width*1.3)
        }
      }
      genes.for.coverage <- rep(genes.for.coverage, num.transcripts.per.gene)
      strand(genes.for.coverage) <- "*"
      
      
      
      max.coverage <- max(max(coverage(genes.for.coverage)))
      
      bin.height <- total.height/max.coverage
      transcript.height <- bin.height/(1+transcript.margin)
      
      #Position them using the disjoint binning functionality of Bioconductor
      bins <- disjointBins(genes.for.coverage)
      names(bins) <- names(genes.for.coverage)
      
      
      #TODO: This could be vectorized with a tapply per gene in the bins object
      # and inside, an apply to each transcript to get its position
      #Initialize the transcript counter
      transcript.in.gene <- 1
      last.gene <- ""
      for(nt in seq_len(length(bins))) {
        bin <- bins[nt]
        #if we are starting a new gene restart the transcript counter, 
        #else, move to the next transcript in the gene
        if(last.gene != names(bin)) { 
          transcript.in.gene <- 1
          last.gene <- names(bin)
        } else {
          transcript.in.gene <- transcript.in.gene + 1
        }
        
        #And compute the y0 and y1 of that transcript
        transcript <- data$transcripts[[names(bin)]][transcript.in.gene]
        names(transcript) <- transcript$tx_id #Does it work with all txdbs??
        
        transcript.y0 <- bin.height*(bin-1)
        transcript.y1 <- transcript.y0 + transcript.height
        
        transcript.pos[[as.character(names(transcript))]] <- list(y0=setNames(transcript.y0, NULL), y1=setNames(transcript.y1, NULL))
        
      }
      
    }
    
    #Once we've got the position of transcripts, compute the position of the genes  
    for(g in as.character(names(data$genes))) {
      #get the vertical position of all transcripts of that gene
      tpos <- data.frame(do.call(rbind, transcript.pos[as.character(data$transcripts[[g]]$tx_id)]))
      gene.pos[[g]] <- list(y0=min(unlist(tpos[,1])), y1=max(unlist(tpos[,2])))
    }
    
    #All positioning data ready. Plot the transcripts
    
    #Now, plot the transcripts in their positions
    detail.level <- ifelse(plot.transcripts.structure==TRUE, 2, 1)
      
    #Join all transcripts in a single GRanges as expected by kpPlotTranscripts
    transcripts <- unlist(GRangesList(data$transcripts))
    names(transcripts) <- transcripts$tx_id
    
    #Compute the y0 and y1 of all transcripts
    y0 <- unlist(do.call(rbind, transcript.pos[names(transcripts)])[,1])
    y1 <- unlist(do.call(rbind, transcript.pos[names(transcripts)])[,2])
    
    kpPlotTranscripts(karyoplot, 
                      data=list(transcripts=transcripts, coding.exons=data$coding.exons, non.coding.exons=data$non.coding.exons), 
                      add.transcript.names=add.transcript.names, transcript.names = transcript.names,
                      y0 = y0, y1=y1, detail.level = detail.level, 
                      r0=r0, r1=r1, 
                      non.coding.exons.height = non.coding.exons.height, 
                      add.strand.marks = add.strand.marks, mark.height = mark.height, mark.width = mark.width,
                      mark.distance = mark.distance, marks.col = marks.col, 
                      transcript.name.position = transcript.name.position, 
                      transcript.name.cex = transcript.name.cex, 
                      transcript.name.col = transcript.name.col, 
                      coding.exons.col = coding.exons.col, 
                      coding.exons.border.col = coding.exons.border.col,
                      non.coding.exons.col = non.coding.exons.col, 
                      non.coding.exons.border.col = non.coding.exons.border.col, 
                      introns.col = introns.col,
                      col=transcript.col,
                      border=transcript.border.col,
                      data.panel = data.panel, clipping = clipping,
                      ymin=0, ymax=1, ...) 
                        
    #Finally, plot the gene names if needed
    if(add.gene.names) {
      y0 <- unlist(do.call(rbind, gene.pos[as.character(names(data$genes))])[,1])
      y1 <- unlist(do.call(rbind, gene.pos[as.character(names(data$genes))])[,2])
      kpPlotNames(karyoplot, data=data$genes, y0=y0, y1=y1, labels=gene.labels, col=gene.name.col, cex=gene.name.cex, position = gene.name.position, r0 = r0, r1=r1, clipping=clipping, data.panel=data.panel)
    }
  } #END if plot.transcripts==TRUE
  
  #Store the gene and transcript position in the karyoplot object
  karyoplot$latest.plot <- list(funct="kpPlotGenes", 
                                computed.values=list(gene.vertical.position=gene.pos, 
                                                     transcript.vertical.position=transcript.pos)
  )

  invisible(karyoplot)
}

#' plotKaryotype
#' 
#' @description 
#' 
#' Create a new empty plot with a karyotype (the chromosome ideograms and chromosome names).
#' 
#' @details 
#'  
#'  This is the main function of \code{karyoploteR}. It creates the basic empty plot with 
#'  the chromosome ideograms and returns the karyoplot object needed for all other plotting 
#'  functions. Both the basic plotting parameters (margins, sizes, etc.) and the specific
#'  plotting functions for the ideograms and chromosome labels are customizable. 
#'  In particular, passing in a \code{plot.params} object specifies the basic plotting 
#'  parameters to use and the \code{ideogram.plotter} and \code{labels.plotter} parameters 
#'  can be used to specify custom plotting functions for the ideogram and the chromosome 
#'  labels. It is also possible to specify the genome and a list with the chromosomes to
#'  be plotted. 
#'  
#'  The \code{plot.type} parameter specifies the type of karyoplot to create: the number
#'  and positions of the data panels respect to the ideograms: 
#'  \itemize{
#'    \item \code{plot.type=1}  Horizontal ideograms with a single data panel above them
#'    \item \code{plot.type=2}  Horizontal ideograms with two data panels, one above and one below them
#'    \item \code{plot.type=3}  Horizontal ideograms with all chromosomes in a single line with two data panels, one above and one below them
#'    \item \code{plot.type=4}  Horizontal ideograms with all chromosomes in a single line with one data panel above
#'    \item \code{plot.type=5}  Horizontal ideograms with all chromosomes in a single line with one data panel below them
#'    \item \code{plot.type=6}  Horizontal ideograms with NO data panels. Only plotting in the ideograms is possible.
#'    \item \code{plot.type=7}  Horizontal ideograms with all chromosomes in a single line with NO data panels. Only plotting in the ideograms is possible.
#'  }
#'  
#' There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
#'  
#' 
#' @usage plotKaryotype(genome="hg19", plot.type=1, ideogram.plotter=kpAddCytobands, labels.plotter=kpAddChromosomeNames, chromosomes="auto", zoom=NULL, cytobands=NULL, plot.params=NULL, use.cache=TRUE, main=NULL, ...)
#' 
#' @param genome    The genome to plot. It can be either a UCSC style genome name (hg19, mm10, etc), a BSgenome, a Seqinfo object, a GRanges object with the chromosomes as ranges or in general any genome specification accepted by \code{\link[regioneR]{getGenomeAndMask}}. (defaults to "hg19")
#' @param plot.type    The orientation of the ideogram and placing of the data panels. Values explained above.. (defaults to 1)
#' @param ideogram.plotter    The function to be used to plot the ideograms. Only one function is included with the package, \code{kpAddCytobands}, but it is possible to create custom ones. If NULL, no ideograms are plotted. (defaults to \code{kpAddCytobands})
#' @param labels.plotter    The function to be used to plot the labels identifying the chromosomes. Only one function is included with the package, \code{kpAddChromosomeNames}, but it is possible to create custom ones. If NULL, no labels are plotted. (defaults to \code{kpAddChromosomeNames})
#' @param chromosomes    The chromosomes to plot. Can be either a vector of chromosome names or a chromosome group name ("canonical", "autosomal", "all"). Setting it yo "auto" will select canonical. If no predefined filtering data is available, a heuristic filtering  will be used. To deactivate filtering set chromosomes="all". (defaults to "auto")
#' @param zoom   A GRanges object specifiyng a single region to zoom in or any format accepted by \code{regioneR::toGRanges}. If not NULL, it takes precedence over \code{chromosome} and only the zoomed in region is represented. If more than one region is present in the GRanges, only the first one is used. (defaults to NULL, do not zoom in and show the whole plot as specified by \code{genome} and \code{chromosomes})
#' @param cytobands    A GRanges object (or anything accepted by \code{\link[regioneR]{toGRanges}} function: bed file, data.frame...) specifying the positions and types of the cytobands. The type of the cytobands MUST be in a column named "gieStain" (as used by UCSC) with values such as 'gneg', 'gpos50', 'stalk', 'acen'... If NULL, the cytobands are recovered from the package cache or downloaded from UCSC if possible (it's not possible for custom genomes). If empty, no cytobands will be plotted. (defaults to NULL)
#' @param plot.params    An object obtained from \code{\link{getDefaultPlotParams}} and possibly modified, containing the basic plotting parameters. If NULL, the defaults parameters will be used. (defaults to NULL)
#' @param use.cache    \code{karyoploteR} has a small cache with the chromosome names and lengths and the cytobands for a handful of organisms so it's not needed to retrieve them from databses or \code{BSGenomes} objects. Set this parameter to FALSE to ignore the cache. (defaults to TRUE, use the cache)
#' @param main    The text to be used as the title of the plot. NULL produces no title. (defaults to NULL)
#' @param ...    The ellipsis can be used to pass in any additional parameter accepted by the internal functions used.
#' 
#' @return
#' 
#' The \code{KaryoPlot} object needed by the plotting functions.
#' 
#' @seealso \code{\link{getDefaultPlotParams}}, \code{\link{kpPoints}}
#' 
#' @examples
#'  
#'  set.seed(1000)
#' 
#' rand.data <- createRandomRegions(genome="hg19", nregions=10000, length.mean=1, 
#'                                  length.sd=0, mask=NA, non.overlapping=TRUE)
#' mcols(rand.data) <- data.frame(y=rnorm(n=10000, mean = 0.5, sd=0.1))
#'  
#' #The simplest way, with all default parameters
#' kp <- plotKaryotype()
#' kpPoints(kp, rand.data, pch=".")
#' 
#' #Or we can plot only a few chromosomes, with 2 data panels
#' kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 2)
#' kpDataBackground(kp, data.panel = 1, color = "lightgreen")
#' kpDataBackground(kp, data.panel = 2, color = "lightblue")
#' kpPoints(kp, rand.data, pch=".", data.panel = 1)
#' kpPoints(kp, rand.data, pch=".", data.panel = 2)
#' 
#' 
#' #Or we can use a different organism, 
#' kp <- plotKaryotype(genome = "mm10")
#' kp <- plotKaryotype(genome = "dm6")
#' 
#' # Or we can change the plotting parameters. In this case, to create a smaller ideogram
#' # and smaller data panel below it
#' plot.params <- getDefaultPlotParams(plot.type=2)
#' plot.params$ideogramheight <- 5
#' plot.params$data2height <- 50
#' 
#' kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 2, plot.params = plot.params)
#' kpDataBackground(kp, data.panel = 1, color = "lightgreen")
#' kpDataBackground(kp, data.panel = 2, color = "lightblue")
#' kpPoints(kp, rand.data, pch=".", data.panel = 1)
#' kpPoints(kp, rand.data, pch=".", data.panel = 2)
#' 
#' #Or we can remove the cytobands, passing an empty GRanges object
#' kp <- plotKaryotype(cytobands = GRanges())
#' 
#' #Or remove the chromosome labels
#' kp <- plotKaryotype(labels.plotter = NULL)
#' kpPoints(kp, rand.data, pch=".")
#' 
#' #In addition, it's possible to use maggrittr piping to chain the plotting calls
#' library(magrittr)
#' kp <- plotKaryotype() %>%
#'    kpDataBackground(color = "lightgreen") %>%
#'    kpPoints(rand.data, pch=".")
#' 
#' 
#' @import regioneR
#' @import GenomicRanges
#' @importFrom Seqinfo seqlevels
#' @importFrom GenomeInfoDb keepSeqlevels
#' @importFrom S4Vectors runLength runValue
#' @importFrom memoise memoise
#' @importFrom rtracklayer ucscTableQuery
#' @importFrom IRanges overlapsAny
#' @import methods
#' @importFrom stats setNames
#' 
#' @export plotKaryotype
#' 


plotKaryotype <- function(genome="hg19", plot.type=1, ideogram.plotter=kpAddCytobands,
                          labels.plotter=kpAddChromosomeNames, chromosomes="auto",
                          zoom=NULL, cytobands=NULL, plot.params=NULL,
                          use.cache=TRUE, main=NULL, ...) {
  
  #Parameters Check
  #TODO: Finish checks
  #genome
  if(is.null(genome)) stop("genome cannot be NULL.")
  #plot.type
  
  
  #cytobands
  if(!is.null(cytobands)) {
    cytobands <- tryCatch(toGRanges(cytobands), error=function(e) {})
    if(!methods::is(cytobands, "GRanges")) stop("'cytobands' must be NULL, a GRanges or something accepted by regioneR::toGRanges")
  }
  
  #zoom
  if(!is.null(zoom)) {
    zoom <- regioneR::toGRanges(zoom)
    if(!methods::is(zoom, "GRanges")) stop("'zoom' must be NULL or a GRanges object")
    if(length(zoom)>1) {
      warning("The zoom parameter has more than one region. Only the first one will be used.")
      zoom <- zoom[1]
    }
  }
  
  #End parameters check
  
  if(is.null(plot.params)) {
    plot.params <- getDefaultPlotParams(plot.type)
  }
  
  
  #Prepare the genome and filter the chromosomes as required
  #Get the genome
  #If the user has given us a valid GRanges as genome, use it directly
  #if it's something else, try with the cache or rely on regioneR::getGenomeAndMask
  gr.genome <- NULL
  genome.name <- NULL
  if(methods::is(genome, "GRanges")) {
    gr.genome <- genome
  } else {
    if(methods::is(genome, "BSgenome")) {
      genome <- seqinfo(genome)
    }
    if(methods::is(genome, "Seqinfo")) {
      gr.genome <- as(genome, "GRanges")
      genome.name <- genome(genome)[1]
    } else {
      if(methods::is(genome, "character") & use.cache==TRUE) { #Get the genome from the cache, if available
        if(genome %in% names(data.cache[["genomes"]])) {
          gr.genome <- data.cache[["genomes"]][[genome]]
          genome.name <- genome
        }
      }
    }
  }
  if(is.null(gr.genome)) {
    gr.genome <- tryCatch(regioneR::getGenomeAndMask(genome=genome, mask=NA)$genome,
                          error=function(e) {stop("It was not possible to identify or load the requested genome. ", e)}
    )
  }
  
  
  #Check the genome has no problems (repeated chromosomes, etc...)
  chr.names <- as.character(Seqinfo::seqnames(gr.genome))
  if(any(duplicated(chr.names))) {
    stop(paste0("There are duplicate chromosome names in the genome. Chromosome names must be unique. Chromosome names are: ", paste0(chr.names, collapse = ", ")))
  }
  
  #Use the chromosome names as the names of the genome GRanges
  names(gr.genome) <- chr.names
  

  #Chromosome Filtering
  
  #If zoom is set, change the chromosome parameter to the name of the chomosome
  #we are zooming in, so everything else is automatically filtered out.
  if(!is.null(zoom)) {
    if(!IRanges::overlapsAny(zoom, gr.genome)) {
      stop("You are trying to set the zoom to a region not part of the current genome.")
    } else {
      chromosomes <- as.character(Seqinfo::seqnames(zoom))
    }
  }
  
  #And filter it
  if(!is.null(chromosomes) && any(chromosomes != "all")) {
    
    if(length(chromosomes)==1 && (chromosomes %in% c("canonical", "autosomal", "auto"))) {
      if(!is.null(genome.name) && is.character(genome.name)) {
        if(chromosomes=="auto") chromosomes <- "canonical"   #Set it to canonical to perform the actual filtering
        tryCatch(expr={gr.genome <- filterChromosomes(gr.genome, organism=genome.name, chr.type=chromosomes)},
                 error=function(e) {
                   message("WARNING: There was an error when filtering the chromosomes and selecting only ", chromosomes, " chromosomes.  Falling back to using the unfiltered genome. \n", e)
                 })
      } else {
        #If filtering gave an error and chromosomes is "canonical" or "auto", then try to use a heuristic filtering
        if(chromosomes %in% c("auto", "canonical")) {
          message("No predefined canonical chromosomes found for the requested genome. Applying a heuristic chromosome filtering.")
          message("To get the unfiltered genome, please set chromosomes=\"all\" in the plotKaryotype call")
        
          valid.chrs <- seqlevels(gr.genome)
          valid.chrs <- valid.chrs[!grepl("chrUn", valid.chrs, ignore.case = TRUE)]
          valid.chrs <- valid.chrs[!grepl("_random", valid.chrs, ignore.case = TRUE)]
          valid.chrs <- valid.chrs[!grepl("_alt", valid.chrs, ignore.case = TRUE)]
          valid.chrs <- valid.chrs[!grepl("_fix", valid.chrs, ignore.case = TRUE)]
          
          #Remove the mitocondrial chromosome.
          valid.chrs <- valid.chrs[!(valid.chrs == "chrM")]
          
          gr.genome <- keepSeqlevels(gr.genome, valid.chrs, pruning.mode="coarse")
          
        } else {
          if(chromosomes == "autosomal") { #It should not be anything else
            message("WARNING: It is only possible to filter chromosomes using the ",
                    " 'autosomal' option when the genome ",
                    "is specified by name (i.e. 'hg19', 'mm10') and just for a selection",
                    " of genomes. Please, specify the names of the desired chromosomes",
                    " using the 'chromosomes' parameter (i.e. chromosomes=c('chr1', 'chr2') ). ",
                    " Falling back to using the unfiltered genome.")
          }
        }
      }
    } else {
      if(!all(chromosomes %in% as.character(seqnames(gr.genome)))) {
        message("NOTE: Not all requested chromosomes are part of the genome. Trying to filter as requested. ",
                "   * Requested Chromosomes: ", paste0(chromosomes, collapse = ", "),
                "   * Chromosomes in the genome: ", paste0(as.character(seqnames(gr.genome)), collapse = ", ")
        )
      }
      tryCatch(expr={gr.genome <- filterChromosomes(gr.genome, keep.chr=chromosomes)[chromosomes]}, #The selection by "[chromsomes]" ensures the order is the one specified and not the canonical in the genome
               error=function(e) {
                 message("WARNING: There was an error when filtering the chromosomes. Falling back to using the unfiltered genome. \n", e)
               }
      )
    }
  }
  
  #Check we still have a genome! Explanation: If the filtering step partially fails, we might end up with an empty genome
  if(length(gr.genome)==0) {
    stop("The genome has no chromosomes left after filtering. Cannot plot with no chromosomes.")
  }  

  
  #Get the CytoBands if needed
  if(is.null(cytobands)) {
    if(!is.null(genome.name) && all(is.character(genome.name))) {
      cytobands <- getCytobands(genome.name)
    } else {
      if(all(is.character(genome))) {
        cytobands <- getCytobands(genome)
      } 
    }
    #if there are cytobands, filter the cytobands using the current genome
    if(!is.null(cytobands) && length(cytobands)>0) {
      cytobands <- GenomeInfoDb::keepSeqlevels(cytobands, value=Seqinfo::seqlevels(gr.genome), pruning.mode="coarse")
    }
  }

  #Create the KaryoPlot Object that can be used to plot additional data onto the karyotype
    kp <- list()
    class(kp) <- "KaryoPlot"
    kp$plot.params <- plot.params
    if(!is.null(genome.name)) {
      kp$genome.name <- genome.name
    } else {
      kp$genome.name <- "custom"
    }
    
    kp$genome <- gr.genome
    kp$cytobands <- cytobands
    kp$plot.type <- plot.type
    
    
    #If zoom is NULL, set the plot.region to the whole genome. If it's not null, set it to the zoom region
    if(is.null(zoom)) {
      kp$plot.region <- kp$genome
      kp$zoom <- FALSE
    } else {
      kp$plot.region <- zoom
      names(kp$plot.region) <- as.character(seqnames(kp$plot.region))
      kp$zoom <- TRUE
    }
    
    #Remove the strand of plot.region, since it can mess with some libraries (bamsignals::bamCoverage, for example)
    strand(kp$plot.region) <- "*"
    
    #Get the chromosome names from the plot.region object so they are in the order specified by the user
    #Older version used seqlevels(gr.genome) which were naturally ordered.
    kp$chromosomes <- as.character(seqnames(kp$plot.region))
    #WARNING: Should we get the lengths with "width"? This would help for chromosomes not starting at 1. Do we want to support that? Is teher any valid use case?
    kp$chromosome.lengths <- stats::setNames(end(gr.genome), seqnames(gr.genome))
    
    #Get the Coordinates Change Function to be used in this plot
    #coordChangeFunctions <- getCoordChangeFunctions(plot.type = plot.type, genome = gr.genome, plot.params = plot.params)
    coordChangeFunctions <- getCoordChangeFunctions(karyoplot=kp)
    kp$coord.change.function <- coordChangeFunctions$coordChangeFunction
    kp$ideogram.mid <- coordChangeFunctions$ideogramMid
    kp$chromosome.height <- coordChangeFunctions$chr.height
    
    
  #Remove all margins around the plot to take complete control of the available space
    kp$graphical.par <- list()
    kp$graphical.par$old.par <- graphics::par(no.readonly = TRUE)
    graphics::par(mar=c(0,0,0,0)+0.1)
    
    kp$beginKpPlot <- function() {
      graphics::par(kp$graphical.par$new.par)  
    }
    kp$endKpPlot <- function() {
      graphics::par(kp$graphical.par$old.par)  
    }
    
    on.exit(kp$endKpPlot())
  
    

  #Create the plot
    pp <- plot.params
    if(plot.type %in% c(1,2,6)) {
      xlim <- c(0, 1)
      ylim <- c(0, pp$bottommargin + length(gr.genome)*kp$chromosome.height + pp$topmargin)
    } else {
      if(plot.type %in% c(3,4,5,7)) {
        xlim <- c(0, 1)
        ylim <- c(0, pp$bottommargin + kp$chromosome.height + pp$topmargin)
      }
    }
  
    #create an empty plot
    graphics::plot(0, type="n", xlim=xlim, ylim=ylim, axes=FALSE, ylab="", xlab="", xaxs="i", yaxs="i")
  
  
    #Get the limits of the plot from the graphical device
    kp$plot <- list()
      p <- graphics::par("usr")
      kp$plot$xmin <- p[1]
      kp$plot$xmax <- p[2]
      kp$plot$ymin <- p[3]  
      kp$plot$ymax <- p[4]
 
  kp$graphical.par$new.par <- graphics::par(no.readonly = TRUE) #Remember the parameters used

  #Finally, plot the ideograms and labels, if needed
  #And plot the ideogram
  if(!is.null(ideogram.plotter)) {
    ideogram.plotter(kp, ...)
  }    

  #Plot the Chromosome Labels
    if(!is.null(labels.plotter)) {
      labels.plotter(kp, ...)
    }  
  
  #Add the main title
  if(!is.null(main)) {
    kpAddMainTitle(kp, main, ...)
  }
  
  
 
  return(kp)
}

#' kpAddChromosomeSeparators
#' 
#' @description 
#' 
#' Plots between the chromosomes
#' 
#' @details 
#' 
#' Depending on the plot type it will draw vertical lines (if all chromosomes
#' are in a one line (3,4,5,7)) or horizontal lines (1,2,6)
#' 
#' By default the lines will occupy the whole chromsome extent (data.panel="all") 
#' but using the \code{data.panel} parameter it can be tuned.
#' 
#' @usage kpAddChromosomeSeparators(karyoplot, col="gray", lty=3, data.panel="all", ...)
#' 
#' @param karyoplot    a \code{karyoplot} object returned by a call to \code{plotKaryotype}
#' @param col (color) The color of the separator lines (defaults to "gray")
#' @param lty (integer) The line type of the separators (defaults to 3, dashed lines)
#' @param data.panel (data panel specification) For vertical lines, the span of the separator lines. Ignored for horizontal lines. (defaults to "all")
#' @param ...  any additional parameter to be passed to the text plotting. All R base graphics params are passed along.
#' 
#' @return
#' invisibly returns the given karyoplot object
#'  
#' @seealso \code{\link{plotKaryotype}}
#'  
#' @examples
#'
#' kp <- plotKaryotype(plot.type=4)
#' kpAddChromosomeSeparators(kp)
#' 
#' kp <- plotKaryotype(plot.type=5, ideogram.plotter=NULL)
#' kpAddChromosomeSeparators(kp)
#' 
#' kp <- plotKaryotype(plot.type=2)
#' kpAddChromosomeSeparators(kp, col="red")
#' 
#'  
#' @export kpAddChromosomeSeparators
#' 

kpAddChromosomeSeparators <- function(karyoplot, col="gray", lty=3, data.panel="all", ...) {
  
  if(!methods::is(karyoplot, "KaryoPlot")) stop("'karyoplot' must be a valid 'KaryoPlot' object")

  
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  
  #If plot.type %in% 1,2,6 draw horizontal lines, if in 3,4,5,7 draw vertical lines
  ccf <- karyoplot$coord.change.function
  
  if(karyoplot$plot.type %in% c(3,4,5,7)) { #All chromosomes in one line, draw vertical separators
    y0 <- ccf(y = karyoplot$plot.params[[paste0("data", data.panel, "min")]], data.panel = data.panel)$y
    y1 <- ccf(y = karyoplot$plot.params[[paste0("data", data.panel, "max")]], data.panel = data.panel)$y
    #plot a line after the end of each chromosome except the last one
    for(nreg in seq_len(length(karyoplot$plot.region)-1)) {
      x <- ccf(chr = as.character(seqnames(karyoplot$plot.region[nreg])), x=end(karyoplot$plot.region[nreg]), data.panel=data.panel)$x
      x <- x + karyoplot$plot.params$ideogramlateralmargin/2
     
      graphics::segments(x0=x, x1=x, y0=y0, y1=y1, col = col, lty=lty, ...)
      
    }
  } else {
    #Plot horizontal lines?
    #or do nothing. I don't like them... but for consistency might be good to have it plot "something"
    
    x0 <- karyoplot$plot.params$leftmargin
    x1 <- 1 - karyoplot$plot.params$rightmargin #Could be set to the end of the shortest chromosome for each adjacent pair
    #plot a line before the each chromosome except the first one
    for(nreg in 1+seq_len(length(karyoplot$plot.region)-1)) {
      y <- ccf(chr = as.character(seqnames(karyoplot$plot.region[nreg])), y=karyoplot$plot.params$dataallmax, data.panel = "all")$y
      y <- y + karyoplot$plot.params$data1outmargin/2
      
      graphics::segments(x0=x0, x1=x1, y0=y, y1=y, col = col, lty=lty, ...)
      
    }
  }
  

  invisible(karyoplot)
}

#' getCytobands
#' 
#' @description 
#' 
#' Get the cytobands of the specified genome.
#' 
#' @details 
#'  
#' It returns \code{GRanges} object with the cytobands of the specified genome. 
#' The cytobands for some organisms and genome versions have been pre-downloaded from UCSC
#' and included in the \code{karyoploteR} package. For any other genome, \code{getCytobands}
#' will use \code{rtracklayer} to try to fetch the \code{cytoBandIdeo} table from UCSC. If for
#' some reason it is not possible to retrieve the cytobands, it will return an empty \code{GRanges}
#' object. Setting the parameter \code{use.cache} to \code{FALSE}, the data included in the 
#' package will be ignored and the cytobands will be downloaded from UCSC.
#' 
#' The genomes (and versions) with pre-downloaded cytobands are: hg18, hg19, hg38, mm9, mm10, mm39, 
#'      rn5, rn6, rn7, susScr11, 
#'      bosTau9, bosTau8, equCab3, equCab2, panTro6, panTro5, rheMac10,
#'      danRer10, danRer11, xenTro10, dm3, dm6, 
#'      ce6, ce10, ce11, sacCer2, sacCer3
#'    
#' 
#' 
#' @usage getCytobands(genome="hg19", use.cache=TRUE)
#' 
#' @param genome   (character or other) specifies a genome using the UCSC genome name. Defaults to "hg19". If it's not a \code{character}, genome is ignored and and empty \code{GRanges} is returned.
#' @param use.cache   (boolean) wether to use or not the cytoband information included in the packge. \code{use.cache=FALSE} will force a download from the UCSC.
#' 
#' @return
#' It returns a \code{\link{GenomicRanges}} object with the cytobands of the specified genome. If no cytobands are available for any reason, an empty \code{GRanges} is returned.
#' 
#' 
#' @note 
#' 
#' This function is memoised (cached) using the \code{\link{memoise}} package. To empty the 
#' cache, use \code{\link{forget}(getCytobands)}
#'  
#' @seealso \code{\link{plotKaryotype}}
#' 
#' @examples
#'  
#' #get the cytobands for hg19 (using the data included in the package)
#' cyto <- getCytobands("hg19")
#' 
# #Example deactivated due to a warning in biovizbase code
# #do not use the included data and force the download from UCSC
# cyto <- getCytobands("hg19", use.cache=FALSE)
#' 
#' #get the cytobands for Drosophila Melanogaster
#' cyto <- getCytobands("dm6")
#' 
#'  
#' @export getCytobands
#' 
#' @importFrom biovizBase getIdeogram
#' 


getCytobands <- NULL #Neede so roxygen writes the documentation file


#This is the internal function used. The exported and memoised version is created on-load 
#time as a memoised version of this.

.getCytobands <- function(genome="hg19", use.cache=TRUE) {
  #if it's a custom genome, do not attempt to get the cytobands
  if(!is.character(genome) | length(genome)>1) { 
    return(GRanges())
  }
  
  #If the cytobands are in the included cache, use them
  if(use.cache) {
    if(genome %in% names(data.cache[["cytobands"]])) {
      return(data.cache[["cytobands"]][[genome]])
    }
  }
    
  cytobands <- tryCatch(expr={
    #TEMP FIX: 2023-08-28 I deactivate the call to biovizBase due to an error: 
    #   Error in .normarg_seqlengths(value, seqnames(x)) : 
    #   the names on the supplied 'seqlengths' vector must be identical to the seqnames
    #and activate the old code directly calling rtracklayer to access UCSC.
    #TODO: Fall back to bioviz base once this is fixed.
    
    #biovizBase::getIdeogram(genome, cytobands=TRUE, )
    #Old version. Changed to a dependency on boivizBase as requested by package reviewer.    
    ucsc.session <- rtracklayer::browserSession()
    rtracklayer::genome(ucsc.session) <- genome
    cytobands <- rtracklayer::getTable(rtracklayer::ucscTableQuery(ucsc.session,"cytoBandIdeo"))
    cytobands$name <- as.character(cytobands$name)
    cytobands$gieStain <- as.character(cytobands$gieStain)
    toGRanges(cytobands)
    },
    error = function(e) {
      message("Message: Failed to retrieve cytobands for ", genome, " from UCSC. Returning no cytobands.", e)
      return(GRanges())
    }
  )
  cytobands$name <- as.character(cytobands$name)
  cytobands$gieStain <- as.character(cytobands$gieStain)
  
  return(cytobands)
  
}



# # #Code used to save the predownloaded Cytobands for some common genomes
# genomes <- c("hg18", "hg19", "hg38", "mm9", "mm10", "mm39", "rn5", "rn6", "rn7", "susScr11", 
#              "bosTau9", "bosTau8", "equCab3", "equCab2", "panTro6", "panTro5", "rheMac10",
#              "danRer10", "danRer11", "xenTro10", "dm3", "dm6", 
#              "ce6", "ce10", "ce11", "sacCer2", "sacCer3")
# 
# cytobands.cache <- list()
# genomes.cache <- list()
# 
# for(g in genomes) {
#   message("Downloading data for ", g)
#   cytobands.cache[[g]] <- getCytobands(g, use.cache=FALSE)
#   genomes.cache[[g]] <- GRangesForUCSCGenome(genome=g)
#   Sys.sleep(200)  #To ensure no blocking from UCSC due to too many requests
# }
# 
# data.cache <- list(genomes=genomes.cache, cytobands=cytobands.cache)
# 
# library(devtools)
# use_data(data.cache, internal = TRUE, overwrite=TRUE)
#  
# load("R/sysdata.rda")
# data.cache

#OLD CODE
# cytobands.cache <- list()
# cytobands.cache[["hg19"]] <- getCytobands("hg19", use.cache=FALSE)
# cytobands.cache[["hg38"]] <- getCytobands("hg38", use.cache=FALSE)
# cytobands.cache[["mm9"]] <- getCytobands("mm9", use.cache=FALSE)
# cytobands.cache[["mm10"]] <- getCytobands("mm10", use.cache=FALSE)
# cytobands.cache[["rn5"]] <- getCytobands("rn5", use.cache=FALSE)
# cytobands.cache[["rn6"]] <- getCytobands("rn6", use.cache=FALSE)
# cytobands.cache[["danRer10"]] <- getCytobands("danRer10", use.cache=FALSE)
# cytobands.cache[["dm6"]] <- getCytobands("dm6", use.cache=FALSE)
# cytobands.cache[["ce6"]] <- GRanges()
# cytobands.cache[["sacCer3"]] <- GRanges()
# 
# genomes.cache <- list()
# genomes.cache[["hg19"]] <- GRangesForUCSCGenome(genome="hg19")
# genomes.cache[["hg38"]] <- GRangesForUCSCGenome(genome="hg38")
# genomes.cache[["mm9"]] <- GRangesForUCSCGenome(genome="mm9")
# genomes.cache[["mm10"]] <- GRangesForUCSCGenome(genome="mm10")
# genomes.cache[["rn5"]] <- GRangesForUCSCGenome(genome="rn5")
# genomes.cache[["rn6"]] <- GRangesForUCSCGenome(genome="rn6")
# genomes.cache[["danRer10"]] <- GRangesForUCSCGenome(genome="danRer10")
# genomes.cache[["dm6"]] <- GRangesForUCSCGenome(genome="dm6")
# genomes.cache[["ce6"]] <- GRangesForUCSCGenome(genome="ce6")
# genomes.cache[["sacCer3"]] <- GRangesForUCSCGenome(genome="sacCer3")
# 
# data.cache <- list(genomes=genomes.cache, cytobands=cytobands.cache)
# library(devtools)
# use_data(data.cache, internal = TRUE, overwrite=TRUE)
# 
# load("R/sysdata.rda")
# data.cache

#' kpPlotRibbon
#' 
#' @description 
#' 
#' A variable width ribbon
#' 
#' @details 
#'  
#' \code{kpPlotRibbon} plots a variable witdh ribbon along the genome. It can be used,
#' for example, to plot the sd region around a line representing a mean. It can also 
#' be used as a replacement for \code{\link{kpBars}} creating a smoother plot without 
#' the the actual individual bars. \code{kpPlotRibbon} has three additional parameters
#' controlling the smoothing of the lines and their colors.
#' 
#' @usage kpPlotRibbon(karyoplot, data=NULL, chr=NULL, x0=NULL, x1=NULL, y0=NULL, y1=NULL, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, col="gray80", border=NULL, clipping=TRUE, ...)
#'  
#' @inheritParams kpRect 
#' @param col  (color) The background color to plot. If NULL, it will be a lighter version of 'border' or 'black' if border is null. (Defaults to "gray80")
#' @param border (color) The color to use to plot the borders of the bars. If NULL, it will be a darker version of 'col'. If NA, no border will be plotted. (Defaults to NULL)
# @param smooth A boolean indicating if the ribbon should be smoothed (with a spline approximation) before plotting (defaults to FALSE)
#'     
#' @return
#' 
#' Returns the original karyoplot object, unchanged.
#' 
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpBars}}, \code{\link{kpLines}}
#' 
#' @examples
#' 
#' 
#' set.seed(1000)
#' 
#' data <- toGRanges(data.frame(chr="chr1", start=1e6*(0:239), end=1e6*(1:240)))
#' y <- ((sin(start(data))/5 + rnorm(n=24, mean=0, sd=0.1))/5)+0.5
#'  
#' kp <- plotKaryotype("hg19", plot.type=2, chromosomes="chr1")
#' 
#' kpPlotRibbon(kp, data, y0=y-0.3, y1=y+0.3, border="red", col=lighter("red"))
#' kpPlotRibbon(kp, data, y0=y-0.1, y1=y+0.1, border="blue", col=lighter("blue"))
#' kpLines(kp, data, y=y, col="green")
#' kpPlotRibbon(kp, data, y0=0.5+(y-min(y)), y1=0.5-(y-min(y)), data.panel=2)
#' 
#' @export kpPlotRibbon


# smooth=FALSE,
kpPlotRibbon <- function(karyoplot, data=NULL, chr=NULL, x0=NULL, x1=NULL, y0=NULL, y1=NULL, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, col="gray80", border=NULL, clipping=TRUE, ...) {

  if(!methods::is(karyoplot, "KaryoPlot")) stop(paste0("In kpPlotRibbon: 'karyoplot' must be a valid 'KaryoPlot' object"))
  karyoplot$beginKpPlot()
  on.exit(karyoplot$endKpPlot())
  
  #If y0 is not specified with any of the valid methods, set it to the min of the data.panel
  if(is.null(y0)) {
    if(is.null(data)) {
      y0=karyoplot$plot.params[[paste0("data", data.panel, "min")]]
    } else {
      if(!("y0" %in% names(mcols(data)))) {
        y0=karyoplot$plot.params[[paste0("data", data.panel, "min")]]
      }
    }
  }
  
  #Specify the missing colors if possible
  if(is.null(border) & !is.null(col) & !is.na(col)) {
    border=darker(col, amount = 100)
  }
  if(is.null(col) & !is.null(border) & !is.na(border)) {
    col=lighter(border)
  }
  if(is.na(col) & is.null(border)) {
    border <- "black"
  }
  
  pp <- prepareParameters4("kpPlotRibbon", karyoplot=karyoplot, data=data, chr=chr, x0=x0, x1=x1,
                           y0=y0, y1=y1, ymin=ymin, ymax=ymax, r0=r0, r1=r1, 
                           data.panel=data.panel, ...)
  
  ccf <- karyoplot$coord.change.function
  
  x0plot <- ccf(chr=pp$chr, x=pp$x0, data.panel=data.panel)$x
  x1plot <- ccf(chr=pp$chr, x=pp$x1, data.panel=data.panel)$x
  #TODO: Add a parameter to specify center (default), start (xplot=x0plot) or end(xplot=x1plot)
  xplot <- (x0plot+x1plot)/2
  y0plot <- ccf(chr=pp$chr, y=pp$y0, data.panel=data.panel)$y
  y1plot <- ccf(chr=pp$chr, y=pp$y1, data.panel=data.panel)$y
  
  for(chr.name in karyoplot$chromosomes) {
    
    in.chr <- pp$chr==chr.name
    chr.chr <- pp$chr[in.chr]
    x.chr <- xplot[in.chr]
    y0.chr <- y0plot[in.chr]
    y1.chr <- y1plot[in.chr]
    
    processClipping(karyoplot=karyoplot, clipping=clipping, data.panel=data.panel)  
    
    graphics::polygon(x=c(x.chr, rev(x.chr)), y=c(y0.chr, rev(y1.chr)), col=col, border=NA, ...)
    # if(smooth==TRUE) {
    #   graphics::lines(smooth.spline(x = x.chr, y=y0.chr, df = length(x.chr)), col=border, ...)
    #   graphics::lines(smooth.spline(x = x.chr, y=y1.chr, df = length(x.chr)), col=border, ...)
    # } else {
      graphics::lines(x=x.chr, y=y0.chr, col=border, ...)
      graphics::lines(x=x.chr, y=y1.chr, col=border, ...)
    # }
  }
  
  invisible(karyoplot)
}

#' @name kpPlotRainfall
#' @title kpPlotRainfall
#' 
#' @description 
#' 
#' Creates a rainfall plot showing the distances between features in the genome.
#' Usually used to plot the distance bewteen somatic mutations to idenify kataegis.
#' 
#' @details 
#'  
#' \code{kpPlotRainfall} plots the distances between a feature and the next one
#' in a log scale along the genome. It is usually used to plot the distance 
#' between somatic mutations in order to identify regions with an accumulation 
#' of close mutations.
#' 
#' There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
#' 
#' @usage kpPlotRainfall(karyoplot, data, ref=NULL, alt=NULL, col="cell21breast", ymin=NULL, ymax=7, data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, ...)
#' 
#' @param karyoplot    (a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.
#' @param data    (a \code{GRanges}, a \code{VRanges} or a path to a VCF file) A GRanges or VRanges object with the variants to plot or the path to a VCF file.
#' @param ref (character vector or NULL) A character vector of with the reference base of the variants in data. Used to determine the color. If NULL and data is a VRanges or a VCF file, the information in data will be used (defaults to NULL)
#' @param alt (character vector or NULL) A character vector of with the alternative base of the variants in data. Used to determine the color. If NULL and data is a VRanges or a VCF file, the information in data will be used (defaults to NULL)
#' @param col (a color vector, a color table or a color schema) The colors to use to draw the points. If the length of the vector is lower than the length of data, it will be recycled. Color table and color schema must be compatible with getVariantColors. If NULL, points will be plotted in black. (defaults to NULL)
#' @param data.panel    (numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)
#' @param r0    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param r1    (numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)
#' @param ymin    (numeric) The minimum value to be plotted on the data panel. If NULL, it is set to 0. (deafults to NULL)
#' @param ymax    (numeric) The maximum value to be plotted on the data.panel. (defaults to 7, (equivalent to 10Mb between consecutive features))
#' @param clipping  (boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)
#' @param ...    The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions. In particular \code{col} and \code{border} can be used to set the colors used.
#'   
#' @return
#' 
#' Returns the original karyoplot object with the data computed (distances) stored at \code{karyoplot$latest.plot}
#' 
#' @seealso \code{\link{plotKaryotype}}, \code{\link{kpPlotDensity}}, \code{\link{kpPlotCoverage}}
#' 
#' @examples
#' 
#' set.seed(1000)
#' 
#' data <- createRandomRegions(nregions=2000)
#'  
#' kp <- plotKaryotype("hg19", plot.type=4)
#' kp <- kpPlotRainfall(kp, data)
#' kpAxis(kp, ymax=7, tick.pos=c(0:7))
#'  
#' @export kpPlotRainfall
#' @importFrom VariantAnnotation readVcfAsVRanges ref alt

kpPlotRainfall <- function(karyoplot, data, ref=NULL, alt=NULL, col="cell21breast", ymin=NULL, ymax=7, data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, ...) {

  if(!methods::is(karyoplot, "KaryoPlot")) stop(paste0("In kpPlotRainfall: 'karyoplot' must be a valid 'KaryoPlot' object"))
  if(!is.null(ref) & !is.character(ref)) stop("In kpPlotRainfall: ref must be NULL or a character vector")
  if(!is.null(alt) & !is.character(alt)) stop("In kpPlotRainfall: alt must be NULL or a character vector")
  
  #Preprocess data
  if(is.null(data)) stop(paste0("In kpPlotRainfall: data cannot be NULL."))

  if(!methods::is(data, "GRanges") && !methods::is(data, "VRanges")) {
    if(is.character(data) && length(data)==1) {
      data <- tryCatch(VariantAnnotation::readVcfAsVRanges(data), error=function(e) {stop("In kpPlotRainfall: Error when reading the VCF file. Is it a VCF file? ", e)})
    } else {
      stop(paste0("In kpPlotRainfall: 'data' must be a valid 'GRanges' object or a VCF file"))     
    }
  }
  
  if(methods::is(data, "VRanges")) {
    if(is.null(ref)) ref <- VariantAnnotation::ref(data)
    if(is.null(alt)) alt <- VariantAnnotation::alt(data)
    #And convert into a standard GRanges
    data <- GRanges(data)
    mcols(data) <- NULL
  }
  
  #Remove the indels (if possible)
  if(!is.null(ref) && !is.null(alt)) {
    indels <- nchar(ref)!=1 | nchar(alt)!=1
    data <- data[!indels]
    ref <- ref[!indels]
    alt <- alt[!indels]
  }
  
  #Assign colors
  if(is.null(col)) col <- "black"
  #If it's a color table
  if(length(names(col))==7 && all(sort(names(col))==sort(names(.karyoploter.colors$variants$schemas[[1]])))) {
    if(is.null(ref) || is.null(alt)) {
      col <- "black"  #warning("In kpPlotRainfall: a color.table cannot be used if ref and alt are NULL. Provide ref and alt or make data a VRanges or a VCF file")
    } else {
      col <- getVariantsColors(ref=ref, alt=alt, color.table = col)
    }
  } else {
    if(all(is.color(col))) {
      col <- rep(col, length.out=length(data))
    } else { #If it's not a color, assume it's a valid schema name
      if(is.null(ref) || is.null(alt)) {
        col <- "black" #warning("In kpPlotRainfall: a color.schema cannot be used if ref and alt are NULL. Provide ref and alt or make data a VRanges or a VCF file")
      } else {
        col <- getVariantsColors(ref=ref, alt=alt, color.schema = col)
      }
    }
  }
  
  #Sort and split by chromosome
  #first attach the color to the granges so colors are not misasigned
  data$col <- col
  data <- sort(data)
  
  data.per.chr <- split(data, seqnames(data))
  
  distances <- list()
  #and for each chromosome, compute the distances and plot them
  for(chr in karyoplot$chromosomes) {
    if(length(data.per.chr[[chr]])>0) {
      ss <- start(data.per.chr[[chr]])
      feat.dist <- ss - c(1,ss[seq_len(length(ss))-1])
      feat.dist <- log10(abs(feat.dist))
      distances[[chr]] <- feat.dist
      kpPoints(karyoplot, chr=chr, x=ss, y=feat.dist, col=data.per.chr[[chr]]$col, ymin=ymin, ymax=ymax, data.panel=data.panel, r0=r0, r1=r1, clipping=clipping, ...)
    }
  }
  
  karyoplot$latest.plot <- list(funct="kpPlotRainfall", computed.values=list(distances=distances, vars=data, ref=ref, alt=alt))

  invisible(karyoplot)
}

library(karyoploteR)
context("Content of the data cache")

#Test order of genomes
test_that("the genomes are sorted", {
  dc <- karyoploteR:::data.cache
  
  #hg19, canonical chromosomes
  expect_equal(paste0(seqlevels(dc[["genomes"]][["hg19"]])[1:24], collapse = ","), paste0(paste0("chr", c(1:22, "X", "Y")), collapse = ","))
  #hg38, canonical chromosomes
  expect_equal(paste0(seqlevels(dc[["genomes"]][["hg19"]])[1:24], collapse = ","), paste0(paste0("chr", c(1:22, "X", "Y")), collapse = ","))  

  #TODO: Check the other genomes
  
})

---
title: "karyoploteR: plot customizable linear genomes displaying arbitrary data"
author: "Bernat Gel (bgel@igtp.cat)"
date: "`r doc_date()`"
package: "`r pkg_ver('karyoploteR')`"
output: 
  BiocStyle::html_document:
    toc: true
vignette: >
  %\VignetteIndexEntry{karyoploteR vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
---


```{r, include=FALSE}
library(knitr)
library(karyoploteR)
library(regioneR)
library(magrittr)
opts_chunk$set(concordance=FALSE)
set.seed(21666641)
```


# Introduction

Data visualisation is a powerful tool used for data analysis and exploration in many fields. Genomics data 
analysis is one of these fields where good visualisation tools can be of great help. The aim of karyoploteR is to offer the user an easy way to plot data along the genome to get broad wide view where it is possible to identify genome wide relations and distributions. 

`r BiocStyle::Biocpkg("karyoploteR")` is based on base R graphics and mimicks its interface. You first create a plot with `plotKaryotype` and then sequentially call a number of functions (`kpLines`, `kpPoints`, `kpBars`...) to add data to the plot. 

`r BiocStyle::Biocpkg("karyoploteR")` is a plotting tool and only a plotting tool. That means that it is not able to download or retrieve any data. The downside of this is that the user is responsible of getting the data into R. The upside is that it is not tied to any data provider and thus can be used to plot genomic data coming from anywhere. The only exception to this are the ideograms cytobands, that by default are plotted using pre-downloaded data from UCSC. 

# Tutorial and Examples

In addition to this vignette, an detailed step-by-step tutorial and a set of 
complex examples with complete code are available at
[https://bernatgel.github.io/karyoploter_tutorial/]

# Quick Start

The basic idea behind `r BiocStyle::Biocpkg("karyoploteR")` has been to create a plotting system inspired by the R base graphics. Therefore, the basic workflow to create a karyoplot is to start with an empty plot with no data apart from the ideograms themselves using `plotKaryotype` and then add the data plots as required. To add the data there are functions based on the R base graphics low-level primitives -e.g `kpPoints`, `kpLines`, `kpSegments`, `kpRect`... - that can be used to plot virtually anything along the genome and other functions at a higher level useful to plot more specific genomic data types -e.g. `kpPlotRegions`, `kpPlotCoverage`...-.

This is a first simple example plotting a set of regions representing copy-number gains and losses using the `kpPlotRegions` function:

```{r}
  gains <- toGRanges(data.frame(chr=c("chr1", "chr5", "chr17", "chr22"), start=c(1, 1000000, 4000000, 1),
                      end=c(5000000, 3200000, 80000000, 1200000)))
  losses <- toGRanges(data.frame(chr=c("chr3", "chr9", "chr17"), start=c(80000000, 20000000, 1),
                       end=c(170000000, 30000000, 25000000)))
  kp <- plotKaryotype(genome="hg19")
  kpPlotRegions(kp, gains, col="#FFAACC")
  kpPlotRegions(kp, losses, col="#CCFFAA")

```

As you can see, the `plotKaryotype` returns a `KaryoPlot` object that has to be passed to any subsequent plot call.

`plotKaryotype` accepts a number of parameters but the most commonly used are `genome`, `chromosomes` and `plot.type`. The `genome` and `chromosomes` are used to specify the genome to be plotted (defaults to `hg19` and which chromosomes to plot (defaults to `canonical`). The `plot.type` parameter is used to select between different modes of adding data to the genome (above, below or on the ideograms).

For example, to create a plot of the mouse genome with data above the ideograms we would use this:

```{r}
  kp <- plotKaryotype(genome="mm10", plot.type=1, main="The mm10 genome")
```

And to plot the first thee chromosomes of the hg19 human genome assembly with data above and below them:

```{r}
  kp <- plotKaryotype(genome="hg19", plot.type=2, chromosomes=c("chr1", "chr2", "chr3"))
```

All low-level plotting functions share a similar interface, and in general, they accept the standard R plotting parameters (`lwd`, `cex`, `pch`, etc...). The simplest way (althought not always the most convenient) is to treat them as the equivalent R base plotting functions with an additional `chr` parameter. As an example, we can create a set of random 1 base regions (using `r BiocStyle::Biocpkg("regioneR")` `createRandomRegions`) and add a random `y` value to them:

```{r, }
  rand.data <- createRandomRegions(genome="hg19", nregions=1000, length.mean=1, length.sd=0,
                      mask=NA, non.overlapping=TRUE) 
  rand.data <- toDataframe(sort(rand.data))
  rand.data <- cbind(rand.data, y=runif(n=1000, min=-1, max=1))
  
  #Select some data points as "special ones"
  sel.data <- rand.data[c(7, 30, 38, 52),] 
  head(rand.data)
```

And then plot them in different ways.

```{r}
  kp <- plotKaryotype(genome="hg19", plot.type=2, chromosomes=c("chr1", "chr2", "chr3"))
  
  kpDataBackground(kp, data.panel = 1, r0=0, r1=0.45)
  kpAxis(kp, ymin=-1, ymax=1, r0=0.05, r1=0.4, col="gray50", cex=0.5)
  kpPoints(kp, chr=rand.data$chr, x=rand.data$start, y=rand.data$y,
           ymin=-1, ymax=1, r0=0.05, r1=0.4, col="black", pch=".", cex=2)
  kpPoints(kp, chr=sel.data$chr, x=sel.data$start, y=sel.data$y,
           ymin=-1, ymax=1, r0=0.05, r1=0.4, col="red")
  kpText(kp, chr=sel.data$chr, x=sel.data$start, y=sel.data$y,
         ymin=-1, ymax=1, r0=0.05, r1=0.4, labels=c("A", "B", "C", "D"), col="red",
         pos=4, cex=0.8)
  
  
  #Upper part: data.panel=1
  kpDataBackground(kp, data.panel = 1, r0=0.5, r1=1)
  kpAxis(kp, ymin=-1, ymax=1, r0=0.5, r1=1, col="gray50", cex=0.5, numticks = 5)
  kpAbline(kp, h=c(-0.5, 0, 0.5), col="gray50", ymin=-1, ymax=1, r0=0.5, r1=1)
  kpLines(kp, chr=rand.data$chr, x=rand.data$start, y=rand.data$y,
          col="#AA88FF", ymin=-1, ymax=1, r0=0.5, r1=1)
  #Use kpSegments to add small tic to the line
  kpSegments(kp, chr=rand.data$chr, x0=rand.data$start, x1=rand.data$start,
             y0=rand.data$y-0.1, y1=rand.data$y+0.1,
             col="#8866DD", ymin=-1, ymax=1, r0=0.5, r1=1)
  #Plot the same line but inverting the data by pssing a r0>r1
  kpLines(kp, chr=rand.data$chr, x=rand.data$start, y=rand.data$y,
          col="#FF88AA", ymin=-1, ymax=1, r0=1, r1=0.5)
  
  
  #Lower part: data.panel=2
  kpDataBackground(kp, r0=0, r1=0.29, color = "#EEFFEE", data.panel = 2)
  kpAxis(kp, col="#AADDAA", ymin=-1, ymax=1, r0=0, r1=0.29, data.panel = 2,
         numticks = 2, cex=0.5, tick.len = 0)
  kpAbline(kp, h=0, col="#AADDAA", ymin=-1, ymax=1, r0=0, r1=0.29, data.panel = 2)
  kpBars(kp, chr=rand.data$chr, x0=rand.data$start, x1=rand.data$end, y1 = rand.data$y,
          col="#AADDAA", ymin=-1, ymax=1, r0=0, r1=0.29, data.panel = 2, border="#AADDAA" )
  
  kpDataBackground(kp, r0=0.34, r1=0.63, color = "#EEEEFF", data.panel = 2)
  kpAxis(kp, col="#AAAADD", ymin=-1, ymax=1, r0=0.34, r1=0.63, data.panel = 2, 
         numticks = 2, cex=0.5, tick.len = 0)
  kpAbline(kp, h=0, col="#AAAADD", ymin=-1, ymax=1, r0=0.34, r1=0.63, data.panel = 2)
  kpSegments(kp, chr=rand.data$chr, x0=rand.data$start, x1=rand.data$end, 
             y0=rand.data$y-0.2, y1=rand.data$y, 
             col="#AAAADD", ymin=-1, ymax=1, r0=0.34, r1=0.63, data.panel = 2, lwd=2)
  
  kpDataBackground(kp, r0=0.68, r1=0.97, color = "#FFEEEE", data.panel = 2)
  kpAxis(kp, col="#DDAAAA", ymin=-1, ymax=1, r0=0.68, r1=0.97, data.panel = 2,
         numticks = 2, cex=0.5, tick.len = 0)
  kpPoints(kp, chr=rand.data$chr, x=rand.data$start, y=rand.data$y,
          col="#DDAAAA", ymin=-1, ymax=1, r0=0.68, r1=0.97, data.panel = 2, pch=".", cex=3)
 
```



# Creating a karyotype plot

All plots in `r BiocStyle::Biocpkg("karyoploteR")` start with a call to `plotKaryotype`. This function is used to define the desired type of plot and the basic plotting parameters, creates an empty plot with the ideograms representing the chromosomes and finally returns a `KaryoPlot` object that will be needed by all functions adding data into the plot.

There are two main parts in the karyoplots: the ideograms and the data panels. The ideograms represent the chromosomes and are usually represented by the chromosomic cytobands. The data panels are the parts of the plot where data will be plotted. They are not marked by default (no border or background) and depending on the plot type there may be more than one per chromosome.

`plotKaryotype` accepts a number of parameters to modify its behaviour, but by default it will create an empty karyoplot of the human genome version hg19 with a single data panel above the ideograms:

```{r}
  kp <- plotKaryotype()
```

In this section we will see how the different parameters of `plotKarytype` can be used to modify this basic plot and create plots with more data panels, for other organisms, with a different style or showing just some of the chromosomes.


## Genomes and Chromosomes

A karyoplot is a representation of a genome, and thus, one of the main parameters of `plotKaryotype` is `genome`. With it we can specify what genome we want to plot. The package includes a small cache with information on some genomes and to use it we have to specify the genome using the standard UCSC genome name (hg19, hg38, mm10, dm6, ...). However, internally it can use `r BiocStyle::Biocpkg("regioneR")`'s `getGenomeAndMask` function and so we can specify the genome in any fornmat accepted by this function, including the name of any `BSGenome` object available in the system. If we want `plotKaryotype` to ignore the included cache and try to automatically get the genome information from other sources we can set `use.cache` to `FALSE`.

In addition, with the `chromosomes` parameter, it is possible to plot only a subset of the chromosomes of the genome. The chromosomes can be specified either as a list of chromosome names or as one of the predefined sets for the available organisms: autosomal, canonical and all. By default, only canonical chromosomes are drawn. The `chromosomes` parameter can also be used to change the order of the chromosomes. 

```{r}
  kp <- plotKaryotype(chromosomes=c("autosomal"))
```
```{r}
  kp <- plotKaryotype(genome="mm10", chromosomes=c("chr10", "chr13", "chr2"))
```



## Types of Plots
    
There are currently 5 plot types available: 


  * **plot.type=1** A plot with stacked horizontal ideograms  and a single data panel on top of them
  * **plot.type=2** A plot with stacked horizontal ideograms and two data panels, one above and one below them
  * **plot.type=3** A plot with horizontal ideograms all in one level, and two data panels, one above and one below them
  * **plot.type=4** A plot with horizontal ideograms all in one level, and one data panel above them
  * **plot.type=5** A plot with horizontal ideograms all in one level, and one data panel below them


To clearly see where the data panels are and in some cases, to help the readers interpret the data it is possible to add a background to the data panels with `kpDataBackground`. Please take into account that the function draws a solid rectangle and so if any data was already plotted it would be no longer visible.

This is plot type 1:
```{r}
  kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 1)
  kpDataBackground(kp, data.panel = 1)
```

This is plot type 2:
```{r}
 kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 2)
 kpDataBackground(kp, data.panel = 1)
 kpDataBackground(kp, data.panel = 2)
```

This is plot type 3:
```{r}
 kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 3)
 kpDataBackground(kp, data.panel = 1)
 kpDataBackground(kp, data.panel = 2)
```

This is plot type 4:
```{r}
 kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 4)
 kpDataBackground(kp, data.panel = 1)
```

And this is plot type 5:
```{r}
 kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 5)
 kpDataBackground(kp, data.panel = 1)
```

<!-- ## Ideograms and Labels 

```{r, eval=FALSE}
 # NOT RUN
 pt <- permTest(A=my.regions, B=repeats, randomize.function=randomizeRegions,
 evaluate.function=overlapRegions)
```
-->


## Adding Axis

In some cases, adding axis to the plots can help stablishing a context for the data. `kpAxis` draws an axis on the letf or right side of the data panel and it's possible to change it's appearance, position, labels and ticks. If combined with a `kpDataBackground`, its important to draw the axis after the background, so it's not overdrawn by it.

```{r}
  kp <- plotKaryotype(chromosomes=c("chr1", "chr2"), plot.type=2)
 
  #data.panel=1
  kpDataBackground(kp)
  #Default axis
    kpAxis(kp) 
  #Axis on the right side of the data.panel
    kpAxis(kp, side = 2) 
  
  #data.panel=2
  kpDataBackground(kp, r1=0.47, data.panel=2)
  #Changing the limits and having more ticks, with a smaller font size
  kpAxis(kp, r1=0.47, ymin=-5000, ymax = 5000, numticks = 5, cex=0.5, data.panel=2)  
  #and a different scale on the right
  kpAxis(kp, r1=0.47, ymin=-2, ymax = 2, numticks = 3, cex=0.5, data.panel=2, side=2)
  
  kpDataBackground(kp, r0=0.53, data.panel=2)
  #Changing the colors and labels and tick positions
  kpAxis(kp, r0=0.53, tick.pos = c(0.3, 0.6, 1), labels = c("A", "B", "C"), col="#66AADD",
         cex=0.5, data.panel=2)
  
```

## Changing the plotting parameters

In addition to changing the genomes, chromosomes, and plot types, it's also possible to change and customize the different sizes and margins defining the look of the karyoplot. To do this we need to to provide an object with all the plotting parameters as the `plot.params` parameter of `plotKaryotype`. The easiest way to get a valid `plot.params` object is calling `getDefaultPlotParams` and modifying the response. To see the available plot params and their default values we can call `plotDefaultPlotParams`, which will create a plot with the representation of the plot parameters. Note that the plotting parameters plot are only implemented for plot types 1, 2 and 3.

This is for `plot.type=2`
```{r}
plotDefaultPlotParams(plot.type=2)
```

And this is for `plot.type=3`
```{r}
plotDefaultPlotParams(plot.type=3)
```

Or we can change the plot parameters to create different configurations. For example, we can create a plot with a data panel larger than the other and smaller margins:

```{r}
plot.params <- getDefaultPlotParams(plot.type=2)
plot.params$ideogramheight <- 5
plot.params$data2height <- 50
plot.params$leftmargin <- 0.05
plot.params$bottommargin <- 20
plot.params$topmargin <- 20

plotDefaultPlotParams(plot.type=2, plot.params=plot.params)
```

Or a plot with a very small data panel above the ideogram almost touching it (for example, to mark the regions of interest) and a bigger data panel below it (for example, to plot the detailed data):

```{r}
plot.params <- getDefaultPlotParams(plot.type=3)
plot.params$ideogramheight <- 50
plot.params$data1height <- 50
plot.params$data1inmargin <- 1
plot.params$data2height <- 400

plotDefaultPlotParams(plot.type = 3, plot.params=plot.params)

```

## Zooming: plotting small parts of the genome

In addition to plotting the whole genome, it is possible to use karyoploteR 
to plot a single small region, zooming in into it and not plotting the rest of
the genome.

**IMPORTANT:** It is not possible to zoom into multiple regions in a single plot. 
Each zoomed plot can only represent a single region.

To activate this feature, we only need to specify the region to zoom in 
passing a GRanges object in the `zoom` parameter of the `plotKaryotype` 
function. This will create a new plot showing only the region in `zoom` and
with the number of data panels derived from `plot.type`.

For example, this is a standard plot of chromosome 1 with some random data:

```{r}
  data.points <- data.frame(chr="chr1", pos=(1:240)*1e6, value=rnorm(240, 0.5, 0.1))
  kp <- plotKaryotype(plot.type = 4, chromosomes = "chr1")
  kpDataBackground(kp, data.panel = 1)
  kpAddBaseNumbers(kp)
  kpPoints(kp, chr = data.points$chr, x=data.points$pos, y=data.points$value, col=rainbow(240))
```

And we can zoom into the region between 180-240Mb to see it with more detail.

```{r}
  detail.region <- toGRanges(data.frame("chr1", 180e6, 240e6))
  data.points <- data.frame(chr="chr1", pos=(1:240)*1e6, value=rnorm(240, 0.5, 0.1))
  kp <- plotKaryotype(plot.type = 4, zoom=detail.region)
  kpDataBackground(kp, data.panel = 1)
  kpAddBaseNumbers(kp)
  kpPoints(kp, chr = data.points$chr, x=data.points$pos, y=data.points$value, col=rainbow(240))
```


## Clipping and cutting the object representation

When zooming, by default any data representation is clipped to the visible part 
of the data panel. That is, only the part of the data representations inside 
the data panel is drawn and anything falling out of it is cutted out.

It is possible to change this behaviour by setting the `clipping` parameter to 
`FALSE`. 

As an example, we can create a plot with a big point and a couple of arrows: one
ending above the limit of the data panel and the other one totally contained in
the data panal.

```{r}
  kp <- plotKaryotype(plot.type = 4, chromosomes = "chr1")
  kpDataBackground(kp, data.panel = 1)
  kpAddBaseNumbers(kp)
  kpPoints(kp, chr = "chr1", x=180e6, y=0.5, pch=16, cex=8, col="#FAC67A", clipping=TRUE)
  kpArrows(kp, chr = "chr1", x0 = 50e6, x1=170e6, y0=0.2, y1=1.1)
  kpArrows(kp, chr = "chr1", x0 = 160e6, x1=240e6, y0=0.9, y1=0.5)
```

We can see the two complete arrows and the point.

However, when we zoom in closer to the point, we end up with only parts of the 
arrows and the point.


```{r}
  detail.region <- toGRanges(data.frame("chr1", 135e6, 180e6))
  kp <- plotKaryotype(plot.type = 4, zoom = detail.region)
  kpDataBackground(kp, data.panel = 1)
  kpAddBaseNumbers(kp)
  kpPoints(kp, chr = "chr1", x=180e6, y=0.5, pch=16, cex=8, col="#FAC67A")
  kpArrows(kp, chr = "chr1", x0 = 50e6, x1=170e6, y0=0.2, y1=1.1)
  kpArrows(kp, chr = "chr1", x0 = 160e6, x1=240e6, y0=0.9, y1=0.5)
```

Note that while the point of the arrow is within the detail region it gets clipped 
because zooming activates the clipping.

We can disable clipping of individual elements using the `clipping` parameter. 
For example, we can disable it for the arrows and leave it active for the point.


```{r}
  detail.region <- toGRanges(data.frame("chr1", 135e6, 180e6))
  kp <- plotKaryotype(plot.type = 4, zoom = detail.region)
  kpDataBackground(kp, data.panel = 1)
  kpAddBaseNumbers(kp)
  kpPoints(kp, chr = "chr1", x=180e6, y=0.5, pch=16, cex=8, col="#FAC67A")
  kpArrows(kp, chr = "chr1", x0 = 50e6, x1=170e6, y0=0.2, y1=1.1, clipping=FALSE)
  kpArrows(kp, chr = "chr1", x0 = 160e6, x1=240e6, y0=0.9, y1=0.5, clipping=FALSE)
```

Notice the the downward pointing arrow is still clipped, but this is only because
it end out of the actual image.


# Adding Data

After creating a plot we can add data to it using successive calls to the various data plotting functions. There are two types of data plotting functions: the low levels ones, based on the basic plotting functions from base graphics (`kpPoints`, `kpLines`, etc...) and the higher level ones, that are functions specialized in drawing certain object types such as `GRanges` (`kpPlotRegions`, `kpPlotCoverage`). It is perfectly possible to draw new data on top of the already plotted one in order to create combined plots. 

In addition, it is be possible to create custom plotting functions based on the coordinates change function included in the `karyoplot` object.

## Common Parameters
    
All plotting functions share a set of common parameters that define where and how data will be plotted.

`r0` and `r1` define the region of the data panel where the data will be plotted. They are inspired by the r0 and r1 parameters in Circos, where they define the min and max radius where the data will be confined. A value of 0 is the most proximal to the ideogram and 1 is the farthest one. In addition, if `r0>r1`, the data will be "flipped", drawing larger values of y closer to the ideogram.

`ymin` and `ymax` define the minimum and maximum expected y value to be plotted. By default they are 0 and 1 but any finite number is possible. They work together with `r0` and `r1` to define where a data point will be drawn. In general, a data point with `y=ymin` will be plotted at `r0` and a data point with `y=ymax` will be plotted at `r1`.

`data.panel` states in which data panel (if there's more than one available) the data will be plotted. The data panel identifier depends on the `plot.type`.

`clipping` states whether data representation could span out of the data panel
or if it should be cut at the data panel boundary (`clipping=TRUE`, default).

In addition, all plotting functions accept the applicable standard R graphic parameters (`lwd`, `col`, `cex`, ...)


## Basic Plotting Functions

The basic or low-level plotting functions mimmick the base R plotting functions and are use to draw basic types: points, lines, segments, arrows, etc... 
    
All basic plotting functions share a number of parameters to specify the data points. `chr` accepts a vector of chromosome names stating the chromosome to which data point belongs. `x` (or `x0` and `x1`) are used to specify the horizontal position of the data points (or its start and end) and the units are base pairs. `y` (or `y0` and `y1`) specify the value (or start and end value) of the data point and should be in the range `[ymin-ymax]`. All parameters are recycled if needed using the standard vector recycling rules, but in some situations this might result in strange results.
    
For example, to plot a point with value 0.2 in position 30Mb of chromosome 1 and a rectangle with values 0.2 to 0.4 in positions from 100Mb to 120Mb we would use:

```{r}
  kp <- plotKaryotype(chromosomes=c("chr1"))
  kpDataBackground(kp)
  kpAxis(kp)
  kpPoints(kp, chr="chr1", x=30000000, y=0.2)  
  kpRect(kp, chr="chr1", x0=100000000, x1=120000000, y0=0.2, y1=0.4)
```

Another possibility is to create a `GRanges` object with the data, with `chr`, `x0` and `x1` as the sequence, start and end, and one (`y`) or two (`y0` and `y1`) metadata columns with the values. This `GRanges` object can then be passed in in the `data` parameter. In addition, it is possible to overrule the content of data if any of the explicit parameters is used.
 
```{r}
  dd <- toGRanges(data.frame(chr="chr1", start=30000000, end=30000000, y=0.2))
  dd2 <- toGRanges(data.frame(chr="chr1", start=100000000, end=120000000, y0=0.2, y1=0.4))
  
  kp <- plotKaryotype(chromosomes=c("chr1")) 
  kpDataBackground(kp)
  kpAxis(kp)
  kpPoints(kp, data=dd)
  kpPoints(kp, data=dd, y=0.8)  
  kpRect(kp, data=dd2)
  
``` 
    
    
These are the available basic plotting functions (more detailed information and 
extended examples can be found at [karyoploteR's tutorial and examples page](https://bernatgel.github.io/karyoploter_tutorial/#Examples)): 

  * **kpAbline** Draws horizontal and vertical lines spanning the whole avaliable space
  * **kpArrows** Draws arrows. Using the  `code` parameter, it's possible to specify where the arrowhead should be placed.
  * **kpBars** Draws vertical bars. If `y0` is present, bars span from `y0` to `y1`, if it's ommited, bars span from 0 to `y1` 
  * **kpHeatmap** Draws a heatmap-like representation of the data. Specifically, for each data point a rectangle is drawn with the color determined by the `y` value 
  * **kpLines** Draws straight lines joining the data points.  
  * **kpPoints** Draws points (or other shaes using `pch`) in the data points.
  * **kpPolygon** Draws a closed polygon joining all data points
  * **kpRect** Draws a rectangle at the specified points.
  * **kpSegments** Draws segments joining the specified points
  * **kpText** Draws text labels at the specified positions. Text labels are provided via the `labels` argument.



```{r}
  pp <- getDefaultPlotParams(plot.type = 1)
  pp$data1height=600
  
  tr.i <- 1/11
  tr.o <- 1/10
  
  kp <- plotKaryotype(chromosomes=c("chr1"), plot.params = pp) 
  
  dd <- toGRanges(data.frame(chr="chr1", start=end(kp$genome[1])/50*(0:49), end=end(kp$genome[1])/50*(1:50)))
  mcols(dd) <- data.frame(y=((sin(start(dd)) + rnorm(n=50, mean=0, sd=0.1))/5)+0.5)
  
  tn <- 0
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpPoints(kp, dd, r0=tr.o*tn, r1=tr.o*tn+tr.i, pch=".", cex=2)
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpPoints", cex=0.7)
  
  tn <- 1
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpLines(kp, dd, r0=tr.o*tn, r1=tr.o*tn+tr.i, pch=".", cex=2)
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpLines", cex=0.7)
  
  tn <- 2
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpBars(kp, dd, y1=dd$y, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#AAFFAA", border="#66DD66")
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpBars", cex=0.7)
  
  tn <- 3
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpRect(kp, dd, y0=dd$y-0.3, y1=dd$y, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#AAAAFF", border="#6666DD")
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpRect", cex=0.7)
  
  tn <- 4
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpText(kp, dd, labels=as.character(1:50), cex=0.5, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#DDAADD")
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpText", cex=0.7)
  
  tn <- 5
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpSegments(kp, dd, y0=dd$y-0.3, y1=dd$y, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpSegments", cex=0.7)

  tn <- 6
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpArrows(kp, dd, y0=dd$y-0.3, y1=dd$y, r0=tr.o*tn, r1=tr.o*tn+tr.i, length=0.04)
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpArrows", cex=0.7)

  tn <- 7
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpHeatmap(kp, dd, r0=tr.o*tn+tr.i/4, r1=tr.o*tn+tr.i-tr.i/4, colors = c("green", "black", "red"))
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpHeatmap", cex=0.7)

  tn <- 8
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpPolygon(kp, dd, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpPolygon", cex=0.7)
  
  tn <- 9
  kpDataBackground(kp, r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpAbline(kp, h=c(0.25, 0.5, 0.75), v=start(dd), r0=tr.o*tn, r1=tr.o*tn+tr.i)
  kpRect(kp, chr="chr1", x0=5000000, x1=45000000, y0=0.2, y1=0.8, r0=tr.o*tn, r1=tr.o*tn+tr.i, col="#EEEEEE", border="#666666")
  kpText(kp, chr="chr1", x=25000000, y=0.5, col="red", r0=tr.o*tn, r1=tr.o*tn+tr.i, labels="kpAbline", cex=0.7)
  
  
```

## Higher Level Plotting Functions

Higher level functions are designed to plot specific data types and objects and they expect data to be given using a specific object.
    
These are the currently available high-level plotting functions:

  * **kpPlotRegions** Accepts a `GRanges` object and plots the regions as solid rectangles. If there are overlapping regions, it automatically detect them and plot them in a stacked way. 
  * **kpPlotCoverage** Accepts a `Granges` object and plots the coverage level over the genome as a histogram-like bar plot.
  * **kpPlotDensity** Accepts a `GRanges` object and computes its density over set size windows. It is possible to change the window size to change the smoothing effect.
  * **kpPlotBAMDensity** Accepts a BAM file and computes the read density along the genome. The density is computed directly from the BAM file
  * **kpPlotMarkers** Given a set of genomic positions and labels, creates sticks and texts markers naming the positions. Useful for genes and other named genomic elements. Includes a simple positioning algorithm that will attempt to avoid the overlapping of text labels.
  * **kpPlotRainfall** Given a set of variants, creates a raifall plot depicting the distance between each variant and the next one. Useful to identify _kataegis_, regions with an accumulation of variants.
  * **kpPlotRibbon** Plots a variable width line. Useful to show confidence intervals and similar objects.
  * **kpPlotLinks** Plots links between different regions of the genome, either in the same of different chromosomes.
  
  Extended information regarding these functions and additional real-life examples can be found at the [karyoploteR's tutorial and examples page](https://bernatgel.github.io/karyoploter_tutorial/#Examples)


# Compatibility with `r BiocStyle::Biocpkg("magrittr")`

`r BiocStyle::Biocpkg("karyoploteR")` is compatible with `r BiocStyle::Biocpkg("magrittr")` and so it is also possible to use `%>%` pipes to chain the calls to the plotting functions. This allows somewhat simpler code.

For example this code 

```{r, eval=FALSE}
  kp <- plotKaryotype(genome="hg19")
  kpDataBackground(kp)
  kpAxis(kp)
  kpPlotRegions(kp, gains, col="#FFAACC")
  kpPlotRegions(kp, losses, col="#CCFFAA")

```

is equivalent to this one using pipes

```{r, eval=FALSE}
  library(magrittr)
  kp <- plotKaryotype(genome="hg19") %>% kpDataBackground() %>%  kpAxis() %>%
    kpPlotRegions(gains, col="#FFAACC") %>%
    kpPlotRegions(losses, col="#CCFFAA")
```

<!-- Coming in the future

# Customization 

## The `KaryoPlot` Object


## Using the coordinate change function

## Custom data plots

## Custom ideograms and labels
    
     \incfig[h!]{figures/speed_test_regioneR_small.pdf}{0.8\textwidth}{Randomization time against number of regions}
 {}
 
     \incfig[h!]{figures/mask_test_regioneR_small.pdf}{0.8\textwidth}{Randomization time against mask density}
 {}
-->

# Session Info

```{r, sessionInfo}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{processClipping}
\alias{processClipping}
\title{processClipping}
\usage{
processClipping(karyoplot, clipping, data.panel)
}
\arguments{
\item{karyoplot}{(KaryoPlot) A KaryoPlot object representing the current plot}

\item{clipping}{(logical) Wheter clipping should be activated or not}

\item{data.panel}{(data panel identifier) The name of the data panel on which the plot should be allowed. Anything plotted outside it will be hidden (if clipping==TRUE and the plot is a zoom plot)}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Sets image clipping if needed
}
\details{
Small utility function to help manage clipping. If the current plot is
a zoomed plot and clipping is TRUE, activate the clip to the current 
data.panel. This will hide any plotting ocurring out of the data.panel
region.
}
\note{
Users wont usually use this function. It is used by the plotting functions 
to set the clipping if needed
}
\examples{

kp <- plotKaryotype()
processClipping(kp, TRUE, 1)

 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/color.R
\name{lighter}
\alias{lighter}
\title{lighter}
\usage{
lighter(col, amount=150)
}
\arguments{
\item{col}{(color) The original color. Might be specified as a color name or a "#RRGGBB(AA)" hex color definition.}

\item{amount}{(integer, [0-255]) The fixed amount to add to each RGB channel (Defaults to 150).}
}
\value{
A lighter color
}
\description{
Given a color, return a lighter one
}
\details{
Very simple utility function to create lighter colors. Given a color, it
transforms it to rgb space, adds a set amount to all chanels and transforms
it back to a color.
}
\examples{
 
lighter("red")
lighter("#333333")
lighter(c("red", 3, "#FF00FF"))
 
}
\seealso{
\code{\link{darker}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpPlotRegions.R
\name{kpPlotRegions}
\alias{kpPlotRegions}
\title{kpPlotRegions}
\usage{
kpPlotRegions(karyoplot, data, data.panel=1, r0=NULL, r1=NULL, col="black", border=NULL, avoid.overlapping=TRUE, num.layers=NULL, layer.margin=0.05, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{GRanges} or equivalent) It can be any of the formats accepted by the \code{\link[regioneR]{toGRanges}} function from the package \href{http://bioconductor.org/packages/release/bioc/html/regioneR.html}{regioneR}.}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{col}{(color) The background color of the regions. (defaults to black)}

\item{border}{(color) The color used to draw the border of the regions. If NULL, no border is drawn. (defaults to NULL)}

\item{avoid.overlapping}{(boolean) Whether overlapping regions should be drawn as stacks (TRUE) on drawing one occluding the other in a single layer (FALSE). (defaults to TRUE)}

\item{num.layers}{(numeric) The number of layers the plotting space should be divided into to allow for plotting overlapping regions. The lotting region will be divided into this many pieces regardless if any overlapping regions actually exist. If NULL, the maximum number of regions overlapping a single point in the genome. (defaults to NULL)}

\item{layer.margin}{(numeric) The blank space left between layers of regions. (defaults to 0.05)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Plots rectangles along the genome representing the regions (or intervals) specified by a \code{GRanges} object
}
\details{
This is one of the high-level, or specialized, plotting functions of karyoploteR. It takes a \code{GRanges} object and
 plots its content. Overlapping regions can be stacked and the number of layers for overlapping regions can be set.
 In contrast with the low-level functions such as \code{\link{kpRect}}, it is not possible to specify the data using 
 independent numeric vectors and the function only takes in \code{GRanges}.
}
\examples{
 
 
 set.seed(1000)
 
 #Example 1: create 20 sets of non-overlapping random regions and plot them all. Add a coverage plot on top.
 kp <- plotKaryotype("hg19", plot.type=1, chromosomes=c("chr1", "chr2"))
 
 all.regs <- GRanges()
 
 nreps <- 20
 for(i in 1:nreps) {
   regs <- createRandomRegions(nregions = 100, length.mean = 10000000, length.sd = 1000000,
                               non.overlapping = TRUE, genome = "hg19", mask=NA)
   all.regs <- c(all.regs, regs)
   kpPlotRegions(kp, regs, r0 = (i-1)*(0.8/nreps), r1 = (i)*(0.8/nreps), col="#AAAAAA")
 }
 
 kpPlotCoverage(kp, all.regs, ymax = 20, r0=0.8,  r1=1, col="#CCCCFF")
 kpAxis(kp, ymin = 0, ymax= 20, numticks = 2, r0 = 0.8, r1=1)
 
 
 #Example 2: Do the same with a single bigger set of possibly overlapping regions
 
 kp <- plotKaryotype("hg19", plot.type=1, chromosomes=c("chr1", "chr2"))
 
 regs <- createRandomRegions(nregions = 1000, length.mean = 10000000, length.sd = 1000000,
                             non.overlapping = FALSE, genome = "hg19", mask=NA)
                             
 kpPlotRegions(kp, regs, r0 = 0, r1 = 0.8, col="#AAAAAA")
 
 kpPlotCoverage(kp, regs, ymax = 20, r0=0.8,  r1=1, col="#CCCCFF")
 kpAxis(kp, ymin = 0, ymax= 20, numticks = 2, r0 = 0.8, r1=1)
 
 
 
}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpRect}}, \code{\link{kpSegments}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpAddCytobandLabels.R
\name{kpAddCytobandLabels}
\alias{kpAddCytobandLabels}
\title{kpAddCytobandLabels}
\usage{
kpAddCytobandLabels(karyoplot, cex=0.5, force.all=FALSE, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(karyoplot object) A valid karyoplot object created by a call to \code{\link{plotKaryotype}}}

\item{cex}{(numeric) The cex parameter for the cytoband labels}

\item{force.all}{(boolean) If true, all cytoband labels are plotted, even if they do not fit into the cytobands (Defaults to FALSE)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the name will be not drawn out of the drawing are (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the labels may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{Any other parameter to be passed to internal function calls. Specially useful for graphic parameters.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Plots the base numbers along the chromosome ideograms
}
\details{
This function can be used to add labels idenfifying the cytobands. It gets the
labels from the cytobands information stored in the karyoplot object and it will
only plot the labels that fit inside the available space. This means than in some 
cases (such as when plotting a complete genome with default parameters) it is 
possible that no labels at all are added.
}
\examples{
  
kp <- plotKaryotype()
kpAddBaseNumbers(kp)
kpAddCytobandLabels(kp)

kp <- plotKaryotype(chromosomes="chr17")
kpAddBaseNumbers(kp, tick.dist=10000000, minor.tick.dist=1000000)
kpAddCytobandLabels(kp)

 
}
\seealso{
\code{\link{plotKaryotype}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getVariantsColors.R
\name{getVariantsColors}
\alias{getVariantsColors}
\title{getVariantsColors}
\usage{
getVariantsColors(ref, alt, color.table=NULL, color.schema=c("cell21breast"))
}
\arguments{
\item{ref}{(character vector) The reference nucleotides of the variants. It has to have the same length as \code{alt}.}

\item{alt}{(character vector) The alternative nucleotides of the variants. It has to have the same length as \code{ref}}

\item{color.table}{(named character vector) if present, its used to assign colors to the nucleotide substitutions.}

\item{color.schema}{(character) The name of the color schema to use: \code{cell21breast} (the color schema used in "Mutational Processes Molding the Genomes of 21 Breast Cancers" by S. Nik-Zainal, Cell, 2012). (defaults to \code{cell21breast})}
}
\value{
a named character vector with the colors associated to each variant
}
\description{
Given the reference and alternative for a set of variants, assigns a color 
to each of them
}
\details{
The function creates an nucleotide substitution identifier with for each 
variant and uses it to query the color.table lookup table. If color.table
is NULL, a color.table based in the selected color.schema is used. All 
unkwonwn nucleotide substitutions are assigned a gray color. Color table 
needs to have entries for C>A, C>G, C>T, T>A, T>C and T>G (and optionally 
"others"), since other changes can be reverse complemented to these.
}
\examples{
 
ref <- c("A", "A", "C", "T", "G", "A")
alt <- c("G", "C", "T", "A", "A", "-")
getVariantsColors(ref, alt)

col.table <- c("C>A"="#FF0000", "C>G"="#000000", "C>T"="#00FF00", "T>A"="#0000FF", "T>C"="#BB00BB", "T>G"="#00BBBB", "other"="#888888")
getVariantsColors(ref, alt, col.table)


}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpPlotRainfall}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpPlotMarkers.R
\name{kpPlotMarkers}
\alias{kpPlotMarkers}
\title{kpPlotMarkers}
\usage{
kpPlotMarkers(karyoplot, data=NULL, chr=NULL, x=NULL, y=0.75, labels=NULL, 
                     adjust.label.position=TRUE,  ignore.chromosome.ends=FALSE,
                     label.margin=0.001, max.iter=150, label.dist=0.001,
                     marker.parts = c(0.8,0.1, 0.1), text.orientation ="vertical",
                     ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL,
                     line.color="black", label.color="black",
                     pos=NULL, srt=NULL, offset=NULL, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{GRanges}) A GRanges object with the data. If \code{data} is present, \code{chr} will be set to \code{seqnames(data)} and \code{x} to the midpoints of the rages in data. If no parameter \code{y} is specified and \code{data} has a column named \code{y} or \code{value} this column will be used to define the \code{y} value of each data point. (defaults to NULL)}

\item{chr}{(a charecter vector) A vector of chromosome names specifying the chromosomes of the data points. If \code{data} is not NULL, \code{chr} is ignored. (defaults to NULL)}

\item{x}{(a numeric vector) A numeric vector with the positions (in base pairs) of the data points in the chromosomes. If \code{data} is not NULL, \code{x} is ignored. (defaults to NULL)}

\item{y}{(a numeric vector) A numeric vector with the values of the data points. If \code{y} is not NULL, it is used instead of any data column in \code{data}. (defaults to 0.75)}

\item{labels}{(a character vector) The labels to be plotted. (defaults to NULL)}

\item{adjust.label.position}{(logical) whether to adjust the label positions to avoid label overlapping (defaults to TRUE)}

\item{ignore.chromosome.ends}{(logical) If TRUE, when adjusting label position marker labels can move beyond the chromosome ends. (defaults to FALSE, do not move out of origin chromosome)}

\item{label.margin}{(numeric) The vertical margin to leave between the ens of the marker line and the marker label. In plot coordinates. (defaults to 0.001)}

\item{max.iter}{(numeric) The maximum number of iterations in the iterative algorithm to adjust the label positioning. (defaults to 150)}

\item{label.dist}{(numeric) The minimum distance between labels to consider them as non-overlapping (defaults to 0.001)}

\item{marker.parts}{(numeruc vector of three elements) The portion of the distance between 0 and y to be filled with a: vertical, diagonal of vertical part of the marker line. (defaults to c(0.8,0.1,0.1), long vertical stem, small diagonal and small vertical on top)}

\item{text.orientation}{("vertical" or "horizontal) How should the text be plotted. Forced values of srt and pos take precedence. (defaults to "vertical")}

\item{ymin}{(numeric) The minimum value of \code{y} to be plotted. If NULL, it is set to the min value of the selected data panel. (defaults to NULL)}

\item{ymax}{(numeric) The maximum value of \code{y} to be plotted. If NULL, it is set to the max value of the selected data panel. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{line.color}{(color) The color of marker line. (defaults to "black")}

\item{label.color}{(color) The color of the label (defaults to "black")}

\item{pos}{(1,2,3,4) The standard pos graphical parameter. If NULL, it's automatically set depending on "text.orientation". (defaults to NULL)}

\item{srt}{(numeric) The standard srt graphical parameter. If NULL, it's automatically set depending on "text.orientation". (defaults to NULL)}

\item{offset}{(numeric) The standard offset graphical parameter. If NULL, it's automatically set depending on "text.orientation". (defaults to NULL)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object with the data computed (adjusted label positioning) stored at \code{karyoplot$latest.plot}
}
\description{
Plots markers on the genome as a line with a label on top.
}
\details{
This function plots markers on the genome. It implements an interative
algorithm to avoid ovelapping between the labels of different markers. Since
labels might be plotted in a different position than the original points, 
a line with three parts (a vertical, a diagonal and another vertical) is 
plotted to link the label with the original position. It is possible to plot
labels in horizontal or vertical text and to specify different colors for the
marker line and label.

There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
}
\note{
The iterative algorithm is not guaranteed to suceed and might end up
with overlapping labels if labels are too dense or if too few iterations 
allowed. With many markers, the algorithm might be slow.
}
\examples{
 

data <- toGRanges(data.frame(c("chr1", "chr1", "chr1"), c(20e6, 21e6, 22e6), c(20.01e6, 21.01e6, 22.01e6), labels=c("GeneA", "GeneB", "GeneC")))

kp <- plotKaryotype("hg19", plot.type=1, chromosomes = "chr1", main="Default markers")
kpPlotMarkers(kp, data)

kp <- plotKaryotype("hg19", plot.type=2, chromosomes = "chr1", main="Markers Horizontal")
kpPlotMarkers(kp, data, text.orientation = "horizontal")
kpPlotMarkers(kp, data, text.orientation = "horizontal", label.dist = 0.02, data.panel=2)

kp <- plotKaryotype("hg19", plot.type=2, chromosomes = "chr1", main="Different Marker parts")
kpPlotMarkers(kp, data, text.orientation = "horizontal", marker.parts=c(0, 1, 0), line.color="red")
kpPlotMarkers(kp, data, text.orientation = "horizontal", marker.parts=c(0.1, 0.2, 0.4), label.dist = 0.02, data.panel=2, label.color="blue")


 
}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpLines}}, \code{\link{kpText}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpAddCytobandsAsLine.R
\name{kpAddCytobandsAsLine}
\alias{kpAddCytobandsAsLine}
\title{kpAddCytobandsAsLine}
\usage{
kpAddCytobandsAsLine(karyoplot, color.table=NULL, color.schema='only.centromeres', lwd=3, lend=1, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{a \code{karyoplot} object returned by a call to \code{plotKaryotype}}

\item{color.table}{(named character vector) a table specifying the colors to plot the cytobands. If NULL, it gets the colors calling \code{getCytobandColors}. (defaults to NULL)}

\item{color.schema}{(character: 'only.centromeres', 'circos', 'biovizbase') The name of the color schema to use. It is directly passed along to \code{\link{getCytobandColors}}. \code{color.table} takes precendence over \code{color.schema}. (defaults to 'only.centromeres')}

\item{lwd}{(integer) The width of the line used to represent the ideogram (defaults to 3)}

\item{lend}{(0, 1 or 2) The type of line end. (defaults to 1, "butt")}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, cytoband representation will be not drawn out of the drawing are (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the cytobands representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{any additional parameter to be passed to the functions called from kpAddCytobands.}
}
\value{
invisibly returns the given karyoplot object
}
\description{
Plots the chromosome cytobands in a karyoplot as a line
}
\details{
Plots the cytobands representing the chromosome structure in a karyoplot. It extracts the 
cytobands from the \code{karyoplot} object it recieves as a parameter. It is possible to 
specify the colors used to plot the cytobands. In contrast to \code{\link{kpAddCytobands}}
it represents the chromosomes as a thin line
}
\note{
In general, this function is automatically called by plotKaryotype
and the user never needs to call it.
}
\examples{


kp <- plotKaryotype(ideogram.plotter = NULL)
kpAddCytobandsAsLine(kp)
 
kp <- plotKaryotype(ideogram.plotter = NULL, plot.type=2)
kpAddCytobandsAsLine(kp)
 
}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{getCytobandColors}}, \code{\link{kpAddBaseNumbers}}, \code{\link{kpAddCytobandLabels}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpPlotBigWig.R
\name{kpPlotBigWig}
\alias{kpPlotBigWig}
\title{kpPlotBigWig}
\usage{
kpPlotBigWig(karyoplot, data, ymin=NULL, ymax="global", data.panel=1, r0=NULL, r1=NULL, col=NULL, border=NULL, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{BigWigFile} or character) The path to a bigwig file (either local or a URL to a remote file) or a \code{BigWigFile} object.}

\item{ymin}{(numeric) The minimum value to be plotted on the data panel. If NULL, the minimum between 0 and the minimum value in the WHOLE GENOME will be used. (deafults to NULL)}

\item{ymax}{(numeric or c("global", "per.chr", "visible.region")) The maximum value to be plotted on the data.panel. It can be either a numeric value or one of c("global", "per.chr", "per.region"). "Global" will set ymax to the maximum value in the whole data file. "per.chr" will set ymax to the maximum value in each chromosome. "visible.region" will set ymax to the maximum value in the visible region. (defaults to "global")}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{col}{(color) The fill color of the area. A single color. If NULL the color will be assigned automatically, either a lighter version of the color used for the outer line or gray if the line color is not defined. If NA no area will be drawn. (defaults to NULL)}

\item{border}{(color) The color of the line enclosing the area. A single color. If NULL the color will be assigned automatically, either a darker version of the color used for the area or black if col=NA. If NA no border will be drawn. (Defaults to NULL)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object with the data computed (ymax and ymin values used) stored at \code{karyoplot$latest.plot}
}
\description{
Plots the wiggle values in a BigWig file. This function does not work on windows.
}
\details{
\code{kpPlotBigWig} plots the data contained in a binary file format called 
BigWig. BigWig are used to efficiently store numeric values computed for 
windows covering the whole genome, ususally the coverage from an NGS 
experiment such as ChIP-seq. Only data required for the plotted region
is loaded, and when more than one chromosome is visible, it will load the
data for one crhomosome at a time.
The function accepts either a \code{\link{BigWigFile}} oject or a 
\code{character} with the path to a valid big wig file. The character can 
also be a URL to a remote server. In this case data will be loaded 
transparently using the \code{import} function from 
\code{rtracklayer}.  
The data is plotted using \code{\link{kpArea}} and therefore it is possible
to plot as a single line, a line with shaded area below or as a shaded area 
only adjusting the \code{col} and \code{border} parameters.
}
\note{
Since this functions uses \code{rtracklayer} BigWig infrastructure and it does not work on windows, this function won't work on windows either.
}
\examples{

if (.Platform$OS.type != "windows") {
  bigwig.file <- system.file("extdata", "BRCA.genes.hg19.bw", package = "karyoploteR")
  brca.genes.file <- system.file("extdata", "BRCA.genes.hg19.txt", package = "karyoploteR")
  brca.genes <- toGRanges(brca.genes.file)
  library(GenomeInfoDb)  # for seqlevelsStyle()
  seqlevelsStyle(brca.genes) <- "UCSC"

  kp <- plotKaryotype(zoom = brca.genes[1])
  kp <- kpPlotBigWig(kp, data=bigwig.file, r0=0, r1=0.2)
  kp <- kpPlotBigWig(kp, data=bigwig.file, r0=0.25, r1=0.45, border="red", lwd=2)
  kp <- kpPlotBigWig(kp, data=bigwig.file, r0=0.5, r1=0.7, ymin=0, ymax=1000, border="gold", col=NA)
  kpAxis(kp, r0=0.5, r1=0.7, ymin=0, ymax=1000)
  kp <- kpPlotBigWig(kp, data=bigwig.file, r0=0.75, r1=0.95, ymin=0, ymax="visible.region", border="orchid", col=NA)
  kpAxis(kp, r0=0.75, r1=0.95, ymin=0, ymax=kp$latest.plot$computed.values$ymax)
}


}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpArea}}, \code{\link{kpPlotBAMDensity}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpAddBaseNumbers.R
\name{kpAddBaseNumbers}
\alias{kpAddBaseNumbers}
\title{kpAddBaseNumbers}
\usage{
kpAddBaseNumbers(karyoplot, tick.dist=20000000, tick.len=5, units="auto", add.units=FALSE, digits=2, minor.ticks=TRUE, minor.tick.dist=5000000, minor.tick.len=2,  cex=0.5, tick.col=NULL, minor.tick.col=NULL, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(karyoplot object) A valid karyoplot object created by a call to \code{\link{plotKaryotype}}}

\item{tick.dist}{(numeric) The distance between the major numbered tick marks in bases (defaults to 20 milions, one major tick every 20Mb)}

\item{tick.len}{(numeric) The length of the major tick marks in plot coordinates (defaults to 5)}

\item{units}{(character) the units for the numbers to be represented. Must be one of "auto", "b", "kb" or "Mb". If auto, it will utomatically choose the most suitable unit. (Defaults to "auto")}

\item{add.units}{(boolean) Add the units (Mb, Kb...) to the tick labels. (Defaults to FALSE)}

\item{digits}{(integer) The maximum number of digits after the decimal point in labels. (defaults to 2)}

\item{minor.ticks}{(boolean) Whether to add unlabeled minor ticks between the major ticks (defaults to TRUE)}

\item{minor.tick.dist}{(numeric) The distance between the minor ticks in bases (defaults to 5 milions, a minor tick mark every 5Mb)}

\item{minor.tick.len}{(numeric) The length of the minor tick marks in plot coordinates (defaults to 2)}

\item{cex}{(numeric) The cex parameter for the major ticks label (defaults to 0.5)}

\item{tick.col}{(color) If specified, the color to plot the major ticks. Otherwise the default color or, if given, the col parameter will be used. (Defaults to NULL)}

\item{minor.tick.col}{(color) If specified, the color to plot the minor ticks. Otherwise the default color or, if given, the col parameter will be used. (Defaults to NULL)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{Any other parameter to be passed to internal function calls. Specially useful for graphic parameters.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Plots the base numbers along the chromosome ideograms
}
\details{
This function can be used to add the base numbers scale to the chromosome ideograms.
The base numbers and ticks will be drawn next to the ideograms and not on a separate
independent x axis. It is possible to control the number and position of the tick
marks and labels
}
\examples{
 

kp <- plotKaryotype()
kpAddBaseNumbers(kp)

kp <- plotKaryotype(chromosomes="chr17")
kpAddBaseNumbers(kp, tick.dist=10000000, minor.tick.dist=1000000)


 
}
\seealso{
\code{\link{plotKaryotype}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpPlotNames.R
\name{kpPlotNames}
\alias{kpPlotNames}
\title{kpPlotNames}
\usage{
kpPlotNames(karyoplot, data=NULL, chr=NULL, x0=NULL, x1=x0, y0=NULL, y1=NULL, labels=NULL, position="left", ymax=NULL, ymin=NULL, r0=NULL, r1=NULL,  data.panel=1, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{GRanges}) A GRanges object with the data. If \code{data} is present, \code{chr} will be set to \code{seqnames(data)}, \code{x0} to \code{start(data)} and x1 to \code{end(data)}. If no parameter \code{y0} is specified and \code{data} has a column named \code{y0}, this column will be used. The same for \code{y1}. (defaults to NULL)}

\item{chr}{(a charecter vector) A vector of chromosome names specifying the chromosomes of the data points. If \code{data} is not NULL, \code{chr} is ignored. (defaults to NULL)}

\item{x0}{(a numeric vector) A numeric vector of x left positions (in base pairs). If \code{data} is not NULL, \code{x0}. (defaults to NULL)}

\item{x1}{(a numeric vector) A numeric vector of x right positions (in base pairs). If \code{data} is not NULL, \code{x1}. (defaults to NULL)}

\item{y0}{(a numeric vector) A numeric vector of y bottom positions. If \code{y} is not NULL, it is used instead of any data column in \code{data}. (defaults to NULL)}

\item{y1}{(a numeric vector) A numeric vector of y top positions. If \code{y} is not NULL, it is used instead of any data column in \code{data}. (defaults to NULL)}

\item{labels}{(character) The labels to use in the plot. They will be associated to the rectangles by its order and recycled as needed.}

\item{position}{(character) The position of the text relative to the rectangle. Can be "left", "right", "top", "bottom" or "center". Defaults to "left".}

\item{ymax}{(numeric) The maximum value of \code{y} to be plotted. If NULL, it is set to the max value of the selected data panel. (defaults to NULL)}

\item{ymin}{(numeric) The minimum value of \code{y} to be plotted. If NULL, it is set to the min value of the selected data panel. (defaults to NULL)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Plots text labels with positioning relative to rectangles along the genome.
}
\details{
This is a simple wrapper around \code{\link{kpText}} that positions the 
 text relative to the rectangles defined by its arguments. They may be
 used to name or label different graphical elements in the plot.
 The rectangles may be specified as in \code{\link{kpRect}} the relative 
 positions accepted are: "left", "right", "top", "bottom", "center". 
 It is possible to specify and empty label (\code{labels=""}) to leave an
 element without name.
}
\examples{
 
 
 regs <- toGRanges(data.frame(chr=c("chr1", "chr1", "chr1"),
                  start=c(20e6, 100e6, 200e6),
                  end=c(40e6, 170e6, 210e6),
                  y0=c(0.1, 0.5, 0.7),
                  y1=c(0.5, 0.6, 0.95)))
 
 kp <- plotKaryotype(genome="hg19", chromosomes="chr1")
 kpRect(kp, data=regs)  
 
 kpPlotNames(kp, data=regs, labels=c("R1", "R2", "R3"))
 kpPlotNames(kp, data=regs, labels=c("R1", "R2", "R3"), position="top", cex=2)    
 kpPlotNames(kp, data=regs, labels=c("R1", "", "R3"), position="right", col="red")
 kpPlotNames(kp, data=regs, labels="bottom", position="bottom", col=rainbow(3))
 kpPlotNames(kp, data=regs, labels="o", position="center", col=rainbow(3), cex=1)                
 
}
\seealso{
\code{\link{kpText}}, \code{\link{kpRect}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpAddLabels.R
\name{kpAddLabels}
\alias{kpAddLabels}
\title{kpAddLabels}
\usage{
kpAddLabels(karyoplot, labels, label.margin=0.01,  side="left", pos=NULL, offset=0, r0=NULL, r1=NULL, data.panel=1, ...)
}
\arguments{
\item{karyoplot}{a \code{karyoplot} object returned by a call to \code{plotKaryotype}}

\item{labels}{(character) the text on the labels}

\item{label.margin}{(numeric) the additional the margin between the labels the first base of the chromosome. In plot coordinates. Usual value might be 0.05. Can be negative. (defaults to 0.01)}

\item{side}{("left" or "right") The side of the plot where to plot the labels. (defaults to "left")}

\item{pos}{(numeric) The standard graphical parameter. See \code{\link[graphics]{text}}. If NULL, pos will be selected automatically based on "side" (Defaults to NULL)}

\item{offset}{(numeric) The standard graphical parameter. See \code{\link[graphics]{text}}. (Defaults to 0)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to position the label. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to position the label. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the labels are to be added. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{...}{any additional parameter to be passed to the text plotting. All R base graphics params are passed along.}
}
\value{
invisibly returns the given karyoplot object
}
\description{
Add labels to identify the data in the plot
}
\details{
Given a KaryoPlot object, plot labels on the side of the data panels to help identify the different types of data plotted
}
\examples{

plot.params <- getDefaultPlotParams(plot.type=2)
plot.params$leftmargin <- 0.2
plot.params$rightmargin <- 0.2

#In standard whole karyotypes, labels are drawn for all chromosomes

kp <- plotKaryotype("hg19", chromosomes=c("chr1", "chr2"), plot.type=2, plot.params = plot.params)
#data panel 1
kpDataBackground(kp, r0=0, r1=0.5, col="#FFDDDD")
kpDataBackground(kp, r0=0.5, r1=1, col="#DDFFDD")
kpAddLabels(kp, "Everything", label.margin = 0.12, srt=90, pos=3, cex=0.8)
kpAddLabels(kp, "Red", r0=0, r1=0.5, cex=0.6)
kpAddLabels(kp, "Green", r0=0.5, r1=1, cex=0.6)
#data panel 2
kpDataBackground(kp, col="#DDDDFF", data.panel = 2)
kpAddLabels(kp, "BLUE", data.panel=2)

#Plot on the right
#data panel 1
kpAddLabels(kp, "Everything", label.margin = 0.12, srt=90, pos=1, cex=0.8, side="right")
kpAddLabels(kp, "Red", r0=0, r1=0.5, cex=0.6, side="right")
kpAddLabels(kp, "Green", r0=0.5, r1=1, cex=0.6, side="right")
 
 
 
#In karyotypes with all chromosomes in a single line, 
#labels are added on the first (side="left") or last (side="right") chromosome

kp <- plotKaryotype("hg19", chromosomes=c("chr1", "chr2", "chr3"), plot.type=3, plot.params = plot.params)
#data panel 1
kpDataBackground(kp, r0=0, r1=0.5, col="#FFDDDD")
kpDataBackground(kp, r0=0.5, r1=1, col="#DDFFDD")
kpAddLabels(kp, "Everything", label.margin = 0.12, srt=90, pos=3, cex=0.8)
kpAddLabels(kp, "Red", r0=0, r1=0.5, cex=0.6)
kpAddLabels(kp, "Green", r0=0.5, r1=1, cex=0.6)
#data panel 2
kpDataBackground(kp, col="#DDDDFF", data.panel = 2)
kpAddLabels(kp, "BLUE", data.panel=2)

#Plot on the right
#data panel 1
kpAddLabels(kp, "Everything", label.margin = 0.12, srt=90, pos=1, cex=0.8, side="right")
kpAddLabels(kp, "Red", r0=0, r1=0.5, cex=0.6, side="right")
kpAddLabels(kp, "Green", r0=0.5, r1=1, cex=0.6, side="right")



#In Zoomed regions, they are placed at the correct position too
kp <- plotKaryotype("hg19", zoom="chr1:20000000-40000000", plot.type=2, plot.params = plot.params)
kpAddBaseNumbers(kp, tick.dist=5000000, add.units=TRUE)
#data panel 1
kpDataBackground(kp, r0=0, r1=0.5, col="#FFDDDD")
kpDataBackground(kp, r0=0.5, r1=1, col="#DDFFDD")
kpAddLabels(kp, "Everything", label.margin = 0.12, srt=90, pos=3, cex=0.8)
kpAddLabels(kp, "Red", r0=0, r1=0.5, cex=0.6)
kpAddLabels(kp, "Green", r0=0.5, r1=1, cex=0.6)
#data panel 2
kpDataBackground(kp, col="#DDDDFF", data.panel = 2)
kpAddLabels(kp, "BLUE", data.panel=2)

#Plot on the right
#data panel 1
kpAddLabels(kp, "Everything", label.margin = 0.12, srt=90, pos=1, cex=0.8, side="right")
kpAddLabels(kp, "Red", r0=0, r1=0.5, cex=0.6, side="right")
kpAddLabels(kp, "Green", r0=0.5, r1=1, cex=0.6, side="right")




}
\seealso{
\code{\link{plotKaryotype}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/text.R
\name{getTextSize}
\alias{getTextSize}
\title{getTextSize}
\usage{
getTextSize(karyoplot, labels, cex=1, data.panel="1")
}
\arguments{
\item{karyoplot}{(KaryoPlot) A KaryoPlot object representing the current plot}

\item{labels}{(character) The character strings to measure}

\item{cex}{(numeric) The cex value used to plot the text (defaults to 1)}

\item{data.panel}{(data panel identifier) The name of the data panel on which text was plotted. (defaults to "1")}
}
\value{
Returns a list with two elements: width and height. Each of them is a numeric
vector of the same length as "labels" with the width in bases of each label
and the height in r units of each label.
}
\description{
Returns the size of character strings in bases and r's
}
\details{
Small utility function to get the size of text labels in usable units for
karyoploteR: bases for the width and r's for the height. The r units are the
ones passed to r0 and r1 and take into account that a data panel has always
total height of 1 r (from r0=0 to r1=1)
}
\examples{

pp <- getDefaultPlotParams(plot.type=2)
pp$data2height <- 50

kp <- plotKaryotype(chromosomes="chr1", plot.type=2, plot.params=pp)
 
label <- "Looooooong label"
kpText(kp, chr="chr1", x=70e6, y=0.5, labels=label)
text.size <- getTextSize(kp, labels=label)
kpRect(kp, chr="chr1", x0=70e6-text.size$width/2, x1=70e6+text.size$width/2,
           y0=0.5-text.size$height/2, y1=0.5+text.size$height/2)
 
label <- "SHORT"
text.size <- getTextSize(kp, labels=label, cex=3)
kpRect(kp, chr="chr1", x0=170e6-text.size$width/2, x1=170e6+text.size$width/2,
           y0=0.2-text.size$height/2, y1=0.2+text.size$height/2, col="gold")
kpText(kp, chr="chr1", x=170e6, y=0.2, labels=label, cex=3)
    
label <- c("two_labels", "in a small data.panel=2")
kpText(kp, chr="chr1", x=c(100e6, 170e6), y=c(0.4, 0.2), labels=label, cex=0.6, data.panel=2)
text.size <- getTextSize(kp, labels=label, cex=0.6, data.panel=2)
kpRect(kp, chr="chr1", x0=c(100e6, 170e6)-text.size$width/2, x1=c(100e6, 170e6)+text.size$width/2,
           y0=c(0.4, 0.2)-text.size$height/2, y1=c(0.4, 0.2)+text.size$height/2, data.panel=2)

    
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{findIntersections}
\alias{findIntersections}
\title{findIntersections}
\usage{
findIntersections(data, thr)
}
\arguments{
\item{data}{(GRanges with y mcol) A GRanges with the data points}

\item{thr}{(numeric) The value at wich we want to calculate the intersections}
}
\value{
A GRanges representing the intersection points between the data line and the threshold.
It will return an empty GRanges if the line does not intersect the threshold.
}
\description{
Finds the intersections of a data line with a given threshold
}
\details{
Given a GRanges with an mcol with name "y" representing the values. This function
will return a GRanges with the points intersecting a specific value "thr".
}
\note{
Important: It will only return the intersection points where the line crosses
 the threshold but not if a data point lies exactly at the threshold.
}
\examples{

d <- toGRanges(c("1:1-1", "1:5-5", "1:15-15"))
d$y <- c(-2, 3, 1)
 
findIntersections(d, 1.5)  
findIntersections(d, 0)  
findIntersections(d, 5)  

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpPlotDensity.R
\name{kpPlotDensity}
\alias{kpPlotDensity}
\title{kpPlotDensity}
\usage{
kpPlotDensity(karyoplot, data=NULL, window.size=1e6, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{GRanges}) A GRanges object from which the density will be computed.}

\item{window.size}{(numeric) The size of the windows for wich the density is computed. (Defaults to 1e6, one megabase windows)}

\item{ymin}{(numeric) The minimum value to be plotted on the data panel. If NULL, it is set to 0. (deafults to NULL)}

\item{ymax}{(numeric) The maximum value to be plotted on the data.panel. If NULL the maximum density is used. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions. In particular \code{col} and \code{border} can be used to set the colors used.}
}
\value{
Returns the original karyoplot object with the data computed (windows and density) stored at \code{karyoplot$latest.plot}
}
\description{
Plots the density of features along the genome
}
\details{
\code{kpPlotDensity} plots the density of a set of features represented by a 
\code{GRanges} object along the genome. It creates a non-overlapping tiling 
of the genome and computes the number of features per window. It's possible 
to specify the window size.

There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
}
\examples{

set.seed(1000)

data <- createRandomRegions(nregions=20000)
 
kp <- plotKaryotype("hg19", plot.type=2, chromosomes="chr1")

kp <- kpPlotDensity(kp, data)
kpAxis(kp, ymin = 0, ymax=kp$latest.plot$computed.values$max.density)

kp <- kpPlotDensity(kp, data, data.panel=2, col="#CCCCFF",  ymax=20, lwd=2)
kpAxis(kp, ymin = 0, ymax=20, data.panel=2)

kp <- kpLines(kp, data=kp$latest.plot$computed.values$windows, y=kp$latest.plot$computed.values$density, col="black", r0=0.5, r1=1, data.panel=2, ymax=20)

}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpPlotRibbon}}, \code{\link{kpPlotCoverage}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{autotrack}
\alias{autotrack}
\title{autotrack}
\usage{
autotrack(current.track, total.tracks, margin=0.05, r0=0, r1=1)
}
\arguments{
\item{current.track}{(numeric) The track or tracks the current plot will occupy, starting from 1. If more than one value is provided, the plot will expand from min(current.track) to max(current.track).}

\item{total.tracks}{(numeric) The total number of tracks}

\item{margin}{(numeric) The margin is specified as the part of a track, by default 0.05, 5 percent of the track height.}

\item{r0}{(numeric) the original r0}

\item{r1}{(numeric) the original r1}
}
\value{
A list of two numerics: r0 and r1
}
\description{
Computes r0 and r1 given track definition
}
\details{
Small utility function to help compute r0 and r1 given the total number of tracks 
and the track(s) the current plot will occupy. It also takes into account a margin
between tracks and original r0 and r1, so we can say something like, "Out of 5 
tracks between 0 and 0.5, this plot will be at track 2", and it will return
r0=0.1 and r1=0.2
}
\examples{

#first track out of 4  
autotrack(1, 4)

#the same, but without margin
autotrack(1, 4, 0)

#first and second tracks out of 4
autotrack(c(1,2), 4)

#The first track out of 4, fitting the four track between 0 and 0.5
autotrack(1, 4, r0=0, r1=0.5)
 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpAddMainTitle.R
\name{kpAddMainTitle}
\alias{kpAddMainTitle}
\title{kpAddMainTitle}
\usage{
kpAddMainTitle(karyoplot, main=NULL, ...)
}
\arguments{
\item{karyoplot}{a \code{karyoplot} object returned by a call to \code{plotKaryotype}}

\item{main}{(character) the main title of the plot}

\item{...}{any additional parameter to be passed to the text plotting. All R base graphics params are passed along.}
}
\value{
invisibly returns the given karyoplot object
}
\description{
Plots the chromosome names in the karyoplot
}
\details{
Given a KaryoPlot object and a character string, plot the character strings
as the main title of the plot. This function is usually automatically
called by plotKaryotype unless.
}
\examples{

kp <- plotKaryotype(labels.plotter = NULL)
kpAddMainTitle(kp, col="red", srt=30)
 
}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{getMainTitleBoundingBox}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genes.R
\name{addGeneNames}
\alias{addGeneNames}
\title{addGeneNames}
\usage{
addGeneNames(genes.data, orgDb="auto", keys=NULL, keytype="ENTREZID", names="SYMBOL")
}
\arguments{
\item{genes.data}{(GenesData object) A valid genes.dat object like the ones obtained by \code{\link{makeGenesDataFromTxDb}}}

\item{orgDb}{The orgDb object to use to extract the gene symbols. If "auto" the function will try to determine automatically the correct organism. See available obects at https://bioconductor.org/packages/release/BiocViews.html#___OrgDb (defaults to "auto")}

\item{keys}{(character vector ) The keys to be used in the internal select statement to get the names. If NULL, the first column of \code{mcols(GenesData$genes)} will be used. (defaults to NULL)}

\item{keytype}{(character) The keytype used in the internal select statement. (defaults to "ENTREZID", that is, gene_id)}

\item{names}{The column to extract from orgDb to use as gene names. (deafults to "SYMBOL")}
}
\value{
The original GenesData object with one additional column named "names" in 
\code{GenesData$genes$names}.
}
\description{
Adds the gene names (defaults to symbols) to a GenesData object to 
be used by kpPlotGenes
}
\details{
This function takes a valid data object and uses an OrgDb object to 
find the gene names (symbols by default) and add them. Names are added 
as a column named \code{names} to the \code{genes} element of GenesData 
and they replace anything that was present there before.
If no \code{ObjDb} object is given, the function will try to identify
the correct organism using the data in \code{GenesData$metadata} and
select the OrgDb object if available. If it cannot identify the organism 
or there's no valid OrgDb for that organism it will fail with an error.
Internally, the function uses a call to \code{AnnotationDbi::select} on
the OrgDb. It is possible to specify the keys and keytypes as well as
the column we want to use as names (defaults to SYMBOL for gene symbols).
}
\examples{
 

library(TxDb.Hsapiens.UCSC.hg19.knownGene)

zoom <- toGRanges("chr17:29e6-30e6")
kp <- plotKaryotype(genome="hg19", zoom=zoom)
genes.data <- makeGenesDataFromTxDb(TxDb.Hsapiens.UCSC.hg19.knownGene, 
                 karyoplot=kp, plot.transcripts=FALSE,
                 plot.transcripts.structure=FALSE)
genes.data <- addGeneNames(genes.data)
kpPlotGenes(kp, data=genes.data, r1=0.5, plot.transcripts=FALSE,
            gene.name.position = "left")
 
  
}
\seealso{
\code{\link{kpPlotGenes}}, \code{\link{makeGenesDataFromTxDb}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/color.R
\name{colByRegion}
\alias{colByRegion}
\title{colByRegion}
\usage{
colByRegion(data, regions, colors=NULL, original.colors=NULL, default.col="black")
}
\arguments{
\item{data}{Either a vector of characters or a GRanges object}

\item{regions}{(GRanges or equivalent) A set of regions where the color will be modified. Internally it will be converted into a Genomic Ranges object by \code{\link[regioneR]{toGRanges}} (from regioneR package) and so it can be either a GRanges, a data.frame, a character or any other value type accepted by that function. If \code{colors} is NULL (the default) and regions has additional columns in addition to chr, start and end, if any has a name in c("color", "colors", "col", "cols") it will be used. Otherwise the first additional column will be used.}

\item{colors}{(color) The colors to be used for each region. The content will be recycled if needed. If NULL, the colors are assumed to be available in the regions object. (defaults to NULL)}

\item{original.colors}{(color vector) The original colors of the data points. They will be use instead of the default color for data points not overlapping the regions. If NULL, the default color will be used. (defaults to NULL)}

\item{default.col}{The default color to return for data elements not overlapping the regions. Only used if original.colors is NULL (defaults to "black")}
}
\value{
A vector of colors
}
\description{
Given a set of data elements, return a color for each one based on whether 
they overlap a given set of regions. This might be useful, for example,  to
set a different color for data points overlapping a certain region of
interest.
}
\details{
Given a set of data elements, return a color for each one based on whether 
they overlap a given set of regions. The colors might be different for each
region and can be specified either in the regions object itself or in 
a separate \code{colors} parameter. If specified in \code{colors}, the values
will be recycled as needed. Data points not in the specified region can
take either a default color or keep their "original.color" if given. This
is useful when using colByRegion to highlight data points as in 
kpPlotManhattan.
}
\examples{

data <- toGRanges("chr1", c(1e6*1:245), c(1e6*1:245)+10)
data$y <- rnorm(n = length(data), mean = 0.5, sd = 0.15)

regions <- toGRanges(c("chr1:10e6-20e6", "chr1:100e6-150e6"))
regions$col <- c("red", "blue")

kp <- plotKaryotype(chromosomes="chr1")
kpPoints(kp, data=data, r0=0, r1=0.2)
kpPoints(kp, data=data, r0=0.2, r1=0.4, col=colByRegion(data, regions = regions) )
kpText(kp, data=data, r0=0.4, r1=0.6, col=colByRegion(data, regions = regions), label="A", cex=0.5 )
kpBars(kp, data=data, y0=0, y1=data$y, r0=0.6, r1=0.8, border=colByRegion(data, regions = regions))
#It might not work wor objects where R expects a single color such as lines. Segments should be used instead
kpLines(kp, data=data, r0=0.8, r1=1, col=colByRegion(data, regions = regions) )


kp <- plotKaryotype(chromosomes="chr1")
kpPoints(kp, data=data, r0=0, r1=0.25)
kpPoints(kp, data=data, r0=0.25, r1=0.5, col=colByRegion(data, regions = regions, colors="green") )
kpText(kp, data=data, r0=0.5, r1=0.75, col=colByRegion(data, regions = regions, color=c("gray", "gold")), label="A", cex=0.5 )
kpBars(kp, data=data, y0=0, y1=data$y, r0=0.75, r1=1, border=colByRegion(data, regions = regions))

}
\seealso{
\link{kpPoints}, \link{colByChr}, \link[regioneR]{toGRanges}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpPlotLinks.R
\name{kpPlotLinks}
\alias{kpPlotLinks}
\title{kpPlotLinks}
\usage{
kpPlotLinks(karyoplot, data, data2=NULL, y=0, arch.height=NULL, data.panel=1, r0=NULL, r1=NULL, ymin=NULL, ymax=NULL, col="#8e87eb", border=NULL, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{GRanges}) A GRanges object with link start regions. If data2 is NULL, mcols(data) should be a bed-like structure with "link.chr", "link.start", "link.end" and optionally a "link.strand" columns. The first thee columns can have any name and the strand information will be extracted from the first column with "strand" in its name.}

\item{data2}{(a \code{GRanges}) A GRanges object with the link end regions. If null, the end of the regions will be extracted from mcols(data). (Defaults to NULL)}

\item{y}{(numeric) The y value where the origin and end of the links should be plotted (Defaults to 0)}

\item{arch.height}{(numeric) The approximate arch height in links in the same chromosome in "y" scale. If NULL, it defaults to the whole span of the data panel.Also affects the curvature of links between chromosomes (Defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{ymin}{(numeric) The minimum value to be plotted on the data panel. If NULL, it is set to 0. (deafults to NULL)}

\item{ymax}{(numeric) The maximum value to be plotted on the data.panel. If NULL the maximum density is used. (defaults to NULL)}

\item{col}{(color) The background color of the links. If NULL and border is specified, it defaults to a lighter version of border.}

\item{border}{(color) The border color of the links. If NULL and col is specified, it defaults to a darker version of col.}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Given 2 \code{GRanges} objects, plot lines or ribbons between region pairs
}
\details{
This is one of the high-level, or specialized, plotting functions of karyoploteR.
 It takes two \code{GRanges} objects (or a single specially crafted one) and
 plots links (either lines or ribbons) between region pairs. Links are 
 plotted bewteen the first region of both objects, between the second one, etc...
 and therefore both objects need to have the same length. Specifying a region
 as negative strand, will "flip" it, so the the start of a region can be 
 linked to the end of its pair.
}
\note{
For a link to be plotted BOTH ends must be visible in the karyoplot. In 
  particular, if a chromosome is not included in the plot (due to not
  being specified in \code{chromosomes}, for example) any link with an end
  on it will NOT be plotted. The same is true for zoomed in plots, where only
  intrachromosomal links will be visible. No warning or message will be
  generated.
}
\examples{
 
 
 set.seed(222)
 
 starts <- sort(createRandomRegions(nregions = 15))
 ends <- sort(createRandomRegions(nregions = 15))
 
 kp <- plotKaryotype()
 kpPlotLinks(kp, data=starts, data2=ends)
 
 #Create larger regions, so they look like ribbons
 starts <- sort(createRandomRegions(nregions = 15, length.mean = 8e6, length.sd = 5e6))
 ends <- sort(createRandomRegions(nregions = 15, length.mean = 8e6, length.sd = 5e6))
 
 kp <- plotKaryotype()
 kpPlotLinks(kp, data=starts, data2=ends)
 
 #flip some of them to represent inversions
 strand(ends) <- sample(c("+", "-"), length(ends), replace = TRUE)
 
 kp <- plotKaryotype()
 kpPlotLinks(kp, data=starts, data2=ends)
 

}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpPlotRibbon}}, \code{\link{kpSegments}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpAddChromosomeSeparators.R
\name{kpAddChromosomeSeparators}
\alias{kpAddChromosomeSeparators}
\title{kpAddChromosomeSeparators}
\usage{
kpAddChromosomeSeparators(karyoplot, col="gray", lty=3, data.panel="all", ...)
}
\arguments{
\item{karyoplot}{a \code{karyoplot} object returned by a call to \code{plotKaryotype}}

\item{col}{(color) The color of the separator lines (defaults to "gray")}

\item{lty}{(integer) The line type of the separators (defaults to 3, dashed lines)}

\item{data.panel}{(data panel specification) For vertical lines, the span of the separator lines. Ignored for horizontal lines. (defaults to "all")}

\item{...}{any additional parameter to be passed to the text plotting. All R base graphics params are passed along.}
}
\value{
invisibly returns the given karyoplot object
}
\description{
Plots between the chromosomes
}
\details{
Depending on the plot type it will draw vertical lines (if all chromosomes
are in a one line (3,4,5,7)) or horizontal lines (1,2,6)

By default the lines will occupy the whole chromsome extent (data.panel="all") 
but using the \code{data.panel} parameter it can be tuned.
}
\examples{

kp <- plotKaryotype(plot.type=4)
kpAddChromosomeSeparators(kp)

kp <- plotKaryotype(plot.type=5, ideogram.plotter=NULL)
kpAddChromosomeSeparators(kp)

kp <- plotKaryotype(plot.type=2)
kpAddChromosomeSeparators(kp, col="red")

 
}
\seealso{
\code{\link{plotKaryotype}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpAxis.R
\name{kpAxis}
\alias{kpAxis}
\title{kpAxis}
\usage{
kpAxis(karyoplot, ymin=NULL, ymax=NULL, r0=NULL, r1=NULL, side=1, numticks=3, labels=NULL, tick.pos=NULL, tick.len=NULL, label.margin=NULL, data.panel=1, text.col="black", col="black", chromosomes="auto", ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{ymin}{(numeric) The minimum value of \code{y} to be plotted. If NULL, it is set to the min value of the selected data panel. (defaults to NULL)}

\item{ymax}{(numeric) The maximum value of \code{y} to be plotted. If NULL, it is set to the max value of the selected data panel. (defaults to NULL)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{side}{(numeric) In which side of the data panel should the axis be plotted. 1 - plot it on the right of the data panel. 2 - Plot it on the left. (defualts to 1)}

\item{numticks}{(numeric) the number of ticks (and labels) of the axis. If \code{tick.pos} is present, it takes precedence over \code{num.ticks} and \code{num.ticks} is ignored. (defaults to 3)}

\item{labels}{(character) the labels to be placed next to the ticks. If the number of labels is lower than the number of  tickes, the labels will be reused. If NULL, the numeric values of the ticks will be used. (defaults to NULL)}

\item{tick.pos}{(numeric) the places in the axis where a tick should be drawn. If present, \code{num.ticks} is ignored. If NULL, ticks are placed equidistant. (defaults to NULL)}

\item{tick.len}{(numeric) the length of the ticks to be drawn measured in base pairs. If NULL, tick length is 0.01 times the length in bases of the longest chromosome. (defaults to NULL)}

\item{label.margin}{(numeric) the additional the margin between the labels and ticks. Can be negative. If NULL, the default margin is used. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{text.col}{(color) The color of the text elements (defaults to "black")}

\item{col}{(color) The color of the axis lines (defaults to "black")}

\item{chromosomes}{(character) To which chromosomes should we add the axis: "first", "last", "auto", "all" or a vector of chromosome names. With auto, the chromosomes will depend on the plot type and side of axis plotting. (defaults to "auto")}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Plot axis at the sides of the data panels
}
\details{
\code{kpAxis} plots axis at the sides of the data panels. It is possible to control the 
number of ticks and their labels, the placement of the plots and whether they span the
whole data panel or just part of it. To do that they use the same placement parameters 
used by other karyoploteR functions (\code{r0} and \code{r1}). This function does not have
a chr option: axis are always plotted for all chromosomes.
}
\examples{

kp <- plotKaryotype("hg19", plot.type=2, chromosomes=c("chr1", "chr2"))

#Prepare data panel 1
kpDataBackground(kp, data.panel=1)
kpAxis(kp, data.panel = 1)
kpAxis(kp, data.panel = 1, ymin = 0, ymax=10, numticks = 11, side = 2, cex = 0.4, col="red")

#Prepare data panel 2
#Data panel 2 is conceptually split into two parts and the second part is "inverted"
kpDataBackground(kp, data.panel=2, r0 = 0, r1 = 0.45, color = "#EEEEFF")
kpAxis(kp, data.panel = 2, r0=0, r1=0.45, ymin = 0, ymax = 1, cex=0.5, 
           tick.pos = c(0.3, 0.5, 0.7), labels = c("-1 sd", "mean", "+1 sd"))
kpAxis(kp, data.panel = 2, r0=0, r1=0.45, ymin = 0, ymax = 1, cex=0.5, side=2)

kpDataBackground(kp, data.panel=2, r0 = 0.55, r1 = 1, color = "#EEFFEE")
kpAxis(kp, data.panel = 2, r0=1, r1=0.55, ymin = 0, ymax = 1, side=1, cex=0.5)
kpAxis(kp, data.panel = 2, r0=1, r1=0.55, ymin = 0, ymax = 1, side=2, cex=0.5)


#Customizing the axis appearance
pp <- getDefaultPlotParams(plot.type=4)
pp$leftmargin <- 0.2
pp$rightmargin <- 0.2
kp <- plotKaryotype("hg19", plot.type=4, chromosomes=c("chr1", "chr2"), plot.params=pp)

#Prepare data panel 1
kpDataBackground(kp, data.panel=1)
kpAxis(kp, data.panel = 1, text.col="red", cex=1.6, srt=45)
kpAxis(kp, data.panel = 1, ymin = 0, ymax=10, numticks = 11, side = 2, 
       cex = 0.7, col="red", text.col="gold", tick.len=30e6, )





}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpDataBackground}}, \code{\link{kpAbline}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prepareParameters4.R
\name{prepareParameters4}
\alias{prepareParameters4}
\title{prepareParameters4}
\usage{
prepareParameters4(function.name, karyoplot, data=NULL, chr=NULL, x0=NULL, x1=NULL, y0=NULL, y1=NULL, ymax=NULL, ymin=NULL, r0=NULL, r1=NULL, data.panel=1, filter.data=TRUE, ...)
}
\arguments{
\item{function.name}{(character) The name of the function calling \code{prepareParameters4}. Only user for error reporting.}

\item{karyoplot}{(KaryoPlot) A karyoplot object.}

\item{data}{A GRanges}

\item{chr}{A character representing the chromosome names.}

\item{x0}{The position in the chromosome in number of bases.}

\item{x1}{The position in the chromosome in number of bases.}

\item{y0}{The value to be plotted.}

\item{y1}{The value to be plotted.}

\item{ymax}{The maximum value of y}

\item{ymin}{The minimum value of y}

\item{r0}{The start of the range to use for plotting}

\item{r1}{The end of the range to use for plotting}

\item{data.panel}{The data panel to use}

\item{filter.data}{A boolean indicating if data should be filtered so only data in visible chromosomes is kept. (defaults to TRUE, filter data)}

\item{...}{Any additional parameter}
}
\value{
A list with five values: \code{chr}, \code{x0}, \code{x1}, \code{y0} and \code{y1}. Each of them 
a vector of the same length with the normalized values to plot.
}
\description{
Prepare and normalize the parameters for functions with x0, x1 and y0, y1 parameters
}
\details{
This function prepares and normalizes the parameters for plotting functions  
with x0, x1, y0 and y1 parameters (as opposed to x and y) so functions can
offer a richer interface while internally dealing only with standard and 
simple code. It extracts the 
positions from \code{data} if available and applies the \code{r0} and 
\code{r1} scaling. It returns the ready to plot values in a list with
only \code{chr}, \code{x0}, \code{x1}, \code{y0} and \code{y1}. 
Individual parameters (\code{chr}, \code{x0}, \code{x1}, \code{y0} and 
All parameters are interpreted and used as explained in \code{\link{kpRect}}.
It also filters out any data points corresponding to chromosomes not present
in the current karyoplot.
}
\note{
This function is only useful when creating custom plotting functions. 
It is not intended to the general user.

For detailed documentation on the parameters, see \code{\link{kpRect}}
}
\examples{

kp <- plotKaryotype()
prepareParameters4("TestFunc", kp, data=NULL, chr="chr1", x0=c(10, 20, 30), x1=c(20, 30, 40), y0=c(0, 1, 2), y1=c(0.5, 1.5, 3), r0=0, r1=0.5, ymin=0, ymax=3)

 
}
\seealso{
\code{\link{kpRect}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpPlotLoess.R
\name{kpPlotLoess}
\alias{kpPlotLoess}
\title{kpPlotLoess}
\usage{
kpPlotLoess(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, conf.interval=0.95, span=0.5, data.panel=1, r0=NULL, r1=NULL, ymin=NULL, ymax=NULL, col="black", lty=1, lwd=1, ci.col="#888888AA", ci.border=NA, ci.border.lty=1, ci.border.lwd=1, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{GRanges}) A GRanges object with the data. If \code{data} is present, \code{chr} will be set to \code{seqnames(data)} and \code{x} to the midpoints of the rages in data. If no parameter \code{y} is specified and \code{data} has a column named \code{y} or \code{value} this column will be used to define the \code{y} value of each data point. (defaults to NULL)}

\item{chr}{(a charecter vector) A vector of chromosome names specifying the chromosomes of the data points. If \code{data} is not NULL, \code{chr} is ignored. (defaults to NULL)}

\item{x}{(a numeric vector) A numeric vector with the positions (in base pairs) of the data points in the chromosomes. If \code{data} is not NULL, \code{x} is ignored. (defaults to NULL)}

\item{y}{(a numeric vector) A numeric vector with the values of the data points. If \code{y} is not NULL, it is used instead of any data column in \code{data}. (defaults to NULL)}

\item{conf.interval}{The confidence interval to plot. If a number in (0,1), the confidence interval is plotted. Else, no confidence interval is plotted. (defaults to 0.95)}

\item{span}{A parameter to control the smoothing level. It is passed to underlying function \code{\link[stats]{loess}}. (deafults to 0.5)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{ymin}{(numeric) The minimum value of \code{y} to be plotted. If NULL, it is set to the min value of the selected data panel. (defaults to NULL)}

\item{ymax}{(numeric) The maximum value of \code{y} to be plotted. If NULL, it is set to the max value of the selected data panel. (defaults to NULL)}

\item{col}{The color of the fitting line. (defaults to "black")}

\item{lty}{The line type (dashed, dotted...) of the fitting line (defaults to 1, solid)}

\item{lwd}{The line width of the fitting line (defaults to 1)}

\item{ci.col}{The color of the area representing the confidence interval. If NA no CI is plotted. (defaults to #888888AA, transparent gray)}

\item{ci.border}{The color of line marking the border of the confidence interval. If NA, it's not plotted. (defaults to NA)}

\item{ci.border.lty}{The line type of line marking the border of the confidence interval. (defaults to 1, solid)}

\item{ci.border.lwd}{The line width of line marking the border of the confidence interval. (defaults to 1)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Plot a LOESS smoothed line with confidence intervals given a list of points.
}
\details{
Given a set of data points (specified in any way accepted by \code{\link{kpPoints}}),
plot a LOESS smoothed line with optional confidence intervals. LOESS is
computed independently per each chromosome and data points are sorted before
fitting. It is possible to adjust the confidence interval with 
\code{conf.interval} and setting it to NULL or NA will plot no CI. It is also
possible to control the smoothing level with \code{span}. In addition to 
the standard plotting parameters, it is possible to control independently the
color of the fitting line and CI area and CI borders. It is also possible to
adjust the line type and line width of the fitting line and CI border.
}
\examples{


set.seed(1000)

dd <- data.frame(chr="chr1", x=1:48*5e6, y=rnorm(n=48, 0.5, 0.1 ))

kp <- plotKaryotype(chromosomes="chr1")
kpPoints(kp, chr=dd$chr, x=dd$x, y=dd$y)
kpPlotLoess(kp, chr=dd$chr, x=dd$x, y=dd$y, col="red", conf.interval = 0.99, ci.col = "#FAAAAAAA")


}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpPoints}}, \code{\link{kpLines}}, \code{\link{kpPlotRibbon}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpDataBackground.R
\name{kpDataBackground}
\alias{kpDataBackground}
\title{kpDataBackground}
\usage{
kpDataBackground(karyoplot, r0=NULL, r1=NULL, data.panel=1, color="gray90", clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{color}{(color) a valid color specification}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data background will be not drawn out of the drawing area (i.e. in margins, etc) even if it overflows the visible drawing area. If FALSE, the data background representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Draws a solid rectangle delimiting the plotting area
}
\details{
This function is used to add a background color to delimit the plotting area. 
 It can either delimit the whole plotting area or part of it so different data plotting
 regions can be seen.
}
\examples{

kp <- plotKaryotype("hg19", plot.type=2, chromosomes=c("chr1", "chr2"))

#Prepare data panel 1
kpDataBackground(kp, data.panel=1)
kpAxis(kp, data.panel = 1)
kpAxis(kp, data.panel = 1, ymin = 0, ymax=10, numticks = 11, side = 2, cex = 0.4, col="red")

#Prepare data panel 2
#Data panel 2 is conceptually split into two parts and the second part is "inverted"
kpDataBackground(kp, data.panel=2, r0 = 0, r1 = 0.45, color = "#EEEEFF")
kpAxis(kp, data.panel = 2, r0=0, r1=0.45, ymin = 0, ymax = 1, cex=0.5, 
       tick.pos = c(0.3, 0.5, 0.7), labels = c("-1 sd", "mean", "+1 sd"))
kpAxis(kp, data.panel = 2, r0=0, r1=0.45, ymin = 0, ymax = 1, cex=0.5, side=2)

kpDataBackground(kp, data.panel=2, r0 = 0.55, r1 = 1, color = "#EEFFEE")
kpAxis(kp, data.panel = 2, r0=1, r1=0.55, ymin = 0, ymax = 1, side=1, cex=0.5)
kpAxis(kp, data.panel = 2, r0=1, r1=0.55, ymin = 0, ymax = 1, side=2, cex=0.5)



}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpAxis}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getCytobandColors.R
\name{getCytobandColors}
\alias{getCytobandColors}
\title{getCytobandColors}
\usage{
getCytobandColors(color.table=NULL, color.schema=c("circos", "biovizbase", "only.centromeres"))
}
\arguments{
\item{color.table}{(named character vector) if present, it's returned as-is. Useful to specify your own color.tables.}

\item{color.schema}{(character) The name of the color schema to use: \code{circos}, \code{biovizBase}, \code{only.centromeres} (everything in gray, except for centromeres in red). (defaults to \code{circos})}
}
\value{
a named character vector with the colors associated to each cytoband name
}
\description{
Returns a named character vector with the colors of associated with the cytoband names
}
\details{
The function returns a named character vector with the colors of associated with the 
cytoband names. Two color schemas are available: circos (which copies the colors used by 
Circos) and biovizbase (that gets the cytoband colors from the biovizBase Bioconductor 
package). If a color.table is given, it is returned untouched.
}
\examples{
 
getCytobandColors()
getCytobandColors(color.schema="biovizbase")
 
}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpAddCytobands}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/color.R
\name{colByChr}
\alias{colByChr}
\title{colByChr}
\usage{
colByChr(data, colors="2grays", all.chrs=NULL, default.col="black")
}
\arguments{
\item{data}{Either a vector of characters or a GRanges object}

\item{colors}{The name of a color set ("2grays", "blackgreen", "rainbow"...) or a vector of colors. If the vector is named, names are expected to be the chromosome names. (defaults to "2grays")}

\item{all.chrs}{A vector with all possible chromosomes. If NULL, the list will be extracted from data (using seqlevels if available). (defaults to NULL)}

\item{default.col}{The default color to return when something is unavailable}
}
\value{
A vector of colors
}
\description{
Given a set of data elements, return a color for each one based on their chromosome
}
\details{
Returns a color for each data element based on its chromosome. The returned colors might
com from one of the predefined color sets or passed in as a parameter.

If \code{colors} is the name of one of the available color sets, it the color set is used. 
If it's a named character vector with the chromosome as names, they will be assigned by name
and any missing chromosome will be \code{default.col}. If it's a non-named chraracter vector,
will be used in order and recycled if necessary.

Data might be either a GRanges object or a vector of chromosomes.
}
\note{
Available color.sets:
"2grays"=c("#888888", "#444444"),
"2blues"=c("#6caeff", "#2b5d9b")
"blackgreen"=c("black", "green"),
"greengray"=c("#c6ffb7", "#888888"),
"brewer.set1"=c("#E41A1C", "#377EB8", "#4DAF4A", "#984EA3", "#FF7F00", "#FFFF33", "#A65628", "#F781BF", "#999999")
"brewer.set2"=c("#66C2A5", "#FC8D62", "#8DA0CB", "#E78AC3", "#A6D854", "#FFD92F", "#E5C494", "#B3B3B3")
"brewer.set3"=c("#8DD3C7", "#FFFFB3", "#BEBADA", "#FB8072", "#80B1D3", "#FDB462", "#B3DE69", "#FCCDE5", "#D9D9D9", "#BC80BD", "#CCEBC5", "#FFED6F")
"brewer.pastel1"=c("#FBB4AE", "#B3CDE3", "#CCEBC5", "#DECBE4", "#FED9A6", "#FFFFCC", "#E5D8BD", "#FDDAEC", "#F2F2F2"),
"brewer.pastel2"=c("#B3E2CD", "#FDCDAC", "#CBD5E8", "#F4CAE4", "#E6F5C9", "#FFF2AE", "#F1E2CC", "#CCCCCC"),
"rainbow"=rainbow(n=length(all.chrs))
}
\examples{

chrs <- c("chr1", "chr2", "chr2", "chr1", "chr5")
points <- toGRanges(paste0("chr", c(1:22, "X", "Y")), rep(10e6, 24), rep(10e6, 24))

colByChr(chrs)
colByChr(points)

kp <- plotKaryotype(plot.type=4, labels.plotter=NULL, ideogram.plotter=NULL)
kpAddChromosomeNames(kp, srt=45)
kpAddChromosomeSeparators(kp)

total.tracks <- 6

kpPoints(kp, points, col=colByChr(points), y=0.5, cex=1, r0=autotrack(1,total.tracks)$r0, r1=autotrack(1,total.tracks)$r1)
colors <- NULL
kpPoints(kp, points, y=0.5, col=colByChr(points, colors=colors), cex=1, r0=autotrack(2,total.tracks)$r0, r1=autotrack(2,total.tracks)$r1)
colors <- c("red", "blue")
kpPoints(kp, points, y=0.5, col=colByChr(points, colors=colors), cex=1, r0=autotrack(3,total.tracks)$r0, r1=autotrack(3,total.tracks)$r1)
colors <- c(chr1="red", chr7="blue")
kpPoints(kp, points, y=0.5, col=colByChr(points, colors=colors), cex=1, r0=autotrack(4,total.tracks)$r0, r1=autotrack(4,total.tracks)$r1)
kpPoints(kp, points, y=0.5, col=colByChr(points, colors=colors, default.col="green"), cex=1, r0=autotrack(5,total.tracks)$r0, r1=autotrack(5,total.tracks)$r1)
colors <- c("red", "yellow", 3, "orchid", "blue")
kpPoints(kp, points, y=0.5, col=colByChr(points, colors=colors), cex=1, r0=autotrack(6,total.tracks)$r0, r1=autotrack(6,total.tracks)$r1)

#Color sets
pp <- getDefaultPlotParams(plot.type=4)
pp$leftmargin <- 0.2
kp <- plotKaryotype(plot.type=4, labels.plotter=NULL, ideogram.plotter=NULL, plot.params=pp)
kpAddChromosomeNames(kp, srt=45)
kpAddChromosomeSeparators(kp)

color.sets <- c( "2grays", "2blues", "blackgreen", "greengray", "brewer.set1",
                   "brewer.set2", "brewer.set3", "brewer.pastel1", "brewer.pastel2", "rainbow" )
total.tracks <- length(color.sets)
for(i in seq_len(length(color.sets))) {
    kpPoints(kp, points, y=0.5, col=colByChr(points, colors=color.sets[i]), cex=1, r0=autotrack(i,total.tracks)$r0, r1=autotrack(i,total.tracks)$r1)
    kpAddLabels(kp, labels=color.sets[i], cex=0.7, r0=autotrack(i,total.tracks)$r0, r1=autotrack(i,total.tracks)$r1)
}

}
\seealso{
\code{\link{kpPoints}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/color.R
\name{horizonColors}
\alias{horizonColors}
\title{horizonColors}
\usage{
horizonColors(col, num.parts)
}
\arguments{
\item{col}{(array of colors) An array of colors}

\item{num.parts}{(positive integer) The number of colors to generate for pos and neg}
}
\value{
A list with 2 elements, pos and neg, each with num.parts colors
}
\description{
Returns the color structure needed by kpPlotHorizon
}
\details{
This function transforms an array of colors into a list of colors 
**internally** needed by kpPlotHorizon: a list with two elements, "neg" 
and "pos", each an array of colors of length num.parts. If col is 
a character of length one, it is interpreted as the name of a color scheme.


horizonColors(col, num.parts)
}
\examples{
 
horizonColors("redblue6", 3)
horizonColors("redblue6", 6)
horizonColors("bluegold3", 2)
horizonColors(c("red", "blue"), 3)
horizonColors(c("red", "#FFFFFF00", "blue"), 3)
 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpArea.R
\name{kpArea}
\alias{kpArea}
\title{kpArea}
\usage{
kpArea(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, base.y=0, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, col=NULL, border=NULL, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{GRanges}) A GRanges object with the data. If \code{data} is present, \code{chr} will be set to \code{seqnames(data)} and \code{x} to the midpoints of the rages in data. If no parameter \code{y} is specified and \code{data} has a column named \code{y} or \code{value} this column will be used to define the \code{y} value of each data point. (defaults to NULL)}

\item{chr}{(a charecter vector) A vector of chromosome names specifying the chromosomes of the data points. If \code{data} is not NULL, \code{chr} is ignored. (defaults to NULL)}

\item{x}{(a numeric vector) A numeric vector with the positions (in base pairs) of the data points in the chromosomes. If \code{data} is not NULL, \code{x} is ignored. (defaults to NULL)}

\item{y}{(a numeric vector) A numeric vector with the values of the data points. If \code{y} is not NULL, it is used instead of any data column in \code{data}. (defaults to NULL)}

\item{base.y}{(numeric) The y value at which the polygon will be closed. (defaults to 0)}

\item{ymin}{(numeric) The minimum value of \code{y} to be plotted. If NULL, it is set to the min value of the selected data panel. (defaults to NULL)}

\item{ymax}{(numeric) The maximum value of \code{y} to be plotted. If NULL, it is set to the max value of the selected data panel. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{col}{(color) The fill color of the area. A single color. If NULL the color will be assigned automatically, either a lighter version of the color used for the outer line or gray if the line color is not defined. If NA no area will be drawn. (defaults to NULL)}

\item{border}{(color) The color of the line enclosing the area. A single color. If NULL the color will be assigned automatically, either a darker version of the color used for the area or black if col=NA. If NA no border will be drawn. (Defaults to NULL)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Plots a line joining the data points along the genome and fills the area below the line.
}
\details{
This is a karyoploteR low-level plotting functions. Given a set of positions 
on the genome (chromosome and base) and a value (y) for each of them, it 
plots a line joining them and shades the area below them. Data can be 
provided via a \code{GRanges} object (\code{data}), independent parameters 
for chr, x and y or a combination of both. A number of parameters can be used
to define exactly where and how the line and area are drawn. In addition, 
via the ellipsis operator (\code{...}), \code{kpArea} accepts any parameter 
valid for \code{\link[graphics]{lines}} and \code{\link[graphics]{polygon}}
(e.g. \code{lwd}, \code{lty}, \code{col}, \code{density}...) The lines are drawn in a per 
chromosome basis, so it is not possible to draw lines encompassing more than 
one chromosome.
}
\examples{
 
set.seed(1000)
data.points <- sort(createRandomRegions(nregions=500, mask=NA))
mcols(data.points) <- data.frame(y=runif(500, min=0, max=1))

kp <- plotKaryotype("hg19", plot.type=2, chromosomes=c("chr1", "chr2"))
  kpDataBackground(kp, data.panel=1)
  kpDataBackground(kp, data.panel=2)

  kpArea(kp, data=data.points)
  kpArea(kp, data=data.points, col="lightgray", border="red", lty=2, r0=0, r1=0.5)
  kpArea(kp, data=data.points, border="red", data.panel=2, r0=0, r1=0.5)
  kpArea(kp, data=data.points, border="blue", data.panel=2, r0=0, r1=0.5, base.y=1)

  kpArea(kp, data=data.points, border="gold", data.panel=2, r0=0.5, r1=1, base.y=0.5)


 
}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpLines}}, \code{\link{kpText}}, \code{\link{kpPlotRibbon}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/color.R
\name{getColorSchemas}
\alias{getColorSchemas}
\title{getColorSchemas}
\usage{
getColorSchemas()
}
\value{
A list with the color schemas included in karyoploteR for cytobands,
variants, horizons...
}
\description{
Return a structure with the color schemas included in karyoploteR
}
\examples{
 
getColorSchemas()
 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDefaultPlotParams.R
\name{plotDefaultPlotParams}
\alias{plotDefaultPlotParams}
\title{plotDefaultPlotParameters}
\usage{
plotDefaultPlotParams(plot.type=2, plot.params=NULL, ...)
}
\arguments{
\item{plot.type}{(numeric) plot the params of this plot type. Currently, only plot types 2 and 3 are accepted. (defaults to 2)}

\item{plot.params}{(a plot params object) a plot params object such the one returned by \code{\link{getDefaultPlotParams}}. If specified, it will be used to create the plots.}

\item{...}{The ellipsis operator can be used to pass any additional graphics parameter}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Creates a karyoplot with the default parameters drawn.
}
\details{
Given a plot.type, this function creates a new karyoplot with lines and arrows showing 
 the meaning and values of the plot.params
}
\examples{

kp <- plotDefaultPlotParams(plot.type=2)

 
}
\seealso{
\code{\link{plotKaryotype}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getCytobands.R
\name{getCytobands}
\alias{getCytobands}
\title{getCytobands}
\usage{
getCytobands(genome="hg19", use.cache=TRUE)
}
\arguments{
\item{genome}{(character or other) specifies a genome using the UCSC genome name. Defaults to "hg19". If it's not a \code{character}, genome is ignored and and empty \code{GRanges} is returned.}

\item{use.cache}{(boolean) wether to use or not the cytoband information included in the packge. \code{use.cache=FALSE} will force a download from the UCSC.}
}
\value{
It returns a \code{\link{GenomicRanges}} object with the cytobands of the specified genome. If no cytobands are available for any reason, an empty \code{GRanges} is returned.
}
\description{
Get the cytobands of the specified genome.
}
\details{
It returns \code{GRanges} object with the cytobands of the specified genome. 
The cytobands for some organisms and genome versions have been pre-downloaded from UCSC
and included in the \code{karyoploteR} package. For any other genome, \code{getCytobands}
will use \code{rtracklayer} to try to fetch the \code{cytoBandIdeo} table from UCSC. If for
some reason it is not possible to retrieve the cytobands, it will return an empty \code{GRanges}
object. Setting the parameter \code{use.cache} to \code{FALSE}, the data included in the 
package will be ignored and the cytobands will be downloaded from UCSC.

The genomes (and versions) with pre-downloaded cytobands are: hg18, hg19, hg38, mm9, mm10, mm39, 
     rn5, rn6, rn7, susScr11, 
     bosTau9, bosTau8, equCab3, equCab2, panTro6, panTro5, rheMac10,
     danRer10, danRer11, xenTro10, dm3, dm6, 
     ce6, ce10, ce11, sacCer2, sacCer3
}
\note{
This function is memoised (cached) using the \code{\link{memoise}} package. To empty the 
cache, use \code{\link{forget}(getCytobands)}
}
\examples{
 
#get the cytobands for hg19 (using the data included in the package)
cyto <- getCytobands("hg19")


#get the cytobands for Drosophila Melanogaster
cyto <- getCytobands("dm6")

 
}
\seealso{
\code{\link{plotKaryotype}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/color.R
\name{transparent}
\alias{transparent}
\title{transparent}
\usage{
transparent(col, amount=0.5)
}
\arguments{
\item{col}{(color) The original color. Might be specified as a color name or a "#RRGGBB(AA)" hex color definition.}

\item{amount}{(number, [0-1]) The amount of transparency. 0 for completely visible, 1 for completely transparent. (Defaults to 0.5).}
}
\value{
A transparent color
}
\description{
Given a color, return a transparent one
}
\details{
Very simple utility function to create transparent colors. Given a color, it
transforms it to rgb space, adds a set amount to all chanels and transforms
it back to a color.
}
\examples{
 
transparent("red")
transparent("#333333")
 
}
\seealso{
\code{\link{lighter}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpPlotCoverage.R
\name{kpPlotCoverage}
\alias{kpPlotCoverage}
\title{kpPlotCoverage}
\usage{
kpPlotCoverage(karyoplot, data, show.0.cov=TRUE, data.panel=1, r0=NULL, r1=NULL, col="#0e87eb", border=NULL, ymax=NULL, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{GRanges} or a coverage object) A GRanges object from wich the coverage will be computed or a \code{SimpleRleList} result of computing the coverage.}

\item{show.0.cov}{(boolean) Wether to plot a thin line representing the regions with no coverage at all. (defaults to TRUE, plot the line)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{col}{(color) The background color of the regions. (defaults to "#0e87eb")}

\item{border}{(color) The color of the border used to plot the coverage. If NULL, NA (no border) is used. (defaults to NULL)}

\item{ymax}{(numeric) The maximum value to be plotted on the data.panel. If NULL the maximum coverage is used. (defaults to NULL)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object with the data computed (max.coverage, ymax) stored in latest.plot.
}
\description{
Given a \code{GRanges} object, plot the coverage along the genome.
}
\details{
This is one of the high-level, or specialized, plotting functions of karyoploteR.
 It takes a \code{GRanges} object and plots it's coverage, that is, the number of regions
 overlapping each genomic position. The input can also be a \code{SimpleRleList} resulting
 from computing the coverage with \code{coverage(data)}. In contrast with the low-level 
 functions such as \code{\link{kpRect}}, it is not possible to specify the data using 
 independent numeric vectors and the function only takes in the expected object types.
 
 There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
}
\examples{
 
 set.seed(1000)
 
 #Example 2: Do the same with a single bigger set of possibly overlapping regions
 
 kp <- plotKaryotype("hg19", plot.type=1, chromosomes=c("chr1", "chr2"))
 
 regs <- createRandomRegions(nregions = 1000, length.mean = 10000000, length.sd = 1000000,
                             non.overlapping = FALSE, genome = "hg19", mask=NA)
 kpPlotRegions(kp, regs, r0 = 0, r1 = 0.8, col="#AAAAAA")
 
 kpPlotCoverage(kp, regs, ymax = 20, r0=0.8,  r1=1, col="#CCCCFF")
 kpAxis(kp, ymin = 0, ymax= 20, numticks = 2, r0 = 0.8, r1=1)
 
 
}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpPlotRegions}}, \code{\link{kpBars}},  \code{\link{kpPlotBAMCoverage}}, \code{\link{kpPlotDensity}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/color.R
\name{is.color}
\alias{is.color}
\title{is.color}
\usage{
is.color(x)
}
\arguments{
\item{x}{The element to test}
}
\value{
TRUE is x is a valid color, FALSE otherwise
}
\description{
Test if something is a valid color
}
\details{
This function tests if something is a valid color. Returns TRUE or FALSE. 
The function is vectorised.
}
\examples{
 
is.color("red")
is.color("#333333")
is.color(NA)
is.color(NULL)
is.color("not_a_color")
is.color(3)

is.color(c("not_a_color", "red", 3, "#FF0000"))
 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpPlotTranscripts.R
\name{kpPlotTranscripts}
\alias{kpPlotTranscripts}
\title{kpPlotTranscripts}
\usage{
kpPlotTranscripts(karyoplot, data, y0=NULL, y1=NULL, non.coding.exons.height=0.5, 
detail.level=2,
add.strand.marks=TRUE, mark.height=0.20, mark.width=1, mark.distance=4,
add.transcript.names=TRUE, transcript.names=NULL, transcript.name.position="left", transcript.name.cex=1,
col="black", border=NULL, coding.exons.col=NULL, coding.exons.border.col=NULL, 
non.coding.exons.col=NULL, non.coding.exons.border.col=NULL, 
introns.col=NULL, marks.col=NULL, transcript.name.col=NULL,
ymax=NULL, ymin=NULL, r0=NULL, r1=NULL, 
data.panel=1, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{list}) data must be a list with an element called 'transcripts' with a \code{GRanges} with all transcripts to be plotted. Additionally, to plot the transcript structure it needs two other elements, 'coding.exons' and 'non.coding.exons', each a list with an element for every transcript with \code{GRanges} objects representing the transcript exons. An example of the data structure needed can be seen in the function examples.}

\item{y0}{(numeric) The bottom of the transcripts in the y axis. It can have a different value for each transcript and values will be recycled if needed. If null, it will be set to the minimum y value in the data.panel, usually 0. (Defaults to NULL)}

\item{y1}{(numeric) The top of the transcripts in the y axis. It can have a different value for each transcript and values will be recycled if needed. If null, it will be set to the maximum y value in the data.panel, usually 1. (Defaults to NULL)}

\item{non.coding.exons.height}{(numeric) The height of the non.coding exons relative to the transcript height. For example, if 0.5, non-coding exons will have a height half the size of the coding ones. (default 0.5)}

\item{detail.level}{(numeric: 1 or 2) The detail level of the transcript representation: 1 will plot only boxes representing the transcripts, 2 will plot detailed structure of the trasncripts (coding and non-coding exons and introns). (Defaults to 2)}

\item{add.strand.marks}{(boolean) Whether strand marks should be plotted or not. Strand marks are small arrows along the introns (or whole transcripts if detail level=1). (defaults to TRUE)}

\item{mark.height}{(numeric) The height of the strand marks in "coding exons heights", that is, if mark.height is 0.5, the mark will have a height of half the height of an exon. (defaults to 0.2)}

\item{mark.width}{(numeric) The width of the strand marks, in mark heights. mark.width=1 will produce arrow heads with a slope pf 45 degrees. A value higher than 1 will produce smaller angles and a value below 1 larger angles with more vertical lines. (defaults to 1, 45 degrees)}

\item{mark.distance}{(numeric) The distance between marks, in mark widths. A distance of 2, will add a space of 2*mark.width between consecutive marks. (defaults to 4)}

\item{add.transcript.names}{(boolean) Whether to add transcript names to the plot (defailts to TRUE)}

\item{transcript.names}{(named character) A named character vector with the labels of the transcripts. If not null, it will be used as a dictionary, so transcript ids should be names and desired labels the values. If NULL, the transcript ids will be used as labels. (defaults to null)}

\item{transcript.name.position}{(character) The position of the text relative to the rectangle. Can be "left", "right", "top", "bottom" or "center". (Defaults to "left")}

\item{transcript.name.cex}{(numeric) The cex value to plot the transcript labels. (defaults to 1)}

\item{col}{(color) The color of the transcripts and labels. It is possible to specify different colors for each element class (transcript names, exons, strand marks...). All elements with no explicit color will be plotted using col. (defaults to "black)}

\item{border}{(color) The color of the border of rectangles representing genes, transcripts and exons. Every element class may have its own specific color using the appropiate parameters. The ones with no explicit color will use border. At the same time, if border is NULL, it will default to col. (fesults to NULL)}

\item{coding.exons.col}{(color) The fill color of the rectangles representing the coding exons. If NULL, it will use col. (defaults to NULL)}

\item{coding.exons.border.col}{(color) The color of the border of the coding exons. If NULL, it will use border. (defaults to NULL)}

\item{non.coding.exons.col}{(color) The fill color of the rectangles representing the non-coding exons. If NULL, it will use col. (defaults to NULL)}

\item{non.coding.exons.border.col}{(color) The color of the border of the non-coding exons. If NULL, it will use border. (defaults to NULL)}

\item{introns.col}{(color) The color of the lines representing the introns. If NULL, it will use col. (defaults to NULL)}

\item{marks.col}{(color) The color of the arrows representing the strand. If NULL, it will use col. (defaults to NULL)}

\item{transcript.name.col}{(color) The color of the transcript labels. If NULL, it will use col. (defaults to NULL)}

\item{ymax}{(numeric) The maximum value of \code{y} to be plotted. If NULL, it is set to the max value of the selected data panel. (defaults to NULL)}

\item{ymin}{(numeric) The minimum value of \code{y} to be plotted. If NULL, it is set to the min value of the selected data panel. (defaults to NULL)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Plot gene transcripts on the genome, with options to add strand markers and
to differentiate between coding and non-coding exons.
}
\details{
This is one of the high-level, or specialized, plotting functions of
 karyoploteR. It takes a list with the transcripts, coding and non-coding 
 exons and creates a traditional boxes and line representation of the
 transcripts. With y0 and y1, it is possible to specify a different vertical 
 position and different height for each transcript. 
 It can add little arrows,
 strand marks, along the introns to show the transcript strand. The marks 
 appearance can be customized using 4 different parameters specifying the 
 height (relative to the height of the transcript), width of each mark 
 (relative to the height), distance between marks (relative to the width) and
 color of the marks. Marks are centered on the space they have available and
 if the available space to too tight for a single mark, no mark will be 
 plotted. The direction of the marks is based on the transcript strand as
 specified in \code{data$transcripts} object.
 Two detail levels are available: \code{detail.level=1} will represent 
 transcripts as solid boxes (optionally with strand marks along the whole
 transcript); \code{detail.level=2} will represent the internal structure of 
 the transcripts -coding and non coding exons, introns, and optionally the
 strand marks only in the introns.
}
\note{
IMPORTANT: The direction of the strand marks is taken from the strand
information in the \code{data$transcripts} object. If transcripts have no
strand information there (they have \code{strand="*"}), no marks will be 
drawn.
}
\examples{
 
#Build the data objet expected by transcripts

transcripts <- c(toGRanges("chr1", 100, 1000),
                 toGRanges("chr1", 1500, 3000))
names(transcripts) <- c("T1", "T2")
strand(transcripts) <- c("+", "-")

coding.exons <- list("T1"=c(toGRanges("chr1", 200, 300),
                            toGRanges("chr1", 500, 800),
                            toGRanges("chr1", 900, 950)),
                     "T2"=c(toGRanges("chr1", 2200, 2300),
                            toGRanges("chr1", 2500, 2510),
                            toGRanges("chr1", 2700, 2800)))


non.coding.exons <- list("T1"=c(toGRanges("chr1", 100, 199),
                                toGRanges("chr1", 951, 1000)),
                         "T2"=c(toGRanges("chr1", 1500, 1700),
                                toGRanges("chr1", 1900, 1950),
                                toGRanges("chr1", 2100, 2199),
                                toGRanges("chr1", 2801, 3000)))

data <- list(transcripts=transcripts, coding.exons=coding.exons, non.coding.exons=non.coding.exons)

#Create a simple example plot
karyoplot <- plotKaryotype(zoom=toGRanges("chr1", 0, 3200))
kpAddBaseNumbers(karyoplot, tick.dist = 400)
kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0, r1=0.1)


#Create a plot with different variants of the transcripts
karyoplot <- plotKaryotype(zoom=toGRanges("chr1", 0, 3200))
kpAddBaseNumbers(karyoplot, tick.dist = 400)
#Standard
kpPlotTranscripts(karyoplot, data=data, r0=0, r1=0.1)
#Customize colors
kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0.11, r1=0.21, transcript.name.position = "right", non.coding.exons.col = "#888888", non.coding.exons.border.col = "#888888", marks.col="#CC6666", transcript.name.col="#CC6666")
#Change vertical position and transcript height
kpPlotTranscripts(karyoplot, data=data, y0=c(0, 0.4), y1=c(0.2, 1), r0=0.25, r1=0.8, add.transcript.names = TRUE, transcript.name.position = "left", add.strand.marks = TRUE, clipping=FALSE)
#Change detail level, colors and transcript names
kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0.9, r1=1, detail.level = 1, add.transcript.names = TRUE, transcript.name.position = "top", add.strand.marks = TRUE, clipping=FALSE, col="blue", marks.col="white", transcript.names=list(T1="Transcript 1", T2="Transcript 2"))

#Create a plot with different variants of the strand marks
karyoplot <- plotKaryotype(zoom=toGRanges("chr1", 0, 3200))
kpAddBaseNumbers(karyoplot, tick.dist = 400)
#Standard
kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0, r1=0.1)
#No marks
kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0.15, r1=0.25, add.strand.marks=FALSE)
#Change the strand marks height
kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0.3, r1=0.4, mark.height=1)
#Change the mark width
kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0.45, r1=0.55, mark.width=2)
#Change the mark distance
kpPlotTranscripts(karyoplot, data=data, y0=0, y1=1, r0=0.6, r1=0.7, mark.distance=1.5)

 
 
}
\seealso{
\code{\link{kpPlotGenes}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getDefaultPlotParams.R
\name{getDefaultPlotParams}
\alias{getDefaultPlotParams}
\title{getDefaultParameters}
\usage{
getDefaultPlotParams(plot.type)
}
\arguments{
\item{plot.type}{(integer) the required plot type. can be any valid plot type (see \code{\link{plotKaryotype}})}
}
\value{
A valid \code{plot.params} object with the default values for the plotting parameters and 
ready to be used in the \code{plotKaryotype}
}
\description{
Returns the default parameters for the given plot.type
}
\details{
Given a plot.type, this function returns a list suitable as a valid \code{plot.params} object.
 The user can then proceed to change the parameter values as needed and supply the modified 
 list to the plotKaryotype function.#'
}
\examples{

pp <- getDefaultPlotParams(plot.type=2)
pp

#Change the ideogramheight param to create thicker ideograms 
pp$ideogramheight <- 150

plotKaryotype(genome="hg19", plot.type=2, plot.params=pp) 

 
}
\seealso{
\code{\link{plotKaryotype}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/color.R
\name{colByValue}
\alias{colByValue}
\title{colByValue}
\usage{
colByValue(value, colors, min=NULL, max=NULL)
}
\arguments{
\item{value}{A vector of numeric values}

\item{colors}{(color) The colors to built the color ramp. Refer to \code{\link[grDevices]{colorRamp}} for more details.}

\item{min}{(NULL or numeric) The min value used to normalize the values. If NULL, min(value) will be used. (defaults to NULL)}

\item{max}{(NULL or numeric) The max value used to normalize the values. If NULL, max(value) will be used. (defaults to NULL)}
}
\value{
A vector of colors
}
\description{
Given a set of values, return a color for each of them based on their numeric
value.
}
\details{
A color ramp (similar to a gradient) will be built using the colors in the 
`colors` parameter using \code{\link[grDevices]{colorRamp}}.
Values will be normalized to [0,1] using `min` and `max`
(if NULL, min(value) will be 0 and max(value) will be 1) and these values
will be used to determine the color. It uses
}
\note{
Alpha values (transparency) are also used in the color computation
(see examples)
}
\examples{

colByValue(c(0,0.25,0.5,0.75,1), colors=c("red", "green"))
colByValue(c(0,0.25,0.5,0.75,1), colors=c("#00000000", "#00000011"))

data <- toGRanges("chr1", c(1e6*1:245), c(1e6*1:245)+10)
data$y <- rnorm(n = length(data), mean = 0.5, sd = 0.15)

kp <- plotKaryotype(chromosomes="chr1")
kpPoints(kp, data=data, r0=0, r1=0.3)
kpPoints(kp, data=data, r0=0.35, r1=0.65, col=colByValue(data$y, colors=c("black", "green")) )
kpPoints(kp, data=data, r0=0.7, r1=1, col=colByValue(data$y, colors=c("black", "green"), min=0.4, max=0.6))

kp <- plotKaryotype(chromosomes="chr1")
kpPoints(kp, data=data, r0=0, r1=0.3, col=colByValue(data$y, colors=c("#00000000", "#000000FF")))
kpPoints(kp, data=data, r0=0.35, r1=0.65, col=colByValue(data$y, colors=c("black", "orange", "green")) )
kpPoints(kp, data=data, r0=0.7, r1=1, col=colByValue(data$y, colors=c("red", "#00000022","#00000022", "green"),min=0.4, max=0.6))

}
\seealso{
\link{kpPoints}, \link{colByChr}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genes.R
\name{makeGenesDataFromTxDb}
\alias{makeGenesDataFromTxDb}
\title{makeGenesDataFromTxDb}
\usage{
makeGenesDataFromTxDb(txdb, karyoplot=NULL, plot.transcripts=TRUE, plot.transcripts.structure=TRUE)
}
\arguments{
\item{txdb}{(a TxDb object) The transcript database object from which the data will be extracted.}

\item{karyoplot}{(karyoplot object) A valid karyoplot object created by a call to \code{\link{plotKaryotype}}. If present, genes data will be restricted to the visible region in the plot. If NULL, all genes will be included. (defaults to NULL)}

\item{plot.transcripts}{(boolean) TRUE if transcripts are needed in addition to the genes. (defaults to TRUE)}

\item{plot.transcripts.structure}{(boolean) TRUE if the coding and non-coding exons are needed in addition to the genes and transcripts. (defaults to TRUE)}
}
\value{
Returns a list with at least one element called \code{genes}, a 
\code{GRanges} with all genes overlapping karyoplot. If 
\code{plot.transcripts} is TRUE, the returned list will have 
a \code{transcript} element, a list of \code{GRanges} objects, one per gene
(named with the gene ids),
with the transcripts of that gene. If \code{plot.transcripts.structure} is
TRUE, two more elements are present: \code{coding.exons} and 
\code{non.coding.exons}, each a list with one element per trascript 
(named with the transcript id), and each element the coding or non-coding
exons of that transcript.
}
\description{
This is a utility function that transforms a TxDb object into a custom 
object valid as input for \code{\link{kpPlotGenes}}.
}
\details{
This function creates a valid data object for \code{\link{kpPlotGenes}} 
starting from a TxDb object. The resulting object will contain only the
genes and transcripts ovelapping the plot region of the given Karyoplot 
object.
}
\note{
\code{\link{kpPlotGenes}} accepts TxDb objects directly. This 
function is only expected to be used when the user want to manipulate the 
results somehow (i.e. removing some of the genes).
}
\examples{
 

library(TxDb.Hsapiens.UCSC.hg19.knownGene)

zoom <- toGRanges("chr17", 32.6e6, 33.2e6)
kp <- plotKaryotype(genome="hg19", zoom=zoom)

genes.data <- makeGenesDataFromTxDb(TxDb.Hsapiens.UCSC.hg19.knownGene, 
                 karyoplot=kp, plot.transcripts=TRUE, 
                 plot.transcripts.structure=TRUE)
  
}
\seealso{
\code{\link{kpPlotGenes}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpPlotBAMCoverage.R
\name{kpPlotBAMCoverage}
\alias{kpPlotBAMCoverage}
\title{kpPlotBAMCoverage}
\usage{
kpPlotBAMCoverage(karyoplot, data=NULL, max.valid.region.size=1e6, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, col=NULL, border=NA, clipping=TRUE,...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a character) The path to a bam file (must be indexed).}

\item{max.valid.region.size}{(numeric) If the length of plotted region exceeds this number, nothing will be plotted. It's a safety mechanism to from excessive memory usage. (Defaults to 1e6, 1 milion bases)}

\item{ymin}{(numeric) The minimum value to be plotted on the data panel. If NULL, it is set to 0. (deafults to NULL)}

\item{ymax}{(numeric) The maximum value to be plotted on the data.panel. If NULL the maximum density is used. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{col}{(color) The fill color to plot. If NULL the color will be assigned automatically, either a lighter version of the color used for the outer line or gray if the line color is not defined. If NA no area will be drawn. (defaults to NULL)}

\item{border}{(color) The color to use to plot the borders of the bars. If NULL, it will be a darker version of 'col'. If NA, no border will be plotted. (Defaults to NA)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions. In particular \code{col} and \code{border} can be used to set the colors used.}
}
\value{
Returns the original karyoplot object with the data computed (max.coverage) stored at \code{karyoplot$latest.plot}
}
\description{
Plots the coverage of a BAM file along the genome
}
\details{
\code{kpPlotBAMCoverage} plots the read coverage of a BAM file, that is, the 
number of reads overlapping each position. It uses the 
\code{\link{bamsignals}} package to efficiently access the BAM file.
The BAM file must be indexed. This function is only recommended when 
plotting small parts of the genome. For larger plots consider using 
\code{\link{kpPlotBAMDensity}}.

There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
}
\note{
Since the plotting the exact coverage for large
regions of the genome may be unfeasable, it includes a safety mechanism
causing it to raise a warning and do nothing if the region is larger than 
a threshold specified by \code{max.valid.region.size}.
}
\examples{

library(pasillaBamSubset) #A package with 2 example bam files
un1.bam.file <- untreated1_chr4() # get the name of the first bam
un3.bam.file <- untreated3_chr4() #and the name of the second

kp <- plotKaryotype(genome="dm6", chromosomes="chr4") #The pasilla data comes from drosophila
kp <- kpAddBaseNumbers(kp, tick.dist = 1e5)
kp <- kpPlotBAMCoverage(kp, data = un1.bam.file) #Warning and does not plot. region too large.
kp <- kpPlotBAMCoverage(kp, data = un1.bam.file, max.valid.region.size=2000000)

#Use zoom to plot a smaller region to see the coverage with more detail
kp <- plotKaryotype(genome="dm6", zoom=toGRanges("chr4", 340000, 350000))
kp <- kpAddBaseNumbers(kp, tick.dist = 1e3)
kp <- kpPlotBAMCoverage(kp, data = un1.bam.file)


#Change the colors and borders and compare  two bams
kp <- plotKaryotype(genome="dm6", zoom=toGRanges("chr4", 340000, 350000))
kp <- kpAddBaseNumbers(kp, tick.dist = 1e3)
kp <- kpPlotBAMCoverage(kp, data = un1.bam.file, r0=0.5, r1=1, border="orange")
kp <- kpPlotBAMCoverage(kp, data = un3.bam.file, r0=0.5, r1=0, border="darkgreen") #r1 < r0 will flip the plot
kpAbline(kp, h=0.5, col="darkgray")



}
\seealso{
\code{\link{kpPlotBAMDensity}}, \code{\link{kpPlotCoverage}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpPlotHorizon.R
\name{kpPlotHorizon}
\alias{kpPlotHorizon}
\title{kpPlotHorizon}
\usage{
kpPlotHorizon(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, 
                     num.parts=3, breaks=NULL, ymin=NULL, ymax=NULL,
                     data.panel=1, r0=0, r1=1, col="redblue6", 
                     border=NA, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{GRanges}) A GRanges object with the data. If \code{data} is present, \code{chr} will be set to \code{seqnames(data)} and \code{x} to the midpoints of the rages in data. If no parameter \code{y} is specified and \code{data} has a column named \code{y} or \code{value} this column will be used to define the \code{y} value of each data point. (defaults to NULL)}

\item{chr}{(a charecter vector) A vector of chromosome names specifying the chromosomes of the data points. If \code{data} is not NULL, \code{chr} is ignored. (defaults to NULL)}

\item{x}{(a numeric vector) A numeric vector with the positions (in base pairs) of the data points in the chromosomes. If \code{data} is not NULL, \code{x} is ignored. (defaults to NULL)}

\item{y}{(a numeric vector) A numeric vector with the values of the data points. If \code{y} is not NULL, it is used instead of any data column in \code{data}. (defaults to NULL)}

\item{num.parts}{(numeric) The number of parts into which the positive and the negative y spaces will be cut. Only used if \code{breaks} is NULL. (defaults to 3)}

\item{breaks}{(numeric vector or list) A numeric vector of a list with two numeric vectors named "pos" and "neg". The exact break points where the y space will be cut. If NULL, the breaks will be automatically computed using num.parts. (defaults to NULL)}

\item{ymin}{(numeric) The minimum value of \code{y} to be plotted. If NULL, it is set to the min value of the selected data panel. (defaults to NULL)}

\item{ymax}{(numeric) The maximum value of \code{y} to be plotted. If NULL, it is set to the max value of the selected data panel. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{col}{(character, color vector or list) The palette name to be used, a color vector with the color to be used to define the color gradients or a list with two color vectors named "pos" and "neg". Available palettes are: redblue6, bluepurple10 and bluegold3 (defaults to "redblue6")}

\item{border}{(color) The color of the line delimiting the filled areas. If NULL the color will be assigned automatically to a darker version of the color used for the area. If NA no border will be drawn. (Defaults to NA)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Plot a horizon plot, an area-like plot where different value levels are
plotted in different colors.
}
\details{
kpPlotHorizon will create a horizon plot, a plot usually used in time series,
that will represent a wiggle value (coverage, methylation, expression...) 
that we'd usually plot with a line or area in a fraction of the vertical
space used by these function (usually in 1/6, but that's configurable).
To do that, it will cut the \code{y} space into N parts and assign a 
different color to each one, flip the negative values into the positive space
(with negative value colors) and plot all parts in the same vertical space.

A more detailed explanation of horizon plots can be found at  
https://flowingdata.com/2015/07/02/changing-price-of-food-items-and-horizon-graphs/ 
and a more detailed explanation of the horizon plots implemented in 
karyoploteR together with an explicative animation can be found at
https://bernatgel.github.io/karyoploter_tutorial/
}
\examples{


data.points <- toGRanges(data.frame(chr=c("chr1", "chr1"), start=c(1, 100), end=c(1, 100), y=c(-2, 2)))
kp <- plotKaryotype(zoom=toGRanges("chr1:1-100"))
kpLines(kp, data.points, r0=0, r1=0.5, ymin=-2, ymax=2)
kpAbline(kp, h=c(-2,-1,0,1,2), col="#AAAAAA", r0=0, r1=0.5, ymin=-2, ymax=2)
kpAxis(kp, r0=0, r1=0.5, ymin=-2, ymax=2)
kpPlotHorizon(kp, data.points, r0=0.55, r1=1)


data.points <- toGRanges(data.frame(chr="chr1", start=1:100, end=1:100))
data.points$y <- sin(start(data.points)/2)
kp <- plotKaryotype(zoom=toGRanges("chr1:1-100"))
kpLines(kp, data.points, r0=0, r1=0.5, ymin=-1, ymax=1)
kpAbline(kp, h=c(-1,0,1), col="#AAAAAA", r0=0, r1=0.5, ymin=-1, ymax=1)
kpAxis(kp, r0=0, r1=0.5, ymin=-1, ymax=1)
kpPlotHorizon(kp, data.points, r0=0.55, r1=1)


set.seed(1000)
data.points <- sort(createRandomRegions(nregions=500, mask=NA))
mcols(data.points) <- data.frame(y=runif(500, min=-3, max=3))

kp <- plotKaryotype(chromosomes=c("chr1", "chr2"))
kpPlotHorizon(kp, data=data.points)

kp <- plotKaryotype(chromosomes=c("chr1", "chr2"))
kpPlotHorizon(kp, data=data.points, num.parts=1, r0=autotrack(1, 6)$r0, r1=autotrack(1, 6)$r1)
kpPlotHorizon(kp, data=data.points, num.parts=2, r0=autotrack(2, 6)$r0, r1=autotrack(2, 6)$r1)
kpPlotHorizon(kp, data=data.points, num.parts=3, r0=autotrack(3, 6)$r0, r1=autotrack(3, 6)$r1)
kpPlotHorizon(kp, data=data.points, num.parts=5, r0=autotrack(4, 6)$r0, r1=autotrack(4, 6)$r1)
kpPlotHorizon(kp, data=data.points, num.parts=9, r0=autotrack(5, 6)$r0, r1=autotrack(5, 6)$r1)
kpPlotHorizon(kp, data=data.points, num.parts=15, r0=autotrack(6, 6)$r0, r1=autotrack(6, 6)$r1)
kpLines(kp, data=data.points, ymin=-3, ymax=3)
kpAbline(kp, h=0, ymin=-3, ymax=3)
 
kp <- plotKaryotype(chromosomes=c("chr1", "chr2"))
kpPlotHorizon(kp, data=data.points, num.parts=4, r0=autotrack(1, 6)$r0, r1=autotrack(1, 6)$r1)
kpPlotHorizon(kp, data=data.points, col="redblue6", num.parts=4, r0=autotrack(2, 6)$r0, r1=autotrack(2, 6)$r1)
kpPlotHorizon(kp, data=data.points, col="bluepurple10", num.parts=4, r0=autotrack(3, 6)$r0, r1=autotrack(3, 6)$r1)
kpPlotHorizon(kp, data=data.points, col="bluegold3", num.parts=4, r0=autotrack(4, 6)$r0, r1=autotrack(4, 6)$r1)
kpPlotHorizon(kp, data=data.points, col=c("red", "black", "green"), num.parts=4, r0=autotrack(5, 6)$r0, r1=autotrack(5, 6)$r1)
kpPlotHorizon(kp, data=data.points, col=c("red", "yellow"), num.parts=4, r0=autotrack(6, 6)$r0, r1=autotrack(6, 6)$r1)


}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpLines}}, \code{\link{kpText}}, \code{\link{kpPlotRibbon}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpPlotManhattan.R
\name{kpPlotManhattan}
\alias{kpPlotManhattan}
\title{kpPlotManhattan}
\usage{
kpPlotManhattan(karyoplot, data=NULL, pval=NULL, points.col="2grays", 
points.pch=16, points.cex=1, suggestiveline = -log10(1e-05), 
suggestive.col="black", suggestive.lwd=1, suggestive.lty=2, 
genomewideline = -log10(5e-08), genomewide.col="black", genomewide.lwd=1, 
genomewide.lty=1, logp=TRUE, highlight=NULL, highlight.col="greenyellow",
ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{GRanges}) A GRanges object (or any other format accepted by \code{\link[regioneR]{toGRanges}}) with the data points to plot. If the \code{pval} parameter is NULL and  \code{data} has a column named "p" or "pval", it will be used as the pvalues to plot.}

\item{pval}{(numeric) The pvalues to plot. It must have the same length as data. If NULL, \code{data$p} or \code{data$pval} will be used, if present. (defaults to NULL)}

\item{points.col}{(colors or character) The colors used to plot the points. It can be either a vector of colors of the same length of data or a valid color specification for \code{\link{colByChr}}. (defaults to "2grays")}

\item{points.pch}{(numeric between 1 and 25) The symbol used to plot every point. (Defaults to 16, a filled circle)}

\item{points.cex}{(numeric) The size of the point symbols. (defaults to 1)}

\item{suggestiveline}{(numeric) The suggestive significance threshold. The suggestive line will be plotted at this vertical position. If NULL, no line will be plotted. (defaults to -log10(1e-05))}

\item{suggestive.col}{(color) The color of the suggestive line. (defaults to "black")}

\item{suggestive.lwd}{(numeric) The width of the suggestive line (defaults to 1)}

\item{suggestive.lty}{(numeric) The line type of the suggestive line (defaults to 2, dashed line)}

\item{genomewideline}{(numeric) The genomewide significance threshold. The genomewide line will be plotted at this vertical position. If NULL, no line will be plotted (defaults to  -log10(5e-08))}

\item{genomewide.col}{(color) The color of the genomewide line. (defaults to "black")}

\item{genomewide.lwd}{(numeric) The width of the genomewide line. (defaults to 1)}

\item{genomewide.lty}{(numeric) The line type of the genomewide line. (defaults to 1, solid line)}

\item{logp}{(logical) If TRUE, pval will be transformed using -log10(pval). (defaults to TRUE)}

\item{highlight}{(GRanges, character vector, logical vector or numeric vector) The points to highlight in a different color. If a GRanges (or anythng accepted by \code{\link[regioneR]{toGRanges}}) the points overlapping these regions will be highlighted. Otherwise the points will be selected with \code{data[highlight]}. If NULL no point will be highlighted. (defaults to NULL)}

\item{highlight.col}{The color of the highlighted points (defaults to "greenyellow")}

\item{ymin}{(numeric) The minimum value to be plotted on the data panel. If NULL, it is set to 0. (deafults to NULL)}

\item{ymax}{(numeric) The maximum value to be plotted on the data.panel. If NULL, it is set to 1. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object with the data computed (ymin, ymax,
suggestiveline, genomewideline and data (with two additional columns pval and
color)) stored at \code{karyoplot$latest.plot}
}
\description{
Creates a manhattan plot, the ones usually seen in GWAS studies.
}
\details{
Creates a manhattan plot, the ones usually seen in GWAS studies. By default,
it will compute the -log10 of the pvalues given and plot them as points. In
addition, it can plot to horizontal lines, one for the "suggestive" threshold
and another one for the "genomewide" significance threshold.
In addition, it can highlight some of the data points in a different color. 
Highlighted data points can be specified per name, per position in the data 
structure or by their position on the genome (see examples).

There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
}
\examples{

set.seed(1000)

#First simulate a GWAS result with a single significant peak
data <- createRandomRegions(nregions=20000, length.mean=1, length.sd=0, genome=filterChromosomes(getGenome("hg19")))
names(data) <- paste0("rs", 1:20000)
data$pval <- rnorm(n = 20000, mean = 0.5, sd = 0.5)
data$pval[data$pval<0] <- -1*data$pval[data$pval<0]
snps.in.peak <- which(overlapsAny(data, toGRanges("chr3:70e6-80e6")))
data$pval[snps.in.peak] <- runif(n = length(snps.in.peak), min=0.1, max=8)
data$pval <- 10^(-1*data$pval)
 
kp <- plotKaryotype("hg19", plot.type=4)
kp <- kpPlotManhattan(kp, data, ymax=8)
kpAxis(kp, ymax=8)

#Highlighting 
kp <- plotKaryotype("hg19", plot.type=4)
kp <- kpPlotManhattan(kp, data, ymax=8, highlight="chr3:70e6-80e6", r0=autotrack(1,4))
kp <- kpPlotManhattan(kp, data, ymax=8, highlight=snps.in.peak, highlight.col="orchid", r0=autotrack(2,4))
kp <- kpPlotManhattan(kp, data, ymax=8, highlight=names(data)[snps.in.peak], highlight.col="orange", r0=autotrack(3,4))
kp <- kpPlotManhattan(kp, data, ymax=8, highlight=overlapsAny(data, toGRanges("chr3:70e6-80e6")), r0=autotrack(4,4))

#Look and feel
kp <- plotKaryotype("hg19", plot.type=4)
kp <- kpPlotManhattan(kp, data, ymax=8, points.col="2blues", highlight="chr3:70e6-80e6", points.pch=2, points.cex=0.6, suggestive.col="red", suggestive.lwd=3, suggestive.lty=4)


}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpPoints}}, \code{\link{colByChr}}, \code{\link{colByRegion}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpPlotGenes.R
\name{kpPlotGenes}
\alias{kpPlotGenes}
\title{kpPlotGenes}
\usage{
kpPlotGenes(karyoplot, data, gene.margin=0.3, gene.col=NULL, gene.border.col=NULL,
                       add.gene.names=TRUE, gene.names=NULL, gene.name.position="top", gene.name.cex=1, gene.name.col=NULL,
                       plot.transcripts=TRUE, transcript.margin=0.5, transcript.col=NULL, transcript.border.col=NULL,
                       add.transcript.names=FALSE, transcript.names=NULL, transcript.name.position="left", transcript.name.cex=0.6, transcript.name.col=NULL,
                       plot.transcripts.structure=TRUE,
                       non.coding.exons.height=0.5, 
                       add.strand.marks=TRUE, mark.height=0.20, mark.width=1, mark.distance=4,
                       coding.exons.col=NULL, coding.exons.border.col=NULL, 
                       non.coding.exons.col=NULL, non.coding.exons.border.col=NULL, 
                       introns.col=NULL, marks.col=NULL,
                       data.panel=1, r0=NULL, r1=NULL, col="black", 
                       border=NULL, avoid.overlapping=TRUE, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{TxDb} object or a list with the required elements) A \code{TxDb} object with information on genes, transcripts and exons and their position on the genome.}

\item{gene.margin}{(numeric) If whole genes (as oposed to transcripts) are plotted (\code{plot.transcripts=FALSE}), the vertical margin between overlapping genes. The value is with respect to the gene height. A value of 0.5 will create a space above the genes with half the height of the genes themselves. (defaults to 0.3)}

\item{gene.col}{(color) If whole genes (as oposed to transcripts) are plotted (\code{plot.transcripts=FALSE}), the color used to fill the rectangles representing the genes. If NULL, the value of \code{col} will be used. (Defaults to NULL)}

\item{gene.border.col}{(color) If whole genes (as oposed to transcripts) are plotted (\code{plot.transcripts=FALSE}), the color used in the border of the rectangles representing the genes. If NULL, the value of \code{col} will be used. If NA, no border is drawn. (Defaults to NULL)}

\item{add.gene.names}{(boolean) Whether to add the names of the genes to the plot.}

\item{gene.names}{(named character vector) A named character vector with the labels of the genes. If not NULL, it will be used as a dictionary, so gene ids should be names and desired labels the values. If NULL, if genes.data$genes$name exists, it will use it, otherwise it will use the mcols(genes.data$genes)[,1] as labels. (defaults to NULL)}

\item{gene.name.position}{(character) The position of the gene name text relative to the rectangle. Can be "left", "right", "top", "bottom" or "center". (Defaults to "top")}

\item{gene.name.cex}{(numeric) The cex value to plot the gene names (defaults to 1)}

\item{gene.name.col}{(color) The color of the gene labels. If NULL, it will use col. (defaults to NULL)}

\item{plot.transcripts}{(boolean) Whether to plot the individual transcripts (TRUE) or a single rectangle to represent the whole gene (FALSE). (Defaults to TRUE)}

\item{transcript.margin}{(numeric) If transcripts are plotted (\code{plot.transcripts=TRUE}), the vertical margin between overlapping transcripts. The value is with respect to the transcript height. A value of 0.5 will create a space above the transcripts with half the height of the transcripts themselves. (defaults to 0.5)}

\item{transcript.col}{(color) If transcripts are plotted (\code{plot.transcripts=TRUE}), the color used to fill the rectangles representing the transcripts. If NULL, the value of \code{col} will be used. (Defaults to NULL)}

\item{transcript.border.col}{(color) If transcripts are plotted (\code{plot.transcripts=TRUE}), the color used in the border the rectangles representing the transcripts. If NULL, the value of \code{col} will be used. If NA, no border will be drawn. (Defaults to NULL)}

\item{add.transcript.names}{(boolean) Whether to add the names of the tramscripts to the plot. (defaults to FALSE)}

\item{transcript.names}{(named character) A named character vector with the labels of the transcripts. If not null, it will be used as a dictionary, so transcript ids should be names and desired labels the values. If NULL, the transcript ids will be used as labels. (defaults to null)}

\item{transcript.name.position}{(character) The position of the transcript name text relative to the rectangle. Can be "left", "right", "top", "bottom" or "center". (Defaults to "left")}

\item{transcript.name.cex}{(numeric) The cex value to plot the transcript names (defaults to 0.6)}

\item{transcript.name.col}{(color) The color of the transcript labels. If NULL, it will use col. (defaults to NULL)}

\item{plot.transcripts.structure}{(boolean) Whether to draw the transcripts as single rectangles (FALSE) or to show the complete transcript structure (introns and exons) (TRUE). (Defaults to TRUE)}

\item{non.coding.exons.height}{(numeric) The height of the non.coding exons relative to the transcript height. For example, if 0.5, non-coding exons will have a height half the size of the coding ones. (default 0.5)}

\item{add.strand.marks}{(boolean) Whether strand marks should be plotted or not. Strand marks are small arrows along the introns (or whole transcripts if plot.transcript.structure=FALSE). (defaults to TRUE)}

\item{mark.height}{(numeric) The height of the strand marks in "coding exons heights", that is, if mark.height is 0.5, the mark will have a height of half the height of an exon. (defaults to 0.2)}

\item{mark.width}{(numeric) The width of the strand marks, in mark heights. mark.width=1 will produce arrow heads with a slope pf 45 degrees. A value higher than 1 will produce smaller angles and a value below 1 larger angles with more vertical lines. (defaults to 1, 45 degrees)}

\item{mark.distance}{(numeric) The distance between marks, in mark widths. A distance of 2, will add a space of 2*mark.width between consecutive marks. (defaults to 4)}

\item{coding.exons.col}{(color) The fill color of the rectangles representing the coding exons. If NULL, it will use col. (defaults to NULL)}

\item{coding.exons.border.col}{(color) The color of the border of the coding exons. If NULL, it will use border. (defaults to NULL)}

\item{non.coding.exons.col}{(color) The fill color of the rectangles representing the non-coding exons. If NULL, it will use col. (defaults to NULL)}

\item{non.coding.exons.border.col}{(color) The color of the border of the non-coding exons. If NULL, it will use border. (defaults to NULL)}

\item{introns.col}{(color) The color of the lines representing the introns. If NULL, it will use col. (defaults to NULL)}

\item{marks.col}{(color) The color of the arrows representing the strand. If NULL, it will use col. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{col}{(color) The color of the genes, transcripts and labels. It is possible to specify different colors for each element class (transcript names, exons, strand marks...). All elements with no explicit color will be plotted using col. (Defaults to "black")}

\item{border}{(color) The color of the border of rectangles representing genes, transcripts and exons. Every element class may have its own specific color using the appropiate parameters. The ones with no explicit color will use border. At the same time, if border is NULL, it will default to col. (Defaults to NULL)}

\item{avoid.overlapping}{(boolean) If two or more regions (genes, transcripts) overlap in the genome (even partially), they can be drawn in two different layers (TRUE) or in the same layer, with superposing representations (FALSE). (Defaults to TRUE, draw non-overlapping elements)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Plot genes and transcripts in the genome. Can get the genes and trancripts information from TxDb or from custom objects.
}
\details{
This is one of karyoploteR's higher level functions. It takes a transcript 
 database (\code{TxDb}) object or a custom object with a specific structure 
 and plots the genes along the genome. It's possible to plot genes as 
 a whole using rectangle for each gene or to plot each transcript 
 independently. If transcripts are drawn, it's possible to plot them as
 single boxes or to plot the detailed structure, differentiating 
 coding exons, non-coding exons and introns. Transcripts may have, in 
 addition, little arrows to mark the trascript strand (plus or minus). These
 strand marks are plotted in introns if the transcript structure is shown 
 or on the whole transcript length if transcripts are plotted as boxes. 
 Finally, it's possible to add labels to genes and transcripts. By default 
 genes and transcripts identifiers in the input data structure will be used
 as labels, but it's possible to provide named character vectors to be 
 used as dictionaries to change id's to better names.
   
 The genes and transcripts representations are customizable. It's possible
 to change the colors of the different elements individually (i.e. to 
 have red coding exons, blue non-coding exons and green introns); it's 
 possible to change the relative height of the non-coding exons and to 
 change the slate and density of the strand marks.
 
 The data stating the positions of genes, transcripts and exons in the 
 genome and their relations (which transcripts belong to which genes) 
 can be given as a standard transcript database (\code{TxDb}) object or
 as a custom list with the following elements: \code{genes},
 \code{transcripts}, \code{coding.exons} and \code{non.coding.exons}.
}
\note{
Plotting transcripts, specially plotting their structure might get 
quite slow in comparison to the usual speed of plotting in karyoploteR. It
is not advised to plot genes and transcripts on the whole genome or in 
large regions of it. These functions have been designed to work with
zoomed in karyoplots.
}
\examples{
 
 
 library(TxDb.Hsapiens.UCSC.hg19.knownGene)
 txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
 
 zoom <- toGRanges("chr2", 47986268, 48147403)
 gene.names <- c("2956"="MSH6", "80204"="FBXO11")
 
 kp <- plotKaryotype(genome="hg19", zoom=zoom)
 kpPlotGenes(kp, data=txdb, add.transcript.names = FALSE, gene.names=gene.names, r1=0.6)

 kp <- plotKaryotype(genome="hg19", zoom=zoom)
 kpPlotGenes(kp, data=txdb, plot.transcripts=FALSE, gene.names=gene.names, r1=0.6)

 kp <- plotKaryotype(genome="hg19", zoom=zoom)
 kpPlotGenes(kp, data=txdb, plot.transcripts.structure=FALSE, add.transcript.names=FALSE, gene.names=gene.names, r1=0.8, col="blue", marks.col="white", gene.name.col="black")
 
 library(TxDb.Mmusculus.UCSC.mm10.knownGene)
 kp <- plotKaryotype(genome="mm10", zoom="chr1:10.5e6-12.5e6")
 genes.data <- makeGenesDataFromTxDb(txdb=TxDb.Mmusculus.UCSC.mm10.knownGene, karyoplot=kp)
 genes.data <- addGeneNames(genes.data)
 genes.data <- mergeTranscripts(genes.data)
 kpPlotGenes(kp, genes.data, r1=0.25, mark.height = 0.5, gene.name.position = "left")
 
 
}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpRect}}, \code{\link{kpSegments}}, \code{\link{kpPlotTranscripts}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getDataPanelBoundingBox.R
\name{getDataPanelBoundingBox}
\alias{getDataPanelBoundingBox}
\title{getDataPanelBoundingBox}
\usage{
getDataPanelBoundingBox(karyoplot, data.panel)
}
\arguments{
\item{karyoplot}{a \code{karyoplot} object returned by a call to \code{plotKaryotype}}

\item{data.panel}{a valid data panel name (i.e. 1, 2, "ideogram", "all")}
}
\value{
Returns a list with four elements (x0, x1, y0 and y1), each of them an 
integer with the plot coordinates for the data.panel
}
\description{
Return the bounding box of a data panel in plot coordinates
}
\details{
Given a KaryoPlot object and a data.panel name, return the region 
where the data panel is placed. The returned values are in plot
coordinates, that is, the coord.change.function has been applied.
}
\note{
A user is not expected to need this function. It is mainly
used by plotting functions, specially when clipping the plot in 
a zoomed region.
}
\examples{

kp <- plotKaryotype(plot.type=2)
dp1 <- getDataPanelBoundingBox(kp, 1)
 
}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpDataBackground}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpAddColorRect.R
\name{kpAddColorRect}
\alias{kpAddColorRect}
\title{kpAddColorRect}
\usage{
kpAddColorRect(karyoplot, col="gray", rect.width=0.02, rect.margin=0.01,  side="left", y0=0, y1=1, r0=NULL, r1=NULL, data.panel=1, border=NA, ...)
}
\arguments{
\item{karyoplot}{a \code{karyoplot} object returned by a call to \code{plotKaryotype}}

\item{col}{(color) the color of the rectangle}

\item{rect.width}{(numeric) the width of the rectangle in plot coordinates (the whole plot has a width of 1). Usual value might be 0.05. Can be negative. (defaults to 0.02)}

\item{rect.margin}{(numeric) the additional the margin between the rectangle and the chromosome. In plot coordinates (the whole plot has a width of 1). Usual value might be 0.05. Can be negative. (defaults to 0.01)}

\item{side}{("left" or "right") The side of the plot where to plot the labels. (defaults to "left")}

\item{y0}{(numeric) If the vertical space defined by r0 and r1 goes from 0 to 1, the value at which the bottom of the rectangle starts. Ex: y0=0.5, y1=1 will create a rectangle occupying the top half of the total allocated vertical space. (defaults to 0)}

\item{y1}{(numeric) If the vertical space defined by r0 and r1 goes from 0 to 1, the value at which the top of the rectangle ends. Ex: y0=0, y1=0.5 will create a rectangle occupying the bottom half of the total allocated vertical space. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to position the rectangle. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to position the rectangle. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the labels are to be added. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{border}{(color) The color of the rectangle border. If NA, no border will be plotted. (defaults to NA)}

\item{...}{any additional parameter to be passed to the text plotting. All R base graphics params are passed along.}
}
\value{
invisibly returns the given karyoplot object
}
\description{
Add color rectangles next to the data panels. Ideal to identify the data in the plot
}
\details{
Given a KaryoPlot object, plot colored rectangles on the side of the data panels to help identify the different samples or types of data plotted
}
\examples{

 num.samples <- 10
samples.metadata <- data.frame(stage=c("I", "I", "I", "III", "IV", "III", "II", "IV", "IV", "IV"),
                                metastasis=c(0,0,0,0,1,0,0,0,1,0),
                                subtype=c("A", "A", "B", "B", "A", "B", "B", "B", "A", "B"))

kp <- plotKaryotype(plot.type=4)
for(i in 1:num.samples) {
  #metastasis
  kpAddColorRect(kp, col = colByCategory(samples.metadata$metastasis, color=c("white", "black"))[i],
                 rect.margin = 0.01, rect.width = 0.01, r0=autotrack(i, num.samples))
  #stage
  kpAddColorRect(kp, 
    col = colByCategory(samples.metadata$stage, colors=c("I"="plum1", "II"="hotpink", "III"="orange", "IV"="red2"))[i],
    rect.margin = 0.021, rect.width = 0.01, r0=autotrack(i, num.samples))
  #subtype
  kpAddColorRect(kp, 
                 col = colByCategory(samples.metadata$subtype, colors=c("dodgerblue", "gold"))[i],
                 rect.margin = 0.032, rect.width = 0.01, r0=autotrack(i, num.samples))
}

}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{autotrack}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotKaryotype.R
\name{plotKaryotype}
\alias{plotKaryotype}
\title{plotKaryotype}
\usage{
plotKaryotype(genome="hg19", plot.type=1, ideogram.plotter=kpAddCytobands, labels.plotter=kpAddChromosomeNames, chromosomes="auto", zoom=NULL, cytobands=NULL, plot.params=NULL, use.cache=TRUE, main=NULL, ...)
}
\arguments{
\item{genome}{The genome to plot. It can be either a UCSC style genome name (hg19, mm10, etc), a BSgenome, a Seqinfo object, a GRanges object with the chromosomes as ranges or in general any genome specification accepted by \code{\link[regioneR]{getGenomeAndMask}}. (defaults to "hg19")}

\item{plot.type}{The orientation of the ideogram and placing of the data panels. Values explained above.. (defaults to 1)}

\item{ideogram.plotter}{The function to be used to plot the ideograms. Only one function is included with the package, \code{kpAddCytobands}, but it is possible to create custom ones. If NULL, no ideograms are plotted. (defaults to \code{kpAddCytobands})}

\item{labels.plotter}{The function to be used to plot the labels identifying the chromosomes. Only one function is included with the package, \code{kpAddChromosomeNames}, but it is possible to create custom ones. If NULL, no labels are plotted. (defaults to \code{kpAddChromosomeNames})}

\item{chromosomes}{The chromosomes to plot. Can be either a vector of chromosome names or a chromosome group name ("canonical", "autosomal", "all"). Setting it yo "auto" will select canonical. If no predefined filtering data is available, a heuristic filtering  will be used. To deactivate filtering set chromosomes="all". (defaults to "auto")}

\item{zoom}{A GRanges object specifiyng a single region to zoom in or any format accepted by \code{regioneR::toGRanges}. If not NULL, it takes precedence over \code{chromosome} and only the zoomed in region is represented. If more than one region is present in the GRanges, only the first one is used. (defaults to NULL, do not zoom in and show the whole plot as specified by \code{genome} and \code{chromosomes})}

\item{cytobands}{A GRanges object (or anything accepted by \code{\link[regioneR]{toGRanges}} function: bed file, data.frame...) specifying the positions and types of the cytobands. The type of the cytobands MUST be in a column named "gieStain" (as used by UCSC) with values such as 'gneg', 'gpos50', 'stalk', 'acen'... If NULL, the cytobands are recovered from the package cache or downloaded from UCSC if possible (it's not possible for custom genomes). If empty, no cytobands will be plotted. (defaults to NULL)}

\item{plot.params}{An object obtained from \code{\link{getDefaultPlotParams}} and possibly modified, containing the basic plotting parameters. If NULL, the defaults parameters will be used. (defaults to NULL)}

\item{use.cache}{\code{karyoploteR} has a small cache with the chromosome names and lengths and the cytobands for a handful of organisms so it's not needed to retrieve them from databses or \code{BSGenomes} objects. Set this parameter to FALSE to ignore the cache. (defaults to TRUE, use the cache)}

\item{main}{The text to be used as the title of the plot. NULL produces no title. (defaults to NULL)}

\item{...}{The ellipsis can be used to pass in any additional parameter accepted by the internal functions used.}
}
\value{
The \code{KaryoPlot} object needed by the plotting functions.
}
\description{
Create a new empty plot with a karyotype (the chromosome ideograms and chromosome names).
}
\details{
This is the main function of \code{karyoploteR}. It creates the basic empty plot with 
 the chromosome ideograms and returns the karyoplot object needed for all other plotting 
 functions. Both the basic plotting parameters (margins, sizes, etc.) and the specific
 plotting functions for the ideograms and chromosome labels are customizable. 
 In particular, passing in a \code{plot.params} object specifies the basic plotting 
 parameters to use and the \code{ideogram.plotter} and \code{labels.plotter} parameters 
 can be used to specify custom plotting functions for the ideogram and the chromosome 
 labels. It is also possible to specify the genome and a list with the chromosomes to
 be plotted. 
 
 The \code{plot.type} parameter specifies the type of karyoplot to create: the number
 and positions of the data panels respect to the ideograms: 
 \itemize{
   \item \code{plot.type=1}  Horizontal ideograms with a single data panel above them
   \item \code{plot.type=2}  Horizontal ideograms with two data panels, one above and one below them
   \item \code{plot.type=3}  Horizontal ideograms with all chromosomes in a single line with two data panels, one above and one below them
   \item \code{plot.type=4}  Horizontal ideograms with all chromosomes in a single line with one data panel above
   \item \code{plot.type=5}  Horizontal ideograms with all chromosomes in a single line with one data panel below them
   \item \code{plot.type=6}  Horizontal ideograms with NO data panels. Only plotting in the ideograms is possible.
   \item \code{plot.type=7}  Horizontal ideograms with all chromosomes in a single line with NO data panels. Only plotting in the ideograms is possible.
 }
 
There's more information at the \url{https://bernatgel.github.io/karyoploter_tutorial/}{karyoploteR tutorial}.
}
\examples{
 
 set.seed(1000)

rand.data <- createRandomRegions(genome="hg19", nregions=10000, length.mean=1, 
                                 length.sd=0, mask=NA, non.overlapping=TRUE)
mcols(rand.data) <- data.frame(y=rnorm(n=10000, mean = 0.5, sd=0.1))
 
#The simplest way, with all default parameters
kp <- plotKaryotype()
kpPoints(kp, rand.data, pch=".")

#Or we can plot only a few chromosomes, with 2 data panels
kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 2)
kpDataBackground(kp, data.panel = 1, color = "lightgreen")
kpDataBackground(kp, data.panel = 2, color = "lightblue")
kpPoints(kp, rand.data, pch=".", data.panel = 1)
kpPoints(kp, rand.data, pch=".", data.panel = 2)


#Or we can use a different organism, 
kp <- plotKaryotype(genome = "mm10")
kp <- plotKaryotype(genome = "dm6")

# Or we can change the plotting parameters. In this case, to create a smaller ideogram
# and smaller data panel below it
plot.params <- getDefaultPlotParams(plot.type=2)
plot.params$ideogramheight <- 5
plot.params$data2height <- 50

kp <- plotKaryotype(chromosomes = c("chr1", "chr2"), plot.type = 2, plot.params = plot.params)
kpDataBackground(kp, data.panel = 1, color = "lightgreen")
kpDataBackground(kp, data.panel = 2, color = "lightblue")
kpPoints(kp, rand.data, pch=".", data.panel = 1)
kpPoints(kp, rand.data, pch=".", data.panel = 2)

#Or we can remove the cytobands, passing an empty GRanges object
kp <- plotKaryotype(cytobands = GRanges())

#Or remove the chromosome labels
kp <- plotKaryotype(labels.plotter = NULL)
kpPoints(kp, rand.data, pch=".")

#In addition, it's possible to use maggrittr piping to chain the plotting calls
library(magrittr)
kp <- plotKaryotype() \%>\%
   kpDataBackground(color = "lightgreen") \%>\%
   kpPoints(rand.data, pch=".")


}
\seealso{
\code{\link{getDefaultPlotParams}}, \code{\link{kpPoints}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/color.R
\name{plotPalettes}
\alias{plotPalettes}
\title{plotPalette}
\usage{
plotPalettes(cols, add.color.name=TRUE, border=NA, palette.names.col="black", palette.names.cex=1, palette.names.srt=0, color.names.col="auto", color.names.cex=1, color.names.srt=0, ...)
}
\arguments{
\item{cols}{(color vector or list of color vectors) The colors to plot}

\item{add.color.name}{(logical) Wether to add or not the names of the colors, their definition.}

\item{border}{(color) The color of the border of the palette rectangles. If NA, no border. (defaults to NA)}

\item{palette.names.col}{(color) The color of the palette names (defaults to "black")}

\item{palette.names.cex}{(numeric) The cex value (size) for the palette names (defaults to 1)}

\item{palette.names.srt}{(numeric) The srt value (rotation) for the palette names (defaults to 0)}

\item{color.names.col}{(color) The color of the color names. If auto, it will be blak for light colors and white for the dark ones (defaults to "auto")}

\item{color.names.cex}{(numeric) The cex value (size) for the color names  (defaults to 1)}

\item{color.names.srt}{(numeric) The srt value (rotation) for the color names (defaults to 0)}

\item{...}{Any additional plotting parameters}
}
\value{
nothing
}
\description{
Create a plot of the palette.
}
\details{
Creates a simple plot with a rectangle for every color of every palette.
cols must be either a vector of colors (in any format accepted by 
karyoploteR::"is.color") or a list of such vectors.
The names of the list elements will be treated as the palette names, if
the list has no names, palettes will be called "Pallete1", "Palette2", ...
}
\examples{
 
plotPalettes(c("red", "blue", "yellow", "green"))
palettes <- list("P1"=c("red", "#000000", lighter("gold")), 
                 "P2"=c("orchid", "yellow"))
plotPalettes(palettes, color.names.col=c("blue", "green", "red"), border="black", color.names.srt=45)
plotPalettes(palettes, color.names.col="auto", border="black", color.names.srt=45)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpLines.R
\name{kpLines}
\alias{kpLines}
\title{kpLines}
\usage{
kpLines(karyoplot, data=NULL, chr=NULL, x=NULL, y=NULL, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL, clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{data}{(a \code{GRanges}) A GRanges object with the data. If \code{data} is present, \code{chr} will be set to \code{seqnames(data)} and \code{x} to the midpoints of the rages in data. If no parameter \code{y} is specified and \code{data} has a column named \code{y} or \code{value} this column will be used to define the \code{y} value of each data point. (defaults to NULL)}

\item{chr}{(a charecter vector) A vector of chromosome names specifying the chromosomes of the data points. If \code{data} is not NULL, \code{chr} is ignored. (defaults to NULL)}

\item{x}{(a numeric vector) A numeric vector with the positions (in base pairs) of the data points in the chromosomes. If \code{data} is not NULL, \code{x} is ignored. (defaults to NULL)}

\item{y}{(a numeric vector) A numeric vector with the values of the data points. If \code{y} is not NULL, it is used instead of any data column in \code{data}. (defaults to NULL)}

\item{ymin}{(numeric) The minimum value of \code{y} to be plotted. If NULL, it is set to the min value of the selected data panel. (defaults to NULL)}

\item{ymax}{(numeric) The maximum value of \code{y} to be plotted. If NULL, it is set to the max value of the selected data panel. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
Plots a line joining the data points along the genome.
}
\details{
This is one of the functions from karyoploteR implementing the adaptation to the genome 
context of basic plot functions
from R base graphics. Given a set of positions on the genome (chromosome and base) and a 
value (y) for each of them, it plots a line joining them. Data can be provided 
via a \code{GRanges} object (\code{data}), independent parameters for chr, x and y or a 
combination of both. A number of parameters can be used to define exactly where 
and how the lines are drawn. In addition, via the ellipsis operator (\code{...}),
\code{kpLines} accepts any parameter valid for \code{\link[graphics]{lines}} 
(e.g. \code{lwd}, \code{lty}, \code{col}, ...) The lines are drawn in a per chromosome 
basis, so it is not possible to draw lines encompassing more than one chromosome.
}
\examples{
 
set.seed(1000)
data.points <- sort(createRandomRegions(nregions=500, mask=NA))
mcols(data.points) <- data.frame(y=runif(500, min=0, max=1))

kp <- plotKaryotype("hg19", plot.type=2, chromosomes=c("chr1", "chr2"))
  kpDataBackground(kp, data.panel=1)
  kpDataBackground(kp, data.panel=2)

  kpLines(kp, data=data.points, col="red")

  #Three ways of specifying the exact same data.points
  kpPoints(kp, data=data.points)
  kpPoints(kp, data=data.points, y=data.points$y, pch=16, col="#CCCCFF", cex=0.6)
  kpPoints(kp, chr=as.character(seqnames(data.points)), 
           x=(start(data.points)+end(data.points))/2, y=data.points$y, pch=".",
           col="black", cex=1)

  #plotting in the data.panel=2 and using r0 and r1, ymin and ymax
  kpLines(kp, data=data.points, col="red", r0=0, r1=0.3, data.panel=2)
  kpPoints(kp, data=data.points, r0=0, r1=0.3, data.panel=2, pch=".", cex=3)

  kpLines(kp, data=data.points, col="blue", r0=0.4, r1=0.7, data.panel=2)
  kpLines(kp, data=data.points, col="blue", y=-1*(data.points$y), 
          ymin=-1, ymax=0, r0=0.7, r1=1, data.panel=2)
  #It is also possible to "flip" the data by giving an r0 > r1
  kpPoints(kp, data=data.points, col="red", y=(data.points$y), 
           r0=1, r1=0.7, data.panel=2, pch=".", cex=2)  


 
}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpLines}}, \code{\link{kpText}}, \code{\link{kpPlotRegions}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genes.R
\name{mergeTranscripts}
\alias{mergeTranscripts}
\title{mergeTranscripts}
\usage{
mergeTranscripts(genes.data)
}
\arguments{
\item{genes.data}{(GenesData object) A valid genes.dat object like the ones obtained by \code{\link{makeGenesDataFromTxDb}}}
}
\value{
The original GenesData object with a single transcript per gene 
\code{GenesData$genes$names}.
}
\description{
Merges the transcripts of each gene and creates one transcript per gene with
all exons and UTR regions combined
}
\details{
This function takes a valid data object and merges all transcripts from 
each gene into a single transcript. This is useful to reduce the plot
complexity while keeping partial information on transcript structure.#' 
In this transcript, any region that is a coding exon in any transcript,
will be an exon, any region that is a non-coding exon in any transcript
and is not an exon in any transcript, will be a non-coding exon. 
Anything between coding and non-coding exons will be introns.
}
\examples{
 
library(TxDb.Hsapiens.UCSC.hg19.knownGene)

zoom <- toGRanges("chr17:29.4e6-29.8e6")
kp <- plotKaryotype(genome="hg19", zoom=zoom)
genes.data <- makeGenesDataFromTxDb(TxDb.Hsapiens.UCSC.hg19.knownGene, karyoplot=kp)
genes.data <- addGeneNames(genes.data)
kpPlotGenes(kp, data=genes.data, r1=0.5, plot.transcripts=TRUE, gene.name.position = "left")
genes.data.merged <- mergeTranscripts(genes.data)
kpPlotGenes(kp, data=genes.data.merged, r0=0.6, r1=0.8, plot.transcripts=TRUE, gene.name.position = "left")
 
}
\seealso{
\code{\link{kpPlotGenes}}, \code{\link{makeGenesDataFromTxDb}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/color.R
\name{colByCategory}
\alias{colByCategory}
\title{colByCategory}
\usage{
colByCategory(categories, colors)
}
\arguments{
\item{categories}{A vector of categories. Will be transformed into a factor if it's not one (if characters, integers, etc...)}

\item{colors}{(color vector, possibly named) The colors to to use for the different categories. If "auto", a rainbow palette will be used. (defaults to "auto")}
}
\value{
A vector of colors of the same length as value
}
\description{
Given a vector of categorical values, assign a color to each one bases on 
its category
}
\details{
The vector of values will be first transformed into a factor (if it's not
already a factor) and then colors will be selected from the palette in the
order defined by the factor levels. If more colors than the ones available in
the palette are needed, they will be reused. If the color vector is named 
using the factor levels and all levels are included, the link bewteen
levels and colors will be honored.
If the color palette is set to "auto", it will create a palette using 
"rainbow".
}
\examples{

colByCategory(c("A", "A", "C", "A", "C", "B"))
#The order of the colors is defined by the order of the factor, not the "natural order" of the elements
colByCategory(c("A", "A", "C", "A", "C", "B"), colors=c("red", "green", "blue"))
#integer categories plus reuse of colors
colByCategory(categories=c(3,3,1,2,1,4,2,3,2,1), colors=c("red", "green", "blue"))

}
\seealso{
\link{kpAddColorRect}, \link{colByValue}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpAbline.R
\name{kpAbline}
\alias{kpAbline}
\title{kpAbline}
\usage{
kpAbline(karyoplot, chr=NULL, h=NULL, v=NULL, ymin=NULL, ymax=NULL, data.panel=1, r0=NULL, r1=NULL,  clipping=TRUE, ...)
}
\arguments{
\item{karyoplot}{(a \code{KaryoPlot} object) This is the first argument to all data plotting functions of \code{karyoploteR}. A KaryoPlot object referring to the currently active plot.}

\item{chr}{(a charecter vector) A vector of chromosome names specifying the chromosomes where the lines will be plotted. If NULL, the lines will be plotted in all chromosomes. (defaults to NULL)}

\item{h}{(a numeric vector) A numeric vector with the heights where the horizontal lines will be plotted. If \code{h} is NULL, no horizontal lines will be plotted. (defaults to NULL)}

\item{v}{(a numeric vector) A numeric vector with the positions (in base pairs) where the vertical lines will be plotted. If \code{v} is NULL, no vertical lines will be plotted. (defaults to NULL)}

\item{ymin}{(numeric) The minimum value of \code{y} to be plotted. If NULL, it is set to the min value of the selected data panel. (defaults to NULL)}

\item{ymax}{(numeric) The maximum value of \code{y} to be plotted. If NULL, it is set to the max value of the selected data panel. (defaults to NULL)}

\item{data.panel}{(numeric) The identifier of the data panel where the data is to be plotted. The available data panels depend on the plot type selected in the call to \code{\link{plotKaryotype}}. (defaults to 1)}

\item{r0}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{r1}{(numeric) r0 and r1 define the vertical range of the data panel to be used to draw this plot. They can be used to split the data panel in different vertical ranges (similar to tracks in a genome browser) to plot differents data. If NULL, they are set to the min and max of the data panel, it is, to use all the available space. (defaults to NULL)}

\item{clipping}{(boolean) Only used if zooming is active. If TRUE, the data representation will be not drawn out of the drawing area (i.e. in margins, etc) even if the data overflows the drawing area. If FALSE, the data representation may overflow into the margins of the plot. (defaults to TRUE)}

\item{...}{The ellipsis operator can be used to specify any additional graphical parameters. Any additional parameter will be passed to the internal calls to the R base plotting functions.}
}
\value{
Returns the original karyoplot object, unchanged.
}
\description{
This is the \code{KaryoploteR} version of the \code{\link[graphics]{abline}} function to
add horizontal or vertical lines to the plot.
}
\details{
As with all other base-inspired low-level plotting functions in karyoploteR, the function 
has been designed to accept mostly the same parameters as the base one (see the package 
vignette for more information). In this case, however, the interface has been reduced
and it is only possible to plot vertical and horizontal lines and it's not possible to 
provide an intercept and slope. In addition, the function accepts graphical parameters 
that are valid for the base function \code{\link[graphics]{segments}}.
}
\examples{

set.seed(1000)
data.points <- sort(createRandomRegions(nregions=1000, mask=NA))
mcols(data.points) <- data.frame(y=rnorm(1000, mean = 0.5, sd = 0.1))

kp <- plotKaryotype("hg19", plot.type=1, chromosomes=c("chr1", "chr2"))
kpDataBackground(kp, data.panel=1)

kpPoints(kp, data=data.points, pch=".", col="#2222FF", cex=3)

#Add horizontal lines at mean
kpAbline(kp, h=0.5, col="red")

#and at the 1 sd
kpAbline(kp, h=c(0.4, 0.6), col="orange", lwd=0.5)
#and 2 sd's
kpAbline(kp, h=c(0.3, 0.7), col="orange", lwd=0.5, lty=2)

#And add two vertical lines at specific chromosomal locations
kpAbline(kp, v=c(67000000, 190000000), chr="chr1")


}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpSegments}}, \code{\link{kpLines}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kpAddChromosomeNames.R
\name{kpAddChromosomeNames}
\alias{kpAddChromosomeNames}
\title{kpAddChromosomeNames}
\usage{
kpAddChromosomeNames(karyoplot, chr.names=NULL, xoffset=0, yoffset=0, ...)
}
\arguments{
\item{karyoplot}{a \code{karyoplot} object returned by a call to \code{plotKaryotype}}

\item{chr.names}{(character vector) the names to use for the chromosomes. If NULL, the chromosome names in the original genome will be used. (defaults to NULL)}

\item{xoffset}{(numeric) a number of units to move the the chromosome names on the x axis with respect to their standard position (defaults to 0)}

\item{yoffset}{(numeric) a number of units to move the the chromosome names on the y axis with respect to their standard position (defaults to 0)}

\item{...}{any additional parameter to be passed to the text plotting. All R base graphics params are passed along.}
}
\value{
invisibly returns the given karyoplot object
}
\description{
Plots the chromosome names in the karyoplot
}
\details{
Given a KaryoPlot object, plot the names of the depicted chromosomes. This 
function is usually automatically called by plotKaryotype unless 
\code{labels.plotter} is NULL.
}
\examples{

kp <- plotKaryotype(labels.plotter = NULL)
kpAddChromosomeNames(kp, col="red", srt=30)
 
}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{getChromosomeNamesBoundingBox}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getMainTitleBoundingBox.R
\name{getMainTitleBoundingBox}
\alias{getMainTitleBoundingBox}
\title{getMainTitleBoundingBox}
\usage{
getMainTitleBoundingBox(karyoplot)
}
\arguments{
\item{karyoplot}{a \code{karyoplot} object returned by a call to \code{plotKaryotype}}
}
\value{
Returns a list with four elements (x0, x1, y0 and y1), each of them an 
integer with the coordinates for the main title
}
\description{
Return the regions where the chromosome names should be placed
}
\details{
Given a KaryoPlot object, return the regions where the main plot
should be placed. The position will depend on the plot type used.
}
\note{
In general, this function is automatically called by karyoploteR
and the user never needs to call it.
}
\examples{

kp <- plotKaryotype()
bb <- getMainTitleBoundingBox(kp)
 
}
\seealso{
\code{\link{plotKaryotype}}, \code{\link{kpAddMainTitle}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{filterParams}
\alias{filterParams}
\title{filterParams}
\usage{
filterParams(p, valid.elements, orig.length)
}
\arguments{
\item{p}{a list or a single vector}

\item{valid.elements}{a boolean vector with the elements to keep}

\item{orig.length}{the length of the elements on which to apply the filtering}
}
\value{
p with some members filtered
}
\description{
Given a list, select just only the valid.elements from each member. Also 
works with vectors instead of lists
}
\details{
This function is used in filtering the graphical parameters when plotting
only a part of the genome. For each element of the list, if it has the 
exact specified length, filters it using the 'valid.elements' parameter.
}
\examples{
 
a <- 1:10
b <- 3:5
c <- 2

filterParams(list(a,b,c), c(rep(TRUE,5), rep(FALSE,5)), 10)
filterParams(a, c(rep(TRUE,5), rep(FALSE,5)), 10)
 
}
